export CG_BuildSolidList
code
proc CG_BuildSolidList 28 0
file "../cg_predict.c"
line 26
;1:// Copyright (C) 1999-2000 Id Software, Inc.
;2://
;3:// cg_predict.c -- this file generates cg.predictedPlayerState by either
;4:// interpolating between snapshots from the server or locally predicting
;5:// ahead the client's movement.
;6:// It also handles local physics interaction, like fragments bouncing off walls
;7:
;8:#include "cg_local.h"
;9:
;10:static	pmove_t		cg_pmove;
;11:
;12:static	int			cg_numSolidEntities;
;13:static	centity_t	*cg_solidEntities[MAX_ENTITIES_IN_SNAPSHOT];
;14:static	int			cg_numTriggerEntities;
;15:static	centity_t	*cg_triggerEntities[MAX_ENTITIES_IN_SNAPSHOT];
;16:
;17:/*
;18:====================
;19:CG_BuildSolidList
;20:
;21:When a new cg.snap has been set, this function builds a sublist
;22:of the entities that are actually solid, to make for more
;23:efficient collision detection
;24:====================
;25:*/
;26:void CG_BuildSolidList( void ) {
line 32
;27:	int			i;
;28:	centity_t	*cent;
;29:	snapshot_t	*snap;
;30:	entityState_t	*ent;
;31:
;32:	cg_numSolidEntities = 0;
ADDRGP4 cg_numSolidEntities
CNSTI4 0
ASGNI4
line 33
;33:	cg_numTriggerEntities = 0;
ADDRGP4 cg_numTriggerEntities
CNSTI4 0
ASGNI4
line 35
;34:
;35:	if ( cg.nextSnap && !cg.nextFrameTeleport && !cg.thisFrameTeleport ) {
ADDRGP4 cg+36
INDIRP4
CVPU4 4
CNSTU4 0
EQU4 $87
ADDRLP4 16
CNSTI4 0
ASGNI4
ADDRGP4 cg+105544
INDIRI4
ADDRLP4 16
INDIRI4
NEI4 $87
ADDRGP4 cg+105540
INDIRI4
ADDRLP4 16
INDIRI4
NEI4 $87
line 36
;36:		snap = cg.nextSnap;
ADDRLP4 12
ADDRGP4 cg+36
INDIRP4
ASGNP4
line 37
;37:	} else {
ADDRGP4 $88
JUMPV
LABELV $87
line 38
;38:		snap = cg.snap;
ADDRLP4 12
ADDRGP4 cg+32
INDIRP4
ASGNP4
line 39
;39:	}
LABELV $88
line 41
;40:
;41:	for ( i = 0 ; i < snap->numEntities ; i++ ) {
ADDRLP4 8
CNSTI4 0
ASGNI4
ADDRGP4 $97
JUMPV
LABELV $94
line 42
;42:		cent = &cg_entities[ snap->entities[ i ].number ];
ADDRLP4 0
CNSTI4 648
CNSTI4 204
ADDRLP4 8
INDIRI4
MULI4
ADDRLP4 12
INDIRP4
CNSTI4 516
ADDP4
ADDP4
INDIRI4
MULI4
ADDRGP4 cg_entities
ADDP4
ASGNP4
line 43
;43:		ent = &cent->currentState;
ADDRLP4 4
ADDRLP4 0
INDIRP4
ASGNP4
line 45
;44:
;45:		if ( ent->eType == ET_ITEM || ent->eType == ET_PUSH_TRIGGER || ent->eType == ET_TELEPORT_TRIGGER ) {
ADDRLP4 20
ADDRLP4 4
INDIRP4
CNSTI4 4
ADDP4
INDIRI4
ASGNI4
ADDRLP4 20
INDIRI4
CNSTI4 2
EQI4 $101
ADDRLP4 20
INDIRI4
CNSTI4 9
EQI4 $101
ADDRLP4 20
INDIRI4
CNSTI4 10
NEI4 $98
LABELV $101
line 46
;46:			cg_triggerEntities[cg_numTriggerEntities] = cent;
ADDRGP4 cg_numTriggerEntities
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 cg_triggerEntities
ADDP4
ADDRLP4 0
INDIRP4
ASGNP4
line 47
;47:			cg_numTriggerEntities++;
ADDRLP4 24
ADDRGP4 cg_numTriggerEntities
ASGNP4
ADDRLP4 24
INDIRP4
ADDRLP4 24
INDIRP4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
line 48
;48:			continue;
ADDRGP4 $95
JUMPV
LABELV $98
line 51
;49:		}
;50:
;51:		if ( cent->nextState.solid ) {
ADDRLP4 0
INDIRP4
CNSTI4 380
ADDP4
INDIRI4
CNSTI4 0
EQI4 $102
line 52
;52:			cg_solidEntities[cg_numSolidEntities] = cent;
ADDRGP4 cg_numSolidEntities
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 cg_solidEntities
ADDP4
ADDRLP4 0
INDIRP4
ASGNP4
line 53
;53:			cg_numSolidEntities++;
ADDRLP4 24
ADDRGP4 cg_numSolidEntities
ASGNP4
ADDRLP4 24
INDIRP4
ADDRLP4 24
INDIRP4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
line 54
;54:			continue;
LABELV $102
line 56
;55:		}
;56:	}
LABELV $95
line 41
ADDRLP4 8
ADDRLP4 8
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $97
ADDRLP4 8
INDIRI4
ADDRLP4 12
INDIRP4
CNSTI4 512
ADDP4
INDIRI4
LTI4 $94
line 57
;57:}
LABELV $86
endproc CG_BuildSolidList 28 0
proc CG_ClipMoveToEntities 144 36
line 68
;58:
;59:/*
;60:====================
;61:CG_ClipMoveToEntities
;62:
;63:====================
;64:*/
;65:#define SHIELD_HALFTHICKNESS		4	// should correspond with the #define in g_active.c
;66:
;67:static void CG_ClipMoveToEntities ( const vec3_t start, const vec3_t mins, const vec3_t maxs, const vec3_t end,
;68:							int skipNumber, int mask, trace_t *tr ) {
line 77
;69:	int			i, x, zd, zu;
;70:	trace_t		trace;
;71:	entityState_t	*ent;
;72:	clipHandle_t 	cmodel;
;73:	vec3_t		bmins, bmaxs;
;74:	vec3_t		origin, angles;
;75:	centity_t	*cent;
;76:
;77:	for ( i = 0 ; i < cg_numSolidEntities ; i++ ) {
ADDRLP4 64
CNSTI4 0
ASGNI4
ADDRGP4 $108
JUMPV
LABELV $105
line 78
;78:		cent = cg_solidEntities[ i ];
ADDRLP4 60
ADDRLP4 64
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 cg_solidEntities
ADDP4
INDIRP4
ASGNP4
line 79
;79:		ent = &cent->currentState;
ADDRLP4 0
ADDRLP4 60
INDIRP4
ASGNP4
line 81
;80:
;81:		if ( ent->number == skipNumber ) {
ADDRLP4 0
INDIRP4
INDIRI4
ADDRFP4 16
INDIRI4
NEI4 $109
line 82
;82:			continue;
ADDRGP4 $106
JUMPV
LABELV $109
line 85
;83:		}
;84:
;85:		if ( ent->solid == SOLID_BMODEL ) {
ADDRLP4 0
INDIRP4
CNSTI4 176
ADDP4
INDIRI4
CNSTI4 16777215
NEI4 $111
line 87
;86:			// special value for bmodel
;87:			cmodel = trap_CM_InlineModel( ent->modelindex );
ADDRLP4 0
INDIRP4
CNSTI4 160
ADDP4
INDIRI4
ARGI4
ADDRLP4 132
ADDRGP4 trap_CM_InlineModel
CALLI4
ASGNI4
ADDRLP4 68
ADDRLP4 132
INDIRI4
ASGNI4
line 88
;88:			VectorCopy( cent->lerpAngles, angles );
ADDRLP4 108
ADDRLP4 60
INDIRP4
CNSTI4 636
ADDP4
INDIRB
ASGNB 12
line 89
;89:			BG_EvaluateTrajectory( &cent->currentState.pos, cg.physicsTime, origin );
ADDRLP4 60
INDIRP4
CNSTI4 12
ADDP4
ARGP4
ADDRGP4 cg+105560
INDIRI4
ARGI4
ADDRLP4 96
ARGP4
ADDRGP4 BG_EvaluateTrajectory
CALLV
pop
line 90
;90:		}
ADDRGP4 $112
JUMPV
LABELV $111
line 91
;91:		else if (ent->eFlags & EF_SHIELD_BOX_X)
ADDRLP4 0
INDIRP4
CNSTI4 8
ADDP4
INDIRI4
CNSTI4 2048
BANDI4
CNSTI4 0
EQI4 $114
line 92
;92:		{	// "specially" encoded bbox for x-axis aligned shield
line 94
;93:
;94:			x = (ent->solid & 255); // i on server side
ADDRLP4 120
ADDRLP4 0
INDIRP4
CNSTI4 176
ADDP4
INDIRI4
CNSTI4 255
BANDI4
ASGNI4
line 95
;95:			zd = ((ent->solid>>8) & 255);  // j on server side
ADDRLP4 124
ADDRLP4 0
INDIRP4
CNSTI4 176
ADDP4
INDIRI4
CNSTI4 8
RSHI4
CNSTI4 255
BANDI4
ASGNI4
line 96
;96:			zu = ((ent->solid>>16) & 255);  // k on server side
ADDRLP4 128
ADDRLP4 0
INDIRP4
CNSTI4 176
ADDP4
INDIRI4
CNSTI4 16
RSHI4
CNSTI4 255
BANDI4
ASGNI4
line 98
;97:
;98:			bmins[0] = -zd;
ADDRLP4 72
ADDRLP4 124
INDIRI4
NEGI4
CVIF4 4
ASGNF4
line 99
;99:			bmaxs[0] = x;
ADDRLP4 84
ADDRLP4 120
INDIRI4
CVIF4 4
ASGNF4
line 100
;100:			bmins[1] = -SHIELD_HALFTHICKNESS;
ADDRLP4 72+4
CNSTF4 3229614080
ASGNF4
line 101
;101:			bmaxs[1] = SHIELD_HALFTHICKNESS;
ADDRLP4 84+4
CNSTF4 1082130432
ASGNF4
line 102
;102:			bmins[2] = 0;
ADDRLP4 72+8
CNSTF4 0
ASGNF4
line 103
;103:			bmaxs[2] = zu;
ADDRLP4 84+8
ADDRLP4 128
INDIRI4
CVIF4 4
ASGNF4
line 105
;104:
;105:			cmodel = trap_CM_TempBoxModel( bmins, bmaxs );
ADDRLP4 72
ARGP4
ADDRLP4 84
ARGP4
ADDRLP4 132
ADDRGP4 trap_CM_TempBoxModel
CALLI4
ASGNI4
ADDRLP4 68
ADDRLP4 132
INDIRI4
ASGNI4
line 106
;106:			VectorCopy( vec3_origin, angles );
ADDRLP4 108
ADDRGP4 vec3_origin
INDIRB
ASGNB 12
line 107
;107:			VectorCopy( cent->lerpOrigin, origin );
ADDRLP4 96
ADDRLP4 60
INDIRP4
CNSTI4 624
ADDP4
INDIRB
ASGNB 12
line 108
;108:		}
ADDRGP4 $115
JUMPV
LABELV $114
line 109
;109:		else if (ent->eFlags & EF_SHIELD_BOX_Y)
ADDRLP4 0
INDIRP4
CNSTI4 8
ADDP4
INDIRI4
CNSTI4 4194304
BANDI4
CNSTI4 0
EQI4 $120
line 110
;110:		{	// "specially" encoded bbox for y-axis aligned shield
line 111
;111:			x = (ent->solid & 255); // i on server side
ADDRLP4 120
ADDRLP4 0
INDIRP4
CNSTI4 176
ADDP4
INDIRI4
CNSTI4 255
BANDI4
ASGNI4
line 112
;112:			zd = ((ent->solid>>8) & 255);  // j on server side
ADDRLP4 124
ADDRLP4 0
INDIRP4
CNSTI4 176
ADDP4
INDIRI4
CNSTI4 8
RSHI4
CNSTI4 255
BANDI4
ASGNI4
line 113
;113:			zu = ((ent->solid>>16) & 255);  // k on server side
ADDRLP4 128
ADDRLP4 0
INDIRP4
CNSTI4 176
ADDP4
INDIRI4
CNSTI4 16
RSHI4
CNSTI4 255
BANDI4
ASGNI4
line 115
;114:
;115:			bmins[1] = -zd;
ADDRLP4 72+4
ADDRLP4 124
INDIRI4
NEGI4
CVIF4 4
ASGNF4
line 116
;116:			bmaxs[1] = x;
ADDRLP4 84+4
ADDRLP4 120
INDIRI4
CVIF4 4
ASGNF4
line 117
;117:			bmins[0] = -SHIELD_HALFTHICKNESS;
ADDRLP4 72
CNSTF4 3229614080
ASGNF4
line 118
;118:			bmaxs[0] = SHIELD_HALFTHICKNESS;
ADDRLP4 84
CNSTF4 1082130432
ASGNF4
line 119
;119:			bmins[2] = 0;
ADDRLP4 72+8
CNSTF4 0
ASGNF4
line 120
;120:			bmaxs[2] = zu;
ADDRLP4 84+8
ADDRLP4 128
INDIRI4
CVIF4 4
ASGNF4
line 122
;121:
;122:			cmodel = trap_CM_TempBoxModel( bmins, bmaxs );
ADDRLP4 72
ARGP4
ADDRLP4 84
ARGP4
ADDRLP4 132
ADDRGP4 trap_CM_TempBoxModel
CALLI4
ASGNI4
ADDRLP4 68
ADDRLP4 132
INDIRI4
ASGNI4
line 123
;123:			VectorCopy( vec3_origin, angles );
ADDRLP4 108
ADDRGP4 vec3_origin
INDIRB
ASGNB 12
line 124
;124:			VectorCopy( cent->lerpOrigin, origin );
ADDRLP4 96
ADDRLP4 60
INDIRP4
CNSTI4 624
ADDP4
INDIRB
ASGNB 12
line 125
;125:		}
ADDRGP4 $121
JUMPV
LABELV $120
line 127
;126:		else
;127:		{
line 129
;128:			// encoded bbox
;129:			x = (ent->solid & 255); // i on server side
ADDRLP4 120
ADDRLP4 0
INDIRP4
CNSTI4 176
ADDP4
INDIRI4
CNSTI4 255
BANDI4
ASGNI4
line 130
;130:			zd = ((ent->solid>>8) & 255);  // j on server side
ADDRLP4 124
ADDRLP4 0
INDIRP4
CNSTI4 176
ADDP4
INDIRI4
CNSTI4 8
RSHI4
CNSTI4 255
BANDI4
ASGNI4
line 131
;131:			zu = ((ent->solid>>16) & 255) - 32;  // k on server side
ADDRLP4 128
ADDRLP4 0
INDIRP4
CNSTI4 176
ADDP4
INDIRI4
CNSTI4 16
RSHI4
CNSTI4 255
BANDI4
CNSTI4 32
SUBI4
ASGNI4
line 133
;132:
;133:			bmins[0] = bmins[1] = -x;
ADDRLP4 132
ADDRLP4 120
INDIRI4
NEGI4
CVIF4 4
ASGNF4
ADDRLP4 72+4
ADDRLP4 132
INDIRF4
ASGNF4
ADDRLP4 72
ADDRLP4 132
INDIRF4
ASGNF4
line 134
;134:			bmaxs[0] = bmaxs[1] = x;
ADDRLP4 136
ADDRLP4 120
INDIRI4
CVIF4 4
ASGNF4
ADDRLP4 84+4
ADDRLP4 136
INDIRF4
ASGNF4
ADDRLP4 84
ADDRLP4 136
INDIRF4
ASGNF4
line 135
;135:			bmins[2] = -zd;
ADDRLP4 72+8
ADDRLP4 124
INDIRI4
NEGI4
CVIF4 4
ASGNF4
line 136
;136:			bmaxs[2] = zu;
ADDRLP4 84+8
ADDRLP4 128
INDIRI4
CVIF4 4
ASGNF4
line 138
;137:
;138:			cmodel = trap_CM_TempBoxModel( bmins, bmaxs );
ADDRLP4 72
ARGP4
ADDRLP4 84
ARGP4
ADDRLP4 140
ADDRGP4 trap_CM_TempBoxModel
CALLI4
ASGNI4
ADDRLP4 68
ADDRLP4 140
INDIRI4
ASGNI4
line 139
;139:			VectorCopy( vec3_origin, angles );
ADDRLP4 108
ADDRGP4 vec3_origin
INDIRB
ASGNB 12
line 140
;140:			VectorCopy( cent->lerpOrigin, origin );
ADDRLP4 96
ADDRLP4 60
INDIRP4
CNSTI4 624
ADDP4
INDIRB
ASGNB 12
line 141
;141:		}
LABELV $121
LABELV $115
LABELV $112
line 144
;142:
;143:
;144:		trap_CM_TransformedBoxTrace ( &trace, start, end,
ADDRLP4 4
ARGP4
ADDRFP4 0
INDIRP4
ARGP4
ADDRFP4 12
INDIRP4
ARGP4
ADDRFP4 4
INDIRP4
ARGP4
ADDRFP4 8
INDIRP4
ARGP4
ADDRLP4 68
INDIRI4
ARGI4
ADDRFP4 20
INDIRI4
ARGI4
ADDRLP4 96
ARGP4
ADDRLP4 108
ARGP4
ADDRGP4 trap_CM_TransformedBoxTrace
CALLV
pop
line 147
;145:			mins, maxs, cmodel,  mask, origin, angles);
;146:
;147:		if (trace.allsolid || trace.fraction < tr->fraction) {
ADDRLP4 4
INDIRI4
CNSTI4 0
NEI4 $133
ADDRLP4 4+8
INDIRF4
ADDRFP4 24
INDIRP4
CNSTI4 8
ADDP4
INDIRF4
GEF4 $130
LABELV $133
line 148
;148:			trace.entityNum = ent->number;
ADDRLP4 4+52
ADDRLP4 0
INDIRP4
INDIRI4
ASGNI4
line 149
;149:			*tr = trace;
ADDRFP4 24
INDIRP4
ADDRLP4 4
INDIRB
ASGNB 56
line 150
;150:		} else if (trace.startsolid) {
ADDRGP4 $131
JUMPV
LABELV $130
ADDRLP4 4+4
INDIRI4
CNSTI4 0
EQI4 $135
line 151
;151:			tr->startsolid = qtrue;
ADDRFP4 24
INDIRP4
CNSTI4 4
ADDP4
CNSTI4 1
ASGNI4
line 152
;152:		}
LABELV $135
LABELV $131
line 153
;153:		if ( tr->allsolid ) {
ADDRFP4 24
INDIRP4
INDIRI4
CNSTI4 0
EQI4 $138
line 154
;154:			return;
ADDRGP4 $104
JUMPV
LABELV $138
line 156
;155:		}
;156:	}
LABELV $106
line 77
ADDRLP4 64
ADDRLP4 64
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $108
ADDRLP4 64
INDIRI4
ADDRGP4 cg_numSolidEntities
INDIRI4
LTI4 $105
line 157
;157:}
LABELV $104
endproc CG_ClipMoveToEntities 144 36
export CG_Trace
proc CG_Trace 60 28
line 165
;158:
;159:/*
;160:================
;161:CG_Trace
;162:================
;163:*/
;164:void	CG_Trace( trace_t *result, const vec3_t start, const vec3_t mins, const vec3_t maxs, const vec3_t end, 
;165:					 int skipNumber, int mask ) {
line 168
;166:	trace_t	t;
;167:
;168:	trap_CM_BoxTrace ( &t, start, end, mins, maxs, 0, mask);
ADDRLP4 0
ARGP4
ADDRFP4 4
INDIRP4
ARGP4
ADDRFP4 16
INDIRP4
ARGP4
ADDRFP4 8
INDIRP4
ARGP4
ADDRFP4 12
INDIRP4
ARGP4
CNSTI4 0
ARGI4
ADDRFP4 24
INDIRI4
ARGI4
ADDRGP4 trap_CM_BoxTrace
CALLV
pop
line 169
;169:	t.entityNum = t.fraction != 1.0 ? ENTITYNUM_WORLD : ENTITYNUM_NONE;
ADDRLP4 0+8
INDIRF4
CNSTF4 1065353216
EQF4 $144
ADDRLP4 56
CNSTI4 1022
ASGNI4
ADDRGP4 $145
JUMPV
LABELV $144
ADDRLP4 56
CNSTI4 1023
ASGNI4
LABELV $145
ADDRLP4 0+52
ADDRLP4 56
INDIRI4
ASGNI4
line 171
;170:	// check all other solid models
;171:	CG_ClipMoveToEntities (start, mins, maxs, end, skipNumber, mask, &t);
ADDRFP4 4
INDIRP4
ARGP4
ADDRFP4 8
INDIRP4
ARGP4
ADDRFP4 12
INDIRP4
ARGP4
ADDRFP4 16
INDIRP4
ARGP4
ADDRFP4 20
INDIRI4
ARGI4
ADDRFP4 24
INDIRI4
ARGI4
ADDRLP4 0
ARGP4
ADDRGP4 CG_ClipMoveToEntities
CALLV
pop
line 173
;172:
;173:	*result = t;
ADDRFP4 0
INDIRP4
ADDRLP4 0
INDIRB
ASGNB 56
line 174
;174:}
LABELV $140
endproc CG_Trace 60 28
export CG_PointContents
proc CG_PointContents 36 16
line 181
;175:
;176:/*
;177:================
;178:CG_PointContents
;179:================
;180:*/
;181:int		CG_PointContents( const vec3_t point, int passEntityNum ) {
line 188
;182:	int			i;
;183:	entityState_t	*ent;
;184:	centity_t	*cent;
;185:	clipHandle_t cmodel;
;186:	int			contents;
;187:
;188:	contents = trap_CM_PointContents (point, 0);
ADDRFP4 0
INDIRP4
ARGP4
CNSTI4 0
ARGI4
ADDRLP4 20
ADDRGP4 trap_CM_PointContents
CALLI4
ASGNI4
ADDRLP4 16
ADDRLP4 20
INDIRI4
ASGNI4
line 190
;189:
;190:	for ( i = 0 ; i < cg_numSolidEntities ; i++ ) {
ADDRLP4 4
CNSTI4 0
ASGNI4
ADDRGP4 $150
JUMPV
LABELV $147
line 191
;191:		cent = cg_solidEntities[ i ];
ADDRLP4 12
ADDRLP4 4
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 cg_solidEntities
ADDP4
INDIRP4
ASGNP4
line 193
;192:
;193:		ent = &cent->currentState;
ADDRLP4 0
ADDRLP4 12
INDIRP4
ASGNP4
line 195
;194:
;195:		if ( ent->number == passEntityNum ) {
ADDRLP4 0
INDIRP4
INDIRI4
ADDRFP4 4
INDIRI4
NEI4 $151
line 196
;196:			continue;
ADDRGP4 $148
JUMPV
LABELV $151
line 199
;197:		}
;198:
;199:		if (ent->solid != SOLID_BMODEL) { // special value for bmodel
ADDRLP4 0
INDIRP4
CNSTI4 176
ADDP4
INDIRI4
CNSTI4 16777215
EQI4 $153
line 200
;200:			continue;
ADDRGP4 $148
JUMPV
LABELV $153
line 203
;201:		}
;202:
;203:		cmodel = trap_CM_InlineModel( ent->modelindex );
ADDRLP4 0
INDIRP4
CNSTI4 160
ADDP4
INDIRI4
ARGI4
ADDRLP4 24
ADDRGP4 trap_CM_InlineModel
CALLI4
ASGNI4
ADDRLP4 8
ADDRLP4 24
INDIRI4
ASGNI4
line 204
;204:		if ( !cmodel ) {
ADDRLP4 8
INDIRI4
CNSTI4 0
NEI4 $155
line 205
;205:			continue;
ADDRGP4 $148
JUMPV
LABELV $155
line 208
;206:		}
;207:
;208:		contents |= trap_CM_TransformedPointContents( point, cmodel, ent->origin, ent->angles );
ADDRFP4 0
INDIRP4
ARGP4
ADDRLP4 8
INDIRI4
ARGI4
ADDRLP4 0
INDIRP4
CNSTI4 92
ADDP4
ARGP4
ADDRLP4 0
INDIRP4
CNSTI4 116
ADDP4
ARGP4
ADDRLP4 32
ADDRGP4 trap_CM_TransformedPointContents
CALLI4
ASGNI4
ADDRLP4 16
ADDRLP4 16
INDIRI4
ADDRLP4 32
INDIRI4
BORI4
ASGNI4
line 209
;209:	}
LABELV $148
line 190
ADDRLP4 4
ADDRLP4 4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $150
ADDRLP4 4
INDIRI4
ADDRGP4 cg_numSolidEntities
INDIRI4
LTI4 $147
line 211
;210:
;211:	return contents;
ADDRLP4 16
INDIRI4
RETI4
LABELV $146
endproc CG_PointContents 36 16
proc CG_InterpolatePlayerState 64 12
line 223
;212:}
;213:
;214:
;215:/*
;216:========================
;217:CG_InterpolatePlayerState
;218:
;219:Generates cg.predictedPlayerState by interpolating between
;220:cg.snap->player_state and cg.nextFrame->player_state
;221:========================
;222:*/
;223:static void CG_InterpolatePlayerState( qboolean grabAngles ) {
line 229
;224:	float			f;
;225:	int				i;
;226:	playerState_t	*out;
;227:	snapshot_t		*prev, *next;
;228:
;229:	out = &cg.predictedPlayerState;
ADDRLP4 12
ADDRGP4 cg+105580
ASGNP4
line 230
;230:	prev = cg.snap;
ADDRLP4 4
ADDRGP4 cg+32
INDIRP4
ASGNP4
line 231
;231:	next = cg.nextSnap;
ADDRLP4 8
ADDRGP4 cg+36
INDIRP4
ASGNP4
line 233
;232:
;233:	*out = cg.snap->ps;
ADDRLP4 12
INDIRP4
ADDRGP4 cg+32
INDIRP4
CNSTI4 44
ADDP4
INDIRB
ASGNB 468
line 236
;234:
;235:	// if we are still allowing local input, short circuit the view angles
;236:	if ( grabAngles ) {
ADDRFP4 0
INDIRI4
CNSTI4 0
EQI4 $162
line 240
;237:		usercmd_t	cmd;
;238:		int			cmdNum;
;239:
;240:		cmdNum = trap_GetCurrentCmdNumber();
ADDRLP4 48
ADDRGP4 trap_GetCurrentCmdNumber
CALLI4
ASGNI4
ADDRLP4 44
ADDRLP4 48
INDIRI4
ASGNI4
line 241
;241:		trap_GetUserCmd( cmdNum, &cmd );
ADDRLP4 44
INDIRI4
ARGI4
ADDRLP4 20
ARGP4
ADDRGP4 trap_GetUserCmd
CALLI4
pop
line 243
;242:
;243:		PM_UpdateViewAngles( out, &cmd );
ADDRLP4 12
INDIRP4
ARGP4
ADDRLP4 20
ARGP4
ADDRGP4 PM_UpdateViewAngles
CALLV
pop
line 244
;244:	}
LABELV $162
line 247
;245:
;246:	// if the next frame is a teleport, we can't lerp to it
;247:	if ( cg.nextFrameTeleport ) {
ADDRGP4 cg+105544
INDIRI4
CNSTI4 0
EQI4 $164
line 248
;248:		return;
ADDRGP4 $157
JUMPV
LABELV $164
line 251
;249:	}
;250:
;251:	if ( !next || next->serverTime <= prev->serverTime ) {
ADDRLP4 8
INDIRP4
CVPU4 4
CNSTU4 0
EQU4 $169
ADDRLP4 24
CNSTI4 8
ASGNI4
ADDRLP4 8
INDIRP4
ADDRLP4 24
INDIRI4
ADDP4
INDIRI4
ADDRLP4 4
INDIRP4
ADDRLP4 24
INDIRI4
ADDP4
INDIRI4
GTI4 $167
LABELV $169
line 252
;252:		return;
ADDRGP4 $157
JUMPV
LABELV $167
line 255
;253:	}
;254:
;255:	f = (float)( cg.time - prev->serverTime ) / ( next->serverTime - prev->serverTime );
ADDRLP4 28
CNSTI4 8
ASGNI4
ADDRLP4 32
ADDRLP4 4
INDIRP4
ADDRLP4 28
INDIRI4
ADDP4
INDIRI4
ASGNI4
ADDRLP4 16
ADDRGP4 cg+105552
INDIRI4
ADDRLP4 32
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 8
INDIRP4
ADDRLP4 28
INDIRI4
ADDP4
INDIRI4
ADDRLP4 32
INDIRI4
SUBI4
CVIF4 4
DIVF4
ASGNF4
line 257
;256:
;257:	i = next->ps.bobCycle;
ADDRLP4 0
ADDRLP4 8
INDIRP4
CNSTI4 52
ADDP4
INDIRI4
ASGNI4
line 258
;258:	if ( i < prev->ps.bobCycle ) {
ADDRLP4 0
INDIRI4
ADDRLP4 4
INDIRP4
CNSTI4 52
ADDP4
INDIRI4
GEI4 $171
line 259
;259:		i += 256;		// handle wraparound
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 256
ADDI4
ASGNI4
line 260
;260:	}
LABELV $171
line 261
;261:	out->bobCycle = prev->ps.bobCycle + f * ( i - prev->ps.bobCycle );
ADDRLP4 36
ADDRLP4 4
INDIRP4
CNSTI4 52
ADDP4
INDIRI4
ASGNI4
ADDRLP4 12
INDIRP4
CNSTI4 8
ADDP4
ADDRLP4 36
INDIRI4
CVIF4 4
ADDRLP4 16
INDIRF4
ADDRLP4 0
INDIRI4
ADDRLP4 36
INDIRI4
SUBI4
CVIF4 4
MULF4
ADDF4
CVFI4 4
ASGNI4
line 263
;262:
;263:	for ( i = 0 ; i < 3 ; i++ ) {
ADDRLP4 0
CNSTI4 0
ASGNI4
LABELV $173
line 264
;264:		out->origin[i] = prev->ps.origin[i] + f * (next->ps.origin[i] - prev->ps.origin[i] );
ADDRLP4 40
ADDRLP4 0
INDIRI4
CNSTI4 2
LSHI4
ASGNI4
ADDRLP4 44
CNSTI4 64
ASGNI4
ADDRLP4 48
ADDRLP4 40
INDIRI4
ADDRLP4 4
INDIRP4
ADDRLP4 44
INDIRI4
ADDP4
ADDP4
INDIRF4
ASGNF4
ADDRLP4 40
INDIRI4
ADDRLP4 12
INDIRP4
CNSTI4 20
ADDP4
ADDP4
ADDRLP4 48
INDIRF4
ADDRLP4 16
INDIRF4
ADDRLP4 40
INDIRI4
ADDRLP4 8
INDIRP4
ADDRLP4 44
INDIRI4
ADDP4
ADDP4
INDIRF4
ADDRLP4 48
INDIRF4
SUBF4
MULF4
ADDF4
ASGNF4
line 265
;265:		if ( !grabAngles ) {
ADDRFP4 0
INDIRI4
CNSTI4 0
NEI4 $177
line 266
;266:			out->viewangles[i] = LerpAngle( 
ADDRLP4 52
ADDRLP4 0
INDIRI4
CNSTI4 2
LSHI4
ASGNI4
ADDRLP4 56
CNSTI4 212
ASGNI4
ADDRLP4 52
INDIRI4
ADDRLP4 4
INDIRP4
ADDRLP4 56
INDIRI4
ADDP4
ADDP4
INDIRF4
ARGF4
ADDRLP4 52
INDIRI4
ADDRLP4 8
INDIRP4
ADDRLP4 56
INDIRI4
ADDP4
ADDP4
INDIRF4
ARGF4
ADDRLP4 16
INDIRF4
ARGF4
ADDRLP4 60
ADDRGP4 LerpAngle
CALLF4
ASGNF4
ADDRLP4 52
INDIRI4
ADDRLP4 12
INDIRP4
CNSTI4 168
ADDP4
ADDP4
ADDRLP4 60
INDIRF4
ASGNF4
line 268
;267:				prev->ps.viewangles[i], next->ps.viewangles[i], f );
;268:		}
LABELV $177
line 269
;269:		out->velocity[i] = prev->ps.velocity[i] + 
ADDRLP4 52
ADDRLP4 0
INDIRI4
CNSTI4 2
LSHI4
ASGNI4
ADDRLP4 56
CNSTI4 76
ASGNI4
ADDRLP4 60
ADDRLP4 52
INDIRI4
ADDRLP4 4
INDIRP4
ADDRLP4 56
INDIRI4
ADDP4
ADDP4
INDIRF4
ASGNF4
ADDRLP4 52
INDIRI4
ADDRLP4 12
INDIRP4
CNSTI4 32
ADDP4
ADDP4
ADDRLP4 60
INDIRF4
ADDRLP4 16
INDIRF4
ADDRLP4 52
INDIRI4
ADDRLP4 8
INDIRP4
ADDRLP4 56
INDIRI4
ADDP4
ADDP4
INDIRF4
ADDRLP4 60
INDIRF4
SUBF4
MULF4
ADDF4
ASGNF4
line 271
;270:			f * (next->ps.velocity[i] - prev->ps.velocity[i] );
;271:	}
LABELV $174
line 263
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
ADDRLP4 0
INDIRI4
CNSTI4 3
LTI4 $173
line 273
;272:
;273:}
LABELV $157
endproc CG_InterpolatePlayerState 64 12
proc CG_TouchItem 20 12
line 280
;274:
;275:/*
;276:===================
;277:CG_TouchItem
;278:===================
;279:*/
;280:static void CG_TouchItem( centity_t *cent ) {
line 283
;281:	gitem_t		*item;
;282:
;283:	if ( !cg_predictItems.integer ) {
ADDRGP4 cg_predictItems+12
INDIRI4
CNSTI4 0
NEI4 $180
line 284
;284:		return;
ADDRGP4 $179
JUMPV
LABELV $180
line 288
;285:	}
;286:
;287:	// never pick an item up twice in a prediction
;288:	if ( cent->miscTime == cg.time ) {
ADDRFP4 0
INDIRP4
CNSTI4 432
ADDP4
INDIRI4
ADDRGP4 cg+105552
INDIRI4
NEI4 $183
line 289
;289:		return;
ADDRGP4 $179
JUMPV
LABELV $183
line 292
;290:	}
;291:	
;292:	if ( !BG_PlayerTouchesItem( &cg.predictedPlayerState, &cent->currentState, cg.time ) ) {
ADDRGP4 cg+105580
ARGP4
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 cg+105552
INDIRI4
ARGI4
ADDRLP4 4
ADDRGP4 BG_PlayerTouchesItem
CALLI4
ASGNI4
ADDRLP4 4
INDIRI4
CNSTI4 0
NEI4 $186
line 293
;293:		return;
ADDRGP4 $179
JUMPV
LABELV $186
line 296
;294:	}
;295:
;296:	if ( !BG_CanItemBeGrabbed( &cent->currentState, &cg.predictedPlayerState ) ) {
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 cg+105580
ARGP4
ADDRLP4 8
ADDRGP4 BG_CanItemBeGrabbed
CALLI4
ASGNI4
ADDRLP4 8
INDIRI4
CNSTI4 0
NEI4 $190
line 297
;297:		return;		// can't hold it
ADDRGP4 $179
JUMPV
LABELV $190
line 300
;298:	}
;299:
;300:	item = &bg_itemlist[ cent->currentState.modelindex ];
ADDRLP4 0
CNSTI4 44
ADDRFP4 0
INDIRP4
CNSTI4 160
ADDP4
INDIRI4
MULI4
ADDRGP4 bg_itemlist
ADDP4
ASGNP4
line 304
;301:
;302:	// Special case for flags.  
;303:	// We don't predict touching our own flag
;304:	if (item->giType == IT_TEAM)
ADDRLP4 0
INDIRP4
CNSTI4 28
ADDP4
INDIRI4
CNSTI4 7
NEI4 $193
line 305
;305:	{	// NOTE:  This code used to JUST check giTag.  The problem is that the giTag for PW_REDFLAG 
line 307
;306:		// is the same as WP_QUANTUM_BURST.  The giTag should be a SUBCHECK after giType.
;307:		if (cg.predictedPlayerState.persistant[PERS_TEAM] == TEAM_RED &&
ADDRGP4 cg+105580+268+16
INDIRI4
CNSTI4 1
NEI4 $195
ADDRLP4 0
INDIRP4
CNSTI4 32
ADDP4
INDIRI4
CNSTI4 8
NEI4 $195
line 309
;308:			item->giTag == PW_REDFLAG)
;309:			return;
ADDRGP4 $179
JUMPV
LABELV $195
line 310
;310:		if (cg.predictedPlayerState.persistant[PERS_TEAM] == TEAM_BLUE &&
ADDRGP4 cg+105580+268+16
INDIRI4
CNSTI4 2
NEI4 $200
ADDRLP4 0
INDIRP4
CNSTI4 32
ADDP4
INDIRI4
CNSTI4 9
NEI4 $200
line 312
;311:			item->giTag == PW_BLUEFLAG)
;312:			return;
ADDRGP4 $179
JUMPV
LABELV $200
line 313
;313:	}
LABELV $193
line 315
;314:
;315:	if (!(cent->currentState.eFlags & (EF_ITEMPLACEHOLDER | EF_NODRAW)))
ADDRFP4 0
INDIRP4
CNSTI4 8
ADDP4
INDIRI4
CNSTI4 130
BANDI4
CNSTI4 0
NEI4 $205
line 316
;316:	{
line 318
;317:		// grab it
;318:		BG_AddPredictableEventToPlayerstate( EV_ITEM_PICKUP, cent->currentState.modelindex , &cg.predictedPlayerState);
CNSTI4 19
ARGI4
ADDRFP4 0
INDIRP4
CNSTI4 160
ADDP4
INDIRI4
ARGI4
ADDRGP4 cg+105580
ARGP4
ADDRGP4 BG_AddPredictableEventToPlayerstate
CALLV
pop
line 321
;319:
;320:		// Draw the techy-itemplaceholder for weapons and powerups, not ammo, etc.
;321:		if (item->giType == IT_WEAPON || item->giType == IT_POWERUP)
ADDRLP4 12
ADDRLP4 0
INDIRP4
CNSTI4 28
ADDP4
INDIRI4
ASGNI4
ADDRLP4 12
INDIRI4
CNSTI4 1
EQI4 $210
ADDRLP4 12
INDIRI4
CNSTI4 5
NEI4 $208
LABELV $210
line 322
;322:		{	// draw it "gridded out"
line 323
;323:			cent->currentState.eFlags |= EF_ITEMPLACEHOLDER;
ADDRLP4 16
ADDRFP4 0
INDIRP4
CNSTI4 8
ADDP4
ASGNP4
ADDRLP4 16
INDIRP4
ADDRLP4 16
INDIRP4
INDIRI4
CNSTI4 2
BORI4
ASGNI4
line 324
;324:		}
ADDRGP4 $209
JUMPV
LABELV $208
line 326
;325:		else
;326:		{	// remove it from the frame so it won't be drawn
line 327
;327:			cent->currentState.eFlags |= EF_NODRAW;
ADDRLP4 16
ADDRFP4 0
INDIRP4
CNSTI4 8
ADDP4
ASGNP4
ADDRLP4 16
INDIRP4
ADDRLP4 16
INDIRP4
INDIRI4
CNSTI4 128
BORI4
ASGNI4
line 330
;328:			// kef -- special client-only flag to prevent double pickup sounds
;329:			//cent->currentState.eFlags |= EF_CLIENT_NODRAW;
;330:		}
LABELV $209
line 332
;331:		// if its a weapon, give them some predicted ammo so the autoswitch will work
;332:		if ( item->giType == IT_WEAPON )
ADDRLP4 0
INDIRP4
CNSTI4 28
ADDP4
INDIRI4
CNSTI4 1
NEI4 $211
line 333
;333:		{
line 334
;334:			cg.predictedPlayerState.stats[ STAT_WEAPONS ] |= 1 << item->giTag;
ADDRLP4 16
ADDRGP4 cg+105580+204+8
ASGNP4
ADDRLP4 16
INDIRP4
ADDRLP4 16
INDIRP4
INDIRI4
CNSTI4 1
ADDRLP4 0
INDIRP4
CNSTI4 32
ADDP4
INDIRI4
LSHI4
BORI4
ASGNI4
line 335
;335:			if ( !cg.predictedPlayerState.ammo[ item->giTag ] ) {
ADDRLP4 0
INDIRP4
CNSTI4 32
ADDP4
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 cg+105580+396
ADDP4
INDIRI4
CNSTI4 0
NEI4 $216
line 336
;336:				cg.predictedPlayerState.ammo[ item->giTag ] = 1;
ADDRLP4 0
INDIRP4
CNSTI4 32
ADDP4
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 cg+105580+396
ADDP4
CNSTI4 1
ASGNI4
line 337
;337:			}
LABELV $216
line 338
;338:		}
LABELV $211
line 339
;339:	}
LABELV $205
line 342
;340:
;341:	// don't touch it again this prediction
;342:	cent->miscTime = cg.time;
ADDRFP4 0
INDIRP4
CNSTI4 432
ADDP4
ADDRGP4 cg+105552
INDIRI4
ASGNI4
line 343
;343:}
LABELV $179
endproc CG_TouchItem 20 12
proc CG_TouchTriggerPrediction 104 28
line 353
;344:
;345:
;346:/*
;347:=========================
;348:CG_TouchTriggerPrediction
;349:
;350:Predict push triggers and items
;351:=========================
;352:*/
;353:static void CG_TouchTriggerPrediction( void ) {
line 362
;354:	int			i;
;355:	trace_t		trace;
;356:	entityState_t	*ent;
;357:	clipHandle_t cmodel;
;358:	centity_t	*cent;
;359:	qboolean	spectator;
;360:
;361:	// dead clients don't activate triggers
;362:	if ( cg.predictedPlayerState.stats[STAT_HEALTH] <= 0 ) {
ADDRGP4 cg+105580+204
INDIRI4
CNSTI4 0
GTI4 $224
line 363
;363:		return;
ADDRGP4 $223
JUMPV
LABELV $224
line 366
;364:	}
;365:
;366:	spectator = ( cg.predictedPlayerState.pm_type == PM_SPECTATOR );
ADDRGP4 cg+105580+4
INDIRI4
CNSTI4 2
NEI4 $231
ADDRLP4 76
CNSTI4 1
ASGNI4
ADDRGP4 $232
JUMPV
LABELV $231
ADDRLP4 76
CNSTI4 0
ASGNI4
LABELV $232
ADDRLP4 72
ADDRLP4 76
INDIRI4
ASGNI4
line 368
;367:
;368:	if ( cg.predictedPlayerState.pm_type != PM_NORMAL && !spectator ) {
ADDRLP4 80
CNSTI4 0
ASGNI4
ADDRGP4 cg+105580+4
INDIRI4
ADDRLP4 80
INDIRI4
EQI4 $233
ADDRLP4 72
INDIRI4
ADDRLP4 80
INDIRI4
NEI4 $233
line 369
;369:		return;
ADDRGP4 $223
JUMPV
LABELV $233
line 372
;370:	}
;371:
;372:	for ( i = 0 ; i < cg_numTriggerEntities ; i++ ) {
ADDRLP4 4
CNSTI4 0
ASGNI4
ADDRGP4 $240
JUMPV
LABELV $237
line 373
;373:		cent = cg_triggerEntities[ i ];
ADDRLP4 12
ADDRLP4 4
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 cg_triggerEntities
ADDP4
INDIRP4
ASGNP4
line 374
;374:		ent = &cent->currentState;
ADDRLP4 0
ADDRLP4 12
INDIRP4
ASGNP4
line 376
;375:
;376:		if ( ent->eType == ET_ITEM && !spectator ) {
ADDRLP4 0
INDIRP4
CNSTI4 4
ADDP4
INDIRI4
CNSTI4 2
NEI4 $241
ADDRLP4 72
INDIRI4
CNSTI4 0
NEI4 $241
line 377
;377:			CG_TouchItem( cent );
ADDRLP4 12
INDIRP4
ARGP4
ADDRGP4 CG_TouchItem
CALLV
pop
line 378
;378:			continue;
ADDRGP4 $238
JUMPV
LABELV $241
line 381
;379:		}
;380:
;381:		if ( ent->solid != SOLID_BMODEL ) {
ADDRLP4 0
INDIRP4
CNSTI4 176
ADDP4
INDIRI4
CNSTI4 16777215
EQI4 $243
line 382
;382:			continue;
ADDRGP4 $238
JUMPV
LABELV $243
line 385
;383:		}
;384:
;385:		cmodel = trap_CM_InlineModel( ent->modelindex );
ADDRLP4 0
INDIRP4
CNSTI4 160
ADDP4
INDIRI4
ARGI4
ADDRLP4 84
ADDRGP4 trap_CM_InlineModel
CALLI4
ASGNI4
ADDRLP4 8
ADDRLP4 84
INDIRI4
ASGNI4
line 386
;386:		if ( !cmodel ) {
ADDRLP4 8
INDIRI4
CNSTI4 0
NEI4 $245
line 387
;387:			continue;
ADDRGP4 $238
JUMPV
LABELV $245
line 390
;388:		}
;389:
;390:		trap_CM_BoxTrace( &trace, cg.predictedPlayerState.origin, cg.predictedPlayerState.origin, 
ADDRLP4 16
ARGP4
ADDRGP4 cg+105580+20
ARGP4
ADDRGP4 cg+105580+20
ARGP4
ADDRGP4 cg_pmove+180
ARGP4
ADDRGP4 cg_pmove+192
ARGP4
ADDRLP4 8
INDIRI4
ARGI4
CNSTI4 -1
ARGI4
ADDRGP4 trap_CM_BoxTrace
CALLV
pop
line 393
;391:			cg_pmove.mins, cg_pmove.maxs, cmodel, -1 );
;392:
;393:		if ( !trace.startsolid ) {
ADDRLP4 16+4
INDIRI4
CNSTI4 0
NEI4 $253
line 394
;394:			continue;
ADDRGP4 $238
JUMPV
LABELV $253
line 397
;395:		}
;396:
;397:		if ( ent->eType == ET_TELEPORT_TRIGGER ) {
ADDRLP4 0
INDIRP4
CNSTI4 4
ADDP4
INDIRI4
CNSTI4 10
NEI4 $256
line 398
;398:			cg.hyperspace = qtrue;
ADDRGP4 cg+105576
CNSTI4 1
ASGNI4
line 399
;399:		} else {
ADDRGP4 $257
JUMPV
LABELV $256
line 404
;400:			float	s;
;401:			vec3_t	dir;
;402:
;403:			// we hit this push trigger
;404:			if ( spectator ) {
ADDRLP4 72
INDIRI4
CNSTI4 0
EQI4 $259
line 405
;405:				continue;
ADDRGP4 $238
JUMPV
LABELV $259
line 409
;406:			}
;407:
;408:			// flying characters don't hit bounce pads
;409:			if ( cg.predictedPlayerState.powerups[PW_FLIGHT] ) {
ADDRGP4 cg+105580+332+24
INDIRI4
CNSTI4 0
EQI4 $261
line 410
;410:				continue;
ADDRGP4 $238
JUMPV
LABELV $261
line 414
;411:			}
;412:
;413:			// if we are already flying along the bounce direction, don't play sound again
;414:			VectorNormalize2( ent->origin2, dir );
ADDRLP4 0
INDIRP4
CNSTI4 104
ADDP4
ARGP4
ADDRLP4 88
ARGP4
ADDRGP4 VectorNormalize2
CALLF4
pop
line 415
;415:			s = DotProduct( cg.predictedPlayerState.velocity, dir );
ADDRLP4 100
ADDRGP4 cg+105580+32
INDIRF4
ADDRLP4 88
INDIRF4
MULF4
ADDRGP4 cg+105580+32+4
INDIRF4
ADDRLP4 88+4
INDIRF4
MULF4
ADDF4
ADDRGP4 cg+105580+32+8
INDIRF4
ADDRLP4 88+8
INDIRF4
MULF4
ADDF4
ASGNF4
line 416
;416:			if ( s < 500 ) {
ADDRLP4 100
INDIRF4
CNSTF4 1140457472
GEF4 $276
line 418
;417:				// don't play the event sound again if we are in a fat trigger
;418:				BG_AddPredictableEventToPlayerstate( EV_JUMP_PAD, 0, &cg.predictedPlayerState );
CNSTI4 13
ARGI4
CNSTI4 0
ARGI4
ADDRGP4 cg+105580
ARGP4
ADDRGP4 BG_AddPredictableEventToPlayerstate
CALLV
pop
line 419
;419:			}
LABELV $276
line 420
;420:			VectorCopy( ent->origin2, cg.predictedPlayerState.velocity );
ADDRGP4 cg+105580+32
ADDRLP4 0
INDIRP4
CNSTI4 104
ADDP4
INDIRB
ASGNB 12
line 421
;421:		}
LABELV $257
line 422
;422:	}
LABELV $238
line 372
ADDRLP4 4
ADDRLP4 4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $240
ADDRLP4 4
INDIRI4
ADDRGP4 cg_numTriggerEntities
INDIRI4
LTI4 $237
line 423
;423:}
LABELV $223
endproc CG_TouchTriggerPrediction 104 28
export CG_PredictPlayerState
proc CG_PredictPlayerState 796 20
line 452
;424:
;425:
;426:/*
;427:=================
;428:CG_PredictPlayerState
;429:
;430:Generates cg.predictedPlayerState for the current cg.time
;431:cg.predictedPlayerState is guaranteed to be valid after exiting.
;432:
;433:For demo playback, this will be an interpolation between two valid
;434:playerState_t.
;435:
;436:For normal gameplay, it will be the result of predicted usercmd_t on
;437:top of the most recent playerState_t received from the server.
;438:
;439:Each new snapshot will usually have one or more new usercmd over the last,
;440:but we simulate all unacknowledged commands each time, not just the new ones.
;441:This means that on an internet connection, quite a few pmoves may be issued
;442:each frame.
;443:
;444:OPTIMIZE: don't re-simulate unless the newly arrived snapshot playerState_t
;445:differs from the predicted one.  Would require saving all intermediate
;446:playerState_t during prediction.
;447:
;448:We detect prediction errors and allow them to be decayed off over several frames
;449:to ease the jerk.
;450:=================
;451:*/
;452:void CG_PredictPlayerState( void ) {
line 460
;453:	int			cmdNum, current;
;454:	playerState_t	oldPlayerState;
;455:	qboolean	moved;
;456:	usercmd_t	oldestCmd;
;457:	usercmd_t	latestCmd;
;458:	char		temp_string[200];
;459:
;460:	cg.hyperspace = qfalse;	// will be set if touching a trigger_teleport
ADDRGP4 cg+105576
CNSTI4 0
ASGNI4
line 465
;461:
;462:	// if this is the first frame we must guarantee
;463:	// predictedPlayerState is valid even if there is some
;464:	// other error condition
;465:	if ( !cg.validPPS ) {
ADDRGP4 cg+106696
INDIRI4
CNSTI4 0
NEI4 $283
line 466
;466:		cg.validPPS = qtrue;
ADDRGP4 cg+106696
CNSTI4 1
ASGNI4
line 467
;467:		cg.predictedPlayerState = cg.snap->ps;
ADDRGP4 cg+105580
ADDRGP4 cg+32
INDIRP4
CNSTI4 44
ADDP4
INDIRB
ASGNB 468
line 470
;468:		// if we need to, we should check our model cvar and update it with the right value from the userinfo strings
;469:		// since it may have been modified by the server
;470:		Com_sprintf(temp_string, sizeof(temp_string), "%s/%s", cgs.clientinfo[cg.predictedPlayerState.clientNum].modelName, 
ADDRLP4 528
ARGP4
CNSTI4 200
ARGI4
ADDRGP4 $289
ARGP4
ADDRLP4 728
CNSTI4 1264
ASGNI4
ADDRLP4 728
INDIRI4
ADDRGP4 cg+105580+156
INDIRI4
MULI4
ADDRGP4 cgs+31868+132
ADDP4
ARGP4
ADDRLP4 728
INDIRI4
ADDRGP4 cg+105580+156
INDIRI4
MULI4
ADDRGP4 cgs+31868+196
ADDP4
ARGP4
ADDRGP4 Com_sprintf
CALLV
pop
line 472
;471:			cgs.clientinfo[cg.predictedPlayerState.clientNum].skinName);
;472:		updateSkin(cg.predictedPlayerState.clientNum, temp_string);
ADDRGP4 cg+105580+156
INDIRI4
ARGI4
ADDRLP4 528
ARGP4
ADDRGP4 updateSkin
CALLV
pop
line 473
;473:	}
LABELV $283
line 477
;474:
;475:
;476:	// demo playback just copies the moves
;477:	if ( cg.demoPlayback || (cg.snap->ps.pm_flags & PMF_FOLLOW) ) {
ADDRLP4 728
CNSTI4 0
ASGNI4
ADDRGP4 cg+4
INDIRI4
ADDRLP4 728
INDIRI4
NEI4 $304
ADDRGP4 cg+32
INDIRP4
CNSTI4 56
ADDP4
INDIRI4
CNSTI4 4096
BANDI4
ADDRLP4 728
INDIRI4
EQI4 $300
LABELV $304
line 478
;478:		CG_InterpolatePlayerState( qfalse );
CNSTI4 0
ARGI4
ADDRGP4 CG_InterpolatePlayerState
CALLV
pop
line 479
;479:		return;
ADDRGP4 $281
JUMPV
LABELV $300
line 483
;480:	}
;481:
;482:	// non-predicting local movement will grab the latest angles
;483:	if ( cg_nopredict.integer || cg_synchronousClients.integer ) {
ADDRLP4 732
CNSTI4 0
ASGNI4
ADDRGP4 cg_nopredict+12
INDIRI4
ADDRLP4 732
INDIRI4
NEI4 $309
ADDRGP4 cg_synchronousClients+12
INDIRI4
ADDRLP4 732
INDIRI4
EQI4 $305
LABELV $309
line 484
;484:		CG_InterpolatePlayerState( qtrue );
CNSTI4 1
ARGI4
ADDRGP4 CG_InterpolatePlayerState
CALLV
pop
line 485
;485:		return;
ADDRGP4 $281
JUMPV
LABELV $305
line 489
;486:	}
;487:
;488:	// prepare for pmove
;489:	cg_pmove.ps = &cg.predictedPlayerState;
ADDRGP4 cg_pmove
ADDRGP4 cg+105580
ASGNP4
line 490
;490:	cg_pmove.trace = CG_Trace;
ADDRGP4 cg_pmove+216
ADDRGP4 CG_Trace
ASGNP4
line 491
;491:	cg_pmove.pointcontents = CG_PointContents;
ADDRGP4 cg_pmove+220
ADDRGP4 CG_PointContents
ASGNP4
line 492
;492:	if ( cg_pmove.ps->pm_type == PM_DEAD ) {
ADDRGP4 cg_pmove
INDIRP4
CNSTI4 4
ADDP4
INDIRI4
CNSTI4 3
NEI4 $313
line 493
;493:		cg_pmove.tracemask = MASK_PLAYERSOLID & ~CONTENTS_BODY;
ADDRGP4 cg_pmove+28
CNSTI4 65537
ASGNI4
line 494
;494:	}
ADDRGP4 $314
JUMPV
LABELV $313
line 495
;495:	else {
line 496
;496:		cg_pmove.tracemask = MASK_PLAYERSOLID;
ADDRGP4 cg_pmove+28
CNSTI4 33619969
ASGNI4
line 497
;497:	}
LABELV $314
line 498
;498:	if ( cg.snap->ps.persistant[PERS_TEAM] == TEAM_SPECTATOR || (cg.snap->ps.eFlags&EF_ELIMINATED) ) {
ADDRGP4 cg+32
INDIRP4
CNSTI4 328
ADDP4
INDIRI4
CNSTI4 3
EQI4 $321
ADDRGP4 cg+32
INDIRP4
CNSTI4 148
ADDP4
INDIRI4
CNSTI4 1024
BANDI4
CNSTI4 0
EQI4 $317
LABELV $321
line 499
;499:		cg_pmove.tracemask &= ~CONTENTS_BODY;	// spectators can fly through bodies
ADDRLP4 736
ADDRGP4 cg_pmove+28
ASGNP4
ADDRLP4 736
INDIRP4
ADDRLP4 736
INDIRP4
INDIRI4
CNSTI4 -33554433
BANDI4
ASGNI4
line 500
;500:	}
LABELV $317
line 501
;501:	cg_pmove.noFootsteps = ( cgs.dmflags & DF_NO_FOOTSTEPS ) > 0;
ADDRGP4 cgs+25340
INDIRI4
CNSTI4 32
BANDI4
CNSTI4 0
LEI4 $326
ADDRLP4 736
CNSTI4 1
ASGNI4
ADDRGP4 $327
JUMPV
LABELV $326
ADDRLP4 736
CNSTI4 0
ASGNI4
LABELV $327
ADDRGP4 cg_pmove+36
ADDRLP4 736
INDIRI4
ASGNI4
line 502
;502:	cg_pmove.pModDisintegration = cgs.pModDisintegration > 0;
ADDRGP4 cgs+25324
INDIRI4
CNSTI4 0
LEI4 $331
ADDRLP4 740
CNSTI4 1
ASGNI4
ADDRGP4 $332
JUMPV
LABELV $331
ADDRLP4 740
CNSTI4 0
ASGNI4
LABELV $332
ADDRGP4 cg_pmove+40
ADDRLP4 740
INDIRI4
ASGNI4
line 505
;503:
;504:	// save the state before the pmove so we can detect transitions
;505:	oldPlayerState = cg.predictedPlayerState;
ADDRLP4 4
ADDRGP4 cg+105580
INDIRB
ASGNB 468
line 507
;506:
;507:	current = trap_GetCurrentCmdNumber();
ADDRLP4 744
ADDRGP4 trap_GetCurrentCmdNumber
CALLI4
ASGNI4
ADDRLP4 472
ADDRLP4 744
INDIRI4
ASGNI4
line 512
;508:
;509:	// if we don't have the commands right after the snapshot, we
;510:	// can't accurately predict a current position, so just freeze at
;511:	// the last good position we had
;512:	cmdNum = current - CMD_BACKUP + 1;
ADDRLP4 0
ADDRLP4 472
INDIRI4
CNSTI4 64
SUBI4
CNSTI4 1
ADDI4
ASGNI4
line 513
;513:	trap_GetUserCmd( cmdNum, &oldestCmd );
ADDRLP4 0
INDIRI4
ARGI4
ADDRLP4 504
ARGP4
ADDRGP4 trap_GetUserCmd
CALLI4
pop
line 514
;514:	if ( oldestCmd.serverTime > cg.snap->ps.commandTime 
ADDRLP4 748
ADDRLP4 504
INDIRI4
ASGNI4
ADDRLP4 748
INDIRI4
ADDRGP4 cg+32
INDIRP4
CNSTI4 44
ADDP4
INDIRI4
LEI4 $334
ADDRLP4 748
INDIRI4
ADDRGP4 cg+105552
INDIRI4
GEI4 $334
line 515
;515:		&& oldestCmd.serverTime < cg.time ) {	// special check for map_restart
line 516
;516:		if ( cg_showmiss.integer ) {
ADDRGP4 cg_showmiss+12
INDIRI4
CNSTI4 0
EQI4 $281
line 517
;517:			CG_Printf ("exceeded PACKET_BACKUP on commands\n");
ADDRGP4 $341
ARGP4
ADDRGP4 CG_Printf
CALLV
pop
line 518
;518:		}
line 519
;519:		return;
ADDRGP4 $281
JUMPV
LABELV $334
line 523
;520:	}
;521:
;522:	// get the latest command so we can know which commands are from previous map_restarts
;523:	trap_GetUserCmd( current, &latestCmd );
ADDRLP4 472
INDIRI4
ARGI4
ADDRLP4 480
ARGP4
ADDRGP4 trap_GetUserCmd
CALLI4
pop
line 529
;524:
;525:	// get the most recent information we have, even if
;526:	// the server time is beyond our current cg.time,
;527:	// because predicted player positions are going to 
;528:	// be ahead of everything else anyway
;529:	if ( cg.nextSnap && !cg.nextFrameTeleport && !cg.thisFrameTeleport ) {
ADDRGP4 cg+36
INDIRP4
CVPU4 4
CNSTU4 0
EQU4 $342
ADDRLP4 752
CNSTI4 0
ASGNI4
ADDRGP4 cg+105544
INDIRI4
ADDRLP4 752
INDIRI4
NEI4 $342
ADDRGP4 cg+105540
INDIRI4
ADDRLP4 752
INDIRI4
NEI4 $342
line 530
;530:		cg.predictedPlayerState = cg.nextSnap->ps;
ADDRGP4 cg+105580
ADDRGP4 cg+36
INDIRP4
CNSTI4 44
ADDP4
INDIRB
ASGNB 468
line 531
;531:		cg.physicsTime = cg.nextSnap->serverTime;
ADDRGP4 cg+105560
ADDRGP4 cg+36
INDIRP4
CNSTI4 8
ADDP4
INDIRI4
ASGNI4
line 532
;532:	} else {
ADDRGP4 $343
JUMPV
LABELV $342
line 533
;533:		cg.predictedPlayerState = cg.snap->ps;
ADDRGP4 cg+105580
ADDRGP4 cg+32
INDIRP4
CNSTI4 44
ADDP4
INDIRB
ASGNB 468
line 534
;534:		cg.physicsTime = cg.snap->serverTime;
ADDRGP4 cg+105560
ADDRGP4 cg+32
INDIRP4
CNSTI4 8
ADDP4
INDIRI4
ASGNI4
line 535
;535:	}
LABELV $343
line 538
;536:
;537:	// run cmds
;538:	moved = qfalse;
ADDRLP4 476
CNSTI4 0
ASGNI4
line 539
;539:	for ( cmdNum = current - CMD_BACKUP + 1 ; cmdNum <= current ; cmdNum++ ) {
ADDRLP4 0
ADDRLP4 472
INDIRI4
CNSTI4 64
SUBI4
CNSTI4 1
ADDI4
ASGNI4
ADDRGP4 $358
JUMPV
LABELV $355
line 541
;540:		// get the command
;541:		trap_GetUserCmd( cmdNum, &cg_pmove.cmd );
ADDRLP4 0
INDIRI4
ARGI4
ADDRGP4 cg_pmove+4
ARGP4
ADDRGP4 trap_GetUserCmd
CALLI4
pop
line 544
;542:
;543:		// don't do anything if the time is before the snapshot player time
;544:		if ( cg_pmove.cmd.serverTime <= cg.predictedPlayerState.commandTime ) {
ADDRGP4 cg_pmove+4
INDIRI4
ADDRGP4 cg+105580
INDIRI4
GTI4 $360
line 545
;545:			continue;
ADDRGP4 $356
JUMPV
LABELV $360
line 549
;546:		}
;547:
;548:		// don't do anything if the command was from a previous map_restart
;549:		if ( cg_pmove.cmd.serverTime > latestCmd.serverTime ) {
ADDRGP4 cg_pmove+4
INDIRI4
ADDRLP4 480
INDIRI4
LEI4 $364
line 550
;550:			continue;
ADDRGP4 $356
JUMPV
LABELV $364
line 553
;551:		}
;552:
;553:		if (cg.predictedPlayerState.introTime > cg.time)	//what's this for?
ADDRGP4 cg+105580+56
INDIRI4
ADDRGP4 cg+105552
INDIRI4
LEI4 $367
line 554
;554:		{
line 555
;555:			cg_pmove.cmd.buttons = 0;
ADDRGP4 cg_pmove+4+4
CNSTU1 0
ASGNU1
line 556
;556:			cg_pmove.cmd.weapon = 0;
ADDRGP4 cg_pmove+4+5
CNSTU1 0
ASGNU1
line 558
;557://			cg_pmove.cmd.angles[0] = cg_pmove.cmd.angles[1] = cg_pmove.cmd.angles[2] = 0;
;558:			cg_pmove.cmd.forwardmove = cg_pmove.cmd.rightmove = cg_pmove.cmd.upmove = 0;
ADDRLP4 756
CNSTI1 0
ASGNI1
ADDRGP4 cg_pmove+4+22
ADDRLP4 756
INDIRI1
ASGNI1
ADDRGP4 cg_pmove+4+21
ADDRLP4 756
INDIRI1
ASGNI1
ADDRGP4 cg_pmove+4+20
ADDRLP4 756
INDIRI1
ASGNI1
line 559
;559:		}
LABELV $367
line 566
;560:
;561:		// check for a prediction error from last frame
;562:		// on a lan, this will often be the exact value
;563:		// from the snapshot, but on a wan we will have
;564:		// to predict several commands to get to the point
;565:		// we want to compare
;566:		if ( cg.predictedPlayerState.commandTime == oldPlayerState.commandTime ) {
ADDRGP4 cg+105580
INDIRI4
ADDRLP4 4
INDIRI4
NEI4 $382
line 570
;567:			vec3_t	delta;
;568:			float	len;
;569:
;570:			if ( cg.thisFrameTeleport ) {
ADDRGP4 cg+105540
INDIRI4
CNSTI4 0
EQI4 $385
line 572
;571:				// a teleport will not cause an error decay
;572:				VectorClear( cg.predictedError );
ADDRLP4 772
CNSTF4 0
ASGNF4
ADDRGP4 cg+106704+8
ADDRLP4 772
INDIRF4
ASGNF4
ADDRGP4 cg+106704+4
ADDRLP4 772
INDIRF4
ASGNF4
ADDRGP4 cg+106704
ADDRLP4 772
INDIRF4
ASGNF4
line 573
;573:				if ( cg_showmiss.integer ) {
ADDRGP4 cg_showmiss+12
INDIRI4
CNSTI4 0
EQI4 $393
line 574
;574:					CG_Printf( "PredictionTeleport\n" );
ADDRGP4 $396
ARGP4
ADDRGP4 CG_Printf
CALLV
pop
line 575
;575:				}
LABELV $393
line 576
;576:				cg.thisFrameTeleport = qfalse;
ADDRGP4 cg+105540
CNSTI4 0
ASGNI4
line 577
;577:			} else {
ADDRGP4 $386
JUMPV
LABELV $385
line 579
;578:				vec3_t	adjusted;
;579:				CG_AdjustPositionForMover( cg.predictedPlayerState.origin, 
ADDRGP4 cg+105580+20
ARGP4
ADDRGP4 cg+105580+80
INDIRI4
ARGI4
ADDRGP4 cg+105560
INDIRI4
ARGI4
ADDRGP4 cg+105556
INDIRI4
ARGI4
ADDRLP4 772
ARGP4
ADDRGP4 CG_AdjustPositionForMover
CALLV
pop
line 582
;580:					cg.predictedPlayerState.groundEntityNum, cg.physicsTime, cg.oldTime, adjusted );
;581:
;582:				if ( cg_showmiss.integer ) {
ADDRGP4 cg_showmiss+12
INDIRI4
CNSTI4 0
EQI4 $404
line 583
;583:					if (!VectorCompare( oldPlayerState.origin, adjusted )) {
ADDRLP4 4+20
ARGP4
ADDRLP4 772
ARGP4
ADDRLP4 784
ADDRGP4 VectorCompare
CALLI4
ASGNI4
ADDRLP4 784
INDIRI4
CNSTI4 0
NEI4 $407
line 584
;584:						CG_Printf("prediction error\n");
ADDRGP4 $410
ARGP4
ADDRGP4 CG_Printf
CALLV
pop
line 585
;585:					}
LABELV $407
line 586
;586:				}
LABELV $404
line 587
;587:				VectorSubtract( oldPlayerState.origin, adjusted, delta );
ADDRLP4 756
ADDRLP4 4+20
INDIRF4
ADDRLP4 772
INDIRF4
SUBF4
ASGNF4
ADDRLP4 756+4
ADDRLP4 4+20+4
INDIRF4
ADDRLP4 772+4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 756+8
ADDRLP4 4+20+8
INDIRF4
ADDRLP4 772+8
INDIRF4
SUBF4
ASGNF4
line 588
;588:				len = VectorLength( delta );
ADDRLP4 756
ARGP4
ADDRLP4 784
ADDRGP4 VectorLength
CALLF4
ASGNF4
ADDRLP4 768
ADDRLP4 784
INDIRF4
ASGNF4
line 589
;589:				if ( len > 0.1 ) {
ADDRLP4 768
INDIRF4
CNSTF4 1036831949
LEF4 $420
line 590
;590:					if ( cg_showmiss.integer ) {
ADDRGP4 cg_showmiss+12
INDIRI4
CNSTI4 0
EQI4 $422
line 591
;591:						CG_Printf("Prediction miss: %f\n", len);
ADDRGP4 $425
ARGP4
ADDRLP4 768
INDIRF4
ARGF4
ADDRGP4 CG_Printf
CALLV
pop
line 592
;592:					}
LABELV $422
line 593
;593:					if ( cg_errorDecay.integer ) {
ADDRGP4 cg_errorDecay+12
INDIRI4
CNSTI4 0
EQI4 $426
line 597
;594:						int		t;
;595:						float	f;
;596:
;597:						t = cg.time - cg.predictedErrorTime;
ADDRLP4 792
ADDRGP4 cg+105552
INDIRI4
ADDRGP4 cg+106700
INDIRI4
SUBI4
ASGNI4
line 598
;598:						f = ( cg_errorDecay.value - t ) / cg_errorDecay.value;
ADDRLP4 788
ADDRGP4 cg_errorDecay+8
INDIRF4
ADDRLP4 792
INDIRI4
CVIF4 4
SUBF4
ADDRGP4 cg_errorDecay+8
INDIRF4
DIVF4
ASGNF4
line 599
;599:						if ( f < 0 ) {
ADDRLP4 788
INDIRF4
CNSTF4 0
GEF4 $433
line 600
;600:							f = 0;
ADDRLP4 788
CNSTF4 0
ASGNF4
line 601
;601:						}
LABELV $433
line 602
;602:						if ( f > 0 && cg_showmiss.integer ) {
ADDRLP4 788
INDIRF4
CNSTF4 0
LEF4 $435
ADDRGP4 cg_showmiss+12
INDIRI4
CNSTI4 0
EQI4 $435
line 603
;603:							CG_Printf("Double prediction decay: %f\n", f);
ADDRGP4 $438
ARGP4
ADDRLP4 788
INDIRF4
ARGF4
ADDRGP4 CG_Printf
CALLV
pop
line 604
;604:						}
LABELV $435
line 605
;605:						VectorScale( cg.predictedError, f, cg.predictedError );
ADDRGP4 cg+106704
ADDRGP4 cg+106704
INDIRF4
ADDRLP4 788
INDIRF4
MULF4
ASGNF4
ADDRGP4 cg+106704+4
ADDRGP4 cg+106704+4
INDIRF4
ADDRLP4 788
INDIRF4
MULF4
ASGNF4
ADDRGP4 cg+106704+8
ADDRGP4 cg+106704+8
INDIRF4
ADDRLP4 788
INDIRF4
MULF4
ASGNF4
line 606
;606:					} else {
ADDRGP4 $427
JUMPV
LABELV $426
line 607
;607:						VectorClear( cg.predictedError );
ADDRLP4 788
CNSTF4 0
ASGNF4
ADDRGP4 cg+106704+8
ADDRLP4 788
INDIRF4
ASGNF4
ADDRGP4 cg+106704+4
ADDRLP4 788
INDIRF4
ASGNF4
ADDRGP4 cg+106704
ADDRLP4 788
INDIRF4
ASGNF4
line 608
;608:					}
LABELV $427
line 609
;609:					VectorAdd( delta, cg.predictedError, cg.predictedError );
ADDRGP4 cg+106704
ADDRLP4 756
INDIRF4
ADDRGP4 cg+106704
INDIRF4
ADDF4
ASGNF4
ADDRGP4 cg+106704+4
ADDRLP4 756+4
INDIRF4
ADDRGP4 cg+106704+4
INDIRF4
ADDF4
ASGNF4
ADDRGP4 cg+106704+8
ADDRLP4 756+8
INDIRF4
ADDRGP4 cg+106704+8
INDIRF4
ADDF4
ASGNF4
line 610
;610:					cg.predictedErrorTime = cg.oldTime;
ADDRGP4 cg+106700
ADDRGP4 cg+105556
INDIRI4
ASGNI4
line 611
;611:				}
LABELV $420
line 612
;612:			}
LABELV $386
line 613
;613:		}
LABELV $382
line 616
;614:
;615:
;616:		Pmove (&cg_pmove);
ADDRGP4 cg_pmove
ARGP4
ADDRGP4 Pmove
CALLV
pop
line 618
;617:
;618:		moved = qtrue;
ADDRLP4 476
CNSTI4 1
ASGNI4
line 621
;619:
;620:		// add push trigger movement effects
;621:		CG_TouchTriggerPrediction();
ADDRGP4 CG_TouchTriggerPrediction
CALLV
pop
line 622
;622:	}
LABELV $356
line 539
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $358
ADDRLP4 0
INDIRI4
ADDRLP4 472
INDIRI4
LEI4 $355
line 624
;623:
;624:	if ( cg_showmiss.integer > 1 ) {
ADDRGP4 cg_showmiss+12
INDIRI4
CNSTI4 1
LEI4 $468
line 625
;625:		CG_Printf( "[%i : %i] ", cg_pmove.cmd.serverTime, cg.time );
ADDRGP4 $471
ARGP4
ADDRGP4 cg_pmove+4
INDIRI4
ARGI4
ADDRGP4 cg+105552
INDIRI4
ARGI4
ADDRGP4 CG_Printf
CALLV
pop
line 626
;626:	}
LABELV $468
line 628
;627:
;628:	if ( !moved ) {
ADDRLP4 476
INDIRI4
CNSTI4 0
NEI4 $474
line 629
;629:		if ( cg_showmiss.integer ) {
ADDRGP4 cg_showmiss+12
INDIRI4
CNSTI4 0
EQI4 $281
line 630
;630:			CG_Printf( "not moved\n" );
ADDRGP4 $479
ARGP4
ADDRGP4 CG_Printf
CALLV
pop
line 631
;631:		}
line 632
;632:		return;
ADDRGP4 $281
JUMPV
LABELV $474
line 636
;633:	}
;634:
;635:	// adjust for the movement of the groundentity
;636:	CG_AdjustPositionForMover( cg.predictedPlayerState.origin, 
ADDRGP4 cg+105580+20
ARGP4
ADDRGP4 cg+105580+80
INDIRI4
ARGI4
ADDRGP4 cg+105560
INDIRI4
ARGI4
ADDRGP4 cg+105552
INDIRI4
ARGI4
ADDRGP4 cg+105580+20
ARGP4
ADDRGP4 CG_AdjustPositionForMover
CALLV
pop
line 640
;637:		cg.predictedPlayerState.groundEntityNum, 
;638:		cg.physicsTime, cg.time, cg.predictedPlayerState.origin );
;639:
;640:	if ( cg_showmiss.integer ) {
ADDRGP4 cg_showmiss+12
INDIRI4
CNSTI4 0
EQI4 $488
line 641
;641:		if (cg.predictedPlayerState.eventSequence > oldPlayerState.eventSequence + MAX_PS_EVENTS) {
ADDRGP4 cg+105580+108
INDIRI4
ADDRLP4 4+108
INDIRI4
CNSTI4 4
ADDI4
LEI4 $491
line 642
;642:			CG_Printf("WARNING: dropped event\n");
ADDRGP4 $496
ARGP4
ADDRGP4 CG_Printf
CALLV
pop
line 643
;643:		}
LABELV $491
line 644
;644:	}
LABELV $488
line 647
;645:
;646:	// fire events and other transition triggered things
;647:	CG_TransitionPlayerState( &cg.predictedPlayerState, &oldPlayerState );
ADDRGP4 cg+105580
ARGP4
ADDRLP4 4
ARGP4
ADDRGP4 CG_TransitionPlayerState
CALLV
pop
line 656
;648:
;649:/*	if ( cg_showmiss.integer ) {
;650:		if (cg.eventSequence > cg.predictedPlayerState.eventSequence) {
;651:			CG_Printf("WARNING: double event\n");
;652:			cg.eventSequence = cg.predictedPlayerState.eventSequence;
;653:		}
;654:	}
;655:*/
;656:}
LABELV $281
endproc CG_PredictPlayerState 796 20
bss
align 4
LABELV cg_triggerEntities
skip 1024
align 4
LABELV cg_numTriggerEntities
skip 4
align 4
LABELV cg_solidEntities
skip 1024
align 4
LABELV cg_numSolidEntities
skip 4
align 4
LABELV cg_pmove
skip 224
import trap_MemoryRemaining
import testPrintFloat
import testPrintInt
import trap_SetUserCmdValue
import trap_GetUserCmd
import trap_GetCurrentCmdNumber
import trap_GetServerCommand
import trap_GetSnapshot
import trap_GetCurrentSnapshotNumber
import trap_GetGameState
import trap_GetGlconfig
import trap_R_LerpTag
import trap_R_ModelBounds
import trap_R_DrawStretchPic
import trap_R_SetColor
import trap_R_RenderScene
import trap_R_AddLightToScene
import trap_R_AddPolyToScene
import trap_R_AddRefEntityToScene
import trap_R_ClearScene
import trap_R_RegisterShaderNoMip
import trap_R_RegisterShader3D
import trap_R_RegisterShader
import trap_R_RegisterSkin
import trap_R_RegisterModel
import trap_R_LoadWorldMap
import trap_S_StartBackgroundTrack
import trap_S_RegisterSound
import trap_S_Respatialize
import trap_S_UpdateEntityPosition
import trap_S_AddLoopingSound
import trap_S_ClearLoopingSounds
import trap_S_StartLocalSound
import trap_S_StartSound
import trap_CM_MarkFragments
import trap_CM_TransformedBoxTrace
import trap_CM_BoxTrace
import trap_CM_TransformedPointContents
import trap_CM_PointContents
import trap_CM_TempBoxModel
import trap_CM_InlineModel
import trap_CM_NumInlineModels
import trap_CM_LoadMap
import trap_UpdateScreen
import trap_SendClientCommand
import trap_AddCommand
import trap_SendConsoleCommand
import trap_FS_FCloseFile
import trap_FS_Write
import trap_FS_Read
import trap_FS_FOpenFile
import trap_Args
import trap_Argv
import trap_Argc
import trap_Cvar_VariableStringBuffer
import trap_Cvar_Set_No_Modify
import trap_Cvar_Set
import trap_Cvar_Update
import trap_Cvar_Register
import trap_Milliseconds
import trap_Error
import trap_Print
import updateSkin
import CG_TransitionPlayerState
import CG_Respawn
import CG_SetConfigValues
import CG_ParseServerinfo
import CG_ExecuteNewServerCommands
import CG_InitConsoleCommands
import CG_ConsoleCommand
import AW_SPPostgameMenu_f
import cg_medalStreakSounds
import cg_medalStreakPicNames
import cg_medalTeamSounds
import cg_medalTeamPicNames
import cg_medalSounds
import cg_medalPicNames
import CG_DrawTourneyScoreboard
import CG_DrawScoreboard
import CG_DrawInformation
import CG_LoadingClient
import CG_LoadingItem
import CG_LoadingString
import CG_ProcessSnapshots
import CG_ExplosionEffects
import CG_SurfaceExplosion
import CG_MakeExplosion2
import CG_MakeExplosion
import CG_Seeker
import CG_Bleed
import CG_SpawnEffect
import CG_BubbleTrail
import CG_SmokePuff
import CG_AddLocalEntities
import CG_GetActiveList
import CG_AllocLocalEntity
import CG_InitLocalEntities
import CG_ImpactMark
import CG_AddMarks
import CG_InitMarkPolys
import CG_BounceEffect
import CG_OutOfAmmoChange
import CG_DrawWeaponSelect
import CG_AddPlayerWeapon
import CG_AddViewWeapon
import CG_MissileHitPlayer
import CG_MissileHitWall
import CG_FireSeeker
import CG_FireWeapon
import CG_RegisterItemVisuals
import CG_RegisterWeapon
import CG_Weapon_f
import CG_PrevWeapon_f
import CG_NextWeapon_f
import CG_Chunks
import CG_Drip
import CG_TransporterPad
import CG_Bolt
import CG_Steam
import CG_Spark
import CG_PositionRotatedEntityOnTag
import CG_PositionEntityOnTag
import CG_AdjustPositionForMover
import CG_Beam
import CG_AddPacketEntities
import CG_SetEntitySoundPosition
import CG_PainEvent
import CG_EntityEvent
import CG_PlaceString
import CG_CheckEvents
import CG_LoadDeferredPlayers
import CG_CustomSound
import CG_NewClientInfo
import CG_AddRefEntityWithPowerups
import CG_ResetPlayerEntity
import CG_Player
import CG_PlayerShieldHit
import CG_DrawObjectiveInformation
import CG_DrawNumField
import CG_DrawTeamBackground
import CG_DrawFlagModel
import CG_DrawActive
import CG_DrawHead
import CG_CenterPrint
import CG_AddLagometerSnapshotInfo
import CG_AddLagometerFrameInfo
import drawTeamOverlayModificationCount
import numSortedTeamPlayers
import sortedTeamPlayers
import interface_graphics
import UI_ProportionalStringWidth
import CG_GetColorForHealth
import CG_ColorForHealth
import CG_TileClear
import CG_TeamColor
import CG_FadeColor
import CG_DrawStrlen
import CG_DrawSmallStringColor
import CG_DrawSmallString
import CG_DrawBigStringColor
import CG_DrawBigString
import CG_DrawStringExt
import CG_LoadFonts
import UI_DrawProportionalString
import CG_DrawString
import CG_DrawPic
import CG_FillRect
import CG_AdjustFrom640
import CG_PrintInterfaceGraphics
import CG_DrawActiveFrame
import CG_CameraShake
import CG_ZoomUp_f
import CG_ZoomDown_f
import CG_TestModelPrevSkin_f
import CG_TestModelNextSkin_f
import CG_TestModelPrevFrame_f
import CG_TestModelNextFrame_f
import CG_TestGun_f
import CG_TestModel_f
import CG_LastAttacker
import CG_CrosshairPlayer
import CG_UpdateCvars
import CG_StartMusic
import CG_Error
import CG_Printf
import CG_Argv
import CG_ConfigString
import cg_deferPlayers
import cg_predictItems
import cg_blood
import cg_paused
import cg_buildScript
import cg_forceModel
import cg_reportDamage
import cg_stats
import cg_teamChatHeight
import cg_teamChatTime
import cg_synchronousClients
import cg_drawAttacker
import cg_lagometer
import cg_stereoSeparation
import cg_thirdPerson
import cg_thirdPersonAngle
import cg_thirdPersonRange
import cg_zoomFov
import cg_fov
import cg_simpleItems
import cg_ignore
import cg_autoswitch
import cg_viewsize
import cg_drawGun
import cg_gun_z
import cg_gun_y
import cg_gun_x
import cg_gun_frame
import cg_addMarks
import cg_footsteps
import cg_showmiss
import cg_noPlayerAnims
import cg_nopredict
import cg_errorDecay
import cg_debugEvents
import cg_debugPosition
import cg_debugAnim
import cg_animSpeed
import cg_draw2D
import cg_drawStatus
import cg_crosshairHealth
import cg_crosshairSize
import cg_crosshairY
import cg_crosshairX
import cg_teamOverlayUserinfo
import cg_drawTeamOverlay
import cg_drawRewards
import cg_drawCrosshairNames
import cg_drawCrosshair
import cg_drawAmmoWarning
import cg_drawIcons
import cg_draw3dIcons
import cg_drawSnapshot
import cg_drawFPS
import cg_drawTimer
import cg_gibs
import cg_shadows
import cg_swingSpeed
import cg_bobroll
import cg_bobpitch
import cg_bobup
import cg_runroll
import cg_runpitch
import cg_centertime
import cg_markPolys
import cg_items
import cg_weapons
import cg_entities
import cg
import cgs
import CG_AddElectricity
import CG_AddCylinder
import CG_AddBezier
import CG_AddViewSprite
import CG_AddTrail
import CG_AddLine2
import CG_AddOLine
import CG_AddLine
import CG_AddQuad
import CG_AddScaleFadeSprite
import CG_AddSpriteExplosion
import CG_AddExplosion
import CG_AddFallScaleFade
import CG_AddScaleFade
import CG_AddMoveScaleFade
import Max_Ammo
import BG_PlayerTouchesItem
import BG_PlayerStateToEntityState
import BG_AddPredictableEventToPlayerstate
import BG_EvaluateTrajectoryDelta
import BG_EvaluateTrajectory
import BG_CanItemBeGrabbed
import BG_FindItemForHoldable
import BG_FindItemForPowerup
import BG_FindItemForAmmo
import BG_FindItemForWeapon
import BG_FindItem
import BG_FindClassnameForHoldable
import BG_FindItemWithClassname
import bg_numItems
import bg_itemlist
import Pmove
import PM_UpdateViewAngles
import Com_Printf
import Com_Error
import Info_NextPair
import Info_Validate
import Info_SetValueForKey_Big
import Info_SetValueForKey
import Info_RemoveKey_big
import Info_RemoveKey
import Info_ValueForKey
import va
import Swap_Init
import BigFloat
import BigLong
import BigShort
import Q_CleanStr
import Q_PrintStrlen
import Q_strcat
import Q_strncpyz
import Q_strrchr
import Q_strupr
import Q_strlwr
import Q_stricmpn
import Q_strncmp
import Q_stricmp
import Q_isalpha
import Q_isupper
import Q_islower
import Q_isprint
import Com_sprintf
import Parse3DMatrix
import Parse2DMatrix
import Parse1DMatrix
import SkipRestOfLine
import SkipBracedSection
import COM_MatchToken
import COM_ParseExt
import COM_Parse
import COM_GetCurrentParseLine
import COM_BeginParseSession
import COM_DefaultExtension
import COM_StripExtension
import COM_SkipPath
import Com_Clamp
import UnVectorShort
import VectorShort
import PerpendicularVector
import AngleVectors
import MatrixMultiply
import PlaneTypeForNormal
import MakeNormalVectors
import RotateAroundDirection
import RotatePointAroundVector
import ProjectPointOnPlane
import PlaneFromPoints
import AngleDelta
import AngleNormalize180
import AngleNormalize360
import AnglesSubtract
import AngleSubtract
import LerpAngle
import AngleMod
import BoxOnPlaneSide
import SetPlaneSignbits
import AxisCopy
import AxisClear
import AnglesToAxis
import vectoangles
import irandom
import flrandom
import Q_crandom
import Q_random
import Q_rand
import Q_log2
import VectorRotate
import Vector4Scale
import VectorInverse
import VectorNormalize2
import VectorNormalizeFast
import VectorNormalize
import CrossProduct
import DistanceSquared
import Distance
import VectorLengthSquared
import VectorLength
import VectorCompare
import AddPointToBounds
import ClearBounds
import RadiusFromBounds
import NormalizeColor
import ColorBytes4
import ColorBytes3
import _VectorMA
import _VectorScale
import _VectorCopy
import _VectorAdd
import _VectorSubtract
import _DotProduct
import ByteToDir
import DirToByte
import ClampShort
import ClampChar
import Q_rsqrt
import Q_fabs
import axisDefault
import vec3_origin
import g_color_table
import colorDkGrey
import colorMdGrey
import colorLtGrey
import colorWhite
import colorCyan
import colorMagenta
import colorYellow
import colorBlue
import colorGreen
import colorRed
import colorBlack
import colorTable
import bytedirs
import fabs
import abs
import tan
import atan2
import cos
import sin
import sqrt
import floor
import ceil
import memcpy
import memset
import memmove
import sscanf
import vsprintf
import _atoi
import atoi
import _atof
import atof
import toupper
import tolower
import strncpy
import strstr
import strchr
import strcmp
import strcpy
import strcat
import strlen
import rand
import srand
import qsort
lit
align 1
LABELV $496
byte 1 87
byte 1 65
byte 1 82
byte 1 78
byte 1 73
byte 1 78
byte 1 71
byte 1 58
byte 1 32
byte 1 100
byte 1 114
byte 1 111
byte 1 112
byte 1 112
byte 1 101
byte 1 100
byte 1 32
byte 1 101
byte 1 118
byte 1 101
byte 1 110
byte 1 116
byte 1 10
byte 1 0
align 1
LABELV $479
byte 1 110
byte 1 111
byte 1 116
byte 1 32
byte 1 109
byte 1 111
byte 1 118
byte 1 101
byte 1 100
byte 1 10
byte 1 0
align 1
LABELV $471
byte 1 91
byte 1 37
byte 1 105
byte 1 32
byte 1 58
byte 1 32
byte 1 37
byte 1 105
byte 1 93
byte 1 32
byte 1 0
align 1
LABELV $438
byte 1 68
byte 1 111
byte 1 117
byte 1 98
byte 1 108
byte 1 101
byte 1 32
byte 1 112
byte 1 114
byte 1 101
byte 1 100
byte 1 105
byte 1 99
byte 1 116
byte 1 105
byte 1 111
byte 1 110
byte 1 32
byte 1 100
byte 1 101
byte 1 99
byte 1 97
byte 1 121
byte 1 58
byte 1 32
byte 1 37
byte 1 102
byte 1 10
byte 1 0
align 1
LABELV $425
byte 1 80
byte 1 114
byte 1 101
byte 1 100
byte 1 105
byte 1 99
byte 1 116
byte 1 105
byte 1 111
byte 1 110
byte 1 32
byte 1 109
byte 1 105
byte 1 115
byte 1 115
byte 1 58
byte 1 32
byte 1 37
byte 1 102
byte 1 10
byte 1 0
align 1
LABELV $410
byte 1 112
byte 1 114
byte 1 101
byte 1 100
byte 1 105
byte 1 99
byte 1 116
byte 1 105
byte 1 111
byte 1 110
byte 1 32
byte 1 101
byte 1 114
byte 1 114
byte 1 111
byte 1 114
byte 1 10
byte 1 0
align 1
LABELV $396
byte 1 80
byte 1 114
byte 1 101
byte 1 100
byte 1 105
byte 1 99
byte 1 116
byte 1 105
byte 1 111
byte 1 110
byte 1 84
byte 1 101
byte 1 108
byte 1 101
byte 1 112
byte 1 111
byte 1 114
byte 1 116
byte 1 10
byte 1 0
align 1
LABELV $341
byte 1 101
byte 1 120
byte 1 99
byte 1 101
byte 1 101
byte 1 100
byte 1 101
byte 1 100
byte 1 32
byte 1 80
byte 1 65
byte 1 67
byte 1 75
byte 1 69
byte 1 84
byte 1 95
byte 1 66
byte 1 65
byte 1 67
byte 1 75
byte 1 85
byte 1 80
byte 1 32
byte 1 111
byte 1 110
byte 1 32
byte 1 99
byte 1 111
byte 1 109
byte 1 109
byte 1 97
byte 1 110
byte 1 100
byte 1 115
byte 1 10
byte 1 0
align 1
LABELV $289
byte 1 37
byte 1 115
byte 1 47
byte 1 37
byte 1 115
byte 1 0
