export CG_InitLocalEntities
code
proc CG_InitLocalEntities 12 12
file "../cg_localents.c"
line 21
;1:// Copyright (C) 1999-2000 Id Software, Inc.
;2://
;3:
;4:// cg_localents.c -- every frame, generate renderer commands for locally
;5:// processed entities, like smoke puffs, gibs, shells, etc.
;6:
;7:#include "cg_local.h"
;8:
;9:#define	MAX_LOCAL_ENTITIES	512
;10:localEntity_t	cg_localEntities[MAX_LOCAL_ENTITIES];
;11:localEntity_t	cg_activeLocalEntities;		// double linked list
;12:localEntity_t	*cg_freeLocalEntities;		// single linked list
;13:
;14:/*
;15:===================
;16:CG_InitLocalEntities
;17:
;18:This is called at startup and for tournement restarts
;19:===================
;20:*/
;21:void	CG_InitLocalEntities( void ) {
line 24
;22:	int		i;
;23:
;24:	memset( cg_localEntities, 0, sizeof( cg_localEntities ) );
ADDRGP4 cg_localEntities
ARGP4
CNSTI4 0
ARGI4
CNSTI4 208896
ARGI4
ADDRGP4 memset
CALLP4
pop
line 25
;25:	cg_activeLocalEntities.next = &cg_activeLocalEntities;
ADDRGP4 cg_activeLocalEntities+4
ADDRGP4 cg_activeLocalEntities
ASGNP4
line 26
;26:	cg_activeLocalEntities.prev = &cg_activeLocalEntities;
ADDRLP4 4
ADDRGP4 cg_activeLocalEntities
ASGNP4
ADDRLP4 4
INDIRP4
ADDRLP4 4
INDIRP4
ASGNP4
line 27
;27:	cg_freeLocalEntities = cg_localEntities;
ADDRGP4 cg_freeLocalEntities
ADDRGP4 cg_localEntities
ASGNP4
line 28
;28:	for ( i = 0 ; i < MAX_LOCAL_ENTITIES - 1 ; i++ ) {
ADDRLP4 0
CNSTI4 0
ASGNI4
LABELV $88
line 29
;29:		cg_localEntities[i].next = &cg_localEntities[i+1];
ADDRLP4 8
CNSTI4 408
ADDRLP4 0
INDIRI4
MULI4
ASGNI4
ADDRLP4 8
INDIRI4
ADDRGP4 cg_localEntities+4
ADDP4
ADDRLP4 8
INDIRI4
ADDRGP4 cg_localEntities+408
ADDP4
ASGNP4
line 30
;30:	}
LABELV $89
line 28
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
ADDRLP4 0
INDIRI4
CNSTI4 511
LTI4 $88
line 31
;31:}
LABELV $86
endproc CG_InitLocalEntities 12 12
export CG_FreeLocalEntity
proc CG_FreeLocalEntity 12 4
line 39
;32:
;33:
;34:/*
;35:==================
;36:CG_FreeLocalEntity
;37:==================
;38:*/
;39:void CG_FreeLocalEntity( localEntity_t *le ) {
line 40
;40:	if ( !le->prev ) {
ADDRFP4 0
INDIRP4
INDIRP4
CVPU4 4
CNSTU4 0
NEU4 $95
line 41
;41:		CG_Error( "CG_FreeLocalEntity: not active" );
ADDRGP4 $97
ARGP4
ADDRGP4 CG_Error
CALLV
pop
line 42
;42:	}
LABELV $95
line 45
;43:
;44:	// remove from the doubly linked active list
;45:	le->prev->next = le->next;
ADDRLP4 0
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 4
CNSTI4 4
ASGNI4
ADDRLP4 0
INDIRP4
INDIRP4
ADDRLP4 4
INDIRI4
ADDP4
ADDRLP4 0
INDIRP4
ADDRLP4 4
INDIRI4
ADDP4
INDIRP4
ASGNP4
line 46
;46:	le->next->prev = le->prev;
ADDRLP4 8
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 8
INDIRP4
CNSTI4 4
ADDP4
INDIRP4
ADDRLP4 8
INDIRP4
INDIRP4
ASGNP4
line 49
;47:
;48:	// the free list is only singly linked
;49:	le->next = cg_freeLocalEntities;
ADDRFP4 0
INDIRP4
CNSTI4 4
ADDP4
ADDRGP4 cg_freeLocalEntities
INDIRP4
ASGNP4
line 50
;50:	cg_freeLocalEntities = le;
ADDRGP4 cg_freeLocalEntities
ADDRFP4 0
INDIRP4
ASGNP4
line 51
;51:}
LABELV $94
endproc CG_FreeLocalEntity 12 4
export CG_AllocLocalEntity
proc CG_AllocLocalEntity 8 12
line 60
;52:
;53:/*
;54:===================
;55:CG_AllocLocalEntity
;56:
;57:Will allways succeed, even if it requires freeing an old active entity
;58:===================
;59:*/
;60:localEntity_t	*CG_AllocLocalEntity( void ) {
line 63
;61:	localEntity_t	*le;
;62:
;63:	if ( !cg_freeLocalEntities ) {
ADDRGP4 cg_freeLocalEntities
INDIRP4
CVPU4 4
CNSTU4 0
NEU4 $99
line 66
;64:		// no free entities, so free the one at the end of the chain
;65:		// remove the oldest active entity
;66:		CG_FreeLocalEntity( cg_activeLocalEntities.prev );
ADDRGP4 cg_activeLocalEntities
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 67
;67:	}
LABELV $99
line 69
;68:
;69:	le = cg_freeLocalEntities;
ADDRLP4 0
ADDRGP4 cg_freeLocalEntities
INDIRP4
ASGNP4
line 70
;70:	cg_freeLocalEntities = cg_freeLocalEntities->next;
ADDRLP4 4
ADDRGP4 cg_freeLocalEntities
ASGNP4
ADDRLP4 4
INDIRP4
ADDRLP4 4
INDIRP4
INDIRP4
CNSTI4 4
ADDP4
INDIRP4
ASGNP4
line 72
;71:
;72:	memset( le, 0, sizeof( *le ) );
ADDRLP4 0
INDIRP4
ARGP4
CNSTI4 0
ARGI4
CNSTI4 408
ARGI4
ADDRGP4 memset
CALLP4
pop
line 75
;73:
;74:	// link into the active list
;75:	le->next = cg_activeLocalEntities.next;
ADDRLP4 0
INDIRP4
CNSTI4 4
ADDP4
ADDRGP4 cg_activeLocalEntities+4
INDIRP4
ASGNP4
line 76
;76:	le->prev = &cg_activeLocalEntities;
ADDRLP4 0
INDIRP4
ADDRGP4 cg_activeLocalEntities
ASGNP4
line 77
;77:	cg_activeLocalEntities.next->prev = le;
ADDRGP4 cg_activeLocalEntities+4
INDIRP4
ADDRLP4 0
INDIRP4
ASGNP4
line 78
;78:	cg_activeLocalEntities.next = le;
ADDRGP4 cg_activeLocalEntities+4
ADDRLP4 0
INDIRP4
ASGNP4
line 79
;79:	return le;
ADDRLP4 0
INDIRP4
RETP4
LABELV $98
endproc CG_AllocLocalEntity 8 12
export CG_GetActiveList
proc CG_GetActiveList 0 0
line 89
;80:}
;81:
;82:/*
;83:==================
;84:CG_GetActiveList
;85:Accessor fn
;86:==================
;87:*/
;88:localEntity_t	CG_GetActiveList( void )
;89:{
line 90
;90:	return cg_activeLocalEntities;
ADDRFP4 0
INDIRP4
ADDRGP4 cg_activeLocalEntities
INDIRB
ASGNB 408
LABELV $104
endproc CG_GetActiveList 0 0
export CG_ReflectVelocity
proc CG_ReflectVelocity 56 12
line 110
;91:}
;92:
;93:/*
;94:====================================================================================
;95:
;96:FRAGMENT PROCESSING
;97:
;98:A fragment localentity interacts with the environment in some way (hitting walls),
;99:or generates more localentities along a trail.
;100:
;101:====================================================================================
;102:*/
;103:
;104:
;105:/*
;106:================
;107:CG_ReflectVelocity
;108:================
;109:*/
;110:void CG_ReflectVelocity( localEntity_t *le, trace_t *trace ) {
line 116
;111:	vec3_t	velocity;
;112:	float	dot;
;113:	int		hitTime;
;114:
;115:	// reflect the velocity on the trace plane
;116:	hitTime = cg.time - cg.frametime + cg.frametime * trace->fraction;
ADDRLP4 16
ADDRGP4 cg+105552
INDIRI4
ADDRGP4 cg+105548
INDIRI4
SUBI4
CVIF4 4
ADDRGP4 cg+105548
INDIRI4
CVIF4 4
ADDRFP4 4
INDIRP4
CNSTI4 8
ADDP4
INDIRF4
MULF4
ADDF4
CVFI4 4
ASGNI4
line 117
;117:	BG_EvaluateTrajectoryDelta( &le->pos, hitTime, velocity );
ADDRFP4 0
INDIRP4
CNSTI4 28
ADDP4
ARGP4
ADDRLP4 16
INDIRI4
ARGI4
ADDRLP4 0
ARGP4
ADDRGP4 BG_EvaluateTrajectoryDelta
CALLV
pop
line 118
;118:	dot = DotProduct( velocity, trace->plane.normal );
ADDRLP4 20
ADDRFP4 4
INDIRP4
ASGNP4
ADDRLP4 12
ADDRLP4 0
INDIRF4
ADDRLP4 20
INDIRP4
CNSTI4 24
ADDP4
INDIRF4
MULF4
ADDRLP4 0+4
INDIRF4
ADDRLP4 20
INDIRP4
CNSTI4 28
ADDP4
INDIRF4
MULF4
ADDF4
ADDRLP4 0+8
INDIRF4
ADDRLP4 20
INDIRP4
CNSTI4 32
ADDP4
INDIRF4
MULF4
ADDF4
ASGNF4
line 119
;119:	VectorMA( velocity, -2*dot, trace->plane.normal, le->pos.trDelta );
ADDRFP4 0
INDIRP4
CNSTI4 52
ADDP4
ADDRLP4 0
INDIRF4
ADDRFP4 4
INDIRP4
CNSTI4 24
ADDP4
INDIRF4
CNSTF4 3221225472
ADDRLP4 12
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
ADDRFP4 0
INDIRP4
CNSTI4 56
ADDP4
ADDRLP4 0+4
INDIRF4
ADDRFP4 4
INDIRP4
CNSTI4 28
ADDP4
INDIRF4
CNSTF4 3221225472
ADDRLP4 12
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
ADDRFP4 0
INDIRP4
CNSTI4 60
ADDP4
ADDRLP4 0+8
INDIRF4
ADDRFP4 4
INDIRP4
CNSTI4 32
ADDP4
INDIRF4
CNSTF4 3221225472
ADDRLP4 12
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
line 121
;120:
;121:	VectorScale( le->pos.trDelta, le->bounceFactor, le->pos.trDelta );
ADDRLP4 24
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 28
ADDRLP4 24
INDIRP4
CNSTI4 52
ADDP4
ASGNP4
ADDRLP4 28
INDIRP4
ADDRLP4 28
INDIRP4
INDIRF4
ADDRLP4 24
INDIRP4
CNSTI4 100
ADDP4
INDIRF4
MULF4
ASGNF4
ADDRLP4 32
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 36
ADDRLP4 32
INDIRP4
CNSTI4 56
ADDP4
ASGNP4
ADDRLP4 36
INDIRP4
ADDRLP4 36
INDIRP4
INDIRF4
ADDRLP4 32
INDIRP4
CNSTI4 100
ADDP4
INDIRF4
MULF4
ASGNF4
ADDRLP4 40
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 44
ADDRLP4 40
INDIRP4
CNSTI4 60
ADDP4
ASGNP4
ADDRLP4 44
INDIRP4
ADDRLP4 44
INDIRP4
INDIRF4
ADDRLP4 40
INDIRP4
CNSTI4 100
ADDP4
INDIRF4
MULF4
ASGNF4
line 123
;122:
;123:	VectorCopy( trace->endpos, le->pos.trBase );
ADDRFP4 0
INDIRP4
CNSTI4 40
ADDP4
ADDRFP4 4
INDIRP4
CNSTI4 12
ADDP4
INDIRB
ASGNB 12
line 124
;124:	le->pos.trTime = cg.time;
ADDRFP4 0
INDIRP4
CNSTI4 32
ADDP4
ADDRGP4 cg+105552
INDIRI4
ASGNI4
line 128
;125:
;126:
;127:	// check for stop, making sure that even on low FPS systems it doesn't bobble
;128:	if ( trace->allsolid || 
ADDRLP4 48
ADDRFP4 4
INDIRP4
ASGNP4
ADDRLP4 48
INDIRP4
INDIRI4
CNSTI4 0
NEI4 $119
ADDRLP4 48
INDIRP4
CNSTI4 32
ADDP4
INDIRF4
CNSTF4 0
LEF4 $115
ADDRLP4 52
ADDRFP4 0
INDIRP4
CNSTI4 60
ADDP4
INDIRF4
ASGNF4
ADDRLP4 52
INDIRF4
CNSTF4 1109393408
LTF4 $119
ADDRLP4 52
INDIRF4
ADDRGP4 cg+105548
INDIRI4
NEGI4
CVIF4 4
ADDRLP4 52
INDIRF4
MULF4
GEF4 $115
LABELV $119
line 130
;129:		( trace->plane.normal[2] > 0 && 
;130:		( le->pos.trDelta[2] < 40 || le->pos.trDelta[2] < -cg.frametime * le->pos.trDelta[2] ) ) ) {
line 131
;131:		le->pos.trType = TR_STATIONARY;
ADDRFP4 0
INDIRP4
CNSTI4 28
ADDP4
CNSTI4 0
ASGNI4
line 132
;132:	} else {
LABELV $115
line 134
;133:
;134:	}
LABELV $116
line 135
;135:}
LABELV $106
endproc CG_ReflectVelocity 56 12
export CG_AddFadeRGB
proc CG_AddFadeRGB 60 4
line 151
;136:
;137:/*
;138:=====================================================================
;139:
;140:TRIVIAL LOCAL ENTITIES
;141:
;142:These only do simple scaling or modulation before passing to the renderer
;143:=====================================================================
;144:*/
;145:
;146:/*
;147:====================
;148:CG_AddFadeRGB
;149:====================
;150:*/
;151:void CG_AddFadeRGB( localEntity_t *le ) {
line 155
;152:	refEntity_t *re;
;153:	float c;
;154:
;155:	re = &le->refEntity;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 248
ADDP4
ASGNP4
line 157
;156:
;157:	c = ( le->endTime - cg.time ) * le->lifeRate;
ADDRLP4 8
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 4
ADDRLP4 8
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRGP4 cg+105552
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 8
INDIRP4
CNSTI4 24
ADDP4
INDIRF4
MULF4
ASGNF4
line 158
;158:	c *= 0xff;
ADDRLP4 4
CNSTF4 1132396544
ADDRLP4 4
INDIRF4
MULF4
ASGNF4
line 160
;159:
;160:	re->shaderRGBA[0] = le->color[0] * c;
ADDRLP4 16
ADDRFP4 0
INDIRP4
CNSTI4 104
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ASGNF4
ADDRLP4 20
CNSTF4 1325400064
ASGNF4
ADDRLP4 16
INDIRF4
ADDRLP4 20
INDIRF4
LTF4 $123
ADDRLP4 12
ADDRLP4 16
INDIRF4
ADDRLP4 20
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $124
JUMPV
LABELV $123
ADDRLP4 12
ADDRLP4 16
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $124
ADDRLP4 0
INDIRP4
CNSTI4 116
ADDP4
ADDRLP4 12
INDIRU4
CVUU1 4
ASGNU1
line 161
;161:	re->shaderRGBA[1] = le->color[1] * c;
ADDRLP4 28
ADDRFP4 0
INDIRP4
CNSTI4 108
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ASGNF4
ADDRLP4 32
CNSTF4 1325400064
ASGNF4
ADDRLP4 28
INDIRF4
ADDRLP4 32
INDIRF4
LTF4 $126
ADDRLP4 24
ADDRLP4 28
INDIRF4
ADDRLP4 32
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $127
JUMPV
LABELV $126
ADDRLP4 24
ADDRLP4 28
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $127
ADDRLP4 0
INDIRP4
CNSTI4 117
ADDP4
ADDRLP4 24
INDIRU4
CVUU1 4
ASGNU1
line 162
;162:	re->shaderRGBA[2] = le->color[2] * c;
ADDRLP4 40
ADDRFP4 0
INDIRP4
CNSTI4 112
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ASGNF4
ADDRLP4 44
CNSTF4 1325400064
ASGNF4
ADDRLP4 40
INDIRF4
ADDRLP4 44
INDIRF4
LTF4 $129
ADDRLP4 36
ADDRLP4 40
INDIRF4
ADDRLP4 44
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $130
JUMPV
LABELV $129
ADDRLP4 36
ADDRLP4 40
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $130
ADDRLP4 0
INDIRP4
CNSTI4 118
ADDP4
ADDRLP4 36
INDIRU4
CVUU1 4
ASGNU1
line 163
;163:	re->shaderRGBA[3] = le->color[3] * c;
ADDRLP4 52
ADDRFP4 0
INDIRP4
CNSTI4 116
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ASGNF4
ADDRLP4 56
CNSTF4 1325400064
ASGNF4
ADDRLP4 52
INDIRF4
ADDRLP4 56
INDIRF4
LTF4 $132
ADDRLP4 48
ADDRLP4 52
INDIRF4
ADDRLP4 56
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $133
JUMPV
LABELV $132
ADDRLP4 48
ADDRLP4 52
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $133
ADDRLP4 0
INDIRP4
CNSTI4 119
ADDP4
ADDRLP4 48
INDIRU4
CVUU1 4
ASGNU1
line 165
;164:
;165:	trap_R_AddRefEntityToScene( re );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 166
;166:}
LABELV $120
endproc CG_AddFadeRGB 60 4
export CG_AddMoveScaleFade
proc CG_AddMoveScaleFade 48 12
line 174
;167:
;168:/*
;169:==================
;170:CG_AddMoveScaleFade
;171:==================
;172:*/
;173:void CG_AddMoveScaleFade( localEntity_t *le )
;174:{
line 180
;175:	refEntity_t	*re;
;176:	float		c;
;177:	vec3_t		delta;
;178:	float		len;
;179:
;180:	re = &le->refEntity;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 248
ADDP4
ASGNP4
line 183
;181:
;182:	// fade / grow time
;183:	c = ( le->endTime - cg.time ) * le->lifeRate;
ADDRLP4 24
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 16
ADDRLP4 24
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRGP4 cg+105552
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 24
INDIRP4
CNSTI4 24
ADDP4
INDIRF4
MULF4
ASGNF4
line 185
;184:
;185:	re->shaderRGBA[3] = 0xff * c * le->color[3];
ADDRLP4 32
CNSTF4 1132396544
ADDRLP4 16
INDIRF4
MULF4
ADDRFP4 0
INDIRP4
CNSTI4 116
ADDP4
INDIRF4
MULF4
ASGNF4
ADDRLP4 36
CNSTF4 1325400064
ASGNF4
ADDRLP4 32
INDIRF4
ADDRLP4 36
INDIRF4
LTF4 $137
ADDRLP4 28
ADDRLP4 32
INDIRF4
ADDRLP4 36
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $138
JUMPV
LABELV $137
ADDRLP4 28
ADDRLP4 32
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $138
ADDRLP4 0
INDIRP4
CNSTI4 119
ADDP4
ADDRLP4 28
INDIRU4
CVUU1 4
ASGNU1
line 187
;186:
;187:	if ( !( le->leFlags & LEF_PUFF_DONT_SCALE ) ) {
ADDRFP4 0
INDIRP4
CNSTI4 12
ADDP4
INDIRI4
CNSTI4 1
BANDI4
CNSTI4 0
NEI4 $139
line 188
;188:		re->data.sprite.radius = le->data.sprite.radius * ( 1.0 - c ) + 8;
ADDRLP4 0
INDIRP4
CNSTI4 136
ADDP4
ADDRFP4 0
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
CNSTF4 1065353216
ADDRLP4 16
INDIRF4
SUBF4
MULF4
CNSTF4 1090519040
ADDF4
ASGNF4
line 189
;189:	}
LABELV $139
line 191
;190:
;191:	BG_EvaluateTrajectory( &le->pos, cg.time, re->origin );
ADDRFP4 0
INDIRP4
CNSTI4 28
ADDP4
ARGP4
ADDRGP4 cg+105552
INDIRI4
ARGI4
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
ARGP4
ADDRGP4 BG_EvaluateTrajectory
CALLV
pop
line 195
;192:
;193:	// if the view would be "inside" the sprite, kill the sprite
;194:	// so it doesn't add too much overdraw
;195:	VectorSubtract( re->origin, cg.refdef.vieworg, delta );
ADDRLP4 4
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
INDIRF4
ADDRGP4 cg+106840+24
INDIRF4
SUBF4
ASGNF4
ADDRLP4 4+4
ADDRLP4 0
INDIRP4
CNSTI4 72
ADDP4
INDIRF4
ADDRGP4 cg+106840+24+4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 4+8
ADDRLP4 0
INDIRP4
CNSTI4 76
ADDP4
INDIRF4
ADDRGP4 cg+106840+24+8
INDIRF4
SUBF4
ASGNF4
line 196
;196:	len = VectorLength( delta );
ADDRLP4 4
ARGP4
ADDRLP4 44
ADDRGP4 VectorLength
CALLF4
ASGNF4
ADDRLP4 20
ADDRLP4 44
INDIRF4
ASGNF4
line 197
;197:	if ( len < le->data.sprite.radius ) {
ADDRLP4 20
INDIRF4
ADDRFP4 0
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
GEF4 $152
line 198
;198:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 199
;199:		return;
ADDRGP4 $134
JUMPV
LABELV $152
line 202
;200:	}
;201:
;202:	trap_R_AddRefEntityToScene( re );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 203
;203:}
LABELV $134
endproc CG_AddMoveScaleFade 48 12
export CG_AddScaleFade
proc CG_AddScaleFade 48 4
line 216
;204:
;205:
;206:/*
;207:===================
;208:CG_AddScaleFade
;209:
;210:For rocket smokes that hang in place, fade out, and are
;211:removed if the view passes through them.
;212:There are often many of these, so it needs to be simple.
;213:===================
;214:*/
;215:void CG_AddScaleFade( localEntity_t *le )
;216:{
line 222
;217:	refEntity_t	*re;
;218:	float		c;
;219:	vec3_t		delta;
;220:	float		len;
;221:
;222:	re = &le->refEntity;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 248
ADDP4
ASGNP4
line 225
;223:
;224:	// fade / grow time
;225:	c = ( le->endTime - cg.time ) * le->lifeRate;
ADDRLP4 24
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 16
ADDRLP4 24
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRGP4 cg+105552
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 24
INDIRP4
CNSTI4 24
ADDP4
INDIRF4
MULF4
ASGNF4
line 227
;226:
;227:	re->shaderRGBA[3] = 0xff * c * le->color[3];
ADDRLP4 32
CNSTF4 1132396544
ADDRLP4 16
INDIRF4
MULF4
ADDRFP4 0
INDIRP4
CNSTI4 116
ADDP4
INDIRF4
MULF4
ASGNF4
ADDRLP4 36
CNSTF4 1325400064
ASGNF4
ADDRLP4 32
INDIRF4
ADDRLP4 36
INDIRF4
LTF4 $157
ADDRLP4 28
ADDRLP4 32
INDIRF4
ADDRLP4 36
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $158
JUMPV
LABELV $157
ADDRLP4 28
ADDRLP4 32
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $158
ADDRLP4 0
INDIRP4
CNSTI4 119
ADDP4
ADDRLP4 28
INDIRU4
CVUU1 4
ASGNU1
line 228
;228:	re->data.sprite.radius = le->data.sprite.radius * ( 1.0 - c ) + 8;
ADDRLP4 0
INDIRP4
CNSTI4 136
ADDP4
ADDRFP4 0
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
CNSTF4 1065353216
ADDRLP4 16
INDIRF4
SUBF4
MULF4
CNSTF4 1090519040
ADDF4
ASGNF4
line 232
;229:
;230:	// if the view would be "inside" the sprite, kill the sprite
;231:	// so it doesn't add too much overdraw
;232:	VectorSubtract( re->origin, cg.refdef.vieworg, delta );
ADDRLP4 4
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
INDIRF4
ADDRGP4 cg+106840+24
INDIRF4
SUBF4
ASGNF4
ADDRLP4 4+4
ADDRLP4 0
INDIRP4
CNSTI4 72
ADDP4
INDIRF4
ADDRGP4 cg+106840+24+4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 4+8
ADDRLP4 0
INDIRP4
CNSTI4 76
ADDP4
INDIRF4
ADDRGP4 cg+106840+24+8
INDIRF4
SUBF4
ASGNF4
line 233
;233:	len = VectorLength( delta );
ADDRLP4 4
ARGP4
ADDRLP4 44
ADDRGP4 VectorLength
CALLF4
ASGNF4
ADDRLP4 20
ADDRLP4 44
INDIRF4
ASGNF4
line 234
;234:	if ( len < le->data.sprite.radius ) {
ADDRLP4 20
INDIRF4
ADDRFP4 0
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
GEF4 $169
line 235
;235:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 236
;236:		return;
ADDRGP4 $154
JUMPV
LABELV $169
line 239
;237:	}
;238:
;239:	trap_R_AddRefEntityToScene( re );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 240
;240:}
LABELV $154
endproc CG_AddScaleFade 48 4
export CG_AddFallScaleFade
proc CG_AddFallScaleFade 52 4
line 254
;241:
;242:
;243:/*
;244:=================
;245:CG_AddFallScaleFade
;246:
;247:This is just an optimized CG_AddMoveScaleFade
;248:For blood mists that drift down, fade out, and are
;249:removed if the view passes through them.
;250:There are often 100+ of these, so it needs to be simple.
;251:=================
;252:*/
;253:void CG_AddFallScaleFade( localEntity_t *le )
;254:{
line 260
;255:	refEntity_t	*re;
;256:	float		c;
;257:	vec3_t		delta;
;258:	float		len;
;259:
;260:	re = &le->refEntity;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 248
ADDP4
ASGNP4
line 263
;261:
;262:	// fade time
;263:	c = ( le->endTime - cg.time ) * le->lifeRate;
ADDRLP4 24
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 4
ADDRLP4 24
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRGP4 cg+105552
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 24
INDIRP4
CNSTI4 24
ADDP4
INDIRF4
MULF4
ASGNF4
line 265
;264:
;265:	re->shaderRGBA[3] = 0xff * c * le->color[3];
ADDRLP4 32
CNSTF4 1132396544
ADDRLP4 4
INDIRF4
MULF4
ADDRFP4 0
INDIRP4
CNSTI4 116
ADDP4
INDIRF4
MULF4
ASGNF4
ADDRLP4 36
CNSTF4 1325400064
ASGNF4
ADDRLP4 32
INDIRF4
ADDRLP4 36
INDIRF4
LTF4 $174
ADDRLP4 28
ADDRLP4 32
INDIRF4
ADDRLP4 36
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $175
JUMPV
LABELV $174
ADDRLP4 28
ADDRLP4 32
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $175
ADDRLP4 0
INDIRP4
CNSTI4 119
ADDP4
ADDRLP4 28
INDIRU4
CVUU1 4
ASGNU1
line 267
;266:
;267:	re->origin[2] = le->pos.trBase[2] - ( 1.0 - c ) * le->pos.trDelta[2];
ADDRLP4 40
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 0
INDIRP4
CNSTI4 76
ADDP4
ADDRLP4 40
INDIRP4
CNSTI4 48
ADDP4
INDIRF4
CNSTF4 1065353216
ADDRLP4 4
INDIRF4
SUBF4
ADDRLP4 40
INDIRP4
CNSTI4 60
ADDP4
INDIRF4
MULF4
SUBF4
ASGNF4
line 269
;268:
;269:	re->data.sprite.radius = le->data.sprite.radius * ( 1.0 - c ) + 16;
ADDRLP4 0
INDIRP4
CNSTI4 136
ADDP4
ADDRFP4 0
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
CNSTF4 1065353216
ADDRLP4 4
INDIRF4
SUBF4
MULF4
CNSTF4 1098907648
ADDF4
ASGNF4
line 273
;270:
;271:	// if the view would be "inside" the sprite, kill the sprite
;272:	// so it doesn't add too much overdraw
;273:	VectorSubtract( re->origin, cg.refdef.vieworg, delta );
ADDRLP4 8
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
INDIRF4
ADDRGP4 cg+106840+24
INDIRF4
SUBF4
ASGNF4
ADDRLP4 8+4
ADDRLP4 0
INDIRP4
CNSTI4 72
ADDP4
INDIRF4
ADDRGP4 cg+106840+24+4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 8+8
ADDRLP4 0
INDIRP4
CNSTI4 76
ADDP4
INDIRF4
ADDRGP4 cg+106840+24+8
INDIRF4
SUBF4
ASGNF4
line 274
;274:	len = VectorLength( delta );
ADDRLP4 8
ARGP4
ADDRLP4 48
ADDRGP4 VectorLength
CALLF4
ASGNF4
ADDRLP4 20
ADDRLP4 48
INDIRF4
ASGNF4
line 275
;275:	if ( len < le->data.sprite.radius ) {
ADDRLP4 20
INDIRF4
ADDRFP4 0
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
GEF4 $186
line 276
;276:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 277
;277:		return;
ADDRGP4 $171
JUMPV
LABELV $186
line 280
;278:	}
;279:
;280:	trap_R_AddRefEntityToScene( re );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 281
;281:}
LABELV $171
endproc CG_AddFallScaleFade 52 4
export CG_AddExplosion
proc CG_AddExplosion 33 20
line 291
;282:
;283:
;284:
;285:/*
;286:================
;287:CG_AddExplosion
;288:================
;289:*/
;290:void CG_AddExplosion( localEntity_t *ex )
;291:{
line 294
;292:	refEntity_t	*ent;
;293:
;294:	ent = &ex->refEntity;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 248
ADDP4
ASGNP4
line 297
;295:
;296:	// calculate model frame
;297:	if ( ex->lifeRate > 0 ) {
ADDRFP4 0
INDIRP4
CNSTI4 24
ADDP4
INDIRF4
CNSTF4 0
LEF4 $189
line 298
;298:		float frac = (cg.time - ex->startTime) * ex->lifeRate;
ADDRLP4 12
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 8
ADDRGP4 cg+105552
INDIRI4
ADDRLP4 12
INDIRP4
CNSTI4 16
ADDP4
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 12
INDIRP4
CNSTI4 24
ADDP4
INDIRF4
MULF4
ASGNF4
line 299
;299:		int f = floor(frac);
ADDRLP4 8
INDIRF4
ARGF4
ADDRLP4 16
ADDRGP4 floor
CALLF4
ASGNF4
ADDRLP4 4
ADDRLP4 16
INDIRF4
CVFI4 4
ASGNI4
line 300
;300:		if ( f < 0 ) {
ADDRLP4 4
INDIRI4
CNSTI4 0
GEI4 $192
line 301
;301:			f = 0;
ADDRLP4 4
CNSTI4 0
ASGNI4
line 302
;302:		}
LABELV $192
line 304
;303:
;304:		ent->frame = f + 1;
ADDRLP4 0
INDIRP4
CNSTI4 80
ADDP4
ADDRLP4 4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
line 305
;305:		ent->oldframe = f;
ADDRLP4 0
INDIRP4
CNSTI4 96
ADDP4
ADDRLP4 4
INDIRI4
ASGNI4
line 306
;306:		ent->backlerp = 1.0 - ( frac - f );
ADDRLP4 0
INDIRP4
CNSTI4 100
ADDP4
CNSTF4 1065353216
ADDRLP4 8
INDIRF4
ADDRLP4 4
INDIRI4
CVIF4 4
SUBF4
SUBF4
ASGNF4
line 307
;307:		ent->renderfx |= RF_CAP_FRAMES;
ADDRLP4 20
ADDRLP4 0
INDIRP4
CNSTI4 4
ADDP4
ASGNP4
ADDRLP4 20
INDIRP4
ADDRLP4 20
INDIRP4
INDIRI4
CNSTI4 1024
BORI4
ASGNI4
line 308
;308:	}
LABELV $189
line 311
;309:	// Explosions with zero shaders (using model default shader) don't fade, so
;310:	//		allow fading when this flag is set.
;311:	if ( ex->leFlags & LEF_FADE_RGB )
ADDRFP4 0
INDIRP4
CNSTI4 12
ADDP4
INDIRI4
CNSTI4 64
BANDI4
CNSTI4 0
EQI4 $194
line 312
;312:	{
line 313
;313:		float frac = (float)( cg.time - ex->startTime )/(float)( ex->endTime - ex->startTime );
ADDRLP4 8
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 12
ADDRLP4 8
INDIRP4
CNSTI4 16
ADDP4
INDIRI4
ASGNI4
ADDRLP4 4
ADDRGP4 cg+105552
INDIRI4
ADDRLP4 12
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 8
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRLP4 12
INDIRI4
SUBI4
CVIF4 4
DIVF4
ASGNF4
line 315
;314:
;315:		ent->shaderRGBA[0] = 
ADDRLP4 20
CNSTF4 1132396544
ADDRLP4 4
INDIRF4
MULF4
ASGNF4
ADDRLP4 24
CNSTF4 1325400064
ASGNF4
ADDRLP4 20
INDIRF4
ADDRLP4 24
INDIRF4
LTF4 $198
ADDRLP4 16
ADDRLP4 20
INDIRF4
ADDRLP4 24
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $199
JUMPV
LABELV $198
ADDRLP4 16
ADDRLP4 20
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $199
ADDRLP4 32
ADDRLP4 16
INDIRU4
CVUU1 4
ASGNU1
ADDRLP4 0
INDIRP4
CNSTI4 118
ADDP4
ADDRLP4 32
INDIRU1
ASGNU1
ADDRLP4 0
INDIRP4
CNSTI4 117
ADDP4
ADDRLP4 32
INDIRU1
ASGNU1
ADDRLP4 0
INDIRP4
CNSTI4 116
ADDP4
ADDRLP4 32
INDIRU1
ASGNU1
line 318
;316:		ent->shaderRGBA[1] = 
;317:		ent->shaderRGBA[2] = frac * 255;
;318:		ent->shaderRGBA[3] = 255;
ADDRLP4 0
INDIRP4
CNSTI4 119
ADDP4
CNSTU1 255
ASGNU1
line 319
;319:	}
LABELV $194
line 322
;320:
;321:	// add the entity
;322:	trap_R_AddRefEntityToScene(ent);
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 325
;323:
;324:	// add the dlight
;325:	if ( ex->light ) {
ADDRFP4 0
INDIRP4
CNSTI4 148
ADDP4
INDIRF4
CNSTF4 0
EQF4 $200
line 328
;326:		float		light;
;327:
;328:		light = (float)( cg.time - ex->startTime ) / ( ex->endTime - ex->startTime );
ADDRLP4 8
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 12
ADDRLP4 8
INDIRP4
CNSTI4 16
ADDP4
INDIRI4
ASGNI4
ADDRLP4 4
ADDRGP4 cg+105552
INDIRI4
ADDRLP4 12
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 8
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRLP4 12
INDIRI4
SUBI4
CVIF4 4
DIVF4
ASGNF4
line 329
;329:		if ( light < 0.5 ) {
ADDRLP4 4
INDIRF4
CNSTF4 1056964608
GEF4 $203
line 330
;330:			light = 1.0;
ADDRLP4 4
CNSTF4 1065353216
ASGNF4
line 331
;331:		} else {
ADDRGP4 $204
JUMPV
LABELV $203
line 332
;332:			light = 1.0 - ( light - 0.5 ) * 2;
ADDRLP4 4
CNSTF4 1065353216
CNSTF4 1073741824
ADDRLP4 4
INDIRF4
CNSTF4 1056964608
SUBF4
MULF4
SUBF4
ASGNF4
line 333
;333:		}
LABELV $204
line 334
;334:		light = ex->light * light;
ADDRLP4 4
ADDRFP4 0
INDIRP4
CNSTI4 148
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ASGNF4
line 335
;335:		trap_R_AddLightToScene(ent->origin, light, ex->lightColor[0], ex->lightColor[1], ex->lightColor[2] );
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
ARGP4
ADDRLP4 4
INDIRF4
ARGF4
ADDRLP4 16
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 16
INDIRP4
CNSTI4 152
ADDP4
INDIRF4
ARGF4
ADDRLP4 16
INDIRP4
CNSTI4 156
ADDP4
INDIRF4
ARGF4
ADDRLP4 16
INDIRP4
CNSTI4 160
ADDP4
INDIRF4
ARGF4
ADDRGP4 trap_R_AddLightToScene
CALLV
pop
line 336
;336:	}
LABELV $200
line 337
;337:}
LABELV $188
endproc CG_AddExplosion 33 20
export CG_AddSpriteExplosion
proc CG_AddSpriteExplosion 200 20
line 345
;338:
;339:/*
;340:================
;341:CG_AddSpriteExplosion
;342:================
;343:*/
;344:void CG_AddSpriteExplosion( localEntity_t *le )
;345:{
line 349
;346:	refEntity_t	re;
;347:	float c;
;348:
;349:	re = le->refEntity;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 248
ADDP4
INDIRB
ASGNB 160
line 351
;350:
;351:	c = ( le->endTime - cg.time ) / ( float ) ( le->endTime - le->startTime );
ADDRLP4 164
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 168
ADDRLP4 164
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ASGNI4
ADDRLP4 160
ADDRLP4 168
INDIRI4
ADDRGP4 cg+105552
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 168
INDIRI4
ADDRLP4 164
INDIRP4
CNSTI4 16
ADDP4
INDIRI4
SUBI4
CVIF4 4
DIVF4
ASGNF4
line 352
;352:	if ( c > 1 ) {
ADDRLP4 160
INDIRF4
CNSTF4 1065353216
LEF4 $207
line 353
;353:		c = 1.0;	// can happen during connection problems
ADDRLP4 160
CNSTF4 1065353216
ASGNF4
line 354
;354:	}
LABELV $207
line 356
;355:
;356:	re.shaderRGBA[0] = 0xff;
ADDRLP4 0+116
CNSTU1 255
ASGNU1
line 357
;357:	re.shaderRGBA[1] = 0xff;
ADDRLP4 0+116+1
CNSTU1 255
ASGNU1
line 358
;358:	re.shaderRGBA[2] = 0xff;
ADDRLP4 0+116+2
CNSTU1 255
ASGNU1
line 359
;359:	re.shaderRGBA[3] = 0xff * c * 0.33;
ADDRLP4 176
CNSTF4 1051260355
CNSTF4 1132396544
ADDRLP4 160
INDIRF4
MULF4
MULF4
ASGNF4
ADDRLP4 180
CNSTF4 1325400064
ASGNF4
ADDRLP4 176
INDIRF4
ADDRLP4 180
INDIRF4
LTF4 $217
ADDRLP4 172
ADDRLP4 176
INDIRF4
ADDRLP4 180
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $218
JUMPV
LABELV $217
ADDRLP4 172
ADDRLP4 176
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $218
ADDRLP4 0+116+3
ADDRLP4 172
INDIRU4
CVUU1 4
ASGNU1
line 361
;360:
;361:	re.reType = RT_SPRITE;
ADDRLP4 0
CNSTI4 1
ASGNI4
line 362
;362:	re.data.sprite.radius = 42 * ( 1.0 - c ) + 30;
ADDRLP4 0+132+4
CNSTF4 1109917696
CNSTF4 1065353216
ADDRLP4 160
INDIRF4
SUBF4
MULF4
CNSTF4 1106247680
ADDF4
ASGNF4
line 364
;363:
;364:	trap_R_AddRefEntityToScene( &re );
ADDRLP4 0
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 367
;365:
;366:	// add the dlight
;367:	if ( le->light ) {
ADDRFP4 0
INDIRP4
CNSTI4 148
ADDP4
INDIRF4
CNSTF4 0
EQF4 $221
line 370
;368:		float		light;
;369:
;370:		light = (float)( cg.time - le->startTime ) / ( le->endTime - le->startTime );
ADDRLP4 188
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 192
ADDRLP4 188
INDIRP4
CNSTI4 16
ADDP4
INDIRI4
ASGNI4
ADDRLP4 184
ADDRGP4 cg+105552
INDIRI4
ADDRLP4 192
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 188
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRLP4 192
INDIRI4
SUBI4
CVIF4 4
DIVF4
ASGNF4
line 371
;371:		if ( light < 0.5 ) {
ADDRLP4 184
INDIRF4
CNSTF4 1056964608
GEF4 $224
line 372
;372:			light = 1.0;
ADDRLP4 184
CNSTF4 1065353216
ASGNF4
line 373
;373:		} else {
ADDRGP4 $225
JUMPV
LABELV $224
line 374
;374:			light = 1.0 - ( light - 0.5 ) * 2;
ADDRLP4 184
CNSTF4 1065353216
CNSTF4 1073741824
ADDRLP4 184
INDIRF4
CNSTF4 1056964608
SUBF4
MULF4
SUBF4
ASGNF4
line 375
;375:		}
LABELV $225
line 376
;376:		light = le->light * light;
ADDRLP4 184
ADDRFP4 0
INDIRP4
CNSTI4 148
ADDP4
INDIRF4
ADDRLP4 184
INDIRF4
MULF4
ASGNF4
line 377
;377:		trap_R_AddLightToScene(re.origin, light, le->lightColor[0], le->lightColor[1], le->lightColor[2] );
ADDRLP4 0+68
ARGP4
ADDRLP4 184
INDIRF4
ARGF4
ADDRLP4 196
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 196
INDIRP4
CNSTI4 152
ADDP4
INDIRF4
ARGF4
ADDRLP4 196
INDIRP4
CNSTI4 156
ADDP4
INDIRF4
ARGF4
ADDRLP4 196
INDIRP4
CNSTI4 160
ADDP4
INDIRF4
ARGF4
ADDRGP4 trap_R_AddLightToScene
CALLV
pop
line 378
;378:	}
LABELV $221
line 379
;379:}
LABELV $205
endproc CG_AddSpriteExplosion 200 20
export CG_AddScaleFadeSprite
proc CG_AddScaleFadeSprite 92 4
line 392
;380:
;381:
;382:
;383:
;384:/*
;385:===================
;386:CG_AddScaleFadeSprite
;387:
;388:For trek, oriented sprites like blast rings and the like.
;389:===================
;390:*/
;391:void CG_AddScaleFadeSprite( localEntity_t *le )
;392:{
line 398
;393:	refEntity_t	*re;
;394:	float		c;
;395:	vec3_t		delta;
;396:	float		len;
;397:
;398:	re = &le->refEntity;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 248
ADDP4
ASGNP4
line 400
;399:
;400:	c = ( le->endTime - cg.time ) / ( float ) ( le->endTime - le->startTime );
ADDRLP4 24
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 28
ADDRLP4 24
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ASGNI4
ADDRLP4 4
ADDRLP4 28
INDIRI4
ADDRGP4 cg+105552
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 28
INDIRI4
ADDRLP4 24
INDIRP4
CNSTI4 16
ADDP4
INDIRI4
SUBI4
CVIF4 4
DIVF4
ASGNF4
line 401
;401:	if ( c > 1 ) {
ADDRLP4 4
INDIRF4
CNSTF4 1065353216
LEF4 $229
line 402
;402:		c = 1.0;	// can happen during connection problems
ADDRLP4 4
CNSTF4 1065353216
ASGNF4
line 403
;403:	}
LABELV $229
line 406
;404:
;405:	// Use the liferate to set the scale over time.
;406:	re->data.sprite.radius = le->data.sprite.radius + (le->lifeRate * (cg.time - le->startTime));
ADDRLP4 32
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 0
INDIRP4
CNSTI4 136
ADDP4
ADDRLP4 32
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
ADDRLP4 32
INDIRP4
CNSTI4 24
ADDP4
INDIRF4
ADDRGP4 cg+105552
INDIRI4
ADDRLP4 32
INDIRP4
CNSTI4 16
ADDP4
INDIRI4
SUBI4
CVIF4 4
MULF4
ADDF4
ASGNF4
line 407
;407:	if (re->data.sprite.radius <= 0)
ADDRLP4 0
INDIRP4
CNSTI4 136
ADDP4
INDIRF4
CNSTF4 0
GTF4 $232
line 408
;408:	{
line 409
;409:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 410
;410:		return;
ADDRGP4 $227
JUMPV
LABELV $232
line 415
;411:	}
;412:
;413:	// if the view would be "inside" the sprite, kill the sprite
;414:	// so it doesn't add too much overdraw
;415:	VectorSubtract( re->origin, cg.refdef.vieworg, delta );
ADDRLP4 8
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
INDIRF4
ADDRGP4 cg+106840+24
INDIRF4
SUBF4
ASGNF4
ADDRLP4 8+4
ADDRLP4 0
INDIRP4
CNSTI4 72
ADDP4
INDIRF4
ADDRGP4 cg+106840+24+4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 8+8
ADDRLP4 0
INDIRP4
CNSTI4 76
ADDP4
INDIRF4
ADDRGP4 cg+106840+24+8
INDIRF4
SUBF4
ASGNF4
line 416
;416:	len = VectorLength( delta );
ADDRLP4 8
ARGP4
ADDRLP4 40
ADDRGP4 VectorLength
CALLF4
ASGNF4
ADDRLP4 20
ADDRLP4 40
INDIRF4
ASGNF4
line 417
;417:	if ( len < le->data.sprite.radius ) {
ADDRLP4 20
INDIRF4
ADDRFP4 0
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
GEF4 $244
line 418
;418:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 419
;419:		return;
ADDRGP4 $227
JUMPV
LABELV $244
line 423
;420:	}
;421:
;422:	// We will assume here that we want additive transparency effects.
;423:	re->shaderRGBA[0] = 0xff * c;
ADDRLP4 48
CNSTF4 1132396544
ADDRLP4 4
INDIRF4
MULF4
ASGNF4
ADDRLP4 52
CNSTF4 1325400064
ASGNF4
ADDRLP4 48
INDIRF4
ADDRLP4 52
INDIRF4
LTF4 $247
ADDRLP4 44
ADDRLP4 48
INDIRF4
ADDRLP4 52
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $248
JUMPV
LABELV $247
ADDRLP4 44
ADDRLP4 48
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $248
ADDRLP4 0
INDIRP4
CNSTI4 116
ADDP4
ADDRLP4 44
INDIRU4
CVUU1 4
ASGNU1
line 424
;424:	re->shaderRGBA[1] = 0xff * c;
ADDRLP4 60
CNSTF4 1132396544
ADDRLP4 4
INDIRF4
MULF4
ASGNF4
ADDRLP4 64
CNSTF4 1325400064
ASGNF4
ADDRLP4 60
INDIRF4
ADDRLP4 64
INDIRF4
LTF4 $250
ADDRLP4 56
ADDRLP4 60
INDIRF4
ADDRLP4 64
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $251
JUMPV
LABELV $250
ADDRLP4 56
ADDRLP4 60
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $251
ADDRLP4 0
INDIRP4
CNSTI4 117
ADDP4
ADDRLP4 56
INDIRU4
CVUU1 4
ASGNU1
line 425
;425:	re->shaderRGBA[2] = 0xff * c;
ADDRLP4 72
CNSTF4 1132396544
ADDRLP4 4
INDIRF4
MULF4
ASGNF4
ADDRLP4 76
CNSTF4 1325400064
ASGNF4
ADDRLP4 72
INDIRF4
ADDRLP4 76
INDIRF4
LTF4 $253
ADDRLP4 68
ADDRLP4 72
INDIRF4
ADDRLP4 76
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $254
JUMPV
LABELV $253
ADDRLP4 68
ADDRLP4 72
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $254
ADDRLP4 0
INDIRP4
CNSTI4 118
ADDP4
ADDRLP4 68
INDIRU4
CVUU1 4
ASGNU1
line 426
;426:	re->shaderRGBA[3] = 0xff * le->color[3];
ADDRLP4 84
CNSTF4 1132396544
ADDRFP4 0
INDIRP4
CNSTI4 116
ADDP4
INDIRF4
MULF4
ASGNF4
ADDRLP4 88
CNSTF4 1325400064
ASGNF4
ADDRLP4 84
INDIRF4
ADDRLP4 88
INDIRF4
LTF4 $256
ADDRLP4 80
ADDRLP4 84
INDIRF4
ADDRLP4 88
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $257
JUMPV
LABELV $256
ADDRLP4 80
ADDRLP4 84
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $257
ADDRLP4 0
INDIRP4
CNSTI4 119
ADDP4
ADDRLP4 80
INDIRU4
CVUU1 4
ASGNU1
line 428
;427:
;428:	re->reType = RT_ORIENTEDSPRITE;
ADDRLP4 0
INDIRP4
CNSTI4 2
ASGNI4
line 430
;429:
;430:	trap_R_AddRefEntityToScene( re );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 431
;431:}
LABELV $227
endproc CG_AddScaleFadeSprite 92 4
export CG_AddQuad
proc CG_AddQuad 112 4
line 441
;432:
;433:/*
;434:===================
;435:CG_AddQuad
;436:
;437:Of Trek, by Trek, and for Trek
;438:===================
;439:*/
;440:void CG_AddQuad( localEntity_t *le )
;441:{
line 448
;442:	refEntity_t	*re;
;443:	float		frac, alpha;
;444:	vec3_t		delta;
;445:	float		len;
;446:	vec3_t		curRGB;
;447:
;448:	re = &le->refEntity;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 248
ADDP4
ASGNP4
line 450
;449:
;450:	frac = ( cg.time - le->startTime ) / ( float ) ( le->endTime - le->startTime );
ADDRLP4 40
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 44
ADDRLP4 40
INDIRP4
CNSTI4 16
ADDP4
INDIRI4
ASGNI4
ADDRLP4 4
ADDRGP4 cg+105552
INDIRI4
ADDRLP4 44
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 40
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRLP4 44
INDIRI4
SUBI4
CVIF4 4
DIVF4
ASGNF4
line 451
;451:	if ( frac > 1 )
ADDRLP4 4
INDIRF4
CNSTF4 1065353216
LEF4 $260
line 452
;452:		frac = 1.0;	// can happen during connection problems
ADDRLP4 4
CNSTF4 1065353216
ASGNF4
ADDRGP4 $261
JUMPV
LABELV $260
line 453
;453:	else if (frac < 0)
ADDRLP4 4
INDIRF4
CNSTF4 0
GEF4 $262
line 454
;454:		frac = 0.0;
ADDRLP4 4
CNSTF4 0
ASGNF4
LABELV $262
LABELV $261
line 457
;455:
;456:	// Use the liferate to set the scale over time.
;457:	re->data.sprite.radius = le->data.sprite.radius + (le->data.sprite.dradius*frac);
ADDRLP4 48
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 0
INDIRP4
CNSTI4 136
ADDP4
ADDRLP4 48
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
ADDRLP4 48
INDIRP4
CNSTI4 172
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 458
;458:	if (re->data.sprite.radius <= 0)
ADDRLP4 0
INDIRP4
CNSTI4 136
ADDP4
INDIRF4
CNSTF4 0
GTF4 $264
line 459
;459:	{
line 460
;460:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 461
;461:		return;
ADDRGP4 $258
JUMPV
LABELV $264
line 466
;462:	}
;463:
;464:	// if the view would be "inside" the sprite, kill the sprite
;465:	// so it doesn't add too much overdraw
;466:	VectorSubtract( re->origin, cg.refdef.vieworg, delta );
ADDRLP4 24
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
INDIRF4
ADDRGP4 cg+106840+24
INDIRF4
SUBF4
ASGNF4
ADDRLP4 24+4
ADDRLP4 0
INDIRP4
CNSTI4 72
ADDP4
INDIRF4
ADDRGP4 cg+106840+24+4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 24+8
ADDRLP4 0
INDIRP4
CNSTI4 76
ADDP4
INDIRF4
ADDRGP4 cg+106840+24+8
INDIRF4
SUBF4
ASGNF4
line 467
;467:	len = VectorLength( delta );
ADDRLP4 24
ARGP4
ADDRLP4 56
ADDRGP4 VectorLength
CALLF4
ASGNF4
ADDRLP4 36
ADDRLP4 56
INDIRF4
ASGNF4
line 468
;468:	if ( len < le->data.sprite.radius ) {
ADDRLP4 36
INDIRF4
ADDRFP4 0
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
GEF4 $276
line 469
;469:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 470
;470:		return;
ADDRGP4 $258
JUMPV
LABELV $276
line 474
;471:	}
;472:
;473:	// Calculate the current alpha.
;474:	alpha = le->alpha + (le->dalpha * frac);
ADDRLP4 60
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 20
ADDRLP4 60
INDIRP4
CNSTI4 128
ADDP4
INDIRF4
ADDRLP4 60
INDIRP4
CNSTI4 132
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 475
;475:	VectorMA(le->data.sprite.startRGB, frac, le->data.sprite.dRGB, curRGB);
ADDRLP4 64
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 8
ADDRLP4 64
INDIRP4
CNSTI4 176
ADDP4
INDIRF4
ADDRLP4 64
INDIRP4
CNSTI4 188
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRLP4 8+4
ADDRLP4 64
INDIRP4
CNSTI4 180
ADDP4
INDIRF4
ADDRLP4 64
INDIRP4
CNSTI4 192
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRLP4 72
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 8+8
ADDRLP4 72
INDIRP4
CNSTI4 184
ADDP4
INDIRF4
ADDRLP4 72
INDIRP4
CNSTI4 196
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 476
;476:	re->shaderRGBA[0] = 0xff * alpha * curRGB[0];
ADDRLP4 80
CNSTF4 1132396544
ADDRLP4 20
INDIRF4
MULF4
ADDRLP4 8
INDIRF4
MULF4
ASGNF4
ADDRLP4 84
CNSTF4 1325400064
ASGNF4
ADDRLP4 80
INDIRF4
ADDRLP4 84
INDIRF4
LTF4 $281
ADDRLP4 76
ADDRLP4 80
INDIRF4
ADDRLP4 84
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $282
JUMPV
LABELV $281
ADDRLP4 76
ADDRLP4 80
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $282
ADDRLP4 0
INDIRP4
CNSTI4 116
ADDP4
ADDRLP4 76
INDIRU4
CVUU1 4
ASGNU1
line 477
;477:	re->shaderRGBA[1] = 0xff * alpha * curRGB[1];
ADDRLP4 92
CNSTF4 1132396544
ADDRLP4 20
INDIRF4
MULF4
ADDRLP4 8+4
INDIRF4
MULF4
ASGNF4
ADDRLP4 96
CNSTF4 1325400064
ASGNF4
ADDRLP4 92
INDIRF4
ADDRLP4 96
INDIRF4
LTF4 $285
ADDRLP4 88
ADDRLP4 92
INDIRF4
ADDRLP4 96
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $286
JUMPV
LABELV $285
ADDRLP4 88
ADDRLP4 92
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $286
ADDRLP4 0
INDIRP4
CNSTI4 117
ADDP4
ADDRLP4 88
INDIRU4
CVUU1 4
ASGNU1
line 478
;478:	re->shaderRGBA[2] = 0xff * alpha * curRGB[2];
ADDRLP4 104
CNSTF4 1132396544
ADDRLP4 20
INDIRF4
MULF4
ADDRLP4 8+8
INDIRF4
MULF4
ASGNF4
ADDRLP4 108
CNSTF4 1325400064
ASGNF4
ADDRLP4 104
INDIRF4
ADDRLP4 108
INDIRF4
LTF4 $289
ADDRLP4 100
ADDRLP4 104
INDIRF4
ADDRLP4 108
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $290
JUMPV
LABELV $289
ADDRLP4 100
ADDRLP4 104
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $290
ADDRLP4 0
INDIRP4
CNSTI4 118
ADDP4
ADDRLP4 100
INDIRU4
CVUU1 4
ASGNU1
line 479
;479:	re->shaderRGBA[3] = 0xff;	
ADDRLP4 0
INDIRP4
CNSTI4 119
ADDP4
CNSTU1 255
ASGNU1
line 481
;480:
;481:	re->reType = RT_ORIENTEDSPRITE;
ADDRLP4 0
INDIRP4
CNSTI4 2
ASGNI4
line 483
;482:
;483:	trap_R_AddRefEntityToScene( re );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 484
;484:}
LABELV $258
endproc CG_AddQuad 112 4
export CG_AddLine
proc CG_AddLine 76 4
line 495
;485:
;486:
;487:/*
;488:===================
;489:CG_AddLine
;490:
;491:For trek, for beams and the like.
;492:===================
;493:*/
;494:void CG_AddLine( localEntity_t *le )
;495:{
line 499
;496:	refEntity_t	*re;
;497:	float		frac, alpha;
;498:
;499:	re = &le->refEntity;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 248
ADDP4
ASGNP4
line 501
;500:
;501:	frac = (cg.time - le->startTime) / ( float ) ( le->endTime - le->startTime );
ADDRLP4 12
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 16
ADDRLP4 12
INDIRP4
CNSTI4 16
ADDP4
INDIRI4
ASGNI4
ADDRLP4 4
ADDRGP4 cg+105552
INDIRI4
ADDRLP4 16
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 12
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRLP4 16
INDIRI4
SUBI4
CVIF4 4
DIVF4
ASGNF4
line 502
;502:	if ( frac > 1 ) 
ADDRLP4 4
INDIRF4
CNSTF4 1065353216
LEF4 $293
line 503
;503:		frac = 1.0;	// can happen during connection problems
ADDRLP4 4
CNSTF4 1065353216
ASGNF4
ADDRGP4 $294
JUMPV
LABELV $293
line 504
;504:	else if (frac < 0)
ADDRLP4 4
INDIRF4
CNSTF4 0
GEF4 $295
line 505
;505:		frac = 0.0;
ADDRLP4 4
CNSTF4 0
ASGNF4
LABELV $295
LABELV $294
line 508
;506:
;507:	// Use the liferate to set the scale over time.
;508:	re->data.line.width = le->data.line.width + (le->data.line.dwidth * frac);
ADDRLP4 20
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 0
INDIRP4
CNSTI4 132
ADDP4
ADDRLP4 20
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
ADDRLP4 20
INDIRP4
CNSTI4 172
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 509
;509:	if (re->data.line.width <= 0)
ADDRLP4 0
INDIRP4
CNSTI4 132
ADDP4
INDIRF4
CNSTF4 0
GTF4 $297
line 510
;510:	{
line 511
;511:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 512
;512:		return;
ADDRGP4 $291
JUMPV
LABELV $297
line 516
;513:	}
;514:
;515:	// We will assume here that we want additive transparency effects.
;516:	alpha = le->alpha + (le->dalpha * frac);
ADDRLP4 24
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 8
ADDRLP4 24
INDIRP4
CNSTI4 128
ADDP4
INDIRF4
ADDRLP4 24
INDIRP4
CNSTI4 132
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 517
;517:	re->shaderRGBA[0] = 0xff * alpha;
ADDRLP4 32
CNSTF4 1132396544
ADDRLP4 8
INDIRF4
MULF4
ASGNF4
ADDRLP4 36
CNSTF4 1325400064
ASGNF4
ADDRLP4 32
INDIRF4
ADDRLP4 36
INDIRF4
LTF4 $300
ADDRLP4 28
ADDRLP4 32
INDIRF4
ADDRLP4 36
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $301
JUMPV
LABELV $300
ADDRLP4 28
ADDRLP4 32
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $301
ADDRLP4 0
INDIRP4
CNSTI4 116
ADDP4
ADDRLP4 28
INDIRU4
CVUU1 4
ASGNU1
line 518
;518:	re->shaderRGBA[1] = 0xff * alpha;
ADDRLP4 44
CNSTF4 1132396544
ADDRLP4 8
INDIRF4
MULF4
ASGNF4
ADDRLP4 48
CNSTF4 1325400064
ASGNF4
ADDRLP4 44
INDIRF4
ADDRLP4 48
INDIRF4
LTF4 $303
ADDRLP4 40
ADDRLP4 44
INDIRF4
ADDRLP4 48
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $304
JUMPV
LABELV $303
ADDRLP4 40
ADDRLP4 44
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $304
ADDRLP4 0
INDIRP4
CNSTI4 117
ADDP4
ADDRLP4 40
INDIRU4
CVUU1 4
ASGNU1
line 519
;519:	re->shaderRGBA[2] = 0xff * alpha;
ADDRLP4 56
CNSTF4 1132396544
ADDRLP4 8
INDIRF4
MULF4
ASGNF4
ADDRLP4 60
CNSTF4 1325400064
ASGNF4
ADDRLP4 56
INDIRF4
ADDRLP4 60
INDIRF4
LTF4 $306
ADDRLP4 52
ADDRLP4 56
INDIRF4
ADDRLP4 60
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $307
JUMPV
LABELV $306
ADDRLP4 52
ADDRLP4 56
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $307
ADDRLP4 0
INDIRP4
CNSTI4 118
ADDP4
ADDRLP4 52
INDIRU4
CVUU1 4
ASGNU1
line 520
;520:	re->shaderRGBA[3] = 0xff * alpha;	// Yes, we could apply c to this too, but fading the color is better for lines.
ADDRLP4 68
CNSTF4 1132396544
ADDRLP4 8
INDIRF4
MULF4
ASGNF4
ADDRLP4 72
CNSTF4 1325400064
ASGNF4
ADDRLP4 68
INDIRF4
ADDRLP4 72
INDIRF4
LTF4 $309
ADDRLP4 64
ADDRLP4 68
INDIRF4
ADDRLP4 72
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $310
JUMPV
LABELV $309
ADDRLP4 64
ADDRLP4 68
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $310
ADDRLP4 0
INDIRP4
CNSTI4 119
ADDP4
ADDRLP4 64
INDIRU4
CVUU1 4
ASGNU1
line 522
;521:
;522:	re->reType = RT_LINE;
ADDRLP4 0
INDIRP4
CNSTI4 9
ASGNI4
line 524
;523:
;524:	trap_R_AddRefEntityToScene( re );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 525
;525:}
LABELV $291
endproc CG_AddLine 76 4
export CG_AddOLine
proc CG_AddOLine 76 4
line 536
;526:
;527:
;528:/*
;529:===================
;530:CG_AddOLine
;531:
;532:For trek, for rectangles.
;533:===================
;534:*/
;535:void CG_AddOLine( localEntity_t *le )
;536:{
line 540
;537:	refEntity_t	*re;
;538:	float		frac, alpha;
;539:
;540:	re = &le->refEntity;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 248
ADDP4
ASGNP4
line 542
;541:
;542:	frac = (cg.time - le->startTime) / ( float ) ( le->endTime - le->startTime );
ADDRLP4 12
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 16
ADDRLP4 12
INDIRP4
CNSTI4 16
ADDP4
INDIRI4
ASGNI4
ADDRLP4 4
ADDRGP4 cg+105552
INDIRI4
ADDRLP4 16
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 12
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRLP4 16
INDIRI4
SUBI4
CVIF4 4
DIVF4
ASGNF4
line 543
;543:	if ( frac > 1 ) 
ADDRLP4 4
INDIRF4
CNSTF4 1065353216
LEF4 $313
line 544
;544:		frac = 1.0;	// can happen during connection problems
ADDRLP4 4
CNSTF4 1065353216
ASGNF4
ADDRGP4 $314
JUMPV
LABELV $313
line 545
;545:	else if (frac < 0)
ADDRLP4 4
INDIRF4
CNSTF4 0
GEF4 $315
line 546
;546:		frac = 0.0;
ADDRLP4 4
CNSTF4 0
ASGNF4
LABELV $315
LABELV $314
line 549
;547:
;548:	// Use the liferate to set the scale over time.
;549:	re->data.line.width = le->data.line.width + (le->data.line.dwidth * frac);
ADDRLP4 20
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 0
INDIRP4
CNSTI4 132
ADDP4
ADDRLP4 20
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
ADDRLP4 20
INDIRP4
CNSTI4 172
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 550
;550:	if (re->data.line.width <= 0)
ADDRLP4 0
INDIRP4
CNSTI4 132
ADDP4
INDIRF4
CNSTF4 0
GTF4 $317
line 551
;551:	{
line 552
;552:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 553
;553:		return;
ADDRGP4 $311
JUMPV
LABELV $317
line 557
;554:	}
;555:
;556:	// We will assume here that we want additive transparency effects.
;557:	alpha = le->alpha + (le->dalpha * frac);
ADDRLP4 24
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 8
ADDRLP4 24
INDIRP4
CNSTI4 128
ADDP4
INDIRF4
ADDRLP4 24
INDIRP4
CNSTI4 132
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 558
;558:	re->shaderRGBA[0] = 0xff * alpha;
ADDRLP4 32
CNSTF4 1132396544
ADDRLP4 8
INDIRF4
MULF4
ASGNF4
ADDRLP4 36
CNSTF4 1325400064
ASGNF4
ADDRLP4 32
INDIRF4
ADDRLP4 36
INDIRF4
LTF4 $320
ADDRLP4 28
ADDRLP4 32
INDIRF4
ADDRLP4 36
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $321
JUMPV
LABELV $320
ADDRLP4 28
ADDRLP4 32
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $321
ADDRLP4 0
INDIRP4
CNSTI4 116
ADDP4
ADDRLP4 28
INDIRU4
CVUU1 4
ASGNU1
line 559
;559:	re->shaderRGBA[1] = 0xff * alpha;
ADDRLP4 44
CNSTF4 1132396544
ADDRLP4 8
INDIRF4
MULF4
ASGNF4
ADDRLP4 48
CNSTF4 1325400064
ASGNF4
ADDRLP4 44
INDIRF4
ADDRLP4 48
INDIRF4
LTF4 $323
ADDRLP4 40
ADDRLP4 44
INDIRF4
ADDRLP4 48
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $324
JUMPV
LABELV $323
ADDRLP4 40
ADDRLP4 44
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $324
ADDRLP4 0
INDIRP4
CNSTI4 117
ADDP4
ADDRLP4 40
INDIRU4
CVUU1 4
ASGNU1
line 560
;560:	re->shaderRGBA[2] = 0xff * alpha;
ADDRLP4 56
CNSTF4 1132396544
ADDRLP4 8
INDIRF4
MULF4
ASGNF4
ADDRLP4 60
CNSTF4 1325400064
ASGNF4
ADDRLP4 56
INDIRF4
ADDRLP4 60
INDIRF4
LTF4 $326
ADDRLP4 52
ADDRLP4 56
INDIRF4
ADDRLP4 60
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $327
JUMPV
LABELV $326
ADDRLP4 52
ADDRLP4 56
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $327
ADDRLP4 0
INDIRP4
CNSTI4 118
ADDP4
ADDRLP4 52
INDIRU4
CVUU1 4
ASGNU1
line 561
;561:	re->shaderRGBA[3] = 0xff * alpha;	// Yes, we could apply c to this too, but fading the color is better for lines.
ADDRLP4 68
CNSTF4 1132396544
ADDRLP4 8
INDIRF4
MULF4
ASGNF4
ADDRLP4 72
CNSTF4 1325400064
ASGNF4
ADDRLP4 68
INDIRF4
ADDRLP4 72
INDIRF4
LTF4 $329
ADDRLP4 64
ADDRLP4 68
INDIRF4
ADDRLP4 72
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $330
JUMPV
LABELV $329
ADDRLP4 64
ADDRLP4 68
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $330
ADDRLP4 0
INDIRP4
CNSTI4 119
ADDP4
ADDRLP4 64
INDIRU4
CVUU1 4
ASGNU1
line 563
;562:
;563:	re->reType = RT_ORIENTEDLINE;
ADDRLP4 0
INDIRP4
CNSTI4 10
ASGNI4
line 565
;564:
;565:	trap_R_AddRefEntityToScene( re );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 566
;566:}
LABELV $311
endproc CG_AddOLine 76 4
export CG_AddLine2
proc CG_AddLine2 104 4
line 576
;567:
;568:/*
;569:===================
;570:CG_AddLine2
;571:
;572:For trek, for beams and the like.
;573:===================
;574:*/
;575:void CG_AddLine2( localEntity_t *le )
;576:{
line 581
;577:	refEntity_t	*re;
;578:	float		frac, alpha;
;579:	vec3_t		curRGB;
;580:
;581:	re = &le->refEntity;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 248
ADDP4
ASGNP4
line 583
;582:
;583:	frac = (cg.time - le->startTime) / ( float ) ( le->endTime - le->startTime );
ADDRLP4 24
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 28
ADDRLP4 24
INDIRP4
CNSTI4 16
ADDP4
INDIRI4
ASGNI4
ADDRLP4 4
ADDRGP4 cg+105552
INDIRI4
ADDRLP4 28
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 24
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRLP4 28
INDIRI4
SUBI4
CVIF4 4
DIVF4
ASGNF4
line 584
;584:	if ( frac > 1 ) 
ADDRLP4 4
INDIRF4
CNSTF4 1065353216
LEF4 $333
line 585
;585:		frac = 1.0;	// can happen during connection problems
ADDRLP4 4
CNSTF4 1065353216
ASGNF4
ADDRGP4 $334
JUMPV
LABELV $333
line 586
;586:	else if (frac < 0)
ADDRLP4 4
INDIRF4
CNSTF4 0
GEF4 $335
line 587
;587:		frac = 0.0;
ADDRLP4 4
CNSTF4 0
ASGNF4
LABELV $335
LABELV $334
line 590
;588:
;589:	// Use the liferate to set the scale over time.
;590:	re->data.line.width = le->data.line2.width + (le->data.line2.dwidth * frac);
ADDRLP4 32
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 0
INDIRP4
CNSTI4 132
ADDP4
ADDRLP4 32
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
ADDRLP4 32
INDIRP4
CNSTI4 172
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 591
;591:	re->data.line.width2 = le->data.line2.width2 + (le->data.line2.dwidth2 * frac);
ADDRLP4 36
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 0
INDIRP4
CNSTI4 136
ADDP4
ADDRLP4 36
INDIRP4
CNSTI4 176
ADDP4
INDIRF4
ADDRLP4 36
INDIRP4
CNSTI4 180
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 592
;592:	if (re->data.line.width <= 0)
ADDRLP4 0
INDIRP4
CNSTI4 132
ADDP4
INDIRF4
CNSTF4 0
GTF4 $337
line 593
;593:	{
line 594
;594:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 595
;595:		return;
ADDRGP4 $331
JUMPV
LABELV $337
line 599
;596:	}
;597:
;598:	// We will assume here that we want additive transparency effects.
;599:	alpha = le->alpha + (le->dalpha * frac);
ADDRLP4 40
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 20
ADDRLP4 40
INDIRP4
CNSTI4 128
ADDP4
INDIRF4
ADDRLP4 40
INDIRP4
CNSTI4 132
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 600
;600:	VectorMA(le->data.line2.startRGB, frac, le->data.line2.dRGB, curRGB);
ADDRLP4 44
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 8
ADDRLP4 44
INDIRP4
CNSTI4 184
ADDP4
INDIRF4
ADDRLP4 44
INDIRP4
CNSTI4 196
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRLP4 8+4
ADDRLP4 44
INDIRP4
CNSTI4 188
ADDP4
INDIRF4
ADDRLP4 44
INDIRP4
CNSTI4 200
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRLP4 52
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 8+8
ADDRLP4 52
INDIRP4
CNSTI4 192
ADDP4
INDIRF4
ADDRLP4 52
INDIRP4
CNSTI4 204
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 601
;601:	re->shaderRGBA[0] = 0xff * alpha * curRGB[0];
ADDRLP4 60
CNSTF4 1132396544
ADDRLP4 20
INDIRF4
MULF4
ADDRLP4 8
INDIRF4
MULF4
ASGNF4
ADDRLP4 64
CNSTF4 1325400064
ASGNF4
ADDRLP4 60
INDIRF4
ADDRLP4 64
INDIRF4
LTF4 $342
ADDRLP4 56
ADDRLP4 60
INDIRF4
ADDRLP4 64
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $343
JUMPV
LABELV $342
ADDRLP4 56
ADDRLP4 60
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $343
ADDRLP4 0
INDIRP4
CNSTI4 116
ADDP4
ADDRLP4 56
INDIRU4
CVUU1 4
ASGNU1
line 602
;602:	re->shaderRGBA[1] = 0xff * alpha * curRGB[1];
ADDRLP4 72
CNSTF4 1132396544
ADDRLP4 20
INDIRF4
MULF4
ADDRLP4 8+4
INDIRF4
MULF4
ASGNF4
ADDRLP4 76
CNSTF4 1325400064
ASGNF4
ADDRLP4 72
INDIRF4
ADDRLP4 76
INDIRF4
LTF4 $346
ADDRLP4 68
ADDRLP4 72
INDIRF4
ADDRLP4 76
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $347
JUMPV
LABELV $346
ADDRLP4 68
ADDRLP4 72
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $347
ADDRLP4 0
INDIRP4
CNSTI4 117
ADDP4
ADDRLP4 68
INDIRU4
CVUU1 4
ASGNU1
line 603
;603:	re->shaderRGBA[2] = 0xff * alpha * curRGB[2];
ADDRLP4 84
CNSTF4 1132396544
ADDRLP4 20
INDIRF4
MULF4
ADDRLP4 8+8
INDIRF4
MULF4
ASGNF4
ADDRLP4 88
CNSTF4 1325400064
ASGNF4
ADDRLP4 84
INDIRF4
ADDRLP4 88
INDIRF4
LTF4 $350
ADDRLP4 80
ADDRLP4 84
INDIRF4
ADDRLP4 88
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $351
JUMPV
LABELV $350
ADDRLP4 80
ADDRLP4 84
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $351
ADDRLP4 0
INDIRP4
CNSTI4 118
ADDP4
ADDRLP4 80
INDIRU4
CVUU1 4
ASGNU1
line 604
;604:	re->shaderRGBA[3] = 0xff * alpha;	// Yes, we could apply c to this too, but fading the color is better for lines.
ADDRLP4 96
CNSTF4 1132396544
ADDRLP4 20
INDIRF4
MULF4
ASGNF4
ADDRLP4 100
CNSTF4 1325400064
ASGNF4
ADDRLP4 96
INDIRF4
ADDRLP4 100
INDIRF4
LTF4 $353
ADDRLP4 92
ADDRLP4 96
INDIRF4
ADDRLP4 100
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $354
JUMPV
LABELV $353
ADDRLP4 92
ADDRLP4 96
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $354
ADDRLP4 0
INDIRP4
CNSTI4 119
ADDP4
ADDRLP4 92
INDIRU4
CVUU1 4
ASGNU1
line 606
;605:
;606:	re->reType = RT_LINE2;
ADDRLP4 0
INDIRP4
CNSTI4 11
ASGNI4
line 608
;607:
;608:	trap_R_AddRefEntityToScene( re );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 609
;609:}
LABELV $331
endproc CG_AddLine2 104 4
export CG_AddTrail
proc CG_AddTrail 192 28
line 621
;610:
;611:
;612:
;613:/*
;614:===================
;615:CG_AddTrail
;616:
;617:For trek, for sparks and the like.
;618:===================
;619:*/
;620:void CG_AddTrail( localEntity_t *le ) 
;621:{
line 628
;622:	refEntity_t	*re;
;623:	float frac, length, alpha;
;624:	vec3_t	dir;
;625:	trace_t	trace;
;626:	vec3_t	curRGB;
;627:
;628:	re = &le->refEntity;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 248
ADDP4
ASGNP4
line 630
;629:
;630:	frac = (cg.time - le->startTime) / ( float ) ( le->endTime - le->startTime );
ADDRLP4 96
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 100
ADDRLP4 96
INDIRP4
CNSTI4 16
ADDP4
INDIRI4
ASGNI4
ADDRLP4 4
ADDRGP4 cg+105552
INDIRI4
ADDRLP4 100
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 96
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRLP4 100
INDIRI4
SUBI4
CVIF4 4
DIVF4
ASGNF4
line 631
;631:	if ( frac > 1 ) 
ADDRLP4 4
INDIRF4
CNSTF4 1065353216
LEF4 $357
line 632
;632:		frac = 1.0;	// can happen during connection problems
ADDRLP4 4
CNSTF4 1065353216
ASGNF4
ADDRGP4 $358
JUMPV
LABELV $357
line 633
;633:	else if (frac < 0)
ADDRLP4 4
INDIRF4
CNSTF4 0
GEF4 $359
line 634
;634:		frac = 0.0;
ADDRLP4 4
CNSTF4 0
ASGNF4
LABELV $359
LABELV $358
line 637
;635:
;636:	// Use the liferate to set the scale over time.
;637:	re->data.line.width = le->data.trail.width + (le->data.trail.dwidth * frac);
ADDRLP4 104
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 0
INDIRP4
CNSTI4 132
ADDP4
ADDRLP4 104
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
ADDRLP4 104
INDIRP4
CNSTI4 172
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 638
;638:	if (re->data.line.width <= 0)
ADDRLP4 0
INDIRP4
CNSTI4 132
ADDP4
INDIRF4
CNSTF4 0
GTF4 $361
line 639
;639:	{
line 640
;640:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 641
;641:		return;
ADDRGP4 $355
JUMPV
LABELV $361
line 644
;642:	}
;643:
;644:	if (!le->leFlags & LEF_MOVE)
ADDRFP4 0
INDIRP4
CNSTI4 12
ADDP4
INDIRI4
CNSTI4 0
NEI4 $366
ADDRLP4 108
CNSTI4 1
ASGNI4
ADDRGP4 $367
JUMPV
LABELV $366
ADDRLP4 108
CNSTI4 0
ASGNI4
LABELV $367
ADDRLP4 108
INDIRI4
CNSTI4 4
BANDI4
CNSTI4 0
EQI4 $363
line 645
;645:	{
line 646
;646:		return;
ADDRGP4 $355
JUMPV
LABELV $363
line 650
;647:	}
;648:
;649:	// kef -- do these two lines _before_ copying origin into oldorigin
;650:	VectorSubtract(re->oldorigin, re->origin, dir);
ADDRLP4 8
ADDRLP4 0
INDIRP4
CNSTI4 84
ADDP4
INDIRF4
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 8+4
ADDRLP4 0
INDIRP4
CNSTI4 88
ADDP4
INDIRF4
ADDRLP4 0
INDIRP4
CNSTI4 72
ADDP4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 8+8
ADDRLP4 0
INDIRP4
CNSTI4 92
ADDP4
INDIRF4
ADDRLP4 0
INDIRP4
CNSTI4 76
ADDP4
INDIRF4
SUBF4
ASGNF4
line 651
;651:	VectorNormalize(dir);
ADDRLP4 8
ARGP4
ADDRGP4 VectorNormalize
CALLF4
pop
line 653
;652:
;653:	VectorCopy(re->origin, re->oldorigin);
ADDRLP4 0
INDIRP4
CNSTI4 84
ADDP4
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
INDIRB
ASGNB 12
line 654
;654:	BG_EvaluateTrajectory( &le->pos, cg.time, re->origin );
ADDRFP4 0
INDIRP4
CNSTI4 28
ADDP4
ARGP4
ADDRGP4 cg+105552
INDIRI4
ARGI4
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
ARGP4
ADDRGP4 BG_EvaluateTrajectory
CALLV
pop
line 656
;655:
;656:	if (le->leFlags & LEF_USE_COLLISION)
ADDRFP4 0
INDIRP4
CNSTI4 12
ADDP4
INDIRI4
CNSTI4 8
BANDI4
CNSTI4 0
EQI4 $371
line 657
;657:	{
line 659
;658:		// trace a line from previous position to new position
;659:		CG_Trace( &trace, re->oldorigin, NULL, NULL, re->origin, -1, CONTENTS_SOLID );
ADDRLP4 40
ARGP4
ADDRLP4 0
INDIRP4
CNSTI4 84
ADDP4
ARGP4
ADDRLP4 128
CNSTP4 0
ASGNP4
ADDRLP4 128
INDIRP4
ARGP4
ADDRLP4 128
INDIRP4
ARGP4
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
ARGP4
CNSTI4 -1
ARGI4
CNSTI4 1
ARGI4
ADDRGP4 CG_Trace
CALLV
pop
line 661
;660:
;661:		if ( trace.fraction != 1.0 ) 
ADDRLP4 40+8
INDIRF4
CNSTF4 1065353216
EQF4 $373
line 662
;662:		{	// Hit something.
line 666
;663:			// if it is in a nodrop zone, remove it
;664:			// this keeps gibs from waiting at the bottom of pits of death
;665:			// and floating levels
;666:			if ( trap_CM_PointContents( trace.endpos, 0 ) & CONTENTS_NODROP ) {
ADDRLP4 40+12
ARGP4
CNSTI4 0
ARGI4
ADDRLP4 132
ADDRGP4 trap_CM_PointContents
CALLI4
ASGNI4
ADDRLP4 132
INDIRI4
CVIU4 4
CNSTU4 2147483648
BANDU4
CNSTU4 0
EQU4 $376
line 667
;667:				CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 668
;668:				return;
ADDRGP4 $355
JUMPV
LABELV $376
line 672
;669:			}
;670:
;671:			// reflect the velocity on the trace plane
;672:			CG_ReflectVelocity( le, &trace );
ADDRFP4 0
INDIRP4
ARGP4
ADDRLP4 40
ARGP4
ADDRGP4 CG_ReflectVelocity
CALLV
pop
line 673
;673:		}
LABELV $373
line 674
;674:		VectorSubtract(re->oldorigin, re->origin, dir);
ADDRLP4 8
ADDRLP4 0
INDIRP4
CNSTI4 84
ADDP4
INDIRF4
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 8+4
ADDRLP4 0
INDIRP4
CNSTI4 88
ADDP4
INDIRF4
ADDRLP4 0
INDIRP4
CNSTI4 72
ADDP4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 8+8
ADDRLP4 0
INDIRP4
CNSTI4 92
ADDP4
INDIRF4
ADDRLP4 0
INDIRP4
CNSTI4 76
ADDP4
INDIRF4
SUBF4
ASGNF4
line 675
;675:		VectorNormalize(dir);
ADDRLP4 8
ARGP4
ADDRGP4 VectorNormalize
CALLF4
pop
line 676
;676:	}
LABELV $371
line 679
;677:
;678:	// Set the length based on the velocity of the bit.
;679:	length = le->data.trail.length + (le->data.trail.dlength * frac);
ADDRLP4 124
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 32
ADDRLP4 124
INDIRP4
CNSTI4 176
ADDP4
INDIRF4
ADDRLP4 124
INDIRP4
CNSTI4 180
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 680
;680:	if (length <= 0)
ADDRLP4 32
INDIRF4
CNSTF4 0
GTF4 $381
line 681
;681:	{
line 682
;682:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 683
;683:		return;
ADDRGP4 $355
JUMPV
LABELV $381
line 686
;684:	}
;685:
;686:	VectorMA(re->origin, length, dir, re->oldorigin);
ADDRLP4 0
INDIRP4
CNSTI4 84
ADDP4
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
INDIRF4
ADDRLP4 8
INDIRF4
ADDRLP4 32
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRLP4 0
INDIRP4
CNSTI4 88
ADDP4
ADDRLP4 0
INDIRP4
CNSTI4 72
ADDP4
INDIRF4
ADDRLP4 8+4
INDIRF4
ADDRLP4 32
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRLP4 0
INDIRP4
CNSTI4 92
ADDP4
ADDRLP4 0
INDIRP4
CNSTI4 76
ADDP4
INDIRF4
ADDRLP4 8+8
INDIRF4
ADDRLP4 32
INDIRF4
MULF4
ADDF4
ASGNF4
line 689
;687:
;688:	// We will assume here that we want additive transparency effects.
;689:	alpha = le->alpha + (le->dalpha * frac);
ADDRLP4 140
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 36
ADDRLP4 140
INDIRP4
CNSTI4 128
ADDP4
INDIRF4
ADDRLP4 140
INDIRP4
CNSTI4 132
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 690
;690:	VectorMA(le->data.trail.startRGB, frac, le->data.trail.dRGB, curRGB);
ADDRLP4 144
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 20
ADDRLP4 144
INDIRP4
CNSTI4 184
ADDP4
INDIRF4
ADDRLP4 144
INDIRP4
CNSTI4 196
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRLP4 20+4
ADDRLP4 144
INDIRP4
CNSTI4 188
ADDP4
INDIRF4
ADDRLP4 144
INDIRP4
CNSTI4 200
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRLP4 152
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 20+8
ADDRLP4 152
INDIRP4
CNSTI4 192
ADDP4
INDIRF4
ADDRLP4 152
INDIRP4
CNSTI4 204
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 691
;691:	re->shaderRGBA[0] = 0xff * alpha * curRGB[0];
ADDRLP4 160
CNSTF4 1132396544
ADDRLP4 36
INDIRF4
MULF4
ADDRLP4 20
INDIRF4
MULF4
ASGNF4
ADDRLP4 164
CNSTF4 1325400064
ASGNF4
ADDRLP4 160
INDIRF4
ADDRLP4 164
INDIRF4
LTF4 $388
ADDRLP4 156
ADDRLP4 160
INDIRF4
ADDRLP4 164
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $389
JUMPV
LABELV $388
ADDRLP4 156
ADDRLP4 160
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $389
ADDRLP4 0
INDIRP4
CNSTI4 116
ADDP4
ADDRLP4 156
INDIRU4
CVUU1 4
ASGNU1
line 692
;692:	re->shaderRGBA[1] = 0xff * alpha * curRGB[1];
ADDRLP4 172
CNSTF4 1132396544
ADDRLP4 36
INDIRF4
MULF4
ADDRLP4 20+4
INDIRF4
MULF4
ASGNF4
ADDRLP4 176
CNSTF4 1325400064
ASGNF4
ADDRLP4 172
INDIRF4
ADDRLP4 176
INDIRF4
LTF4 $392
ADDRLP4 168
ADDRLP4 172
INDIRF4
ADDRLP4 176
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $393
JUMPV
LABELV $392
ADDRLP4 168
ADDRLP4 172
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $393
ADDRLP4 0
INDIRP4
CNSTI4 117
ADDP4
ADDRLP4 168
INDIRU4
CVUU1 4
ASGNU1
line 693
;693:	re->shaderRGBA[2] = 0xff * alpha * curRGB[2];
ADDRLP4 184
CNSTF4 1132396544
ADDRLP4 36
INDIRF4
MULF4
ADDRLP4 20+8
INDIRF4
MULF4
ASGNF4
ADDRLP4 188
CNSTF4 1325400064
ASGNF4
ADDRLP4 184
INDIRF4
ADDRLP4 188
INDIRF4
LTF4 $396
ADDRLP4 180
ADDRLP4 184
INDIRF4
ADDRLP4 188
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $397
JUMPV
LABELV $396
ADDRLP4 180
ADDRLP4 184
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $397
ADDRLP4 0
INDIRP4
CNSTI4 118
ADDP4
ADDRLP4 180
INDIRU4
CVUU1 4
ASGNU1
line 694
;694:	re->shaderRGBA[3] = 0xff;	// Yes, we could apply c to this too, but fading the color is better for lines.
ADDRLP4 0
INDIRP4
CNSTI4 119
ADDP4
CNSTU1 255
ASGNU1
line 696
;695:
;696:	re->reType = RT_LINE;
ADDRLP4 0
INDIRP4
CNSTI4 9
ASGNI4
line 698
;697:
;698:	trap_R_AddRefEntityToScene( re );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 699
;699:}
LABELV $355
endproc CG_AddTrail 192 28
export CG_AddViewSprite
proc CG_AddViewSprite 168 28
line 711
;700:
;701:
;702:
;703:/*
;704:===================
;705:CG_AddViewSprite
;706:
;707:For trek, view sprites like smoke and the like.
;708:===================
;709:*/
;710:void CG_AddViewSprite( localEntity_t *le )
;711:{
line 719
;712:	refEntity_t	*re;
;713:	float		frac, alpha;
;714:	vec3_t		delta;
;715:	float		len;
;716:	trace_t		trace;
;717:	vec3_t		curRGB;
;718:
;719:	re = &le->refEntity;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 248
ADDP4
ASGNP4
line 721
;720:
;721:	frac = ( cg.time - le->startTime ) / ( float ) ( le->endTime - le->startTime );
ADDRLP4 96
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 100
ADDRLP4 96
INDIRP4
CNSTI4 16
ADDP4
INDIRI4
ASGNI4
ADDRLP4 4
ADDRGP4 cg+105552
INDIRI4
ADDRLP4 100
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 96
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRLP4 100
INDIRI4
SUBI4
CVIF4 4
DIVF4
ASGNF4
line 722
;722:	if ( frac > 1 )
ADDRLP4 4
INDIRF4
CNSTF4 1065353216
LEF4 $400
line 723
;723:		frac = 1.0;	// can happen during connection problems
ADDRLP4 4
CNSTF4 1065353216
ASGNF4
ADDRGP4 $401
JUMPV
LABELV $400
line 724
;724:	else if (frac < 0)
ADDRLP4 4
INDIRF4
CNSTF4 0
GEF4 $402
line 725
;725:		frac = 0.0;
ADDRLP4 4
CNSTF4 0
ASGNF4
LABELV $402
LABELV $401
line 728
;726:
;727:	// Use the liferate to set the scale over time.
;728:	re->data.sprite.radius = le->data.sprite.radius + (le->data.sprite.dradius*frac);
ADDRLP4 104
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 0
INDIRP4
CNSTI4 136
ADDP4
ADDRLP4 104
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
ADDRLP4 104
INDIRP4
CNSTI4 172
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 729
;729:	if (re->data.sprite.radius <= 0)
ADDRLP4 0
INDIRP4
CNSTI4 136
ADDP4
INDIRF4
CNSTF4 0
GTF4 $404
line 730
;730:	{
line 731
;731:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 732
;732:		return;
ADDRGP4 $398
JUMPV
LABELV $404
line 735
;733:	}
;734:
;735:	if (le->leFlags & LEF_MOVE)
ADDRFP4 0
INDIRP4
CNSTI4 12
ADDP4
INDIRI4
CNSTI4 4
BANDI4
CNSTI4 0
EQI4 $406
line 736
;736:	{
line 737
;737:		VectorCopy(re->origin, re->oldorigin);
ADDRLP4 0
INDIRP4
CNSTI4 84
ADDP4
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
INDIRB
ASGNB 12
line 738
;738:		BG_EvaluateTrajectory( &le->pos, cg.time, re->origin );
ADDRFP4 0
INDIRP4
CNSTI4 28
ADDP4
ARGP4
ADDRGP4 cg+105552
INDIRI4
ARGI4
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
ARGP4
ADDRGP4 BG_EvaluateTrajectory
CALLV
pop
line 740
;739:
;740:		if (le->leFlags & LEF_USE_COLLISION)
ADDRFP4 0
INDIRP4
CNSTI4 12
ADDP4
INDIRI4
CNSTI4 8
BANDI4
CNSTI4 0
EQI4 $409
line 741
;741:		{
line 743
;742:			// trace a line from previous position to new position
;743:			CG_Trace( &trace, re->oldorigin, NULL, NULL, re->origin, -1, CONTENTS_SOLID );
ADDRLP4 40
ARGP4
ADDRLP4 0
INDIRP4
CNSTI4 84
ADDP4
ARGP4
ADDRLP4 116
CNSTP4 0
ASGNP4
ADDRLP4 116
INDIRP4
ARGP4
ADDRLP4 116
INDIRP4
ARGP4
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
ARGP4
CNSTI4 -1
ARGI4
CNSTI4 1
ARGI4
ADDRGP4 CG_Trace
CALLV
pop
line 745
;744:
;745:			if ( trace.fraction != 1.0 ) 
ADDRLP4 40+8
INDIRF4
CNSTF4 1065353216
EQF4 $411
line 746
;746:			{	// Hit something.
line 750
;747:				// if it is in a nodrop zone, remove it
;748:				// this keeps gibs from waiting at the bottom of pits of death
;749:				// and floating levels
;750:				if ( trap_CM_PointContents( trace.endpos, 0 ) & CONTENTS_NODROP ) {
ADDRLP4 40+12
ARGP4
CNSTI4 0
ARGI4
ADDRLP4 120
ADDRGP4 trap_CM_PointContents
CALLI4
ASGNI4
ADDRLP4 120
INDIRI4
CVIU4 4
CNSTU4 2147483648
BANDU4
CNSTU4 0
EQU4 $414
line 751
;751:					CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 752
;752:					return;
ADDRGP4 $398
JUMPV
LABELV $414
line 756
;753:				}
;754:
;755:				// reflect the velocity on the trace plane
;756:				CG_ReflectVelocity( le, &trace );
ADDRFP4 0
INDIRP4
ARGP4
ADDRLP4 40
ARGP4
ADDRGP4 CG_ReflectVelocity
CALLV
pop
line 757
;757:			}
LABELV $411
line 758
;758:		}
LABELV $409
line 759
;759:	}
LABELV $406
line 763
;760:
;761:	// if the view would be "inside" the sprite, kill the sprite
;762:	// so it doesn't add too much overdraw
;763:	VectorSubtract( re->origin, cg.refdef.vieworg, delta );
ADDRLP4 24
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
INDIRF4
ADDRGP4 cg+106840+24
INDIRF4
SUBF4
ASGNF4
ADDRLP4 24+4
ADDRLP4 0
INDIRP4
CNSTI4 72
ADDP4
INDIRF4
ADDRGP4 cg+106840+24+4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 24+8
ADDRLP4 0
INDIRP4
CNSTI4 76
ADDP4
INDIRF4
ADDRGP4 cg+106840+24+8
INDIRF4
SUBF4
ASGNF4
line 764
;764:	len = VectorLength( delta );
ADDRLP4 24
ARGP4
ADDRLP4 112
ADDRGP4 VectorLength
CALLF4
ASGNF4
ADDRLP4 36
ADDRLP4 112
INDIRF4
ASGNF4
line 765
;765:	if ( len < le->data.sprite.radius ) {
ADDRLP4 36
INDIRF4
ADDRFP4 0
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
GEF4 $427
line 766
;766:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 767
;767:		return;
ADDRGP4 $398
JUMPV
LABELV $427
line 771
;768:	}
;769:
;770:	// Calculate the current alpha.
;771:	alpha = le->alpha + (le->dalpha * frac);
ADDRLP4 116
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 20
ADDRLP4 116
INDIRP4
CNSTI4 128
ADDP4
INDIRF4
ADDRLP4 116
INDIRP4
CNSTI4 132
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 772
;772:	VectorMA(le->data.sprite.startRGB, frac, le->data.sprite.dRGB, curRGB);
ADDRLP4 120
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 8
ADDRLP4 120
INDIRP4
CNSTI4 176
ADDP4
INDIRF4
ADDRLP4 120
INDIRP4
CNSTI4 188
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRLP4 8+4
ADDRLP4 120
INDIRP4
CNSTI4 180
ADDP4
INDIRF4
ADDRLP4 120
INDIRP4
CNSTI4 192
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRLP4 128
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 8+8
ADDRLP4 128
INDIRP4
CNSTI4 184
ADDP4
INDIRF4
ADDRLP4 128
INDIRP4
CNSTI4 196
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 773
;773:	re->shaderRGBA[0] = 0xff * alpha * curRGB[0];
ADDRLP4 136
CNSTF4 1132396544
ADDRLP4 20
INDIRF4
MULF4
ADDRLP4 8
INDIRF4
MULF4
ASGNF4
ADDRLP4 140
CNSTF4 1325400064
ASGNF4
ADDRLP4 136
INDIRF4
ADDRLP4 140
INDIRF4
LTF4 $432
ADDRLP4 132
ADDRLP4 136
INDIRF4
ADDRLP4 140
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $433
JUMPV
LABELV $432
ADDRLP4 132
ADDRLP4 136
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $433
ADDRLP4 0
INDIRP4
CNSTI4 116
ADDP4
ADDRLP4 132
INDIRU4
CVUU1 4
ASGNU1
line 774
;774:	re->shaderRGBA[1] = 0xff * alpha * curRGB[1];
ADDRLP4 148
CNSTF4 1132396544
ADDRLP4 20
INDIRF4
MULF4
ADDRLP4 8+4
INDIRF4
MULF4
ASGNF4
ADDRLP4 152
CNSTF4 1325400064
ASGNF4
ADDRLP4 148
INDIRF4
ADDRLP4 152
INDIRF4
LTF4 $436
ADDRLP4 144
ADDRLP4 148
INDIRF4
ADDRLP4 152
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $437
JUMPV
LABELV $436
ADDRLP4 144
ADDRLP4 148
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $437
ADDRLP4 0
INDIRP4
CNSTI4 117
ADDP4
ADDRLP4 144
INDIRU4
CVUU1 4
ASGNU1
line 775
;775:	re->shaderRGBA[2] = 0xff * alpha * curRGB[2];
ADDRLP4 160
CNSTF4 1132396544
ADDRLP4 20
INDIRF4
MULF4
ADDRLP4 8+8
INDIRF4
MULF4
ASGNF4
ADDRLP4 164
CNSTF4 1325400064
ASGNF4
ADDRLP4 160
INDIRF4
ADDRLP4 164
INDIRF4
LTF4 $440
ADDRLP4 156
ADDRLP4 160
INDIRF4
ADDRLP4 164
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $441
JUMPV
LABELV $440
ADDRLP4 156
ADDRLP4 160
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $441
ADDRLP4 0
INDIRP4
CNSTI4 118
ADDP4
ADDRLP4 156
INDIRU4
CVUU1 4
ASGNU1
line 776
;776:	re->shaderRGBA[3] = 0xff;	
ADDRLP4 0
INDIRP4
CNSTI4 119
ADDP4
CNSTU1 255
ASGNU1
line 778
;777:
;778:	re->reType = RT_SPRITE;
ADDRLP4 0
INDIRP4
CNSTI4 1
ASGNI4
line 780
;779:
;780:	trap_R_AddRefEntityToScene( re );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 781
;781:}
LABELV $398
endproc CG_AddViewSprite 168 28
export CG_AddBezier
proc CG_AddBezier 128 4
line 793
;782:
;783:
;784:/*
;785:===================
;786:CG_AddBezier
;787:
;788:For trek, for the imod and the...uh...imod.
;789:
;790:===================
;791:*/
;792:void CG_AddBezier( localEntity_t *le )
;793:{
line 796
;794:	refEntity_t	*re;
;795:	float		frac, alpha;
;796:	float		t = (cg.time - le->startTime)*0.001; // time elapsed since beginning of effect
ADDRLP4 0
CNSTF4 981668463
ADDRGP4 cg+105552
INDIRI4
ADDRFP4 0
INDIRP4
CNSTI4 16
ADDP4
INDIRI4
SUBI4
CVIF4 4
MULF4
ASGNF4
line 799
;797:	vec3_t		vTempPos;
;798:
;799:	re = &le->refEntity;
ADDRLP4 4
ADDRFP4 0
INDIRP4
CNSTI4 248
ADDP4
ASGNP4
line 801
;800:
;801:	frac = (cg.time - le->startTime) / ( float ) ( le->endTime - le->startTime );
ADDRLP4 28
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 32
ADDRLP4 28
INDIRP4
CNSTI4 16
ADDP4
INDIRI4
ASGNI4
ADDRLP4 20
ADDRGP4 cg+105552
INDIRI4
ADDRLP4 32
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 28
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRLP4 32
INDIRI4
SUBI4
CVIF4 4
DIVF4
ASGNF4
line 802
;802:	if ( frac > 1 ) 
ADDRLP4 20
INDIRF4
CNSTF4 1065353216
LEF4 $445
line 803
;803:		frac = 1.0;	// can happen during connection problems
ADDRLP4 20
CNSTF4 1065353216
ASGNF4
ADDRGP4 $446
JUMPV
LABELV $445
line 804
;804:	else if (frac < 0)
ADDRLP4 20
INDIRF4
CNSTF4 0
GEF4 $447
line 805
;805:		frac = 0.0;
ADDRLP4 20
CNSTF4 0
ASGNF4
LABELV $447
LABELV $446
line 808
;806:
;807:	// Use the liferate to set the scale over time.
;808:	re->data.bezier.width = le->data.line.width + (le->data.line.dwidth * frac);
ADDRLP4 36
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 4
INDIRP4
CNSTI4 132
ADDP4
ADDRLP4 36
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
ADDRLP4 36
INDIRP4
CNSTI4 172
ADDP4
INDIRF4
ADDRLP4 20
INDIRF4
MULF4
ADDF4
ASGNF4
line 809
;809:	if (re->data.bezier.width <= 0)
ADDRLP4 4
INDIRP4
CNSTI4 132
ADDP4
INDIRF4
CNSTF4 0
GTF4 $449
line 810
;810:	{
line 811
;811:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 812
;812:		return;
ADDRGP4 $442
JUMPV
LABELV $449
line 816
;813:	}
;814:
;815:	// We will assume here that we want additive transparency effects.
;816:	alpha = le->alpha + (le->dalpha * frac);
ADDRLP4 40
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 24
ADDRLP4 40
INDIRP4
CNSTI4 128
ADDP4
INDIRF4
ADDRLP4 40
INDIRP4
CNSTI4 132
ADDP4
INDIRF4
ADDRLP4 20
INDIRF4
MULF4
ADDF4
ASGNF4
line 817
;817:	re->shaderRGBA[0] = 0xff * alpha;
ADDRLP4 48
CNSTF4 1132396544
ADDRLP4 24
INDIRF4
MULF4
ASGNF4
ADDRLP4 52
CNSTF4 1325400064
ASGNF4
ADDRLP4 48
INDIRF4
ADDRLP4 52
INDIRF4
LTF4 $452
ADDRLP4 44
ADDRLP4 48
INDIRF4
ADDRLP4 52
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $453
JUMPV
LABELV $452
ADDRLP4 44
ADDRLP4 48
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $453
ADDRLP4 4
INDIRP4
CNSTI4 116
ADDP4
ADDRLP4 44
INDIRU4
CVUU1 4
ASGNU1
line 818
;818:	re->shaderRGBA[1] = 0xff * alpha;
ADDRLP4 60
CNSTF4 1132396544
ADDRLP4 24
INDIRF4
MULF4
ASGNF4
ADDRLP4 64
CNSTF4 1325400064
ASGNF4
ADDRLP4 60
INDIRF4
ADDRLP4 64
INDIRF4
LTF4 $455
ADDRLP4 56
ADDRLP4 60
INDIRF4
ADDRLP4 64
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $456
JUMPV
LABELV $455
ADDRLP4 56
ADDRLP4 60
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $456
ADDRLP4 4
INDIRP4
CNSTI4 117
ADDP4
ADDRLP4 56
INDIRU4
CVUU1 4
ASGNU1
line 819
;819:	re->shaderRGBA[2] = 0xff * alpha;
ADDRLP4 72
CNSTF4 1132396544
ADDRLP4 24
INDIRF4
MULF4
ASGNF4
ADDRLP4 76
CNSTF4 1325400064
ASGNF4
ADDRLP4 72
INDIRF4
ADDRLP4 76
INDIRF4
LTF4 $458
ADDRLP4 68
ADDRLP4 72
INDIRF4
ADDRLP4 76
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $459
JUMPV
LABELV $458
ADDRLP4 68
ADDRLP4 72
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $459
ADDRLP4 4
INDIRP4
CNSTI4 118
ADDP4
ADDRLP4 68
INDIRU4
CVUU1 4
ASGNU1
line 820
;820:	re->shaderRGBA[3] = 0xff;	// Yes, we could apply c to this too, but fading the color is better for lines.
ADDRLP4 4
INDIRP4
CNSTI4 119
ADDP4
CNSTU1 255
ASGNU1
line 822
;821:
;822:	re->reType = RT_BEZIER;
ADDRLP4 4
INDIRP4
CNSTI4 12
ASGNI4
line 835
;823:
;824:	// the refEntity only stores the two control points, so we need to update them here with 
;825:	//the control_velocity and control_acceleration, then store the results in refEntity. 
;826:	//use (cg.time - le->startTime) as a value for elapsed time t, plug it into the position formula:
;827:	//
;828:	// x = x0 + (v0 * t) + (0.5 * a * t * t)
;829:	//
;830:	//...where x is the position at time t, x0 is initial control point position, v0 is control point velocity,
;831:	//and a is control point acceleration
;832:	//
;833:
;834:	// update control point 1
;835:	VectorMA(le->data.line.control1, t, le->data.line.control1_velocity, vTempPos);
ADDRLP4 80
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 8
ADDRLP4 80
INDIRP4
CNSTI4 176
ADDP4
INDIRF4
ADDRLP4 80
INDIRP4
CNSTI4 200
ADDP4
INDIRF4
ADDRLP4 0
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRLP4 8+4
ADDRLP4 80
INDIRP4
CNSTI4 180
ADDP4
INDIRF4
ADDRLP4 80
INDIRP4
CNSTI4 204
ADDP4
INDIRF4
ADDRLP4 0
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRLP4 88
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 8+8
ADDRLP4 88
INDIRP4
CNSTI4 184
ADDP4
INDIRF4
ADDRLP4 88
INDIRP4
CNSTI4 208
ADDP4
INDIRF4
ADDRLP4 0
INDIRF4
MULF4
ADDF4
ASGNF4
line 836
;836:	VectorMA(vTempPos, (0.5*t*t), le->data.line.control1_acceleration, re->data.bezier.control1);
ADDRLP4 4
INDIRP4
CNSTI4 136
ADDP4
ADDRLP4 8
INDIRF4
ADDRFP4 0
INDIRP4
CNSTI4 224
ADDP4
INDIRF4
CNSTF4 1056964608
ADDRLP4 0
INDIRF4
MULF4
ADDRLP4 0
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
ADDRLP4 4
INDIRP4
CNSTI4 140
ADDP4
ADDRLP4 8+4
INDIRF4
ADDRFP4 0
INDIRP4
CNSTI4 228
ADDP4
INDIRF4
CNSTF4 1056964608
ADDRLP4 0
INDIRF4
MULF4
ADDRLP4 0
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
ADDRLP4 4
INDIRP4
CNSTI4 144
ADDP4
ADDRLP4 8+8
INDIRF4
ADDRFP4 0
INDIRP4
CNSTI4 232
ADDP4
INDIRF4
CNSTF4 1056964608
ADDRLP4 0
INDIRF4
MULF4
ADDRLP4 0
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
line 839
;837:
;838:	// update control point 2
;839:	VectorMA(le->data.line.control2, t, le->data.line.control2_velocity, vTempPos);
ADDRLP4 104
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 8
ADDRLP4 104
INDIRP4
CNSTI4 188
ADDP4
INDIRF4
ADDRLP4 104
INDIRP4
CNSTI4 212
ADDP4
INDIRF4
ADDRLP4 0
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRLP4 8+4
ADDRLP4 104
INDIRP4
CNSTI4 192
ADDP4
INDIRF4
ADDRLP4 104
INDIRP4
CNSTI4 216
ADDP4
INDIRF4
ADDRLP4 0
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRLP4 112
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 8+8
ADDRLP4 112
INDIRP4
CNSTI4 196
ADDP4
INDIRF4
ADDRLP4 112
INDIRP4
CNSTI4 220
ADDP4
INDIRF4
ADDRLP4 0
INDIRF4
MULF4
ADDF4
ASGNF4
line 840
;840:	VectorMA(vTempPos, (0.5*t*t), le->data.line.control2_acceleration, re->data.bezier.control2);
ADDRLP4 4
INDIRP4
CNSTI4 148
ADDP4
ADDRLP4 8
INDIRF4
ADDRFP4 0
INDIRP4
CNSTI4 236
ADDP4
INDIRF4
CNSTF4 1056964608
ADDRLP4 0
INDIRF4
MULF4
ADDRLP4 0
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
ADDRLP4 4
INDIRP4
CNSTI4 152
ADDP4
ADDRLP4 8+4
INDIRF4
ADDRFP4 0
INDIRP4
CNSTI4 240
ADDP4
INDIRF4
CNSTF4 1056964608
ADDRLP4 0
INDIRF4
MULF4
ADDRLP4 0
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
ADDRLP4 4
INDIRP4
CNSTI4 156
ADDP4
ADDRLP4 8+8
INDIRF4
ADDRFP4 0
INDIRP4
CNSTI4 244
ADDP4
INDIRF4
CNSTF4 1056964608
ADDRLP4 0
INDIRF4
MULF4
ADDRLP4 0
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
line 842
;841:
;842:	trap_R_AddRefEntityToScene( re );
ADDRLP4 4
INDIRP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 843
;843:}
LABELV $442
endproc CG_AddBezier 128 4
export CG_AddCylinder
proc CG_AddCylinder 72 4
line 855
;844:
;845:
;846:
;847:/*
;848:===================
;849:CG_AddCylinder
;850:
;851:For trek, cylinder primitive.
;852:===================
;853:*/
;854:void CG_AddCylinder( localEntity_t *le )
;855:{
line 859
;856:	refEntity_t	*re;
;857:	float		frac, alpha;
;858:
;859:	re = &le->refEntity;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 248
ADDP4
ASGNP4
line 861
;860:
;861:	frac = ( cg.time - le->startTime ) / ( float ) ( le->endTime - le->startTime );
ADDRLP4 12
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 16
ADDRLP4 12
INDIRP4
CNSTI4 16
ADDP4
INDIRI4
ASGNI4
ADDRLP4 4
ADDRGP4 cg+105552
INDIRI4
ADDRLP4 16
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 12
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRLP4 16
INDIRI4
SUBI4
CVIF4 4
DIVF4
ASGNF4
line 862
;862:	if ( frac > 1 )
ADDRLP4 4
INDIRF4
CNSTF4 1065353216
LEF4 $470
line 863
;863:		frac = 1.0;	// can happen during connection problems
ADDRLP4 4
CNSTF4 1065353216
ASGNF4
ADDRGP4 $471
JUMPV
LABELV $470
line 864
;864:	else if (frac < 0)
ADDRLP4 4
INDIRF4
CNSTF4 0
GEF4 $472
line 865
;865:		frac = 0.0;
ADDRLP4 4
CNSTF4 0
ASGNF4
LABELV $472
LABELV $471
line 868
;866:
;867:	// Use the liferate to set the scale over time.
;868:	re->data.cylinder.height = le->data.cylinder.height + (le->data.cylinder.dheight*frac);
ADDRLP4 20
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 0
INDIRP4
CNSTI4 144
ADDP4
ADDRLP4 20
INDIRP4
CNSTI4 184
ADDP4
INDIRF4
ADDRLP4 20
INDIRP4
CNSTI4 188
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 869
;869:	if (re->data.cylinder.height <= 0)
ADDRLP4 0
INDIRP4
CNSTI4 144
ADDP4
INDIRF4
CNSTF4 0
GTF4 $474
line 870
;870:	{
line 871
;871:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 872
;872:		return;
ADDRGP4 $468
JUMPV
LABELV $474
line 874
;873:	}
;874:	re->data.cylinder.width = le->data.cylinder.width + (le->data.cylinder.dwidth*frac);
ADDRLP4 24
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 0
INDIRP4
CNSTI4 132
ADDP4
ADDRLP4 24
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
ADDRLP4 24
INDIRP4
CNSTI4 172
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 875
;875:	if (re->data.cylinder.width <= 0)
ADDRLP4 0
INDIRP4
CNSTI4 132
ADDP4
INDIRF4
CNSTF4 0
GTF4 $476
line 876
;876:	{
line 877
;877:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 878
;878:		return;
ADDRGP4 $468
JUMPV
LABELV $476
line 880
;879:	}
;880:	re->data.cylinder.width2 = le->data.cylinder.width2 + (le->data.cylinder.dwidth2*frac);
ADDRLP4 28
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 0
INDIRP4
CNSTI4 136
ADDP4
ADDRLP4 28
INDIRP4
CNSTI4 176
ADDP4
INDIRF4
ADDRLP4 28
INDIRP4
CNSTI4 180
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 881
;881:	if (re->data.cylinder.width2 <= 0)
ADDRLP4 0
INDIRP4
CNSTI4 136
ADDP4
INDIRF4
CNSTF4 0
GTF4 $478
line 882
;882:	{
line 883
;883:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 884
;884:		return;
ADDRGP4 $468
JUMPV
LABELV $478
line 888
;885:	}
;886:
;887:	// Calculate the current alpha.
;888:	alpha = le->alpha + (le->dalpha * frac);
ADDRLP4 32
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 8
ADDRLP4 32
INDIRP4
CNSTI4 128
ADDP4
INDIRF4
ADDRLP4 32
INDIRP4
CNSTI4 132
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 889
;889:	re->shaderRGBA[0] = 0xff * alpha;
ADDRLP4 40
CNSTF4 1132396544
ADDRLP4 8
INDIRF4
MULF4
ASGNF4
ADDRLP4 44
CNSTF4 1325400064
ASGNF4
ADDRLP4 40
INDIRF4
ADDRLP4 44
INDIRF4
LTF4 $481
ADDRLP4 36
ADDRLP4 40
INDIRF4
ADDRLP4 44
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $482
JUMPV
LABELV $481
ADDRLP4 36
ADDRLP4 40
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $482
ADDRLP4 0
INDIRP4
CNSTI4 116
ADDP4
ADDRLP4 36
INDIRU4
CVUU1 4
ASGNU1
line 890
;890:	re->shaderRGBA[1] = 0xff * alpha;
ADDRLP4 52
CNSTF4 1132396544
ADDRLP4 8
INDIRF4
MULF4
ASGNF4
ADDRLP4 56
CNSTF4 1325400064
ASGNF4
ADDRLP4 52
INDIRF4
ADDRLP4 56
INDIRF4
LTF4 $484
ADDRLP4 48
ADDRLP4 52
INDIRF4
ADDRLP4 56
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $485
JUMPV
LABELV $484
ADDRLP4 48
ADDRLP4 52
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $485
ADDRLP4 0
INDIRP4
CNSTI4 117
ADDP4
ADDRLP4 48
INDIRU4
CVUU1 4
ASGNU1
line 891
;891:	re->shaderRGBA[2] = 0xff * alpha;
ADDRLP4 64
CNSTF4 1132396544
ADDRLP4 8
INDIRF4
MULF4
ASGNF4
ADDRLP4 68
CNSTF4 1325400064
ASGNF4
ADDRLP4 64
INDIRF4
ADDRLP4 68
INDIRF4
LTF4 $487
ADDRLP4 60
ADDRLP4 64
INDIRF4
ADDRLP4 68
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $488
JUMPV
LABELV $487
ADDRLP4 60
ADDRLP4 64
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $488
ADDRLP4 0
INDIRP4
CNSTI4 118
ADDP4
ADDRLP4 60
INDIRU4
CVUU1 4
ASGNU1
line 892
;892:	re->shaderRGBA[3] = 0xff;	
ADDRLP4 0
INDIRP4
CNSTI4 119
ADDP4
CNSTU1 255
ASGNU1
line 894
;893:
;894:	re->reType = RT_CYLINDER;
ADDRLP4 0
INDIRP4
CNSTI4 13
ASGNI4
line 896
;895:
;896:	trap_R_AddRefEntityToScene( re );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 897
;897:}
LABELV $468
endproc CG_AddCylinder 72 4
export CG_AddElectricity
proc CG_AddElectricity 64 4
line 911
;898:
;899:
;900:
;901:/*
;902:===================
;903:CG_AddElectricity
;904:
;905:For trek, electricity primitive.
;906:===================
;907:*/
;908:
;909:#define DEFAULT_DEVIATION	0.5
;910:
;911:void CG_AddElectricity( localEntity_t *le ) {
line 915
;912:	refEntity_t	*re;
;913:	float		frac, alpha;
;914:
;915:	re = &le->refEntity;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 248
ADDP4
ASGNP4
line 917
;916:
;917:	frac = ( cg.time - le->startTime ) / ( float ) ( le->endTime - le->startTime );
ADDRLP4 12
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 16
ADDRLP4 12
INDIRP4
CNSTI4 16
ADDP4
INDIRI4
ASGNI4
ADDRLP4 4
ADDRGP4 cg+105552
INDIRI4
ADDRLP4 16
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 12
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRLP4 16
INDIRI4
SUBI4
CVIF4 4
DIVF4
ASGNF4
line 918
;918:	if ( frac > 1 )
ADDRLP4 4
INDIRF4
CNSTF4 1065353216
LEF4 $491
line 919
;919:		frac = 1.0;	// can happen during connection problems
ADDRLP4 4
CNSTF4 1065353216
ASGNF4
ADDRGP4 $492
JUMPV
LABELV $491
line 920
;920:	else if (frac < 0)
ADDRLP4 4
INDIRF4
CNSTF4 0
GEF4 $493
line 921
;921:		frac = 0.0;
ADDRLP4 4
CNSTF4 0
ASGNF4
LABELV $493
LABELV $492
line 923
;922:
;923:	re->data.electricity.width = le->data.electricity.width + (le->data.electricity.dwidth*frac);
ADDRLP4 20
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 0
INDIRP4
CNSTI4 132
ADDP4
ADDRLP4 20
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
ADDRLP4 20
INDIRP4
CNSTI4 172
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 926
;924:	
;925:	// Calculate the current alpha.
;926:	alpha = le->alpha + (le->dalpha * frac);
ADDRLP4 24
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 8
ADDRLP4 24
INDIRP4
CNSTI4 128
ADDP4
INDIRF4
ADDRLP4 24
INDIRP4
CNSTI4 132
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ADDF4
ASGNF4
line 927
;927:	re->shaderRGBA[0] = 0xff * alpha;
ADDRLP4 32
CNSTF4 1132396544
ADDRLP4 8
INDIRF4
MULF4
ASGNF4
ADDRLP4 36
CNSTF4 1325400064
ASGNF4
ADDRLP4 32
INDIRF4
ADDRLP4 36
INDIRF4
LTF4 $496
ADDRLP4 28
ADDRLP4 32
INDIRF4
ADDRLP4 36
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $497
JUMPV
LABELV $496
ADDRLP4 28
ADDRLP4 32
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $497
ADDRLP4 0
INDIRP4
CNSTI4 116
ADDP4
ADDRLP4 28
INDIRU4
CVUU1 4
ASGNU1
line 928
;928:	re->shaderRGBA[1] = 0xff * alpha;
ADDRLP4 44
CNSTF4 1132396544
ADDRLP4 8
INDIRF4
MULF4
ASGNF4
ADDRLP4 48
CNSTF4 1325400064
ASGNF4
ADDRLP4 44
INDIRF4
ADDRLP4 48
INDIRF4
LTF4 $499
ADDRLP4 40
ADDRLP4 44
INDIRF4
ADDRLP4 48
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $500
JUMPV
LABELV $499
ADDRLP4 40
ADDRLP4 44
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $500
ADDRLP4 0
INDIRP4
CNSTI4 117
ADDP4
ADDRLP4 40
INDIRU4
CVUU1 4
ASGNU1
line 929
;929:	re->shaderRGBA[2] = 0xff * alpha;
ADDRLP4 56
CNSTF4 1132396544
ADDRLP4 8
INDIRF4
MULF4
ASGNF4
ADDRLP4 60
CNSTF4 1325400064
ASGNF4
ADDRLP4 56
INDIRF4
ADDRLP4 60
INDIRF4
LTF4 $502
ADDRLP4 52
ADDRLP4 56
INDIRF4
ADDRLP4 60
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $503
JUMPV
LABELV $502
ADDRLP4 52
ADDRLP4 56
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $503
ADDRLP4 0
INDIRP4
CNSTI4 118
ADDP4
ADDRLP4 52
INDIRU4
CVUU1 4
ASGNU1
line 930
;930:	re->shaderRGBA[3] = 0xff;	
ADDRLP4 0
INDIRP4
CNSTI4 119
ADDP4
CNSTU1 255
ASGNU1
line 932
;931:
;932:	re->reType = RT_ELECTRICITY;
ADDRLP4 0
INDIRP4
CNSTI4 14
ASGNI4
line 934
;933:
;934:	trap_R_AddRefEntityToScene( re );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 935
;935:}
LABELV $489
endproc CG_AddElectricity 64 4
proc CG_AddParticle 156 28
line 945
;936:
;937:/*
;938:===================
;939:CG_AddParticle
;940:
;941:For trek, special explosion stuff sometimes wants these
;942:===================
;943:*/
;944:static void CG_AddParticle( localEntity_t *le ) 
;945:{
line 952
;946:	refEntity_t	*re;
;947:	float		frac, alpha;
;948:	vec3_t		delta, dir;
;949:	float		len;
;950:	trace_t		trace;
;951:
;952:	re = &le->refEntity;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 248
ADDP4
ASGNP4
line 954
;953:
;954:	frac = ( cg.time - le->startTime ) / ( float ) ( le->endTime - le->startTime );
ADDRLP4 96
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 100
ADDRLP4 96
INDIRP4
CNSTI4 16
ADDP4
INDIRI4
ASGNI4
ADDRLP4 16
ADDRGP4 cg+105552
INDIRI4
ADDRLP4 100
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 96
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRLP4 100
INDIRI4
SUBI4
CVIF4 4
DIVF4
ASGNF4
line 955
;955:	if ( frac > 1 )
ADDRLP4 16
INDIRF4
CNSTF4 1065353216
LEF4 $506
line 956
;956:		frac = 1.0;	// can happen during connection problems
ADDRLP4 16
CNSTF4 1065353216
ASGNF4
ADDRGP4 $507
JUMPV
LABELV $506
line 957
;957:	else if (frac < 0)
ADDRLP4 16
INDIRF4
CNSTF4 0
GEF4 $508
line 958
;958:		frac = 0.0;
ADDRLP4 16
CNSTF4 0
ASGNF4
LABELV $508
LABELV $507
line 961
;959:
;960:	// Use the liferate to set the scale over time.
;961:	re->data.sprite.radius = le->data.particle.radius + (le->data.particle.dradius*frac);
ADDRLP4 104
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 0
INDIRP4
CNSTI4 136
ADDP4
ADDRLP4 104
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
ADDRLP4 104
INDIRP4
CNSTI4 172
ADDP4
INDIRF4
ADDRLP4 16
INDIRF4
MULF4
ADDF4
ASGNF4
line 962
;962:	if (re->data.sprite.radius <= 0)
ADDRLP4 0
INDIRP4
CNSTI4 136
ADDP4
INDIRF4
CNSTF4 0
GTF4 $510
line 963
;963:	{
line 964
;964:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 965
;965:		return;
ADDRGP4 $504
JUMPV
LABELV $510
line 968
;966:	}
;967:
;968:	if (le->leFlags & LEF_MOVE)
ADDRFP4 0
INDIRP4
CNSTI4 12
ADDP4
INDIRI4
CNSTI4 4
BANDI4
CNSTI4 0
EQI4 $512
line 969
;969:	{
line 971
;970:		// kef -- do these two lines _before_ copying origin into oldorigin
;971:		VectorSubtract(re->oldorigin, re->origin, dir);
ADDRLP4 4
ADDRLP4 0
INDIRP4
CNSTI4 84
ADDP4
INDIRF4
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 4+4
ADDRLP4 0
INDIRP4
CNSTI4 88
ADDP4
INDIRF4
ADDRLP4 0
INDIRP4
CNSTI4 72
ADDP4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 4+8
ADDRLP4 0
INDIRP4
CNSTI4 92
ADDP4
INDIRF4
ADDRLP4 0
INDIRP4
CNSTI4 76
ADDP4
INDIRF4
SUBF4
ASGNF4
line 972
;972:		VectorNormalize(dir);
ADDRLP4 4
ARGP4
ADDRGP4 VectorNormalize
CALLF4
pop
line 974
;973:
;974:		VectorCopy(re->origin, re->oldorigin);
ADDRLP4 0
INDIRP4
CNSTI4 84
ADDP4
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
INDIRB
ASGNB 12
line 975
;975:		BG_EvaluateTrajectory( &le->pos, cg.time, re->origin );
ADDRFP4 0
INDIRP4
CNSTI4 28
ADDP4
ARGP4
ADDRGP4 cg+105552
INDIRI4
ARGI4
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
ARGP4
ADDRGP4 BG_EvaluateTrajectory
CALLV
pop
line 977
;976:
;977:		if (le->leFlags & LEF_USE_COLLISION)
ADDRFP4 0
INDIRP4
CNSTI4 12
ADDP4
INDIRI4
CNSTI4 8
BANDI4
CNSTI4 0
EQI4 $517
line 978
;978:		{
line 980
;979:			// trace a line from previous position to new position
;980:			CG_Trace( &trace, re->oldorigin, NULL, NULL, re->origin, -1, CONTENTS_SOLID );
ADDRLP4 40
ARGP4
ADDRLP4 0
INDIRP4
CNSTI4 84
ADDP4
ARGP4
ADDRLP4 124
CNSTP4 0
ASGNP4
ADDRLP4 124
INDIRP4
ARGP4
ADDRLP4 124
INDIRP4
ARGP4
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
ARGP4
CNSTI4 -1
ARGI4
CNSTI4 1
ARGI4
ADDRGP4 CG_Trace
CALLV
pop
line 982
;981:
;982:			if ( trace.fraction != 1.0 ) 
ADDRLP4 40+8
INDIRF4
CNSTF4 1065353216
EQF4 $519
line 983
;983:			{	// Hit something.
line 987
;984:				// if it is in a nodrop zone, remove it
;985:				// this keeps gibs from waiting at the bottom of pits of death
;986:				// and floating levels
;987:				if ( trap_CM_PointContents( trace.endpos, 0 ) & CONTENTS_NODROP ) {
ADDRLP4 40+12
ARGP4
CNSTI4 0
ARGI4
ADDRLP4 128
ADDRGP4 trap_CM_PointContents
CALLI4
ASGNI4
ADDRLP4 128
INDIRI4
CVIU4 4
CNSTU4 2147483648
BANDU4
CNSTU4 0
EQU4 $522
line 988
;988:					CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 989
;989:					return;
ADDRGP4 $504
JUMPV
LABELV $522
line 993
;990:				}
;991:
;992:				// reflect the velocity on the trace plane
;993:				CG_ReflectVelocity( le, &trace );
ADDRFP4 0
INDIRP4
ARGP4
ADDRLP4 40
ARGP4
ADDRGP4 CG_ReflectVelocity
CALLV
pop
line 994
;994:			}
LABELV $519
line 995
;995:			VectorSubtract(re->oldorigin, re->origin, dir);
ADDRLP4 4
ADDRLP4 0
INDIRP4
CNSTI4 84
ADDP4
INDIRF4
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 4+4
ADDRLP4 0
INDIRP4
CNSTI4 88
ADDP4
INDIRF4
ADDRLP4 0
INDIRP4
CNSTI4 72
ADDP4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 4+8
ADDRLP4 0
INDIRP4
CNSTI4 92
ADDP4
INDIRF4
ADDRLP4 0
INDIRP4
CNSTI4 76
ADDP4
INDIRF4
SUBF4
ASGNF4
line 996
;996:			VectorNormalize(dir);
ADDRLP4 4
ARGP4
ADDRGP4 VectorNormalize
CALLF4
pop
line 997
;997:		}
LABELV $517
line 998
;998:	}
LABELV $512
line 1002
;999:
;1000:	// if the view would be "inside" the sprite, kill the sprite
;1001:	// so it doesn't add too much overdraw
;1002:	VectorSubtract( re->origin, cg.refdef.vieworg, delta );
ADDRLP4 24
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
INDIRF4
ADDRGP4 cg+106840+24
INDIRF4
SUBF4
ASGNF4
ADDRLP4 24+4
ADDRLP4 0
INDIRP4
CNSTI4 72
ADDP4
INDIRF4
ADDRGP4 cg+106840+24+4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 24+8
ADDRLP4 0
INDIRP4
CNSTI4 76
ADDP4
INDIRF4
ADDRGP4 cg+106840+24+8
INDIRF4
SUBF4
ASGNF4
line 1003
;1003:	len = VectorLength( delta );
ADDRLP4 24
ARGP4
ADDRLP4 112
ADDRGP4 VectorLength
CALLF4
ASGNF4
ADDRLP4 36
ADDRLP4 112
INDIRF4
ASGNF4
line 1004
;1004:	if ( len < le->data.particle.radius ) {
ADDRLP4 36
INDIRF4
ADDRFP4 0
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
GEF4 $537
line 1005
;1005:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 1006
;1006:		return;
ADDRGP4 $504
JUMPV
LABELV $537
line 1011
;1007:	}
;1008:
;1009:	// kef -- here's where I, in my infinite wisdom, have decided to emulate the singleplayer
;1010:	//particle think function
;1011:	VectorNegate(dir, le->data.particle.dir);
ADDRFP4 0
INDIRP4
CNSTI4 180
ADDP4
ADDRLP4 4
INDIRF4
NEGF4
ASGNF4
ADDRFP4 0
INDIRP4
CNSTI4 184
ADDP4
ADDRLP4 4+4
INDIRF4
NEGF4
ASGNF4
ADDRFP4 0
INDIRP4
CNSTI4 188
ADDP4
ADDRLP4 4+8
INDIRF4
NEGF4
ASGNF4
line 1012
;1012:	if (le->data.particle.thinkFn)
ADDRFP4 0
INDIRP4
CNSTI4 176
ADDP4
INDIRP4
CVPU4 4
CNSTU4 0
EQU4 $541
line 1013
;1013:	{
line 1014
;1014:		le->data.particle.thinkFn(le);
ADDRLP4 116
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 116
INDIRP4
ARGP4
ADDRLP4 116
INDIRP4
CNSTI4 176
ADDP4
INDIRP4
CALLI4
pop
line 1015
;1015:	}
LABELV $541
line 1018
;1016:
;1017:	// Calculate the current alpha.
;1018:	alpha = le->alpha + (le->dalpha * frac);
ADDRLP4 116
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 20
ADDRLP4 116
INDIRP4
CNSTI4 128
ADDP4
INDIRF4
ADDRLP4 116
INDIRP4
CNSTI4 132
ADDP4
INDIRF4
ADDRLP4 16
INDIRF4
MULF4
ADDF4
ASGNF4
line 1019
;1019:	re->shaderRGBA[0] = 0xff * alpha;
ADDRLP4 124
CNSTF4 1132396544
ADDRLP4 20
INDIRF4
MULF4
ASGNF4
ADDRLP4 128
CNSTF4 1325400064
ASGNF4
ADDRLP4 124
INDIRF4
ADDRLP4 128
INDIRF4
LTF4 $544
ADDRLP4 120
ADDRLP4 124
INDIRF4
ADDRLP4 128
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $545
JUMPV
LABELV $544
ADDRLP4 120
ADDRLP4 124
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $545
ADDRLP4 0
INDIRP4
CNSTI4 116
ADDP4
ADDRLP4 120
INDIRU4
CVUU1 4
ASGNU1
line 1020
;1020:	re->shaderRGBA[1] = 0xff * alpha;
ADDRLP4 136
CNSTF4 1132396544
ADDRLP4 20
INDIRF4
MULF4
ASGNF4
ADDRLP4 140
CNSTF4 1325400064
ASGNF4
ADDRLP4 136
INDIRF4
ADDRLP4 140
INDIRF4
LTF4 $547
ADDRLP4 132
ADDRLP4 136
INDIRF4
ADDRLP4 140
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $548
JUMPV
LABELV $547
ADDRLP4 132
ADDRLP4 136
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $548
ADDRLP4 0
INDIRP4
CNSTI4 117
ADDP4
ADDRLP4 132
INDIRU4
CVUU1 4
ASGNU1
line 1021
;1021:	re->shaderRGBA[2] = 0xff * alpha;
ADDRLP4 148
CNSTF4 1132396544
ADDRLP4 20
INDIRF4
MULF4
ASGNF4
ADDRLP4 152
CNSTF4 1325400064
ASGNF4
ADDRLP4 148
INDIRF4
ADDRLP4 152
INDIRF4
LTF4 $550
ADDRLP4 144
ADDRLP4 148
INDIRF4
ADDRLP4 152
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $551
JUMPV
LABELV $550
ADDRLP4 144
ADDRLP4 148
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $551
ADDRLP4 0
INDIRP4
CNSTI4 118
ADDP4
ADDRLP4 144
INDIRU4
CVUU1 4
ASGNU1
line 1022
;1022:	re->shaderRGBA[3] = 0xff;	
ADDRLP4 0
INDIRP4
CNSTI4 119
ADDP4
CNSTU1 255
ASGNU1
line 1024
;1023:
;1024:	re->reType = RT_SPRITE;
ADDRLP4 0
INDIRP4
CNSTI4 1
ASGNI4
line 1026
;1025:
;1026:	trap_R_AddRefEntityToScene( re );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 1027
;1027:}
LABELV $504
endproc CG_AddParticle 156 28
proc CG_AddSpawner 100 28
line 1030
;1028:
;1029:static void CG_AddSpawner( localEntity_t *le ) 
;1030:{
line 1035
;1031:	refEntity_t	*re;
;1032:	vec3_t		dir;
;1033:	trace_t		trace;
;1034:
;1035:	re = &le->refEntity;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 248
ADDP4
ASGNP4
line 1036
;1036:	if (le->leFlags & LEF_MOVE)
ADDRFP4 0
INDIRP4
CNSTI4 12
ADDP4
INDIRI4
CNSTI4 4
BANDI4
CNSTI4 0
EQI4 $553
line 1037
;1037:	{
line 1039
;1038:		// kef -- do these two lines _before_ copying origin into oldorigin
;1039:		VectorSubtract(re->oldorigin, re->origin, dir);
ADDRLP4 4
ADDRLP4 0
INDIRP4
CNSTI4 84
ADDP4
INDIRF4
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 4+4
ADDRLP4 0
INDIRP4
CNSTI4 88
ADDP4
INDIRF4
ADDRLP4 0
INDIRP4
CNSTI4 72
ADDP4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 4+8
ADDRLP4 0
INDIRP4
CNSTI4 92
ADDP4
INDIRF4
ADDRLP4 0
INDIRP4
CNSTI4 76
ADDP4
INDIRF4
SUBF4
ASGNF4
line 1040
;1040:		VectorNormalize(dir);
ADDRLP4 4
ARGP4
ADDRGP4 VectorNormalize
CALLF4
pop
line 1042
;1041:
;1042:		VectorCopy(re->origin, re->oldorigin);
ADDRLP4 0
INDIRP4
CNSTI4 84
ADDP4
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
INDIRB
ASGNB 12
line 1043
;1043:		BG_EvaluateTrajectory( &le->pos, cg.time, re->origin );
ADDRFP4 0
INDIRP4
CNSTI4 28
ADDP4
ARGP4
ADDRGP4 cg+105552
INDIRI4
ARGI4
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
ARGP4
ADDRGP4 BG_EvaluateTrajectory
CALLV
pop
line 1045
;1044:
;1045:		if (le->leFlags & LEF_USE_COLLISION)
ADDRFP4 0
INDIRP4
CNSTI4 12
ADDP4
INDIRI4
CNSTI4 8
BANDI4
CNSTI4 0
EQI4 $558
line 1046
;1046:		{
line 1048
;1047:			// trace a line from previous position to new position
;1048:			CG_Trace( &trace, re->oldorigin, NULL, NULL, re->origin, -1, CONTENTS_SOLID );
ADDRLP4 16
ARGP4
ADDRLP4 0
INDIRP4
CNSTI4 84
ADDP4
ARGP4
ADDRLP4 88
CNSTP4 0
ASGNP4
ADDRLP4 88
INDIRP4
ARGP4
ADDRLP4 88
INDIRP4
ARGP4
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
ARGP4
CNSTI4 -1
ARGI4
CNSTI4 1
ARGI4
ADDRGP4 CG_Trace
CALLV
pop
line 1050
;1049:
;1050:			if ( trace.fraction != 1.0 ) 
ADDRLP4 16+8
INDIRF4
CNSTF4 1065353216
EQF4 $560
line 1051
;1051:			{	// Hit something.
line 1055
;1052:				// if it is in a nodrop zone, remove it
;1053:				// this keeps gibs from waiting at the bottom of pits of death
;1054:				// and floating levels
;1055:				if ( trap_CM_PointContents( trace.endpos, 0 ) & CONTENTS_NODROP ) {
ADDRLP4 16+12
ARGP4
CNSTI4 0
ARGI4
ADDRLP4 92
ADDRGP4 trap_CM_PointContents
CALLI4
ASGNI4
ADDRLP4 92
INDIRI4
CVIU4 4
CNSTU4 2147483648
BANDU4
CNSTU4 0
EQU4 $563
line 1056
;1056:					CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 1057
;1057:					return;
ADDRGP4 $552
JUMPV
LABELV $563
line 1061
;1058:				}
;1059:
;1060:				// reflect the velocity on the trace plane
;1061:				CG_ReflectVelocity( le, &trace );
ADDRFP4 0
INDIRP4
ARGP4
ADDRLP4 16
ARGP4
ADDRGP4 CG_ReflectVelocity
CALLV
pop
line 1062
;1062:			}
LABELV $560
line 1063
;1063:			VectorSubtract(re->oldorigin, re->origin, dir);
ADDRLP4 4
ADDRLP4 0
INDIRP4
CNSTI4 84
ADDP4
INDIRF4
ADDRLP4 0
INDIRP4
CNSTI4 68
ADDP4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 4+4
ADDRLP4 0
INDIRP4
CNSTI4 88
ADDP4
INDIRF4
ADDRLP4 0
INDIRP4
CNSTI4 72
ADDP4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 4+8
ADDRLP4 0
INDIRP4
CNSTI4 92
ADDP4
INDIRF4
ADDRLP4 0
INDIRP4
CNSTI4 76
ADDP4
INDIRF4
SUBF4
ASGNF4
line 1064
;1064:			VectorNormalize(dir);
ADDRLP4 4
ARGP4
ADDRGP4 VectorNormalize
CALLF4
pop
line 1065
;1065:		}
LABELV $558
line 1066
;1066:	}
LABELV $553
line 1070
;1067:
;1068:	// kef -- here's where I, in my infinite wisdom, have decided to emulate the singleplayer
;1069:	//particle think function
;1070:	if (cg.time < le->data.spawner.nextthink)
ADDRGP4 cg+105552
INDIRI4
ADDRFP4 0
INDIRP4
CNSTI4 192
ADDP4
INDIRI4
GEI4 $568
line 1071
;1071:	{
line 1072
;1072:		return;
ADDRGP4 $552
JUMPV
LABELV $568
line 1074
;1073:	}
;1074:	le->data.spawner.nextthink = cg.time + (le->data.spawner.delay + 
ADDRLP4 72
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 76
ADDRLP4 72
INDIRP4
CNSTI4 184
ADDP4
INDIRF4
ASGNF4
ADDRLP4 76
INDIRF4
NEGF4
ARGF4
ADDRLP4 76
INDIRF4
ARGF4
ADDRLP4 80
ADDRGP4 flrandom
CALLF4
ASGNF4
ADDRLP4 84
ADDRLP4 72
INDIRP4
CNSTI4 188
ADDP4
INDIRI4
CVIF4 4
ASGNF4
ADDRLP4 72
INDIRP4
CNSTI4 192
ADDP4
ADDRGP4 cg+105552
INDIRI4
CVIF4 4
ADDRLP4 84
INDIRF4
ADDRLP4 84
INDIRF4
ADDRLP4 80
INDIRF4
MULF4
ADDF4
ADDF4
CVFI4 4
ASGNI4
line 1077
;1075:		(le->data.spawner.delay*flrandom(-le->data.spawner.variance,le->data.spawner.variance)));
;1076:
;1077:	if (le->data.spawner.thinkFn)
ADDRFP4 0
INDIRP4
CNSTI4 196
ADDP4
INDIRP4
CVPU4 4
CNSTU4 0
EQU4 $572
line 1078
;1078:	{
line 1079
;1079:		le->data.spawner.thinkFn(le);
ADDRLP4 88
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 88
INDIRP4
ARGP4
ADDRLP4 88
INDIRP4
CNSTI4 196
ADDP4
INDIRP4
CALLI4
pop
line 1080
;1080:	}
LABELV $572
line 1081
;1081:	if (le->data.spawner.dontDie)
ADDRFP4 0
INDIRP4
CNSTI4 168
ADDP4
INDIRI4
CNSTI4 0
EQI4 $574
line 1082
;1082:	{
line 1083
;1083:		le->endTime = le->endTime + 10000;
ADDRLP4 88
ADDRFP4 0
INDIRP4
CNSTI4 20
ADDP4
ASGNP4
ADDRLP4 88
INDIRP4
ADDRLP4 88
INDIRP4
INDIRI4
CNSTI4 10000
ADDI4
ASGNI4
line 1084
;1084:	}
LABELV $574
line 1085
;1085:}
LABELV $552
endproc CG_AddSpawner 100 28
export CG_AddFragment
proc CG_AddFragment 112 28
line 1093
;1086:
;1087:
;1088:/*
;1089:================
;1090:CG_AddFragment
;1091:================
;1092:*/
;1093:void CG_AddFragment( localEntity_t *le ) {
line 1098
;1094:	vec3_t	newOrigin;
;1095:	trace_t	trace;
;1096:	int k;
;1097:
;1098:	if ( le->pos.trType == TR_STATIONARY ) {
ADDRFP4 0
INDIRP4
CNSTI4 28
ADDP4
INDIRI4
CNSTI4 0
NEI4 $577
line 1103
;1099:		// sink into the ground if near the removal time
;1100:		int		t;
;1101:		float	oldZ;
;1102:		
;1103:		t = le->endTime - cg.time;
ADDRLP4 72
ADDRFP4 0
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRGP4 cg+105552
INDIRI4
SUBI4
ASGNI4
line 1104
;1104:		if ( t < SINK_TIME ) {
ADDRLP4 72
INDIRI4
CNSTI4 1000
GEI4 $580
line 1108
;1105:			// we must use an explicit lighting origin, otherwise the
;1106:			// lighting would be lost as soon as the origin went
;1107:			// into the ground
;1108:			VectorCopy( le->refEntity.origin, le->refEntity.lightingOrigin );
ADDRLP4 80
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 80
INDIRP4
CNSTI4 260
ADDP4
ADDRLP4 80
INDIRP4
CNSTI4 316
ADDP4
INDIRB
ASGNB 12
line 1109
;1109:			le->refEntity.renderfx |= RF_LIGHTING_ORIGIN;
ADDRLP4 84
ADDRFP4 0
INDIRP4
CNSTI4 252
ADDP4
ASGNP4
ADDRLP4 84
INDIRP4
ADDRLP4 84
INDIRP4
INDIRI4
CNSTI4 128
BORI4
ASGNI4
line 1110
;1110:			oldZ = le->refEntity.origin[2];
ADDRLP4 76
ADDRFP4 0
INDIRP4
CNSTI4 324
ADDP4
INDIRF4
ASGNF4
line 1111
;1111:			le->refEntity.origin[2] -= 16 * ( 1.0 - (float)t / SINK_TIME );
ADDRLP4 88
ADDRFP4 0
INDIRP4
CNSTI4 324
ADDP4
ASGNP4
ADDRLP4 88
INDIRP4
ADDRLP4 88
INDIRP4
INDIRF4
CNSTF4 1098907648
CNSTF4 1065353216
ADDRLP4 72
INDIRI4
CVIF4 4
CNSTF4 1148846080
DIVF4
SUBF4
MULF4
SUBF4
ASGNF4
line 1112
;1112:			trap_R_AddRefEntityToScene( &le->refEntity );
ADDRFP4 0
INDIRP4
CNSTI4 248
ADDP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 1113
;1113:			le->refEntity.origin[2] = oldZ;
ADDRFP4 0
INDIRP4
CNSTI4 324
ADDP4
ADDRLP4 76
INDIRF4
ASGNF4
line 1114
;1114:		} else {
ADDRGP4 $576
JUMPV
LABELV $580
line 1115
;1115:			trap_R_AddRefEntityToScene( &le->refEntity );
ADDRFP4 0
INDIRP4
CNSTI4 248
ADDP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 1116
;1116:		}
line 1118
;1117:
;1118:		return;
ADDRGP4 $576
JUMPV
LABELV $577
line 1122
;1119:	}
;1120:
;1121:	// calculate new position
;1122:	BG_EvaluateTrajectory( &le->pos, cg.time, newOrigin );
ADDRFP4 0
INDIRP4
CNSTI4 28
ADDP4
ARGP4
ADDRGP4 cg+105552
INDIRI4
ARGI4
ADDRLP4 60
ARGP4
ADDRGP4 BG_EvaluateTrajectory
CALLV
pop
line 1125
;1123:
;1124:	// trace a line from previous position to new position
;1125:	CG_Trace( &trace, le->refEntity.origin, NULL, NULL, newOrigin, 0 /*le->ownerGentNum*/, CONTENTS_SOLID );
ADDRLP4 4
ARGP4
ADDRFP4 0
INDIRP4
CNSTI4 316
ADDP4
ARGP4
ADDRLP4 72
CNSTP4 0
ASGNP4
ADDRLP4 72
INDIRP4
ARGP4
ADDRLP4 72
INDIRP4
ARGP4
ADDRLP4 60
ARGP4
CNSTI4 0
ARGI4
CNSTI4 1
ARGI4
ADDRGP4 CG_Trace
CALLV
pop
line 1126
;1126:	if ( trace.fraction == 1.0 ) {
ADDRLP4 4+8
INDIRF4
CNSTF4 1065353216
NEF4 $583
line 1128
;1127:		// still in free fall
;1128:		VectorCopy( newOrigin, le->refEntity.origin );
ADDRFP4 0
INDIRP4
CNSTI4 316
ADDP4
ADDRLP4 60
INDIRB
ASGNB 12
line 1130
;1129:
;1130:		if ( le->leFlags & LEF_TUMBLE ) {
ADDRFP4 0
INDIRP4
CNSTI4 12
ADDP4
INDIRI4
CNSTI4 2
BANDI4
CNSTI4 0
EQI4 $586
line 1133
;1131:			vec3_t angles;
;1132:
;1133:			BG_EvaluateTrajectory( &le->angles, cg.time, angles );
ADDRFP4 0
INDIRP4
CNSTI4 64
ADDP4
ARGP4
ADDRGP4 cg+105552
INDIRI4
ARGI4
ADDRLP4 76
ARGP4
ADDRGP4 BG_EvaluateTrajectory
CALLV
pop
line 1134
;1134:			AnglesToAxis( angles, le->refEntity.axis );
ADDRLP4 76
ARGP4
ADDRFP4 0
INDIRP4
CNSTI4 276
ADDP4
ARGP4
ADDRGP4 AnglesToAxis
CALLV
pop
line 1135
;1135:			for(k = 0; k < 3; k++)
ADDRLP4 0
CNSTI4 0
ASGNI4
LABELV $589
line 1136
;1136:			{
line 1137
;1137:				VectorScale(le->refEntity.axis[k], le->data.fragment.radius, le->refEntity.axis[k]);
ADDRLP4 88
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 92
CNSTI4 12
ADDRLP4 0
INDIRI4
MULI4
ADDRLP4 88
INDIRP4
CNSTI4 276
ADDP4
ADDP4
ASGNP4
ADDRLP4 92
INDIRP4
ADDRLP4 92
INDIRP4
INDIRF4
ADDRLP4 88
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
MULF4
ASGNF4
ADDRLP4 96
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 100
CNSTI4 12
ADDRLP4 0
INDIRI4
MULI4
ADDRLP4 96
INDIRP4
CNSTI4 276
ADDP4
ADDP4
CNSTI4 4
ADDP4
ASGNP4
ADDRLP4 100
INDIRP4
ADDRLP4 100
INDIRP4
INDIRF4
ADDRLP4 96
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
MULF4
ASGNF4
ADDRLP4 104
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 108
CNSTI4 12
ADDRLP4 0
INDIRI4
MULI4
ADDRLP4 104
INDIRP4
CNSTI4 276
ADDP4
ADDP4
CNSTI4 8
ADDP4
ASGNP4
ADDRLP4 108
INDIRP4
ADDRLP4 108
INDIRP4
INDIRF4
ADDRLP4 104
INDIRP4
CNSTI4 168
ADDP4
INDIRF4
MULF4
ASGNF4
line 1138
;1138:			}
LABELV $590
line 1135
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
ADDRLP4 0
INDIRI4
CNSTI4 3
LTI4 $589
line 1140
;1139:
;1140:		}
LABELV $586
line 1142
;1141:
;1142:		trap_R_AddRefEntityToScene( &le->refEntity );
ADDRFP4 0
INDIRP4
CNSTI4 248
ADDP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 1144
;1143:
;1144:		return;
ADDRGP4 $576
JUMPV
LABELV $583
line 1150
;1145:	}
;1146:
;1147:	// if it is in a nodrop zone, remove it
;1148:	// this keeps gibs from waiting at the bottom of pits of death
;1149:	// and floating levels
;1150:	if ( trap_CM_PointContents( trace.endpos, 0 ) & CONTENTS_NODROP ) {
ADDRLP4 4+12
ARGP4
CNSTI4 0
ARGI4
ADDRLP4 76
ADDRGP4 trap_CM_PointContents
CALLI4
ASGNI4
ADDRLP4 76
INDIRI4
CVIU4 4
CNSTU4 2147483648
BANDU4
CNSTU4 0
EQU4 $593
line 1151
;1151:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 1152
;1152:		return;
ADDRGP4 $576
JUMPV
LABELV $593
line 1156
;1153:	}
;1154:
;1155:	// reflect the velocity on the trace plane
;1156:	CG_ReflectVelocity( le, &trace );
ADDRFP4 0
INDIRP4
ARGP4
ADDRLP4 4
ARGP4
ADDRGP4 CG_ReflectVelocity
CALLV
pop
line 1159
;1157:	//FIXME: if LEF_TUMBLE, change avelocity too?
;1158:
;1159:	trap_R_AddRefEntityToScene( &le->refEntity );
ADDRFP4 0
INDIRP4
CNSTI4 248
ADDP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 1160
;1160:}
LABELV $576
endproc CG_AddFragment 112 28
export CG_AddLocalEntities
proc CG_AddLocalEntities 16 8
line 1171
;1161:
;1162:
;1163://==============================================================================
;1164:
;1165:/*
;1166:===================
;1167:CG_AddLocalEntities
;1168:
;1169:===================
;1170:*/
;1171:void CG_AddLocalEntities( void ) {
line 1176
;1172:	localEntity_t	*le, *next;
;1173:
;1174:	// walk the list backwards, so any new local entities generated
;1175:	// (trails, marks, etc) will be present this frame
;1176:	le = cg_activeLocalEntities.prev;
ADDRLP4 0
ADDRGP4 cg_activeLocalEntities
INDIRP4
ASGNP4
line 1177
;1177:	for ( ; le != &cg_activeLocalEntities ; le = next ) {
ADDRGP4 $600
JUMPV
LABELV $597
line 1180
;1178:		// grab next now, so if the local entity is freed we
;1179:		// still have it
;1180:		next = le->prev;
ADDRLP4 4
ADDRLP4 0
INDIRP4
INDIRP4
ASGNP4
line 1182
;1181:
;1182:		if ( cg.time >= le->endTime ) {
ADDRGP4 cg+105552
INDIRI4
ADDRLP4 0
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
LTI4 $601
line 1183
;1183:			CG_FreeLocalEntity( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 1184
;1184:			continue;
ADDRGP4 $598
JUMPV
LABELV $601
line 1187
;1185:		}
;1186:
;1187:		if (le->leFlags & LEF_ONE_FRAME)
ADDRLP4 0
INDIRP4
CNSTI4 12
ADDP4
INDIRI4
CNSTI4 16
BANDI4
CNSTI4 0
EQI4 $604
line 1188
;1188:		{	// If this flag is set, only render one single frame, no more.
line 1189
;1189:			if (le->leFlags & LEF_ONE_FRAME_DONE) 
ADDRLP4 0
INDIRP4
CNSTI4 12
ADDP4
INDIRI4
CNSTI4 32
BANDI4
CNSTI4 0
EQI4 $606
line 1190
;1190:			{
line 1191
;1191:				CG_FreeLocalEntity( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 1192
;1192:				continue;
ADDRGP4 $598
JUMPV
LABELV $606
line 1195
;1193:			}
;1194:			else
;1195:			{
line 1196
;1196:				le->leFlags |= LEF_ONE_FRAME_DONE;
ADDRLP4 8
ADDRLP4 0
INDIRP4
CNSTI4 12
ADDP4
ASGNP4
ADDRLP4 8
INDIRP4
ADDRLP4 8
INDIRP4
INDIRI4
CNSTI4 32
BORI4
ASGNI4
line 1197
;1197:			}
line 1198
;1198:		}
LABELV $604
line 1200
;1199:
;1200:		switch ( le->leType ) {
ADDRLP4 8
ADDRLP4 0
INDIRP4
CNSTI4 8
ADDP4
INDIRI4
ASGNI4
ADDRLP4 8
INDIRI4
CNSTI4 0
LTI4 $608
ADDRLP4 8
INDIRI4
CNSTI4 19
GTI4 $608
ADDRLP4 8
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 $632
ADDP4
INDIRP4
JUMPV
lit
align 4
LABELV $632
address $609
address $614
address $613
address $615
address $617
address $616
address $618
address $619
address $620
address $621
address $622
address $623
address $624
address $625
address $626
address $627
address $628
address $629
address $630
address $631
code
LABELV $608
line 1202
;1201:		default:
;1202:			CG_Error( "Bad leType: %i", le->leType );
ADDRGP4 $611
ARGP4
ADDRLP4 0
INDIRP4
CNSTI4 8
ADDP4
INDIRI4
ARGI4
ADDRGP4 CG_Error
CALLV
pop
line 1203
;1203:			break;
ADDRGP4 $609
JUMPV
line 1206
;1204:
;1205:		case LE_MARK:
;1206:			break;
LABELV $613
line 1209
;1207:
;1208:		case LE_SPRITE_EXPLOSION:
;1209:			CG_AddSpriteExplosion( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddSpriteExplosion
CALLV
pop
line 1210
;1210:			break;
ADDRGP4 $609
JUMPV
LABELV $614
line 1213
;1211:
;1212:		case LE_EXPLOSION:
;1213:			CG_AddExplosion( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddExplosion
CALLV
pop
line 1214
;1214:			break;
ADDRGP4 $609
JUMPV
LABELV $615
line 1217
;1215:
;1216:		case LE_MOVE_SCALE_FADE:		// water bubbles
;1217:			CG_AddMoveScaleFade( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddMoveScaleFade
CALLV
pop
line 1218
;1218:			break;
ADDRGP4 $609
JUMPV
LABELV $616
line 1221
;1219:
;1220:		case LE_FADE_RGB:				// teleporters, railtrails
;1221:			CG_AddFadeRGB( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddFadeRGB
CALLV
pop
line 1222
;1222:			break;
ADDRGP4 $609
JUMPV
LABELV $617
line 1225
;1223:
;1224:		case LE_FALL_SCALE_FADE: // gib blood trails
;1225:			CG_AddFallScaleFade( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddFallScaleFade
CALLV
pop
line 1226
;1226:			break;
ADDRGP4 $609
JUMPV
LABELV $618
line 1229
;1227:
;1228:		case LE_SCALE_FADE:		// rocket trails
;1229:			CG_AddScaleFade( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddScaleFade
CALLV
pop
line 1230
;1230:			break;
ADDRGP4 $609
JUMPV
LABELV $619
line 1233
;1231:
;1232:		case LE_SCALE_FADE_SPRITE:		// Trek type for oriented poly sprites.
;1233:			CG_AddScaleFadeSprite( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddScaleFadeSprite
CALLV
pop
line 1234
;1234:			break;
ADDRGP4 $609
JUMPV
LABELV $620
line 1237
;1235:
;1236:		case LE_LINE:					// Trek type for beams.
;1237:			CG_AddLine( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddLine
CALLV
pop
line 1238
;1238:			break;
ADDRGP4 $609
JUMPV
LABELV $621
line 1241
;1239:
;1240:		case LE_LINE2:					// Trek type for beams, with taper support.
;1241:			CG_AddLine2( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddLine2
CALLV
pop
line 1242
;1242:			break;
ADDRGP4 $609
JUMPV
LABELV $622
line 1245
;1243:
;1244:		case LE_OLINE:					// Trek type for rectangles
;1245:			CG_AddOLine( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddOLine
CALLV
pop
line 1246
;1246:			break;
ADDRGP4 $609
JUMPV
LABELV $623
line 1249
;1247:
;1248:		case LE_TRAIL:					// Trek type for sparks.
;1249:			CG_AddTrail( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddTrail
CALLV
pop
line 1250
;1250:			break;
ADDRGP4 $609
JUMPV
LABELV $624
line 1253
;1251:
;1252:		case LE_VIEWSPRITE:				// Trek primitive for camera-facing sprites.
;1253:			CG_AddViewSprite( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddViewSprite
CALLV
pop
line 1254
;1254:			break;
ADDRGP4 $609
JUMPV
LABELV $625
line 1257
;1255:
;1256:		case LE_BEZIER:
;1257:			CG_AddBezier( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddBezier
CALLV
pop
line 1258
;1258:			break;
ADDRGP4 $609
JUMPV
LABELV $626
line 1261
;1259:
;1260:		case LE_QUAD:
;1261:			CG_AddQuad( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddQuad
CALLV
pop
line 1262
;1262:			break;
ADDRGP4 $609
JUMPV
LABELV $627
line 1265
;1263:
;1264:		case LE_CYLINDER:
;1265:			CG_AddCylinder(le);
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddCylinder
CALLV
pop
line 1266
;1266:			break;
ADDRGP4 $609
JUMPV
LABELV $628
line 1269
;1267:
;1268:		case LE_ELECTRICITY:
;1269:			CG_AddElectricity(le);
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddElectricity
CALLV
pop
line 1270
;1270:			break;
ADDRGP4 $609
JUMPV
LABELV $629
line 1273
;1271:
;1272:		case LE_PARTICLE:
;1273:			CG_AddParticle(le);
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddParticle
CALLV
pop
line 1274
;1274:			break;
ADDRGP4 $609
JUMPV
LABELV $630
line 1277
;1275:
;1276:		case LE_SPAWNER:
;1277:			CG_AddSpawner(le);
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddSpawner
CALLV
pop
line 1278
;1278:			break;
ADDRGP4 $609
JUMPV
LABELV $631
line 1281
;1279:
;1280:		case LE_FRAGMENT:
;1281:			CG_AddFragment(le);
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddFragment
CALLV
pop
line 1282
;1282:			break;
LABELV $609
line 1284
;1283:		}
;1284:	}
LABELV $598
line 1177
ADDRLP4 0
ADDRLP4 4
INDIRP4
ASGNP4
LABELV $600
ADDRLP4 0
INDIRP4
CVPU4 4
ADDRGP4 cg_activeLocalEntities
CVPU4 4
NEU4 $597
line 1285
;1285:}
LABELV $596
endproc CG_AddLocalEntities 16 8
bss
export cg_freeLocalEntities
align 4
LABELV cg_freeLocalEntities
skip 4
export cg_activeLocalEntities
align 4
LABELV cg_activeLocalEntities
skip 408
export cg_localEntities
align 4
LABELV cg_localEntities
skip 208896
import trap_MemoryRemaining
import testPrintFloat
import testPrintInt
import trap_SetUserCmdValue
import trap_GetUserCmd
import trap_GetCurrentCmdNumber
import trap_GetServerCommand
import trap_GetSnapshot
import trap_GetCurrentSnapshotNumber
import trap_GetGameState
import trap_GetGlconfig
import trap_R_LerpTag
import trap_R_ModelBounds
import trap_R_DrawStretchPic
import trap_R_SetColor
import trap_R_RenderScene
import trap_R_AddLightToScene
import trap_R_AddPolyToScene
import trap_R_AddRefEntityToScene
import trap_R_ClearScene
import trap_R_RegisterShaderNoMip
import trap_R_RegisterShader3D
import trap_R_RegisterShader
import trap_R_RegisterSkin
import trap_R_RegisterModel
import trap_R_LoadWorldMap
import trap_S_StartBackgroundTrack
import trap_S_RegisterSound
import trap_S_Respatialize
import trap_S_UpdateEntityPosition
import trap_S_AddLoopingSound
import trap_S_ClearLoopingSounds
import trap_S_StartLocalSound
import trap_S_StartSound
import trap_CM_MarkFragments
import trap_CM_TransformedBoxTrace
import trap_CM_BoxTrace
import trap_CM_TransformedPointContents
import trap_CM_PointContents
import trap_CM_TempBoxModel
import trap_CM_InlineModel
import trap_CM_NumInlineModels
import trap_CM_LoadMap
import trap_UpdateScreen
import trap_SendClientCommand
import trap_AddCommand
import trap_SendConsoleCommand
import trap_FS_FCloseFile
import trap_FS_Write
import trap_FS_Read
import trap_FS_FOpenFile
import trap_Args
import trap_Argv
import trap_Argc
import trap_Cvar_VariableStringBuffer
import trap_Cvar_Set_No_Modify
import trap_Cvar_Set
import trap_Cvar_Update
import trap_Cvar_Register
import trap_Milliseconds
import trap_Error
import trap_Print
import updateSkin
import CG_TransitionPlayerState
import CG_Respawn
import CG_SetConfigValues
import CG_ParseServerinfo
import CG_ExecuteNewServerCommands
import CG_InitConsoleCommands
import CG_ConsoleCommand
import AW_SPPostgameMenu_f
import cg_medalStreakSounds
import cg_medalStreakPicNames
import cg_medalTeamSounds
import cg_medalTeamPicNames
import cg_medalSounds
import cg_medalPicNames
import CG_DrawTourneyScoreboard
import CG_DrawScoreboard
import CG_DrawInformation
import CG_LoadingClient
import CG_LoadingItem
import CG_LoadingString
import CG_ProcessSnapshots
import CG_ExplosionEffects
import CG_SurfaceExplosion
import CG_MakeExplosion2
import CG_MakeExplosion
import CG_Seeker
import CG_Bleed
import CG_SpawnEffect
import CG_BubbleTrail
import CG_SmokePuff
import CG_ImpactMark
import CG_AddMarks
import CG_InitMarkPolys
import CG_BounceEffect
import CG_OutOfAmmoChange
import CG_DrawWeaponSelect
import CG_AddPlayerWeapon
import CG_AddViewWeapon
import CG_MissileHitPlayer
import CG_MissileHitWall
import CG_FireSeeker
import CG_FireWeapon
import CG_RegisterItemVisuals
import CG_RegisterWeapon
import CG_Weapon_f
import CG_PrevWeapon_f
import CG_NextWeapon_f
import CG_Chunks
import CG_Drip
import CG_TransporterPad
import CG_Bolt
import CG_Steam
import CG_Spark
import CG_PositionRotatedEntityOnTag
import CG_PositionEntityOnTag
import CG_AdjustPositionForMover
import CG_Beam
import CG_AddPacketEntities
import CG_SetEntitySoundPosition
import CG_PainEvent
import CG_EntityEvent
import CG_PlaceString
import CG_CheckEvents
import CG_LoadDeferredPlayers
import CG_PredictPlayerState
import CG_Trace
import CG_PointContents
import CG_BuildSolidList
import CG_CustomSound
import CG_NewClientInfo
import CG_AddRefEntityWithPowerups
import CG_ResetPlayerEntity
import CG_Player
import CG_PlayerShieldHit
import CG_DrawObjectiveInformation
import CG_DrawNumField
import CG_DrawTeamBackground
import CG_DrawFlagModel
import CG_DrawActive
import CG_DrawHead
import CG_CenterPrint
import CG_AddLagometerSnapshotInfo
import CG_AddLagometerFrameInfo
import drawTeamOverlayModificationCount
import numSortedTeamPlayers
import sortedTeamPlayers
import interface_graphics
import UI_ProportionalStringWidth
import CG_GetColorForHealth
import CG_ColorForHealth
import CG_TileClear
import CG_TeamColor
import CG_FadeColor
import CG_DrawStrlen
import CG_DrawSmallStringColor
import CG_DrawSmallString
import CG_DrawBigStringColor
import CG_DrawBigString
import CG_DrawStringExt
import CG_LoadFonts
import UI_DrawProportionalString
import CG_DrawString
import CG_DrawPic
import CG_FillRect
import CG_AdjustFrom640
import CG_PrintInterfaceGraphics
import CG_DrawActiveFrame
import CG_CameraShake
import CG_ZoomUp_f
import CG_ZoomDown_f
import CG_TestModelPrevSkin_f
import CG_TestModelNextSkin_f
import CG_TestModelPrevFrame_f
import CG_TestModelNextFrame_f
import CG_TestGun_f
import CG_TestModel_f
import CG_LastAttacker
import CG_CrosshairPlayer
import CG_UpdateCvars
import CG_StartMusic
import CG_Error
import CG_Printf
import CG_Argv
import CG_ConfigString
import cg_deferPlayers
import cg_predictItems
import cg_blood
import cg_paused
import cg_buildScript
import cg_forceModel
import cg_reportDamage
import cg_stats
import cg_teamChatHeight
import cg_teamChatTime
import cg_synchronousClients
import cg_drawAttacker
import cg_lagometer
import cg_stereoSeparation
import cg_thirdPerson
import cg_thirdPersonAngle
import cg_thirdPersonRange
import cg_zoomFov
import cg_fov
import cg_simpleItems
import cg_ignore
import cg_autoswitch
import cg_viewsize
import cg_drawGun
import cg_gun_z
import cg_gun_y
import cg_gun_x
import cg_gun_frame
import cg_addMarks
import cg_footsteps
import cg_showmiss
import cg_noPlayerAnims
import cg_nopredict
import cg_errorDecay
import cg_debugEvents
import cg_debugPosition
import cg_debugAnim
import cg_animSpeed
import cg_draw2D
import cg_drawStatus
import cg_crosshairHealth
import cg_crosshairSize
import cg_crosshairY
import cg_crosshairX
import cg_teamOverlayUserinfo
import cg_drawTeamOverlay
import cg_drawRewards
import cg_drawCrosshairNames
import cg_drawCrosshair
import cg_drawAmmoWarning
import cg_drawIcons
import cg_draw3dIcons
import cg_drawSnapshot
import cg_drawFPS
import cg_drawTimer
import cg_gibs
import cg_shadows
import cg_swingSpeed
import cg_bobroll
import cg_bobpitch
import cg_bobup
import cg_runroll
import cg_runpitch
import cg_centertime
import cg_markPolys
import cg_items
import cg_weapons
import cg_entities
import cg
import cgs
import Max_Ammo
import BG_PlayerTouchesItem
import BG_PlayerStateToEntityState
import BG_AddPredictableEventToPlayerstate
import BG_EvaluateTrajectoryDelta
import BG_EvaluateTrajectory
import BG_CanItemBeGrabbed
import BG_FindItemForHoldable
import BG_FindItemForPowerup
import BG_FindItemForAmmo
import BG_FindItemForWeapon
import BG_FindItem
import BG_FindClassnameForHoldable
import BG_FindItemWithClassname
import bg_numItems
import bg_itemlist
import Pmove
import PM_UpdateViewAngles
import Com_Printf
import Com_Error
import Info_NextPair
import Info_Validate
import Info_SetValueForKey_Big
import Info_SetValueForKey
import Info_RemoveKey_big
import Info_RemoveKey
import Info_ValueForKey
import va
import Swap_Init
import BigFloat
import BigLong
import BigShort
import Q_CleanStr
import Q_PrintStrlen
import Q_strcat
import Q_strncpyz
import Q_strrchr
import Q_strupr
import Q_strlwr
import Q_stricmpn
import Q_strncmp
import Q_stricmp
import Q_isalpha
import Q_isupper
import Q_islower
import Q_isprint
import Com_sprintf
import Parse3DMatrix
import Parse2DMatrix
import Parse1DMatrix
import SkipRestOfLine
import SkipBracedSection
import COM_MatchToken
import COM_ParseExt
import COM_Parse
import COM_GetCurrentParseLine
import COM_BeginParseSession
import COM_DefaultExtension
import COM_StripExtension
import COM_SkipPath
import Com_Clamp
import UnVectorShort
import VectorShort
import PerpendicularVector
import AngleVectors
import MatrixMultiply
import PlaneTypeForNormal
import MakeNormalVectors
import RotateAroundDirection
import RotatePointAroundVector
import ProjectPointOnPlane
import PlaneFromPoints
import AngleDelta
import AngleNormalize180
import AngleNormalize360
import AnglesSubtract
import AngleSubtract
import LerpAngle
import AngleMod
import BoxOnPlaneSide
import SetPlaneSignbits
import AxisCopy
import AxisClear
import AnglesToAxis
import vectoangles
import irandom
import flrandom
import Q_crandom
import Q_random
import Q_rand
import Q_log2
import VectorRotate
import Vector4Scale
import VectorInverse
import VectorNormalize2
import VectorNormalizeFast
import VectorNormalize
import CrossProduct
import DistanceSquared
import Distance
import VectorLengthSquared
import VectorLength
import VectorCompare
import AddPointToBounds
import ClearBounds
import RadiusFromBounds
import NormalizeColor
import ColorBytes4
import ColorBytes3
import _VectorMA
import _VectorScale
import _VectorCopy
import _VectorAdd
import _VectorSubtract
import _DotProduct
import ByteToDir
import DirToByte
import ClampShort
import ClampChar
import Q_rsqrt
import Q_fabs
import axisDefault
import vec3_origin
import g_color_table
import colorDkGrey
import colorMdGrey
import colorLtGrey
import colorWhite
import colorCyan
import colorMagenta
import colorYellow
import colorBlue
import colorGreen
import colorRed
import colorBlack
import colorTable
import bytedirs
import fabs
import abs
import tan
import atan2
import cos
import sin
import sqrt
import floor
import ceil
import memcpy
import memset
import memmove
import sscanf
import vsprintf
import _atoi
import atoi
import _atof
import atof
import toupper
import tolower
import strncpy
import strstr
import strchr
import strcmp
import strcpy
import strcat
import strlen
import rand
import srand
import qsort
lit
align 1
LABELV $611
byte 1 66
byte 1 97
byte 1 100
byte 1 32
byte 1 108
byte 1 101
byte 1 84
byte 1 121
byte 1 112
byte 1 101
byte 1 58
byte 1 32
byte 1 37
byte 1 105
byte 1 0
align 1
LABELV $97
byte 1 67
byte 1 71
byte 1 95
byte 1 70
byte 1 114
byte 1 101
byte 1 101
byte 1 76
byte 1 111
byte 1 99
byte 1 97
byte 1 108
byte 1 69
byte 1 110
byte 1 116
byte 1 105
byte 1 116
byte 1 121
byte 1 58
byte 1 32
byte 1 110
byte 1 111
byte 1 116
byte 1 32
byte 1 97
byte 1 99
byte 1 116
byte 1 105
byte 1 118
byte 1 101
byte 1 0
