export PlayerIcon
code
proc PlayerIcon 80 20
file "../ui_splevel.c"
line 151
;1:// Copyright (C) 1999-2000 Id Software, Inc.
;2://
;3:/*
;4:=============================================================================
;5:
;6:SINGLE PLAYER LEVEL SELECT MENU
;7:
;8:=============================================================================
;9:*/
;10:
;11:#include "ui_local.h"
;12:
;13:typedef struct 
;14:{
;15:	menuframework_s	menu;
;16:	menubitmap_s	mainmenu;
;17:	menubitmap_s	preset;
;18:	menubitmap_s	create;
;19:
;20:} spchoose_t;
;21:static spchoose_t s_spchoose;
;22:
;23:
;24:#define ART_LEVELFRAME_FOCUS		"menu/art/maps_select"
;25:#define ART_LEVELFRAME_SELECTED		"menu/art/maps_selected"
;26:#define ART_MAP_UNKNOWN				"levelshots/unknownmap"
;27:#define ART_MAP_COMPLETE1			"menu/art/level_complete1"
;28:#define ART_MAP_COMPLETE2			"menu/art/level_complete2"
;29:#define ART_MAP_COMPLETE3			"menu/art/level_complete3"
;30:#define ART_MAP_COMPLETE4			"menu/art/level_complete4"
;31:#define ART_MAP_COMPLETE5			"menu/art/level_complete5"
;32:
;33:#define ID_LEFTARROW		10
;34:#define ID_PICTURE0			11
;35:#define ID_PICTURE1			12
;36:#define ID_PICTURE2			13
;37:#define ID_PICTURE3			14
;38:#define ID_RIGHTARROW		15
;39:#define ID_PLAYERPIC		16
;40:#define ID_AWARD1			17
;41:#define ID_AWARD2			18
;42:#define ID_AWARD3			19
;43:#define ID_AWARD4			20
;44:#define ID_AWARD5			21
;45:#define ID_AWARD6			22
;46:#define ID_AWARD7			23
;47:#define ID_AWARD8			24
;48:#define ID_AWARD9			25
;49:#define ID_RESET			26
;50:#define ID_CUSTOM			27
;51:#define ID_NEXT				28
;52:#define ID_MAINMENU			100
;53:#define ID_PLAYERINFO		112
;54:#define ID_NO				120
;55:#define ID_YES				121
;56:#define ID_PRESET			122
;57:#define ID_BACK				123
;58:#define ID_ADVANCED			124
;59:
;60:#define AWARDS_Y			(315)
;61:
;62:#define MAX_ITEM_MAPS 4
;63:
;64:#define MAX_LONGNAME		24
;65:
;66:typedef struct 
;67:{
;68:	menuframework_s	menu;
;69:
;70:	menubitmap_s	mainmenu;
;71:	menubitmap_s	back;
;72:	menubitmap_s	create;
;73:	menubitmap_s	fight;
;74:	menubitmap_s	item_leftarrow;
;75:	menubitmap_s	item_maps[MAX_ITEM_MAPS];
;76:	menubitmap_s	item_rightarrow;
;77:	menubitmap_s	item_player;
;78:	menubitmap_s	item_awards[6];
;79:	menubitmap_s	item_null;
;80:	menubitmap_s	item_reset;
;81:	menubitmap_s	playerinfo;
;82:	menubitmap_s	advanced;
;83:
;84:	qboolean		reinit;
;85:
;86:	const char *	selectedArenaInfo;
;87:	int				numMaps;
;88:	char			levelPicNames[4][MAX_QPATH];
;89:	char			levelNames[4][16];
;90:	char			levelLongNames[4][MAX_LONGNAME];
;91:	int				levelScores[MAX_ITEM_MAPS];
;92:	int				levelScoresSkill[4];
;93:	qhandle_t		levelSelectedPic;
;94:	qhandle_t		levelFocusPic;
;95:	qhandle_t		levelCompletePic[5];
;96:
;97:	qhandle_t		corner_ul_18_12;
;98:	qhandle_t		corner_ur_18_12;
;99:	qhandle_t		corner_ll_18_34;
;100:	qhandle_t		corner_lr_7_12;
;101:
;102:	char			playerModel[MAX_QPATH];
;103:	char			playerPicName[MAX_QPATH];
;104:	int				awardLevels[6];
;105:	sfxHandle_t		awardSounds[6];
;106:
;107:	int				numBots;
;108:	qhandle_t		botPics[7];
;109:	char			botNames[7][10];
;110:} levelMenuInfo_t;
;111:
;112:static levelMenuInfo_t	levelMenuInfo;
;113:
;114://=========================================================================================
;115:// Reset Menu Struct
;116://=========================================================================================
;117:typedef struct 
;118:{
;119:	menuframework_s	menu;
;120:	menubitmap_s	mainmenu;
;121:	menubitmap_s	back;
;122:	menubitmap_s	yes;
;123:
;124:	qhandle_t		corner_ul;
;125:	qhandle_t		corner_ur;
;126:	qhandle_t		corner_ll;
;127:	qhandle_t		corner_lr;
;128:
;129:} resetGameMenuInfo_t;
;130:
;131:static resetGameMenuInfo_t	resetGameMenuInfo;
;132:
;133:
;134:void UI_ResetGameMenu( void );
;135:
;136:static int	selectedArenaSet;
;137:static int	selectedArena;
;138:static int	currentSet;
;139:static int	currentGame;
;140:static int	trainingTier;
;141:static int	finalTier;
;142:static int	minTier;
;143:static int	maxTier;
;144:
;145:
;146:/*
;147:=================
;148:PlayerIcon
;149:=================
;150:*/
;151:void PlayerIcon( const char *modelAndSkin, char *iconName, int iconNameMaxSize ) {
line 155
;152:	char	*skin;
;153:	char	model[MAX_QPATH];
;154:
;155:	Q_strncpyz( model, modelAndSkin, sizeof(model));
ADDRLP4 4
ARGP4
ADDRFP4 0
INDIRP4
ARGP4
CNSTI4 64
ARGI4
ADDRGP4 Q_strncpyz
CALLV
pop
line 156
;156:	skin = Q_strrchr( model, '/' );
ADDRLP4 4
ARGP4
CNSTI4 47
ARGI4
ADDRLP4 68
ADDRGP4 Q_strrchr
CALLP4
ASGNP4
ADDRLP4 0
ADDRLP4 68
INDIRP4
ASGNP4
line 157
;157:	if ( skin ) {
ADDRLP4 0
INDIRP4
CVPU4 4
CNSTU4 0
EQU4 $78
line 158
;158:		*skin++ = '\0';
ADDRLP4 72
ADDRLP4 0
INDIRP4
ASGNP4
ADDRLP4 0
ADDRLP4 72
INDIRP4
CNSTI4 1
ADDP4
ASGNP4
ADDRLP4 72
INDIRP4
CNSTI1 0
ASGNI1
line 159
;159:	}
ADDRGP4 $79
JUMPV
LABELV $78
line 160
;160:	else {
line 161
;161:		skin = "default";
ADDRLP4 0
ADDRGP4 $80
ASGNP4
line 162
;162:	}
LABELV $79
line 164
;163:
;164:	Com_sprintf(iconName, iconNameMaxSize, "models/players2/%s/icon_%s.jpg", model, skin );
ADDRFP4 4
INDIRP4
ARGP4
ADDRFP4 8
INDIRI4
ARGI4
ADDRGP4 $81
ARGP4
ADDRLP4 4
ARGP4
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 Com_sprintf
CALLV
pop
line 166
;165:
;166:	if( !trap_R_RegisterShaderNoMip( iconName ) && Q_stricmp( skin, "default" ) != 0 ) {
ADDRFP4 4
INDIRP4
ARGP4
ADDRLP4 72
ADDRGP4 trap_R_RegisterShaderNoMip
CALLI4
ASGNI4
ADDRLP4 72
INDIRI4
CNSTI4 0
NEI4 $82
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 $80
ARGP4
ADDRLP4 76
ADDRGP4 Q_stricmp
CALLI4
ASGNI4
ADDRLP4 76
INDIRI4
CNSTI4 0
EQI4 $82
line 167
;167:		Com_sprintf(iconName, iconNameMaxSize, "models/players2/%s/icon_default.jpg", model );
ADDRFP4 4
INDIRP4
ARGP4
ADDRFP4 8
INDIRI4
ARGI4
ADDRGP4 $84
ARGP4
ADDRLP4 4
ARGP4
ADDRGP4 Com_sprintf
CALLV
pop
line 168
;168:	}
LABELV $82
line 169
;169:}
LABELV $77
endproc PlayerIcon 80 20
proc PlayerIconHandle 68 12
line 178
;170:
;171:
;172:/*
;173:=================
;174:PlayerIconhandle
;175:=================
;176:*/
;177:static qhandle_t PlayerIconHandle( const char *modelAndSkin ) 
;178:{
line 181
;179:	char	iconName[MAX_QPATH];
;180:
;181:	PlayerIcon( modelAndSkin, iconName, sizeof(iconName) );
ADDRFP4 0
INDIRP4
ARGP4
ADDRLP4 0
ARGP4
CNSTI4 64
ARGI4
ADDRGP4 PlayerIcon
CALLV
pop
line 182
;182:	return trap_R_RegisterShaderNoMip( iconName );
ADDRLP4 0
ARGP4
ADDRLP4 64
ADDRGP4 trap_R_RegisterShaderNoMip
CALLI4
ASGNI4
ADDRLP4 64
INDIRI4
RETI4
LABELV $85
endproc PlayerIconHandle 68 12
proc UI_SPLevelMenu_SetBots 1068 12
line 192
;183:}
;184:
;185:
;186:/*
;187:=================
;188:UI_SPLevelMenu_SetBots
;189:=================
;190:*/
;191:static void UI_SPLevelMenu_SetBots( void ) 
;192:{
line 198
;193:	char	*p;
;194:	char	*bot;
;195:	char	*botInfo;
;196:	char	bots[MAX_INFO_STRING];
;197:
;198:	levelMenuInfo.numBots = 0;
ADDRGP4 levelMenuInfo+4028
CNSTI4 0
ASGNI4
line 200
;199:
;200:	Q_strncpyz( bots, Info_ValueForKey( levelMenuInfo.selectedArenaInfo, "bots" ), sizeof(bots) );
ADDRGP4 levelMenuInfo+3352
INDIRP4
ARGP4
ADDRGP4 $89
ARGP4
ADDRLP4 1036
ADDRGP4 Info_ValueForKey
CALLP4
ASGNP4
ADDRLP4 12
ARGP4
ADDRLP4 1036
INDIRP4
ARGP4
CNSTI4 1024
ARGI4
ADDRGP4 Q_strncpyz
CALLV
pop
line 202
;201:
;202:	p = &bots[0];
ADDRLP4 0
ADDRLP4 12
ASGNP4
ADDRGP4 $91
JUMPV
line 204
;203:	while( *p && levelMenuInfo.numBots < 7 ) 
;204:	{
LABELV $94
line 206
;205:		//skip spaces
;206:		while( *p && *p == ' ' ) {
line 207
;207:			p++;
ADDRLP4 0
ADDRLP4 0
INDIRP4
CNSTI4 1
ADDP4
ASGNP4
line 208
;208:		}
LABELV $95
line 206
ADDRLP4 1040
ADDRLP4 0
INDIRP4
INDIRI1
CVII4 1
ASGNI4
ADDRLP4 1040
INDIRI4
CNSTI4 0
EQI4 $97
ADDRLP4 1040
INDIRI4
CNSTI4 32
EQI4 $94
LABELV $97
line 209
;209:		if( !p ) {
ADDRLP4 0
INDIRP4
CVPU4 4
CNSTU4 0
NEU4 $98
line 210
;210:			break;
ADDRGP4 $92
JUMPV
LABELV $98
line 214
;211:		}
;212:
;213:		// mark start of bot name
;214:		bot = p;
ADDRLP4 8
ADDRLP4 0
INDIRP4
ASGNP4
ADDRGP4 $101
JUMPV
LABELV $100
line 218
;215:
;216:		// skip until space of null
;217:		while( *p && *p != ' ' ) 
;218:		{
line 219
;219:			p++;
ADDRLP4 0
ADDRLP4 0
INDIRP4
CNSTI4 1
ADDP4
ASGNP4
line 220
;220:		}
LABELV $101
line 217
ADDRLP4 1044
ADDRLP4 0
INDIRP4
INDIRI1
CVII4 1
ASGNI4
ADDRLP4 1044
INDIRI4
CNSTI4 0
EQI4 $103
ADDRLP4 1044
INDIRI4
CNSTI4 32
NEI4 $100
LABELV $103
line 221
;221:		if( *p ) {
ADDRLP4 0
INDIRP4
INDIRI1
CVII4 1
CNSTI4 0
EQI4 $104
line 222
;222:			*p++ = 0;
ADDRLP4 1048
ADDRLP4 0
INDIRP4
ASGNP4
ADDRLP4 0
ADDRLP4 1048
INDIRP4
CNSTI4 1
ADDP4
ASGNP4
ADDRLP4 1048
INDIRP4
CNSTI1 0
ASGNI1
line 223
;223:		}
LABELV $104
line 225
;224:
;225:		botInfo = UI_GetBotInfoByName( bot );
ADDRLP4 8
INDIRP4
ARGP4
ADDRLP4 1048
ADDRGP4 UI_GetBotInfoByName
CALLP4
ASGNP4
ADDRLP4 4
ADDRLP4 1048
INDIRP4
ASGNP4
line 226
;226:		if( botInfo ) 
ADDRLP4 4
INDIRP4
CVPU4 4
CNSTU4 0
EQU4 $106
line 227
;227:		{
line 228
;228:			levelMenuInfo.botPics[levelMenuInfo.numBots] = PlayerIconHandle( Info_ValueForKey( botInfo, "model" ) );
ADDRLP4 4
INDIRP4
ARGP4
ADDRGP4 $110
ARGP4
ADDRLP4 1052
ADDRGP4 Info_ValueForKey
CALLP4
ASGNP4
ADDRLP4 1052
INDIRP4
ARGP4
ADDRLP4 1056
ADDRGP4 PlayerIconHandle
CALLI4
ASGNI4
ADDRGP4 levelMenuInfo+4028
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 levelMenuInfo+4032
ADDP4
ADDRLP4 1056
INDIRI4
ASGNI4
line 229
;229:			Q_strncpyz( levelMenuInfo.botNames[levelMenuInfo.numBots], Info_ValueForKey( botInfo, "name" ), 10 );
ADDRLP4 4
INDIRP4
ARGP4
ADDRGP4 $113
ARGP4
ADDRLP4 1060
ADDRGP4 Info_ValueForKey
CALLP4
ASGNP4
ADDRLP4 1064
CNSTI4 10
ASGNI4
ADDRLP4 1064
INDIRI4
ADDRGP4 levelMenuInfo+4028
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+4060
ADDP4
ARGP4
ADDRLP4 1060
INDIRP4
ARGP4
ADDRLP4 1064
INDIRI4
ARGI4
ADDRGP4 Q_strncpyz
CALLV
pop
line 230
;230:		}
ADDRGP4 $107
JUMPV
LABELV $106
line 232
;231:		else 
;232:		{
line 233
;233:			levelMenuInfo.botPics[levelMenuInfo.numBots] = 0;
ADDRGP4 levelMenuInfo+4028
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 levelMenuInfo+4032
ADDP4
CNSTI4 0
ASGNI4
line 234
;234:			Q_strncpyz( levelMenuInfo.botNames[levelMenuInfo.numBots], bot, 10 );
ADDRLP4 1052
CNSTI4 10
ASGNI4
ADDRLP4 1052
INDIRI4
ADDRGP4 levelMenuInfo+4028
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+4060
ADDP4
ARGP4
ADDRLP4 8
INDIRP4
ARGP4
ADDRLP4 1052
INDIRI4
ARGI4
ADDRGP4 Q_strncpyz
CALLV
pop
line 235
;235:		}
LABELV $107
line 236
;236:		Q_CleanStr( levelMenuInfo.botNames[levelMenuInfo.numBots] );
CNSTI4 10
ADDRGP4 levelMenuInfo+4028
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+4060
ADDP4
ARGP4
ADDRGP4 Q_CleanStr
CALLP4
pop
line 237
;237:		levelMenuInfo.numBots++;
ADDRLP4 1052
ADDRGP4 levelMenuInfo+4028
ASGNP4
ADDRLP4 1052
INDIRP4
ADDRLP4 1052
INDIRP4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
line 238
;238:	}
LABELV $91
line 203
ADDRLP4 0
INDIRP4
INDIRI1
CVII4 1
CNSTI4 0
EQI4 $121
ADDRGP4 levelMenuInfo+4028
INDIRI4
CNSTI4 7
LTI4 $95
LABELV $121
LABELV $92
line 239
;239:}
LABELV $86
endproc UI_SPLevelMenu_SetBots 1068 12
proc UI_SPLevelMenu_SetMenuArena 120 12
line 249
;240:
;241:
;242:/*
;243:=================
;244:UI_SPLevelMenu_SetMenuArena
;245:=================
;246:*/
;247:extern vmCvar_t	ui_language;
;248:static void UI_SPLevelMenu_SetMenuArena( int n, int level, const char *arenaInfo ) 
;249:{
line 253
;250:	char		map[MAX_QPATH];
;251:	char			string[MAX_LONGNAME];
;252:
;253:	Q_strncpyz( map, Info_ValueForKey( arenaInfo, "map" ), sizeof(map) );
ADDRFP4 8
INDIRP4
ARGP4
ADDRGP4 $123
ARGP4
ADDRLP4 88
ADDRGP4 Info_ValueForKey
CALLP4
ASGNP4
ADDRLP4 0
ARGP4
ADDRLP4 88
INDIRP4
ARGP4
CNSTI4 64
ARGI4
ADDRGP4 Q_strncpyz
CALLV
pop
line 255
;254:
;255:	Q_strncpyz( levelMenuInfo.levelNames[n], map, sizeof(levelMenuInfo.levelNames[n]) );
ADDRFP4 0
INDIRI4
CNSTI4 4
LSHI4
ADDRGP4 levelMenuInfo+3616
ADDP4
ARGP4
ADDRLP4 0
ARGP4
CNSTI4 16
ARGI4
ADDRGP4 Q_strncpyz
CALLV
pop
line 256
;256:	Q_strupr( levelMenuInfo.levelNames[n] );
ADDRFP4 0
INDIRI4
CNSTI4 4
LSHI4
ADDRGP4 levelMenuInfo+3616
ADDP4
ARGP4
ADDRGP4 Q_strupr
CALLP4
pop
line 258
;257:
;258:	if (ui_language.string[0] == 0 || Q_stricmp ("ENGLISH",ui_language.string)==0 ) {
ADDRGP4 ui_language+16
INDIRI1
CVII4 1
CNSTI4 0
EQI4 $132
ADDRGP4 $130
ARGP4
ADDRGP4 ui_language+16
ARGP4
ADDRLP4 92
ADDRGP4 Q_stricmp
CALLI4
ASGNI4
ADDRLP4 92
INDIRI4
CNSTI4 0
NEI4 $127
LABELV $132
line 259
;259:		Q_strncpyz( string, Info_ValueForKey( arenaInfo, "longname" ), sizeof(string) );
ADDRFP4 8
INDIRP4
ARGP4
ADDRGP4 $133
ARGP4
ADDRLP4 96
ADDRGP4 Info_ValueForKey
CALLP4
ASGNP4
ADDRLP4 64
ARGP4
ADDRLP4 96
INDIRP4
ARGP4
CNSTI4 24
ARGI4
ADDRGP4 Q_strncpyz
CALLV
pop
line 260
;260:	} else {
ADDRGP4 $128
JUMPV
LABELV $127
line 261
;261:		Q_strncpyz( string, Info_ValueForKey( arenaInfo, va("longname_%s",ui_language.string) ), sizeof(string) );
ADDRGP4 $134
ARGP4
ADDRGP4 ui_language+16
ARGP4
ADDRLP4 96
ADDRGP4 va
CALLP4
ASGNP4
ADDRFP4 8
INDIRP4
ARGP4
ADDRLP4 96
INDIRP4
ARGP4
ADDRLP4 100
ADDRGP4 Info_ValueForKey
CALLP4
ASGNP4
ADDRLP4 64
ARGP4
ADDRLP4 100
INDIRP4
ARGP4
CNSTI4 24
ARGI4
ADDRGP4 Q_strncpyz
CALLV
pop
line 262
;262:		if (!string[0]) {
ADDRLP4 64
INDIRI1
CVII4 1
CNSTI4 0
NEI4 $136
line 263
;263:			Q_strncpyz( string, Info_ValueForKey( arenaInfo, "longname" ), sizeof(string) );
ADDRFP4 8
INDIRP4
ARGP4
ADDRGP4 $133
ARGP4
ADDRLP4 104
ADDRGP4 Info_ValueForKey
CALLP4
ASGNP4
ADDRLP4 64
ARGP4
ADDRLP4 104
INDIRP4
ARGP4
CNSTI4 24
ARGI4
ADDRGP4 Q_strncpyz
CALLV
pop
line 264
;264:		}
LABELV $136
line 265
;265:	}
LABELV $128
line 266
;266:	Q_strncpyz( levelMenuInfo.levelLongNames[n], string, sizeof(levelMenuInfo.levelLongNames[n]) );
ADDRLP4 96
CNSTI4 24
ASGNI4
ADDRLP4 96
INDIRI4
ADDRFP4 0
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+3680
ADDP4
ARGP4
ADDRLP4 64
ARGP4
ADDRLP4 96
INDIRI4
ARGI4
ADDRGP4 Q_strncpyz
CALLV
pop
line 267
;267:	Q_strupr( levelMenuInfo.levelLongNames[n] );
CNSTI4 24
ADDRFP4 0
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+3680
ADDP4
ARGP4
ADDRGP4 Q_strupr
CALLP4
pop
line 270
;268:
;269:
;270:	UI_GetBestScore( level, &levelMenuInfo.levelScores[n], &levelMenuInfo.levelScoresSkill[n] );
ADDRFP4 4
INDIRI4
ARGI4
ADDRLP4 100
ADDRFP4 0
INDIRI4
CNSTI4 2
LSHI4
ASGNI4
ADDRLP4 100
INDIRI4
ADDRGP4 levelMenuInfo+3776
ADDP4
ARGP4
ADDRLP4 100
INDIRI4
ADDRGP4 levelMenuInfo+3792
ADDP4
ARGP4
ADDRGP4 UI_GetBestScore
CALLV
pop
line 271
;271:	if( levelMenuInfo.levelScores[n] > 8 ) 
ADDRFP4 0
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 levelMenuInfo+3776
ADDP4
INDIRI4
CNSTI4 8
LEI4 $143
line 272
;272:	{
line 273
;273:		levelMenuInfo.levelScores[n] = 8;
ADDRFP4 0
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 levelMenuInfo+3776
ADDP4
CNSTI4 8
ASGNI4
line 274
;274:	}
LABELV $143
line 276
;275:
;276:	strcpy( levelMenuInfo.levelPicNames[n], va( "levelshots/%s.tga", map ) );
ADDRGP4 $148
ARGP4
ADDRLP4 0
ARGP4
ADDRLP4 104
ADDRGP4 va
CALLP4
ASGNP4
ADDRFP4 0
INDIRI4
CNSTI4 6
LSHI4
ADDRGP4 levelMenuInfo+3360
ADDP4
ARGP4
ADDRLP4 104
INDIRP4
ARGP4
ADDRGP4 strcpy
CALLP4
pop
line 277
;277:	if( !trap_R_RegisterShaderNoMip( levelMenuInfo.levelPicNames[n] ) ) 
ADDRFP4 0
INDIRI4
CNSTI4 6
LSHI4
ADDRGP4 levelMenuInfo+3360
ADDP4
ARGP4
ADDRLP4 108
ADDRGP4 trap_R_RegisterShaderNoMip
CALLI4
ASGNI4
ADDRLP4 108
INDIRI4
CNSTI4 0
NEI4 $149
line 278
;278:	{
line 279
;279:		strcpy( levelMenuInfo.levelPicNames[n], ART_MAP_UNKNOWN );
ADDRFP4 0
INDIRI4
CNSTI4 6
LSHI4
ADDRGP4 levelMenuInfo+3360
ADDP4
ARGP4
ADDRGP4 $153
ARGP4
ADDRGP4 strcpy
CALLP4
pop
line 280
;280:	}
LABELV $149
line 282
;281:
;282:	levelMenuInfo.item_maps[n].shader = 0;
CNSTI4 144
ADDRFP4 0
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+1044+68
ADDP4
CNSTI4 0
ASGNI4
line 283
;283:	levelMenuInfo.item_maps[n].generic.flags &= ~QMF_HIDDEN;
ADDRLP4 112
CNSTI4 144
ADDRFP4 0
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+1044+44
ADDP4
ASGNP4
ADDRLP4 112
INDIRP4
ADDRLP4 112
INDIRP4
INDIRU4
CNSTU4 4294963199
BANDU4
ASGNU4
line 284
;284:	levelMenuInfo.item_maps[n].generic.flags &= ~QMF_INACTIVE;
ADDRLP4 116
CNSTI4 144
ADDRFP4 0
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+1044+44
ADDP4
ASGNP4
ADDRLP4 116
INDIRP4
ADDRLP4 116
INDIRP4
INDIRU4
CNSTU4 4294950911
BANDU4
ASGNU4
line 285
;285:}
LABELV $122
endproc UI_SPLevelMenu_SetMenuArena 120 12
proc UI_SPLevelMenu_SetMenuItems 48 12
line 293
;286:
;287:/*
;288:=================
;289:UI_SPLevelMenu_SetMenuItems
;290:=================
;291:*/
;292:static void UI_SPLevelMenu_SetMenuItems( void ) 
;293:{
line 299
;294:	int			n,i;
;295:	int			level;
;296:	const char	*arenaInfo;
;297:	char		*type;
;298:
;299:	if ( selectedArena == -1 ) 
ADDRGP4 selectedArena
INDIRI4
CNSTI4 -1
NEI4 $161
line 300
;300:	{
line 301
;301:		selectedArena = 0;
ADDRGP4 selectedArena
CNSTI4 0
ASGNI4
line 302
;302:	}
LABELV $161
line 309
;303:
;304://	if( selectedArenaSet == trainingTier || selectedArenaSet == finalTier ) 
;305://	{
;306://		selectedArena = 0;
;307://	}
;308:
;309:	if( selectedArena != -1 ) 
ADDRGP4 selectedArena
INDIRI4
CNSTI4 -1
EQI4 $163
line 310
;310:	{
line 311
;311:		trap_Cvar_SetValue( "ui_spSelection", selectedArenaSet * ARENAS_PER_TIER + selectedArena );
ADDRGP4 $165
ARGP4
ADDRGP4 selectedArenaSet
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 selectedArena
INDIRI4
ADDI4
CVIF4 4
ARGF4
ADDRGP4 trap_Cvar_SetValue
CALLV
pop
line 312
;312:	}
LABELV $163
line 314
;313:
;314:	if( selectedArenaSet == trainingTier ) 
ADDRGP4 selectedArenaSet
INDIRI4
ADDRGP4 trainingTier
INDIRI4
NEI4 $166
line 315
;315:	{
line 316
;316:		arenaInfo = UI_GetSpecialArenaInfo( "training" );
ADDRGP4 $168
ARGP4
ADDRLP4 20
ADDRGP4 UI_GetSpecialArenaInfo
CALLP4
ASGNP4
ADDRLP4 4
ADDRLP4 20
INDIRP4
ASGNP4
line 317
;317:		level = atoi( Info_ValueForKey( arenaInfo, "num" ) );
ADDRLP4 4
INDIRP4
ARGP4
ADDRGP4 $169
ARGP4
ADDRLP4 24
ADDRGP4 Info_ValueForKey
CALLP4
ASGNP4
ADDRLP4 24
INDIRP4
ARGP4
ADDRLP4 28
ADDRGP4 atoi
CALLI4
ASGNI4
ADDRLP4 8
ADDRLP4 28
INDIRI4
ASGNI4
line 318
;318:		UI_SPLevelMenu_SetMenuArena( 0, level, arenaInfo );
CNSTI4 0
ARGI4
ADDRLP4 8
INDIRI4
ARGI4
ADDRLP4 4
INDIRP4
ARGP4
ADDRGP4 UI_SPLevelMenu_SetMenuArena
CALLV
pop
line 319
;319:		levelMenuInfo.selectedArenaInfo = arenaInfo;
ADDRGP4 levelMenuInfo+3352
ADDRLP4 4
INDIRP4
ASGNP4
line 322
;320:
;321://		levelMenuInfo.item_maps[0].generic.x = 256;
;322:		Bitmap_Init( &levelMenuInfo.item_maps[0] );
ADDRGP4 levelMenuInfo+1044
ARGP4
ADDRGP4 Bitmap_Init
CALLV
pop
line 323
;323:		levelMenuInfo.item_maps[0].generic.bottom += 32;
ADDRLP4 32
ADDRGP4 levelMenuInfo+1044+32
ASGNP4
ADDRLP4 32
INDIRP4
ADDRLP4 32
INDIRP4
INDIRI4
CNSTI4 32
ADDI4
ASGNI4
line 324
;324:		levelMenuInfo.numMaps = 1;
ADDRGP4 levelMenuInfo+3356
CNSTI4 1
ASGNI4
line 326
;325:
;326:		levelMenuInfo.item_maps[1].generic.flags |= QMF_INACTIVE;
ADDRLP4 36
ADDRGP4 levelMenuInfo+1044+144+44
ASGNP4
ADDRLP4 36
INDIRP4
ADDRLP4 36
INDIRP4
INDIRU4
CNSTU4 16384
BORU4
ASGNU4
line 327
;327:		levelMenuInfo.item_maps[2].generic.flags |= QMF_INACTIVE;
ADDRLP4 40
ADDRGP4 levelMenuInfo+1044+288+44
ASGNP4
ADDRLP4 40
INDIRP4
ADDRLP4 40
INDIRP4
INDIRU4
CNSTU4 16384
BORU4
ASGNU4
line 328
;328:		levelMenuInfo.item_maps[3].generic.flags |= QMF_INACTIVE;
ADDRLP4 44
ADDRGP4 levelMenuInfo+1044+432+44
ASGNP4
ADDRLP4 44
INDIRP4
ADDRLP4 44
INDIRP4
INDIRU4
CNSTU4 16384
BORU4
ASGNU4
line 329
;329:		levelMenuInfo.levelPicNames[1][0] = 0;
ADDRGP4 levelMenuInfo+3360+64
CNSTI1 0
ASGNI1
line 330
;330:		levelMenuInfo.levelPicNames[2][0] = 0;
ADDRGP4 levelMenuInfo+3360+128
CNSTI1 0
ASGNI1
line 331
;331:		levelMenuInfo.levelPicNames[3][0] = 0;
ADDRGP4 levelMenuInfo+3360+192
CNSTI1 0
ASGNI1
line 332
;332:		levelMenuInfo.item_maps[1].shader = 0;
ADDRGP4 levelMenuInfo+1044+144+68
CNSTI4 0
ASGNI4
line 333
;333:		levelMenuInfo.item_maps[2].shader = 0;
ADDRGP4 levelMenuInfo+1044+288+68
CNSTI4 0
ASGNI4
line 334
;334:		levelMenuInfo.item_maps[3].shader = 0;
ADDRGP4 levelMenuInfo+1044+432+68
CNSTI4 0
ASGNI4
line 335
;335:	}
ADDRGP4 $167
JUMPV
LABELV $166
line 336
;336:	else if( selectedArenaSet == finalTier ) 
ADDRGP4 selectedArenaSet
INDIRI4
ADDRGP4 finalTier
INDIRI4
NEI4 $199
line 337
;337:	{
line 338
;338:		arenaInfo = UI_GetSpecialArenaInfo( "final" );
ADDRGP4 $201
ARGP4
ADDRLP4 20
ADDRGP4 UI_GetSpecialArenaInfo
CALLP4
ASGNP4
ADDRLP4 4
ADDRLP4 20
INDIRP4
ASGNP4
line 339
;339:		level = atoi( Info_ValueForKey( arenaInfo, "num" ) );
ADDRLP4 4
INDIRP4
ARGP4
ADDRGP4 $169
ARGP4
ADDRLP4 24
ADDRGP4 Info_ValueForKey
CALLP4
ASGNP4
ADDRLP4 24
INDIRP4
ARGP4
ADDRLP4 28
ADDRGP4 atoi
CALLI4
ASGNI4
ADDRLP4 8
ADDRLP4 28
INDIRI4
ASGNI4
line 340
;340:		UI_SPLevelMenu_SetMenuArena( 0, level, arenaInfo );
CNSTI4 0
ARGI4
ADDRLP4 8
INDIRI4
ARGI4
ADDRLP4 4
INDIRP4
ARGP4
ADDRGP4 UI_SPLevelMenu_SetMenuArena
CALLV
pop
line 341
;341:		levelMenuInfo.selectedArenaInfo = arenaInfo;
ADDRGP4 levelMenuInfo+3352
ADDRLP4 4
INDIRP4
ASGNP4
line 344
;342:
;343://		levelMenuInfo.item_maps[0].generic.x = 256;
;344:		Bitmap_Init( &levelMenuInfo.item_maps[0] );
ADDRGP4 levelMenuInfo+1044
ARGP4
ADDRGP4 Bitmap_Init
CALLV
pop
line 345
;345:		levelMenuInfo.item_maps[0].generic.bottom += 32;
ADDRLP4 32
ADDRGP4 levelMenuInfo+1044+32
ASGNP4
ADDRLP4 32
INDIRP4
ADDRLP4 32
INDIRP4
INDIRI4
CNSTI4 32
ADDI4
ASGNI4
line 346
;346:		levelMenuInfo.numMaps = 1;
ADDRGP4 levelMenuInfo+3356
CNSTI4 1
ASGNI4
line 348
;347:
;348:		levelMenuInfo.item_maps[1].generic.flags |= QMF_INACTIVE;
ADDRLP4 36
ADDRGP4 levelMenuInfo+1044+144+44
ASGNP4
ADDRLP4 36
INDIRP4
ADDRLP4 36
INDIRP4
INDIRU4
CNSTU4 16384
BORU4
ASGNU4
line 349
;349:		levelMenuInfo.item_maps[2].generic.flags |= QMF_INACTIVE;
ADDRLP4 40
ADDRGP4 levelMenuInfo+1044+288+44
ASGNP4
ADDRLP4 40
INDIRP4
ADDRLP4 40
INDIRP4
INDIRU4
CNSTU4 16384
BORU4
ASGNU4
line 350
;350:		levelMenuInfo.item_maps[3].generic.flags |= QMF_INACTIVE;
ADDRLP4 44
ADDRGP4 levelMenuInfo+1044+432+44
ASGNP4
ADDRLP4 44
INDIRP4
ADDRLP4 44
INDIRP4
INDIRU4
CNSTU4 16384
BORU4
ASGNU4
line 351
;351:		levelMenuInfo.levelPicNames[1][0] = 0;
ADDRGP4 levelMenuInfo+3360+64
CNSTI1 0
ASGNI1
line 352
;352:		levelMenuInfo.levelPicNames[2][0] = 0;
ADDRGP4 levelMenuInfo+3360+128
CNSTI1 0
ASGNI1
line 353
;353:		levelMenuInfo.levelPicNames[3][0] = 0;
ADDRGP4 levelMenuInfo+3360+192
CNSTI1 0
ASGNI1
line 354
;354:		levelMenuInfo.item_maps[1].shader = 0;
ADDRGP4 levelMenuInfo+1044+144+68
CNSTI4 0
ASGNI4
line 355
;355:		levelMenuInfo.item_maps[2].shader = 0;
ADDRGP4 levelMenuInfo+1044+288+68
CNSTI4 0
ASGNI4
line 356
;356:		levelMenuInfo.item_maps[3].shader = 0;
ADDRGP4 levelMenuInfo+1044+432+68
CNSTI4 0
ASGNI4
line 357
;357:	}
ADDRGP4 $200
JUMPV
LABELV $199
line 359
;358:	else 
;359:	{
line 360
;360:		Bitmap_Init( &levelMenuInfo.item_maps[0] );
ADDRGP4 levelMenuInfo+1044
ARGP4
ADDRGP4 Bitmap_Init
CALLV
pop
line 361
;361:		levelMenuInfo.item_maps[0].generic.bottom += 18;
ADDRLP4 20
ADDRGP4 levelMenuInfo+1044+32
ASGNP4
ADDRLP4 20
INDIRP4
ADDRLP4 20
INDIRP4
INDIRI4
CNSTI4 18
ADDI4
ASGNI4
line 363
;362:
;363:		memset( levelMenuInfo.levelNames,0, sizeof(levelMenuInfo.levelNames));
ADDRGP4 levelMenuInfo+3616
ARGP4
CNSTI4 0
ARGI4
CNSTI4 64
ARGI4
ADDRGP4 memset
CALLP4
pop
line 366
;364:
;365:		// Zero out info
;366:		for ( n = 0; n < MAX_ITEM_MAPS; n++ ) 
ADDRLP4 0
CNSTI4 0
ASGNI4
LABELV $236
line 367
;367:		{
line 368
;368:			levelMenuInfo.item_maps[n].generic.flags |= QMF_HIDDEN | QMF_INACTIVE;
ADDRLP4 24
CNSTI4 144
ADDRLP4 0
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+1044+44
ADDP4
ASGNP4
ADDRLP4 24
INDIRP4
ADDRLP4 24
INDIRP4
INDIRU4
CNSTU4 20480
BORU4
ASGNU4
line 369
;369:			levelMenuInfo.levelScores[n] = 0;
ADDRLP4 0
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 levelMenuInfo+3776
ADDP4
CNSTI4 0
ASGNI4
line 370
;370:		}
LABELV $237
line 366
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
ADDRLP4 0
INDIRI4
CNSTI4 4
LTI4 $236
line 372
;371:
;372:		i = 0;
ADDRLP4 16
CNSTI4 0
ASGNI4
line 373
;373:		for ( n = 0; n < MAX_ITEM_MAPS; n++ ) 
ADDRLP4 0
CNSTI4 0
ASGNI4
LABELV $243
line 374
;374:		{
line 375
;375:			level = selectedArenaSet * ARENAS_PER_TIER + n;
ADDRLP4 8
ADDRGP4 selectedArenaSet
INDIRI4
CNSTI4 2
LSHI4
ADDRLP4 0
INDIRI4
ADDI4
ASGNI4
line 376
;376:			arenaInfo = UI_GetArenaInfoByNumber( level );
ADDRLP4 8
INDIRI4
ARGI4
ADDRLP4 24
ADDRGP4 UI_GetArenaInfoByNumber
CALLP4
ASGNP4
ADDRLP4 4
ADDRLP4 24
INDIRP4
ASGNP4
line 377
;377:			type = Info_ValueForKey( arenaInfo, "type" );
ADDRLP4 4
INDIRP4
ARGP4
ADDRGP4 $247
ARGP4
ADDRLP4 28
ADDRGP4 Info_ValueForKey
CALLP4
ASGNP4
ADDRLP4 12
ADDRLP4 28
INDIRP4
ASGNP4
line 378
;378:			if( strstr( type, "single" ) ) 
ADDRLP4 12
INDIRP4
ARGP4
ADDRGP4 $250
ARGP4
ADDRLP4 32
ADDRGP4 strstr
CALLP4
ASGNP4
ADDRLP4 32
INDIRP4
CVPU4 4
CNSTU4 0
EQU4 $248
line 379
;379:			{
line 380
;380:				UI_SPLevelMenu_SetMenuArena( n, level, arenaInfo );
ADDRLP4 0
INDIRI4
ARGI4
ADDRLP4 8
INDIRI4
ARGI4
ADDRLP4 4
INDIRP4
ARGP4
ADDRGP4 UI_SPLevelMenu_SetMenuArena
CALLV
pop
line 381
;381:				i++;
ADDRLP4 16
ADDRLP4 16
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
line 382
;382:			}
LABELV $248
line 383
;383:		}
LABELV $244
line 373
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
ADDRLP4 0
INDIRI4
CNSTI4 4
LTI4 $243
line 385
;384:
;385:		levelMenuInfo.numMaps = i;
ADDRGP4 levelMenuInfo+3356
ADDRLP4 16
INDIRI4
ASGNI4
line 387
;386:
;387:		if( selectedArena != -1 ) 
ADDRGP4 selectedArena
INDIRI4
CNSTI4 -1
EQI4 $252
line 388
;388:		{
line 389
;389:			levelMenuInfo.selectedArenaInfo = UI_GetArenaInfoByNumber( selectedArenaSet * ARENAS_PER_TIER + selectedArena );
ADDRGP4 selectedArenaSet
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 selectedArena
INDIRI4
ADDI4
ARGI4
ADDRLP4 24
ADDRGP4 UI_GetArenaInfoByNumber
CALLP4
ASGNP4
ADDRGP4 levelMenuInfo+3352
ADDRLP4 24
INDIRP4
ASGNP4
line 390
;390:		}
LABELV $252
line 391
;391:	}
LABELV $200
LABELV $167
line 394
;392:
;393:	// enable/disable arrows when they are valid/invalid
;394:	if ( selectedArenaSet == minTier ) 
ADDRGP4 selectedArenaSet
INDIRI4
ADDRGP4 minTier
INDIRI4
NEI4 $255
line 395
;395:	{
line 396
;396:		levelMenuInfo.item_leftarrow.generic.flags |= ( QMF_INACTIVE | QMF_GRAYED );
ADDRLP4 20
ADDRGP4 levelMenuInfo+900+44
ASGNP4
ADDRLP4 20
INDIRP4
ADDRLP4 20
INDIRP4
INDIRU4
CNSTU4 24576
BORU4
ASGNU4
line 397
;397:	}
ADDRGP4 $256
JUMPV
LABELV $255
line 399
;398:	else 
;399:	{
line 400
;400:		levelMenuInfo.item_leftarrow.generic.flags &= ~( QMF_INACTIVE | QMF_GRAYED );
ADDRLP4 20
ADDRGP4 levelMenuInfo+900+44
ASGNP4
ADDRLP4 20
INDIRP4
ADDRLP4 20
INDIRP4
INDIRU4
CNSTU4 4294942719
BANDU4
ASGNU4
line 401
;401:	}
LABELV $256
line 403
;402:
;403:	if ( selectedArenaSet >= maxTier ) 
ADDRGP4 selectedArenaSet
INDIRI4
ADDRGP4 maxTier
INDIRI4
LTI4 $261
line 404
;404:	{
line 405
;405:		levelMenuInfo.item_rightarrow.generic.flags |= ( QMF_INACTIVE | QMF_GRAYED );
ADDRLP4 20
ADDRGP4 levelMenuInfo+1620+44
ASGNP4
ADDRLP4 20
INDIRP4
ADDRLP4 20
INDIRP4
INDIRU4
CNSTU4 24576
BORU4
ASGNU4
line 406
;406:	}
ADDRGP4 $262
JUMPV
LABELV $261
line 408
;407:	else 
;408:	{
line 409
;409:		levelMenuInfo.item_rightarrow.generic.flags &= ~( QMF_INACTIVE | QMF_GRAYED );
ADDRLP4 20
ADDRGP4 levelMenuInfo+1620+44
ASGNP4
ADDRLP4 20
INDIRP4
ADDRLP4 20
INDIRP4
INDIRU4
CNSTU4 4294942719
BANDU4
ASGNU4
line 410
;410:	}
LABELV $262
line 413
;411:
;412:
;413:	UI_SPLevelMenu_SetBots();
ADDRGP4 UI_SPLevelMenu_SetBots
CALLV
pop
line 414
;414:}
LABELV $160
endproc UI_SPLevelMenu_SetMenuItems 48 12
proc UI_SPLevelMenu_ResetAction 0 8
line 423
;415:
;416:
;417:/*
;418:=================
;419:UI_SPLevelMenu_ResetAction
;420:=================
;421:*/
;422:static void UI_SPLevelMenu_ResetAction( qboolean result ) 
;423:{
line 424
;424:	if( !result ) 
ADDRFP4 0
INDIRI4
CNSTI4 0
NEI4 $268
line 425
;425:	{
line 426
;426:		return;
ADDRGP4 $267
JUMPV
LABELV $268
line 430
;427:	}
;428:
;429:	// clear game variables
;430:	UI_NewGame();
ADDRGP4 UI_NewGame
CALLV
pop
line 431
;431:	trap_Cvar_SetValue( "ui_spSelection", 0 );
ADDRGP4 $165
ARGP4
CNSTF4 0
ARGF4
ADDRGP4 trap_Cvar_SetValue
CALLV
pop
line 434
;432:
;433:	// make the level select menu re-initialize
;434:	UI_PopMenu();
ADDRGP4 UI_PopMenu
CALLV
pop
line 435
;435:	UI_SPLevelMenu();
ADDRGP4 UI_SPLevelMenu
CALLV
pop
line 436
;436:}
LABELV $267
endproc UI_SPLevelMenu_ResetAction 0 8
proc UI_SPLevelMenu_ResetEvent 0 0
line 444
;437:
;438:/*
;439:=================
;440:UI_SPLevelMenu_ResetEvent
;441:=================
;442:*/
;443:static void UI_SPLevelMenu_ResetEvent( void* ptr, int event )
;444:{
line 445
;445:	if (event != QM_ACTIVATED) 
ADDRFP4 4
INDIRI4
CNSTI4 3
EQI4 $271
line 446
;446:	{
line 447
;447:		return;
ADDRGP4 $270
JUMPV
LABELV $271
line 450
;448:	}
;449:
;450:	UI_ResetGameMenu();
ADDRGP4 UI_ResetGameMenu
CALLV
pop
line 452
;451:
;452:}
LABELV $270
endproc UI_SPLevelMenu_ResetEvent 0 0
proc UI_SPLevelMenu_LevelEvent 4 8
line 461
;453:
;454:
;455:/*
;456:=================
;457:UI_SPLevelMenu_LevelEvent
;458:=================
;459:*/
;460:static void UI_SPLevelMenu_LevelEvent( void* ptr, int notification ) 
;461:{
line 462
;462:	if (notification != QM_ACTIVATED) 
ADDRFP4 4
INDIRI4
CNSTI4 3
EQI4 $274
line 463
;463:	{
line 464
;464:		return;
ADDRGP4 $273
JUMPV
LABELV $274
line 467
;465:	}
;466:
;467:	selectedArena = ((menucommon_s*)ptr)->id - ID_PICTURE0;
ADDRGP4 selectedArena
ADDRFP4 0
INDIRP4
CNSTI4 8
ADDP4
INDIRI4
CNSTI4 11
SUBI4
ASGNI4
line 468
;468:	levelMenuInfo.selectedArenaInfo = UI_GetArenaInfoByNumber( selectedArenaSet * ARENAS_PER_TIER + selectedArena );
ADDRGP4 selectedArenaSet
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 selectedArena
INDIRI4
ADDI4
ARGI4
ADDRLP4 0
ADDRGP4 UI_GetArenaInfoByNumber
CALLP4
ASGNP4
ADDRGP4 levelMenuInfo+3352
ADDRLP4 0
INDIRP4
ASGNP4
line 469
;469:	UI_SPLevelMenu_SetBots();
ADDRGP4 UI_SPLevelMenu_SetBots
CALLV
pop
line 471
;470:
;471:	trap_Cvar_SetValue( "ui_spSelection", selectedArenaSet * ARENAS_PER_TIER + selectedArena );
ADDRGP4 $165
ARGP4
ADDRGP4 selectedArenaSet
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 selectedArena
INDIRI4
ADDI4
CVIF4 4
ARGF4
ADDRGP4 trap_Cvar_SetValue
CALLV
pop
line 472
;472:}
LABELV $273
endproc UI_SPLevelMenu_LevelEvent 4 8
proc UI_SPLevelMenu_LeftArrowEvent 4 0
line 481
;473:
;474:
;475:/*
;476:=================
;477:UI_SPLevelMenu_LeftArrowEvent
;478:=================
;479:*/
;480:static void UI_SPLevelMenu_LeftArrowEvent( void* ptr, int notification ) 
;481:{
line 482
;482:	if (notification != QM_ACTIVATED) 
ADDRFP4 4
INDIRI4
CNSTI4 3
EQI4 $278
line 483
;483:	{
line 484
;484:		return;
ADDRGP4 $277
JUMPV
LABELV $278
line 487
;485:	}
;486:
;487:	if ( selectedArenaSet == minTier ) 
ADDRGP4 selectedArenaSet
INDIRI4
ADDRGP4 minTier
INDIRI4
NEI4 $280
line 488
;488:	{
line 489
;489:		return;
ADDRGP4 $277
JUMPV
LABELV $280
line 492
;490:	}
;491:
;492:	selectedArena = 0;
ADDRGP4 selectedArena
CNSTI4 0
ASGNI4
line 493
;493:	selectedArenaSet--;
ADDRLP4 0
ADDRGP4 selectedArenaSet
ASGNP4
ADDRLP4 0
INDIRP4
ADDRLP4 0
INDIRP4
INDIRI4
CNSTI4 1
SUBI4
ASGNI4
line 494
;494:	UI_SPLevelMenu_SetMenuItems();
ADDRGP4 UI_SPLevelMenu_SetMenuItems
CALLV
pop
line 495
;495:}
LABELV $277
endproc UI_SPLevelMenu_LeftArrowEvent 4 0
proc UI_SPLevelMenu_RightArrowEvent 4 0
line 504
;496:
;497:
;498:/*
;499:=================
;500:UI_SPLevelMenu_RightArrowEvent
;501:=================
;502:*/
;503:static void UI_SPLevelMenu_RightArrowEvent( void* ptr, int notification ) 
;504:{
line 505
;505:	if (notification != QM_ACTIVATED) 
ADDRFP4 4
INDIRI4
CNSTI4 3
EQI4 $283
line 506
;506:	{
line 507
;507:		return;
ADDRGP4 $282
JUMPV
LABELV $283
line 510
;508:	}
;509:
;510:	if ( selectedArenaSet == maxTier ) 
ADDRGP4 selectedArenaSet
INDIRI4
ADDRGP4 maxTier
INDIRI4
NEI4 $285
line 511
;511:	{
line 512
;512:		return;
ADDRGP4 $282
JUMPV
LABELV $285
line 515
;513:	}
;514:
;515:	selectedArena = 0;
ADDRGP4 selectedArena
CNSTI4 0
ASGNI4
line 516
;516:	selectedArenaSet++;
ADDRLP4 0
ADDRGP4 selectedArenaSet
ASGNP4
ADDRLP4 0
INDIRP4
ADDRLP4 0
INDIRP4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
line 517
;517:	UI_SPLevelMenu_SetMenuItems();
ADDRGP4 UI_SPLevelMenu_SetMenuItems
CALLV
pop
line 518
;518:}
LABELV $282
endproc UI_SPLevelMenu_RightArrowEvent 4 0
proc UI_SPLevelMenu_PlayerEvent 0 4
line 527
;519:
;520:
;521:/*
;522:=================
;523:UI_SPLevelMenu_PlayerEvent
;524:=================
;525:*/
;526:static void UI_SPLevelMenu_PlayerEvent( void* ptr, int notification ) 
;527:{
line 528
;528:	if (notification != QM_ACTIVATED) 
ADDRFP4 4
INDIRI4
CNSTI4 3
EQI4 $288
line 529
;529:	{
line 530
;530:		return;
ADDRGP4 $287
JUMPV
LABELV $288
line 533
;531:	}
;532:
;533:	UI_PlayerSettingsMenu(PS_MENU_SINGLEPLAYER);
CNSTI4 1
ARGI4
ADDRGP4 UI_PlayerSettingsMenu
CALLV
pop
line 534
;534:}
LABELV $287
endproc UI_SPLevelMenu_PlayerEvent 0 4
proc UI_SPLevelMenu_CreateEvent 0 4
line 542
;535:
;536:/*
;537:=================
;538:UI_SPLevelMenu_CreateEvent
;539:=================
;540:*/
;541:static void UI_SPLevelMenu_CreateEvent( void* ptr, int notification ) 
;542:{
line 543
;543:	if (notification != QM_ACTIVATED) 
ADDRFP4 4
INDIRI4
CNSTI4 3
EQI4 $291
line 544
;544:	{
line 545
;545:		return;
ADDRGP4 $290
JUMPV
LABELV $291
line 547
;546:	}
;547:	UI_StartServerMenu( qfalse );
CNSTI4 0
ARGI4
ADDRGP4 UI_StartServerMenu
CALLV
pop
line 548
;548:}
LABELV $290
endproc UI_SPLevelMenu_CreateEvent 0 4
proc UI_SPLevelMenu_AdvancedEvent 4 4
line 557
;549:
;550:
;551:/*
;552:=================
;553:UI_SPLevelMenu_AdvancedEvent
;554:=================
;555:*/
;556:static void UI_SPLevelMenu_AdvancedEvent( void* ptr, int notification ) 
;557:{
line 558
;558:	if (notification != QM_ACTIVATED) 
ADDRFP4 4
INDIRI4
CNSTI4 3
EQI4 $294
line 559
;559:	{
line 560
;560:		return;
ADDRGP4 $293
JUMPV
LABELV $294
line 563
;561:	}
;562:
;563:	switch (((menucommon_s*)ptr)->id)
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 8
ADDP4
INDIRI4
ASGNI4
ADDRLP4 0
INDIRI4
CNSTI4 124
EQI4 $299
ADDRGP4 $296
JUMPV
line 564
;564:	{
LABELV $299
line 566
;565:		case ID_ADVANCED:
;566:			UI_ServerAdvancedOptions(1);
CNSTI4 1
ARGI4
ADDRGP4 UI_ServerAdvancedOptions
CALLV
pop
line 567
;567:			break;
LABELV $296
LABELV $297
line 569
;568:	}
;569:}
LABELV $293
endproc UI_SPLevelMenu_AdvancedEvent 4 4
proc UI_SPLevelMenu_AwardEvent 4 8
line 578
;570:
;571:
;572:/*
;573:=================
;574:UI_SPLevelMenu_AwardEvent
;575:=================
;576:*/
;577:static void UI_SPLevelMenu_AwardEvent( void* ptr, int notification ) 
;578:{
line 581
;579:	int		n;
;580:
;581:	if (notification != QM_ACTIVATED) 
ADDRFP4 4
INDIRI4
CNSTI4 3
EQI4 $301
line 582
;582:	{
line 583
;583:		return;
ADDRGP4 $300
JUMPV
LABELV $301
line 586
;584:	}
;585:
;586:	n = ((menucommon_s*)ptr)->id - ID_AWARD1;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 8
ADDP4
INDIRI4
CNSTI4 17
SUBI4
ASGNI4
line 587
;587:	trap_S_StartLocalSound( levelMenuInfo.awardSounds[n], CHAN_ANNOUNCER );
ADDRLP4 0
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 levelMenuInfo+4004
ADDP4
INDIRI4
ARGI4
CNSTI4 7
ARGI4
ADDRGP4 trap_S_StartLocalSound
CALLV
pop
line 588
;588:}
LABELV $300
endproc UI_SPLevelMenu_AwardEvent 4 8
proc UI_SPLevelMenu_NextEvent 0 4
line 597
;589:
;590:
;591:/*
;592:=================
;593:UI_SPLevelMenu_NextEvent
;594:=================
;595:*/
;596:static void UI_SPLevelMenu_NextEvent( void* ptr, int notification ) 
;597:{
line 598
;598:	if (notification != QM_ACTIVATED) 
ADDRFP4 4
INDIRI4
CNSTI4 3
EQI4 $305
line 599
;599:	{
line 600
;600:		return;
ADDRGP4 $304
JUMPV
LABELV $305
line 603
;601:	}
;602:
;603:	if ( selectedArena == -1 ) 
ADDRGP4 selectedArena
INDIRI4
CNSTI4 -1
NEI4 $307
line 604
;604:	{
line 605
;605:		selectedArena = 0;
ADDRGP4 selectedArena
CNSTI4 0
ASGNI4
line 606
;606:	}
LABELV $307
line 608
;607:
;608:	UI_SPSkillMenu( levelMenuInfo.selectedArenaInfo );
ADDRGP4 levelMenuInfo+3352
INDIRP4
ARGP4
ADDRGP4 UI_SPSkillMenu
CALLV
pop
line 609
;609:}
LABELV $304
endproc UI_SPLevelMenu_NextEvent 0 4
proc UI_SPLevelMenu_BackEvent 12 0
line 618
;610:
;611:
;612:/*
;613:=================
;614:UI_SPLevelMenu_BackEvent
;615:=================
;616:*/
;617:static void UI_SPLevelMenu_BackEvent( void* ptr, int notification ) 
;618:{
line 619
;619:	if (notification != QM_ACTIVATED) 
ADDRFP4 4
INDIRI4
CNSTI4 3
EQI4 $311
line 620
;620:	{
line 621
;621:		return;
ADDRGP4 $310
JUMPV
LABELV $311
line 624
;622:	}
;623:
;624:	if ( selectedArena == -1 ) 
ADDRGP4 selectedArena
INDIRI4
CNSTI4 -1
NEI4 $313
line 625
;625:	{
line 626
;626:		selectedArena = 0;
ADDRGP4 selectedArena
CNSTI4 0
ASGNI4
line 627
;627:	}
LABELV $313
line 629
;628:
;629:	switch (((menucommon_s*)ptr)->id)
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 8
ADDP4
INDIRI4
ASGNI4
ADDRLP4 8
CNSTI4 100
ASGNI4
ADDRLP4 0
INDIRI4
ADDRLP4 8
INDIRI4
EQI4 $318
ADDRLP4 0
INDIRI4
ADDRLP4 8
INDIRI4
LTI4 $315
LABELV $320
ADDRLP4 0
INDIRI4
CNSTI4 123
EQI4 $319
ADDRGP4 $315
JUMPV
line 630
;630:	{
LABELV $318
line 632
;631:		case ID_MAINMENU:
;632:			UI_PopMenu ();
ADDRGP4 UI_PopMenu
CALLV
pop
line 633
;633:			UI_MainMenu();
ADDRGP4 UI_MainMenu
CALLV
pop
line 634
;634:			break;
ADDRGP4 $316
JUMPV
LABELV $319
line 637
;635:
;636:		case ID_BACK:
;637:			UI_PopMenu ();
ADDRGP4 UI_PopMenu
CALLV
pop
line 638
;638:			break;
LABELV $315
LABELV $316
line 640
;639:	}
;640:}
LABELV $310
endproc UI_SPLevelMenu_BackEvent 12 0
proc UI_SPLevelMenu_MenuDraw 1184 20
line 651
;641:
;642:/*
;643:=================
;644:UI_SPLevelMenu_MenuDraw
;645:=================
;646:*/
;647:#define LEVEL_DESC_LEFT_MARGIN		332
;648:#define MAP_WIDTH 118
;649:
;650:static void UI_SPLevelMenu_MenuDraw( void ) 
;651:{
line 661
;652:	int				n;//, i;
;653:	int				x, y;
;654:	vec4_t			color;
;655://	int				level;
;656:	int				fraglimit;
;657:	int				pad;
;658:	char			buf[MAX_INFO_VALUE];
;659:	char			string[64];
;660:
;661:	if(	levelMenuInfo.reinit ) 
ADDRGP4 levelMenuInfo+3348
INDIRI4
CNSTI4 0
EQI4 $322
line 662
;662:	{
line 663
;663:		UI_PopMenu();
ADDRGP4 UI_PopMenu
CALLV
pop
line 664
;664:		UI_SPLevelMenu();
ADDRGP4 UI_SPLevelMenu
CALLV
pop
line 665
;665:		return;
ADDRGP4 $321
JUMPV
LABELV $322
line 668
;666:	}
;667:
;668:	UI_MenuFrame2(&levelMenuInfo.menu);
ADDRGP4 levelMenuInfo
ARGP4
ADDRGP4 UI_MenuFrame2
CALLV
pop
line 670
;669:
;670:	trap_R_SetColor( colorTable[CT_LTBROWN1]);
ADDRGP4 colorTable+416
ARGP4
ADDRGP4 trap_R_SetColor
CALLV
pop
line 671
;671:	UI_DrawHandlePic(  30, 203,  47,  186, uis.whiteShader);	// Left side of frame
CNSTF4 1106247680
ARGF4
CNSTF4 1128988672
ARGF4
CNSTF4 1111228416
ARGF4
CNSTF4 1127874560
ARGF4
ADDRGP4 uis+5252
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 674
;672:
;673:	// Map pics frame
;674:	trap_R_SetColor( colorTable[CT_LTPURPLE3]);
ADDRGP4 colorTable+672
ARGP4
ADDRGP4 trap_R_SetColor
CALLV
pop
line 675
;675:	UI_DrawHandlePic( 84,  50,  64,  -32, levelMenuInfo.corner_ll_18_34);	// Corner at bottom
CNSTF4 1118306304
ARGF4
CNSTF4 1112014848
ARGF4
CNSTF4 1115684864
ARGF4
CNSTF4 3254779904
ARGF4
ADDRGP4 levelMenuInfo+3844
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 676
;676:	UI_DrawHandlePic( 84, 190,  64,  32, levelMenuInfo.corner_ll_18_34);	// Corner at bottom
CNSTF4 1118306304
ARGF4
CNSTF4 1128136704
ARGF4
CNSTF4 1115684864
ARGF4
CNSTF4 1107296256
ARGF4
ADDRGP4 levelMenuInfo+3844
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 677
;677:	UI_DrawHandlePic( 108, 60, 506,  18, uis.whiteShader);	// Top line 
CNSTF4 1121452032
ARGF4
CNSTF4 1114636288
ARGF4
CNSTF4 1140654080
ARGF4
CNSTF4 1099956224
ARGF4
ADDRGP4 uis+5252
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 678
;678:	UI_DrawHandlePic( 84,  85,  34, 102, uis.whiteShader);	// Left side of frame
CNSTF4 1118306304
ARGF4
CNSTF4 1118437376
ARGF4
CNSTF4 1107820544
ARGF4
CNSTF4 1120665600
ARGF4
ADDRGP4 uis+5252
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 680
;679:
;680:	UI_DrawHandlePic(  93, 194,  34,  18, uis.whiteShader);	// Bottom line after corner
CNSTF4 1119485952
ARGF4
CNSTF4 1128398848
ARGF4
CNSTF4 1107820544
ARGF4
CNSTF4 1099956224
ARGF4
ADDRGP4 uis+5252
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 681
;681:	UI_DrawHandlePic( 130, 194,  26,  18, uis.whiteShader);	// Line under left arrow 
CNSTF4 1124204544
ARGF4
CNSTF4 1128398848
ARGF4
CNSTF4 1104150528
ARGF4
CNSTF4 1099956224
ARGF4
ADDRGP4 uis+5252
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 682
;682:	UI_DrawHandlePic( 159, 194, 391,  18, uis.whiteShader);	// Line between next and previous buttons
CNSTF4 1126105088
ARGF4
CNSTF4 1128398848
ARGF4
CNSTF4 1136885760
ARGF4
CNSTF4 1099956224
ARGF4
ADDRGP4 uis+5252
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 683
;683:	UI_DrawHandlePic( 553, 194,  26,  18, uis.whiteShader);	// Line under right arrow 
CNSTF4 1141522432
ARGF4
CNSTF4 1128398848
ARGF4
CNSTF4 1104150528
ARGF4
CNSTF4 1099956224
ARGF4
ADDRGP4 uis+5252
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 684
;684:	UI_DrawHandlePic( 582, 194,  30,  18, uis.whiteShader);	// Line after right arrow 
CNSTF4 1141997568
ARGF4
CNSTF4 1128398848
ARGF4
CNSTF4 1106247680
ARGF4
CNSTF4 1099956224
ARGF4
ADDRGP4 uis+5252
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 686
;685:
;686:	UI_DrawProportionalString(  133,  61, va( (char*)menu_normal_text[MNT_LEVELS],
ADDRGP4 menu_normal_text+1184
INDIRP4
ARGP4
ADDRLP4 1124
ADDRGP4 selectedArenaSet
INDIRI4
CNSTI4 2
LSHI4
ASGNI4
ADDRLP4 1124
INDIRI4
CNSTI4 1
ADDI4
ARGI4
ADDRLP4 1124
INDIRI4
ADDRGP4 levelMenuInfo+3356
INDIRI4
ADDI4
ARGI4
ADDRLP4 1128
ADDRGP4 va
CALLP4
ASGNP4
CNSTI4 133
ARGI4
CNSTI4 61
ARGI4
ADDRLP4 1128
INDIRP4
ARGP4
CNSTI4 16
ARGI4
ADDRGP4 colorTable+16
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 691
;687:		((selectedArenaSet*ARENAS_PER_TIER)+1),
;688:		((selectedArenaSet*ARENAS_PER_TIER)+levelMenuInfo.numMaps)),
;689:		UI_SMALLFONT, colorTable[CT_BLACK]);
;690:
;691:	UI_DrawProportionalString(  74,  27, "111611",UI_RIGHT|UI_TINYFONT, colorTable[CT_BLACK]);
CNSTI4 74
ARGI4
CNSTI4 27
ARGI4
ADDRGP4 $340
ARGP4
CNSTI4 65538
ARGI4
ADDRGP4 colorTable+16
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 692
;692:	UI_DrawProportionalString(  74,  188, "81454",UI_RIGHT|UI_TINYFONT, colorTable[CT_BLACK]);
CNSTI4 74
ARGI4
CNSTI4 188
ARGI4
ADDRGP4 $342
ARGP4
CNSTI4 65538
ARGI4
ADDRGP4 colorTable+16
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 693
;693:	UI_DrawProportionalString(  74,  206, "71",UI_RIGHT|UI_TINYFONT, colorTable[CT_BLACK]);
CNSTI4 74
ARGI4
CNSTI4 206
ARGI4
ADDRGP4 $344
ARGP4
CNSTI4 65538
ARGI4
ADDRGP4 colorTable+16
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 694
;694:	UI_DrawProportionalString(  74,  395, "345-5",UI_RIGHT|UI_TINYFONT, colorTable[CT_BLACK]);
CNSTI4 74
ARGI4
CNSTI4 395
ARGI4
ADDRGP4 $346
ARGP4
CNSTI4 65538
ARGI4
ADDRGP4 colorTable+16
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 697
;695:
;696:	// Opponents frame
;697:	trap_R_SetColor( colorTable[CT_DKBROWN1]);
ADDRGP4 colorTable+432
ARGP4
ADDRGP4 trap_R_SetColor
CALLV
pop
line 698
;698:	UI_DrawHandlePic( 348, 221,  16,  32, levelMenuInfo.corner_ur_18_12);	// Corner at top
CNSTF4 1135476736
ARGF4
CNSTF4 1130168320
ARGF4
CNSTF4 1098907648
ARGF4
CNSTF4 1107296256
ARGF4
ADDRGP4 levelMenuInfo+3840
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 699
;699:	UI_DrawHandlePic( 349, 373,  16,  16, levelMenuInfo.corner_lr_7_12);	// Corner at bottom
CNSTF4 1135509504
ARGF4
CNSTF4 1136295936
ARGF4
ADDRLP4 1132
CNSTF4 1098907648
ASGNF4
ADDRLP4 1132
INDIRF4
ARGF4
ADDRLP4 1132
INDIRF4
ARGF4
ADDRGP4 levelMenuInfo+3848
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 700
;700:	UI_DrawHandlePic(  84, 221, 270,  18, uis.whiteShader);	// Top of level info frame
CNSTF4 1118306304
ARGF4
CNSTF4 1130168320
ARGF4
CNSTF4 1132920832
ARGF4
CNSTF4 1099956224
ARGF4
ADDRGP4 uis+5252
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 701
;701:	UI_DrawHandlePic( 352, 245,  12, 125, uis.whiteShader);	// Right side of level info frame
CNSTF4 1135607808
ARGF4
CNSTF4 1131741184
ARGF4
CNSTF4 1094713344
ARGF4
CNSTF4 1123680256
ARGF4
ADDRGP4 uis+5252
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 702
;702:	UI_DrawHandlePic(  83, 376, 272,   7, uis.whiteShader);	// Bottom of frame
CNSTF4 1118175232
ARGF4
CNSTF4 1136394240
ARGF4
CNSTF4 1132986368
ARGF4
CNSTF4 1088421888
ARGF4
ADDRGP4 uis+5252
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 703
;703:	UI_DrawProportionalString( 88, 223, menu_normal_text[MNT_OPPONENTS], UI_SMALLFONT, colorTable[CT_BLACK] );
CNSTI4 88
ARGI4
CNSTI4 223
ARGI4
ADDRGP4 menu_normal_text+528
INDIRP4
ARGP4
CNSTI4 16
ARGI4
ADDRGP4 colorTable+16
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 706
;704:
;705:	// Player info frame
;706:	trap_R_SetColor( colorTable[CT_DKBROWN1]);
ADDRGP4 colorTable+432
ARGP4
ADDRGP4 trap_R_SetColor
CALLV
pop
line 707
;707:	UI_DrawHandlePic( 367, 221,  16,  32, levelMenuInfo.corner_ul_18_12);	// Corner at top
CNSTF4 1136099328
ARGF4
CNSTF4 1130168320
ARGF4
CNSTF4 1098907648
ARGF4
CNSTF4 1107296256
ARGF4
ADDRGP4 levelMenuInfo+3836
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 708
;708:	UI_DrawHandlePic( 366, 373,  -16,  16, levelMenuInfo.corner_lr_7_12);	// Corner at bottom
CNSTF4 1136066560
ARGF4
CNSTF4 1136295936
ARGF4
CNSTF4 3246391296
ARGF4
CNSTF4 1098907648
ARGF4
ADDRGP4 levelMenuInfo+3848
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 709
;709:	UI_DrawHandlePic( 377, 221, 235,  18, uis.whiteShader);	// Top of player info frame
CNSTF4 1136427008
ARGF4
CNSTF4 1130168320
ARGF4
CNSTF4 1131085824
ARGF4
CNSTF4 1099956224
ARGF4
ADDRGP4 uis+5252
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 710
;710:	UI_DrawHandlePic( 367, 245,  12, 125, uis.whiteShader);	// Left side of frame
CNSTF4 1136099328
ARGF4
CNSTF4 1131741184
ARGF4
CNSTF4 1094713344
ARGF4
CNSTF4 1123680256
ARGF4
ADDRGP4 uis+5252
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 711
;711:	UI_DrawHandlePic( 379, 376, 233,   7, uis.whiteShader);	// Bottom of frame
CNSTF4 1136492544
ARGF4
CNSTF4 1136394240
ARGF4
CNSTF4 1130954752
ARGF4
CNSTF4 1088421888
ARGF4
ADDRGP4 uis+5252
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 715
;712:
;713:
;714:	// Draw player name
;715:	trap_Cvar_VariableStringBuffer( "name", string, 32 );
ADDRGP4 $113
ARGP4
ADDRLP4 1056
ARGP4
CNSTI4 32
ARGI4
ADDRGP4 trap_Cvar_VariableStringBuffer
CALLV
pop
line 716
;716:	Q_CleanStr( string );
ADDRLP4 1056
ARGP4
ADDRGP4 Q_CleanStr
CALLP4
pop
line 717
;717:	UI_DrawProportionalString( 390, 223, string, UI_SMALLFONT, colorTable[CT_BLACK] );
CNSTI4 390
ARGI4
CNSTI4 223
ARGI4
ADDRLP4 1056
ARGP4
CNSTI4 16
ARGI4
ADDRGP4 colorTable+16
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 720
;718:
;719:	// check for model changes
;720:	trap_Cvar_VariableStringBuffer( "model", buf, sizeof(buf) );
ADDRGP4 $110
ARGP4
ADDRLP4 32
ARGP4
CNSTI4 1024
ARGI4
ADDRGP4 trap_Cvar_VariableStringBuffer
CALLV
pop
line 721
;721:	if( Q_stricmp( buf, levelMenuInfo.playerModel ) != 0 ) 
ADDRLP4 32
ARGP4
ADDRGP4 levelMenuInfo+3852
ARGP4
ADDRLP4 1136
ADDRGP4 Q_stricmp
CALLI4
ASGNI4
ADDRLP4 1136
INDIRI4
CNSTI4 0
EQI4 $363
line 722
;722:	{
line 723
;723:		Q_strncpyz( levelMenuInfo.playerModel, buf, sizeof(levelMenuInfo.playerModel) );
ADDRGP4 levelMenuInfo+3852
ARGP4
ADDRLP4 32
ARGP4
CNSTI4 64
ARGI4
ADDRGP4 Q_strncpyz
CALLV
pop
line 724
;724:		PlayerIcon( levelMenuInfo.playerModel, levelMenuInfo.playerPicName, sizeof(levelMenuInfo.playerPicName) );
ADDRGP4 levelMenuInfo+3852
ARGP4
ADDRGP4 levelMenuInfo+3916
ARGP4
CNSTI4 64
ARGI4
ADDRGP4 PlayerIcon
CALLV
pop
line 725
;725:		levelMenuInfo.item_player.shader = 0;
ADDRGP4 levelMenuInfo+1764+68
CNSTI4 0
ASGNI4
line 726
;726:	}
LABELV $363
line 729
;727:
;728:	// standard menu drawing
;729:	Menu_Draw( &levelMenuInfo.menu );
ADDRGP4 levelMenuInfo
ARGP4
ADDRGP4 Menu_Draw
CALLV
pop
line 764
;730:
;731:	// draw player award levels
;732:/*	y = AWARDS_Y;
;733:	i = 0;
;734:	for( n = 0; n < AWARD_MAX; n++ ) 
;735:	{
;736:		level = levelMenuInfo.awardLevels[n];
;737:		if( level > 0 ) 
;738:		{
;739:			x = 385 + (i * 38);
;740:			i++;
;741:
;742:			if( level == 1 ) 
;743:			{
;744:				continue;
;745:			}
;746:
;747:			if( level >= 1000000 ) 
;748:			{
;749:				Com_sprintf( string, sizeof(string), "%im", level / 1000000 );
;750:			}
;751:			else if( level >= 1000 ) {
;752:				Com_sprintf( string, sizeof(string), "%ik", level / 1000 );
;753:			}
;754:			else 
;755:			{
;756:				Com_sprintf( string, sizeof(string), "%i", level );
;757:			}
;758:
;759:			UI_DrawString( x + 19, y + 38, string, UI_CENTER, colorTable[CT_LTGOLD1] );
;760:		}
;761:	}
;762:*/
;763:	// Print black rectangle below map picture
;764:	for ( n = 0; n < levelMenuInfo.numMaps; n++ ) 
ADDRLP4 0
CNSTI4 0
ASGNI4
ADDRGP4 $376
JUMPV
LABELV $373
line 765
;765:	{
line 766
;766:		x = levelMenuInfo.item_maps[n].generic.x;
ADDRLP4 4
CNSTI4 144
ADDRLP4 0
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+1044+12
ADDP4
INDIRI4
ASGNI4
line 767
;767:		y = levelMenuInfo.item_maps[n].generic.y;
ADDRLP4 8
CNSTI4 144
ADDRLP4 0
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+1044+16
ADDP4
INDIRI4
ASGNI4
line 768
;768:		UI_FillRect( x, y + 87, 116, 18, colorTable[CT_BLACK] );
ADDRLP4 4
INDIRI4
CVIF4 4
ARGF4
ADDRLP4 8
INDIRI4
CNSTI4 87
ADDI4
CVIF4 4
ARGF4
CNSTF4 1122500608
ARGF4
CNSTF4 1099956224
ARGF4
ADDRGP4 colorTable+16
ARGP4
ADDRGP4 UI_FillRect
CALLV
pop
line 769
;769:	}
LABELV $374
line 764
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $376
ADDRLP4 0
INDIRI4
ADDRGP4 levelMenuInfo+3356
INDIRI4
LTI4 $373
line 772
;770:
;771:	// show levelshots for levels of current tier
;772:	Vector4Copy( color_white, color );
ADDRLP4 16
ADDRGP4 color_white
INDIRF4
ASGNF4
ADDRLP4 16+4
ADDRGP4 color_white+4
INDIRF4
ASGNF4
ADDRLP4 16+8
ADDRGP4 color_white+8
INDIRF4
ASGNF4
ADDRLP4 16+12
ADDRGP4 color_white+12
INDIRF4
ASGNF4
line 773
;773:	color[3] = 0.5+0.5*sin(uis.realtime/PULSE_DIVISOR);
ADDRGP4 uis+4
INDIRI4
CNSTI4 75
DIVI4
CVIF4 4
ARGF4
ADDRLP4 1140
ADDRGP4 sin
CALLF4
ASGNF4
ADDRLP4 16+12
CNSTF4 1056964608
ADDRLP4 1140
INDIRF4
MULF4
CNSTF4 1056964608
ADDF4
ASGNF4
line 774
;774:	for ( n = 0; n < levelMenuInfo.numMaps; n++ ) 
ADDRLP4 0
CNSTI4 0
ASGNI4
ADDRGP4 $394
JUMPV
LABELV $391
line 775
;775:	{
line 776
;776:		x = levelMenuInfo.item_maps[n].generic.x;
ADDRLP4 4
CNSTI4 144
ADDRLP4 0
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+1044+12
ADDP4
INDIRI4
ASGNI4
line 777
;777:		y = levelMenuInfo.item_maps[n].generic.y;
ADDRLP4 8
CNSTI4 144
ADDRLP4 0
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+1044+16
ADDP4
INDIRI4
ASGNI4
line 781
;778:
;779:		// Map name below picture
;780://		UI_DrawString( x + 64, y + 87, levelMenuInfo.levelLongNames[n], UI_CENTER|UI_SMALLFONT, colorTable[CT_LTGOLD1] );
;781:		UI_DrawProportionalString( x + (MAP_WIDTH/2), y + 87, levelMenuInfo.levelLongNames[n], UI_CENTER|UI_SMALLFONT, colorTable[CT_LTGOLD1] );
ADDRLP4 4
INDIRI4
CNSTI4 59
ADDI4
ARGI4
ADDRLP4 8
INDIRI4
CNSTI4 87
ADDI4
ARGI4
CNSTI4 24
ADDRLP4 0
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+3680
ADDP4
ARGP4
CNSTI4 17
ARGI4
ADDRGP4 colorTable+480
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 783
;782:
;783:		if( levelMenuInfo.levelScores[n] == 1 ) 
ADDRLP4 0
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 levelMenuInfo+3776
ADDP4
INDIRI4
CNSTI4 1
NEI4 $402
line 784
;784:		{
line 786
;785://	UI_DrawHandlePic( x, y, 128, 96, levelMenuInfo.levelCompletePic[levelMenuInfo.levelScoresSkill[n] - 1] ); 
;786:			UI_DrawHandlePic( x, y, 48, 48, levelMenuInfo.levelCompletePic[levelMenuInfo.levelScoresSkill[n] - 1] ); 
ADDRLP4 4
INDIRI4
CVIF4 4
ARGF4
ADDRLP4 8
INDIRI4
CVIF4 4
ARGF4
ADDRLP4 1144
CNSTF4 1111490560
ASGNF4
ADDRLP4 1144
INDIRF4
ARGF4
ADDRLP4 1144
INDIRF4
ARGF4
ADDRLP4 1148
CNSTI4 2
ASGNI4
ADDRLP4 0
INDIRI4
ADDRLP4 1148
INDIRI4
LSHI4
ADDRGP4 levelMenuInfo+3792
ADDP4
INDIRI4
ADDRLP4 1148
INDIRI4
LSHI4
ADDRGP4 levelMenuInfo+3816-4
ADDP4
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 787
;787:		}
LABELV $402
line 789
;788:
;789:		if ( n == selectedArena ) 
ADDRLP4 0
INDIRI4
ADDRGP4 selectedArena
INDIRI4
NEI4 $408
line 790
;790:		{
line 791
;791:			if( Menu_ItemAtCursor( &levelMenuInfo.menu ) == &levelMenuInfo.item_maps[n] ) 
ADDRGP4 levelMenuInfo
ARGP4
ADDRLP4 1144
ADDRGP4 Menu_ItemAtCursor
CALLP4
ASGNP4
CNSTI4 144
ADDRLP4 0
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+1044
ADDP4
CVPU4 4
ADDRLP4 1144
INDIRP4
CVPU4 4
NEU4 $410
line 792
;792:			{
line 793
;793:				trap_R_SetColor( color );
ADDRLP4 16
ARGP4
ADDRGP4 trap_R_SetColor
CALLV
pop
line 794
;794:			}
LABELV $410
line 796
;795:
;796:			UI_DrawHandlePic( x-1, y-1, MAP_WIDTH, 118 - 14, levelMenuInfo.levelSelectedPic ); 
ADDRLP4 1148
CNSTI4 1
ASGNI4
ADDRLP4 4
INDIRI4
ADDRLP4 1148
INDIRI4
SUBI4
CVIF4 4
ARGF4
ADDRLP4 8
INDIRI4
ADDRLP4 1148
INDIRI4
SUBI4
CVIF4 4
ARGF4
CNSTF4 1122762752
ARGF4
CNSTF4 1120927744
ARGF4
ADDRGP4 levelMenuInfo+3808
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 798
;797:
;798:			trap_R_SetColor( NULL );
CNSTP4 0
ARGP4
ADDRGP4 trap_R_SetColor
CALLV
pop
line 799
;799:		}
ADDRGP4 $409
JUMPV
LABELV $408
line 800
;800:		else if( Menu_ItemAtCursor( &levelMenuInfo.menu ) == &levelMenuInfo.item_maps[n] ) 
ADDRGP4 levelMenuInfo
ARGP4
ADDRLP4 1144
ADDRGP4 Menu_ItemAtCursor
CALLP4
ASGNP4
CNSTI4 144
ADDRLP4 0
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+1044
ADDP4
CVPU4 4
ADDRLP4 1144
INDIRP4
CVPU4 4
NEU4 $414
line 801
;801:		{
line 802
;802:			trap_R_SetColor( color );
ADDRLP4 16
ARGP4
ADDRGP4 trap_R_SetColor
CALLV
pop
line 803
;803:			UI_DrawHandlePic( x-1, y-1, MAP_WIDTH, 118 - 14, levelMenuInfo.levelSelectedPic ); 
ADDRLP4 1148
CNSTI4 1
ASGNI4
ADDRLP4 4
INDIRI4
ADDRLP4 1148
INDIRI4
SUBI4
CVIF4 4
ARGF4
ADDRLP4 8
INDIRI4
ADDRLP4 1148
INDIRI4
SUBI4
CVIF4 4
ARGF4
CNSTF4 1122762752
ARGF4
CNSTF4 1120927744
ARGF4
ADDRGP4 levelMenuInfo+3808
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 804
;804:			trap_R_SetColor( NULL );
CNSTP4 0
ARGP4
ADDRGP4 trap_R_SetColor
CALLV
pop
line 805
;805:		}
LABELV $414
LABELV $409
line 806
;806:	}
LABELV $392
line 774
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $394
ADDRLP4 0
INDIRI4
ADDRGP4 levelMenuInfo+3356
INDIRI4
LTI4 $391
line 809
;807:
;808:	// show map name and long name of selected level
;809:	Q_strncpyz( buf, Info_ValueForKey( levelMenuInfo.selectedArenaInfo, "map" ), 20 );
ADDRGP4 levelMenuInfo+3352
INDIRP4
ARGP4
ADDRGP4 $123
ARGP4
ADDRLP4 1144
ADDRGP4 Info_ValueForKey
CALLP4
ASGNP4
ADDRLP4 32
ARGP4
ADDRLP4 1144
INDIRP4
ARGP4
CNSTI4 20
ARGI4
ADDRGP4 Q_strncpyz
CALLV
pop
line 810
;810:	Q_strupr( buf );
ADDRLP4 32
ARGP4
ADDRGP4 Q_strupr
CALLP4
pop
line 811
;811:	Com_sprintf(string, sizeof(string),"%s",buf);
ADDRLP4 1056
ARGP4
CNSTI4 64
ARGI4
ADDRGP4 $419
ARGP4
ADDRLP4 32
ARGP4
ADDRGP4 Com_sprintf
CALLV
pop
line 812
;812:	UI_DrawProportionalString( 169, 197, string, UI_TINYFONT,  colorTable[CT_BLACK] );
CNSTI4 169
ARGI4
CNSTI4 197
ARGI4
ADDRLP4 1056
ARGP4
CNSTI4 65536
ARGI4
ADDRGP4 colorTable+16
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 814
;813:
;814:	fraglimit = atoi( Info_ValueForKey( levelMenuInfo.selectedArenaInfo, "fraglimit" ) );
ADDRGP4 levelMenuInfo+3352
INDIRP4
ARGP4
ADDRGP4 $422
ARGP4
ADDRLP4 1148
ADDRGP4 Info_ValueForKey
CALLP4
ASGNP4
ADDRLP4 1148
INDIRP4
ARGP4
ADDRLP4 1152
ADDRGP4 atoi
CALLI4
ASGNI4
ADDRLP4 1120
ADDRLP4 1152
INDIRI4
ASGNI4
line 815
;815:	UI_DrawProportionalString( 372, 197, va("%s %i", menu_normal_text[MNT_POINTLIMIT],fraglimit) , UI_TINYFONT, colorTable[CT_BLACK] );
ADDRGP4 $423
ARGP4
ADDRGP4 menu_normal_text+1192
INDIRP4
ARGP4
ADDRLP4 1120
INDIRI4
ARGI4
ADDRLP4 1156
ADDRGP4 va
CALLP4
ASGNP4
CNSTI4 372
ARGI4
CNSTI4 197
ARGI4
ADDRLP4 1156
INDIRP4
ARGP4
CNSTI4 65536
ARGI4
ADDRGP4 colorTable+16
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 818
;816:
;817:	// draw bot opponents
;818:	y = 242;
ADDRLP4 8
CNSTI4 242
ASGNI4
line 819
;819:	pad = 64 + 3;
ADDRLP4 12
CNSTI4 67
ASGNI4
line 820
;820:	x = 84 - pad;
ADDRLP4 4
CNSTI4 84
ADDRLP4 12
INDIRI4
SUBI4
ASGNI4
line 821
;821:	for( n = 0; n < levelMenuInfo.numBots; n++ ) 
ADDRLP4 0
CNSTI4 0
ASGNI4
ADDRGP4 $429
JUMPV
LABELV $426
line 822
;822:	{
line 823
;823:		if (n == 4)	//	Next line of bad guys
ADDRLP4 0
INDIRI4
CNSTI4 4
NEI4 $431
line 824
;824:		{
line 825
;825:			y +=68;
ADDRLP4 8
ADDRLP4 8
INDIRI4
CNSTI4 68
ADDI4
ASGNI4
line 826
;826:			x = 84 - pad;
ADDRLP4 4
CNSTI4 84
ADDRLP4 12
INDIRI4
SUBI4
ASGNI4
line 827
;827:		}
LABELV $431
line 829
;828:
;829:		x += pad;
ADDRLP4 4
ADDRLP4 4
INDIRI4
ADDRLP4 12
INDIRI4
ADDI4
ASGNI4
line 830
;830:		if( levelMenuInfo.botPics[n] ) 
ADDRLP4 0
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 levelMenuInfo+4032
ADDP4
INDIRI4
CNSTI4 0
EQI4 $433
line 831
;831:		{
line 832
;832:			UI_DrawHandlePic( x, y, 64, 64, levelMenuInfo.botPics[n]);
ADDRLP4 4
INDIRI4
CVIF4 4
ARGF4
ADDRLP4 8
INDIRI4
CVIF4 4
ARGF4
ADDRLP4 1160
CNSTF4 1115684864
ASGNF4
ADDRLP4 1160
INDIRF4
ARGF4
ADDRLP4 1160
INDIRF4
ARGF4
ADDRLP4 0
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 levelMenuInfo+4032
ADDP4
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 833
;833:		}
ADDRGP4 $434
JUMPV
LABELV $433
line 835
;834:		else 
;835:		{
line 836
;836:			UI_FillRect( x, y, 64, 64, colorTable[CT_BLACK] );
ADDRLP4 4
INDIRI4
CVIF4 4
ARGF4
ADDRLP4 8
INDIRI4
CVIF4 4
ARGF4
ADDRLP4 1160
CNSTF4 1115684864
ASGNF4
ADDRLP4 1160
INDIRF4
ARGF4
ADDRLP4 1160
INDIRF4
ARGF4
ADDRGP4 colorTable+16
ARGP4
ADDRGP4 UI_FillRect
CALLV
pop
line 837
;837:			UI_DrawProportionalString( x+22, y+18, "?", UI_BIGFONT, color_orange );
ADDRLP4 4
INDIRI4
CNSTI4 22
ADDI4
ARGI4
ADDRLP4 8
INDIRI4
CNSTI4 18
ADDI4
ARGI4
ADDRGP4 $438
ARGP4
CNSTI4 32
ARGI4
ADDRGP4 color_orange
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 838
;838:		}
LABELV $434
line 840
;839:
;840:		UI_DrawProportionalString( x, y + 54, levelMenuInfo.botNames[n], UI_TINYFONT, colorTable[CT_LTORANGE] );
ADDRLP4 4
INDIRI4
ARGI4
ADDRLP4 8
INDIRI4
CNSTI4 54
ADDI4
ARGI4
CNSTI4 10
ADDRLP4 0
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+4060
ADDP4
ARGP4
CNSTI4 65536
ARGI4
ADDRGP4 colorTable+224
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 842
;841:
;842:	}
LABELV $427
line 821
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $429
ADDRLP4 0
INDIRI4
ADDRGP4 levelMenuInfo+4028
INDIRI4
LTI4 $426
line 846
;843:
;844:
;845:	// Left rounded ends for buttons
;846:	trap_R_SetColor( colorTable[levelMenuInfo.mainmenu.color]);
ADDRGP4 levelMenuInfo+324+104
INDIRI4
CNSTI4 4
LSHI4
ADDRGP4 colorTable
ADDP4
ARGP4
ADDRGP4 trap_R_SetColor
CALLV
pop
line 847
;847:	UI_DrawHandlePic(110 - 14, levelMenuInfo.mainmenu.generic.y, 
CNSTF4 1119879168
ARGF4
ADDRGP4 levelMenuInfo+324+16
INDIRI4
CVIF4 4
ARGF4
ADDRLP4 1160
CNSTF4 1099956224
ASGNF4
ADDRLP4 1160
INDIRF4
ARGF4
ADDRLP4 1160
INDIRF4
ARGF4
ADDRGP4 uis+5352
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 850
;848:		MENU_BUTTON_MED_HEIGHT, MENU_BUTTON_MED_HEIGHT, uis.graphicButtonLeftEnd);
;849:
;850:	trap_R_SetColor( colorTable[levelMenuInfo.back.color]);
ADDRGP4 levelMenuInfo+468+104
INDIRI4
CNSTI4 4
LSHI4
ADDRGP4 colorTable
ADDP4
ARGP4
ADDRGP4 trap_R_SetColor
CALLV
pop
line 851
;851:	UI_DrawHandlePic(110 - 14, levelMenuInfo.back.generic.y, 
CNSTF4 1119879168
ARGF4
ADDRGP4 levelMenuInfo+468+16
INDIRI4
CVIF4 4
ARGF4
ADDRLP4 1164
CNSTF4 1099956224
ASGNF4
ADDRLP4 1164
INDIRF4
ARGF4
ADDRLP4 1164
INDIRF4
ARGF4
ADDRGP4 uis+5352
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 854
;852:		MENU_BUTTON_MED_HEIGHT, MENU_BUTTON_MED_HEIGHT, uis.graphicButtonLeftEnd);
;853:
;854:	trap_R_SetColor( colorTable[levelMenuInfo.item_reset.color]);
ADDRGP4 levelMenuInfo+2916+104
INDIRI4
CNSTI4 4
LSHI4
ADDRGP4 colorTable
ADDP4
ARGP4
ADDRGP4 trap_R_SetColor
CALLV
pop
line 855
;855:	UI_DrawHandlePic(levelMenuInfo.item_reset.generic.x - 14, levelMenuInfo.item_reset.generic.y, 
ADDRGP4 levelMenuInfo+2916+12
INDIRI4
CNSTI4 14
SUBI4
CVIF4 4
ARGF4
ADDRGP4 levelMenuInfo+2916+16
INDIRI4
CVIF4 4
ARGF4
ADDRLP4 1168
CNSTF4 1099956224
ASGNF4
ADDRLP4 1168
INDIRF4
ARGF4
ADDRLP4 1168
INDIRF4
ARGF4
ADDRGP4 uis+5352
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 858
;856:		MENU_BUTTON_MED_HEIGHT, MENU_BUTTON_MED_HEIGHT, uis.graphicButtonLeftEnd);
;857:
;858:	trap_R_SetColor( colorTable[levelMenuInfo.playerinfo.color]);
ADDRGP4 levelMenuInfo+3060+104
INDIRI4
CNSTI4 4
LSHI4
ADDRGP4 colorTable
ADDP4
ARGP4
ADDRGP4 trap_R_SetColor
CALLV
pop
line 859
;859:	UI_DrawHandlePic(levelMenuInfo.playerinfo.generic.x - 14, levelMenuInfo.playerinfo.generic.y, 
ADDRGP4 levelMenuInfo+3060+12
INDIRI4
CNSTI4 14
SUBI4
CVIF4 4
ARGF4
ADDRGP4 levelMenuInfo+3060+16
INDIRI4
CVIF4 4
ARGF4
ADDRLP4 1172
CNSTF4 1099956224
ASGNF4
ADDRLP4 1172
INDIRF4
ARGF4
ADDRLP4 1172
INDIRF4
ARGF4
ADDRGP4 uis+5352
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 862
;860:		MENU_BUTTON_MED_HEIGHT, MENU_BUTTON_MED_HEIGHT, uis.graphicButtonLeftEnd);
;861:
;862:	trap_R_SetColor( colorTable[levelMenuInfo.create.color]);
ADDRGP4 levelMenuInfo+612+104
INDIRI4
CNSTI4 4
LSHI4
ADDRGP4 colorTable
ADDP4
ARGP4
ADDRGP4 trap_R_SetColor
CALLV
pop
line 863
;863:	UI_DrawHandlePic(levelMenuInfo.create.generic.x - 14, levelMenuInfo.create.generic.y, 
ADDRGP4 levelMenuInfo+612+12
INDIRI4
CNSTI4 14
SUBI4
CVIF4 4
ARGF4
ADDRGP4 levelMenuInfo+612+16
INDIRI4
CVIF4 4
ARGF4
ADDRLP4 1176
CNSTF4 1099956224
ASGNF4
ADDRLP4 1176
INDIRF4
ARGF4
ADDRLP4 1176
INDIRF4
ARGF4
ADDRGP4 uis+5352
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 866
;864:		MENU_BUTTON_MED_HEIGHT, MENU_BUTTON_MED_HEIGHT, uis.graphicButtonLeftEnd);
;865:
;866:	trap_R_SetColor( colorTable[levelMenuInfo.advanced.color]);
ADDRGP4 levelMenuInfo+3204+104
INDIRI4
CNSTI4 4
LSHI4
ADDRGP4 colorTable
ADDP4
ARGP4
ADDRGP4 trap_R_SetColor
CALLV
pop
line 867
;867:	UI_DrawHandlePic(levelMenuInfo.advanced.generic.x - 14, levelMenuInfo.advanced.generic.y, 
ADDRGP4 levelMenuInfo+3204+12
INDIRI4
CNSTI4 14
SUBI4
CVIF4 4
ARGF4
ADDRGP4 levelMenuInfo+3204+16
INDIRI4
CVIF4 4
ARGF4
ADDRLP4 1180
CNSTF4 1099956224
ASGNF4
ADDRLP4 1180
INDIRF4
ARGF4
ADDRLP4 1180
INDIRF4
ARGF4
ADDRGP4 uis+5352
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 871
;868:		MENU_BUTTON_MED_HEIGHT, MENU_BUTTON_MED_HEIGHT, uis.graphicButtonLeftEnd);
;869:
;870:
;871:}
LABELV $321
endproc UI_SPLevelMenu_MenuDraw 1184 20
export UI_SPLevelMenu_Cache
proc UI_SPLevelMenu_Cache 48 4
line 880
;872:
;873:
;874:/*
;875:=================
;876:UI_SPLevelMenu_Cache
;877:=================
;878:*/
;879:void UI_SPLevelMenu_Cache( void ) 
;880:{
line 883
;881:	int				n;
;882:
;883:	trap_R_RegisterShaderNoMip( ART_MAP_UNKNOWN );
ADDRGP4 $153
ARGP4
ADDRGP4 trap_R_RegisterShaderNoMip
CALLI4
pop
line 885
;884:
;885:	for( n = 0; n < AWARD_MAX; n++ ) 
ADDRLP4 0
CNSTI4 0
ASGNI4
LABELV $480
line 886
;886:	{
line 887
;887:		trap_R_RegisterShaderNoMip( ui_medalPicNames[n] );
ADDRLP4 0
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 ui_medalPicNames
ADDP4
INDIRP4
ARGP4
ADDRGP4 trap_R_RegisterShaderNoMip
CALLI4
pop
line 888
;888:		levelMenuInfo.awardSounds[n] = trap_S_RegisterSound( ui_medalSounds[n] );
ADDRLP4 4
ADDRLP4 0
INDIRI4
CNSTI4 2
LSHI4
ASGNI4
ADDRLP4 4
INDIRI4
ADDRGP4 ui_medalSounds
ADDP4
INDIRP4
ARGP4
ADDRLP4 8
ADDRGP4 trap_S_RegisterSound
CALLI4
ASGNI4
ADDRLP4 4
INDIRI4
ADDRGP4 levelMenuInfo+4004
ADDP4
ADDRLP4 8
INDIRI4
ASGNI4
line 889
;889:	}
LABELV $481
line 885
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
ADDRLP4 0
INDIRI4
CNSTI4 9
LTI4 $480
line 891
;890:
;891:	levelMenuInfo.corner_ul_18_12 = trap_R_RegisterShaderNoMip("menu/common/corner_ul_18_12");
ADDRGP4 $486
ARGP4
ADDRLP4 4
ADDRGP4 trap_R_RegisterShaderNoMip
CALLI4
ASGNI4
ADDRGP4 levelMenuInfo+3836
ADDRLP4 4
INDIRI4
ASGNI4
line 892
;892:	levelMenuInfo.corner_ur_18_12 = trap_R_RegisterShaderNoMip("menu/common/corner_ur_18_12");
ADDRGP4 $488
ARGP4
ADDRLP4 8
ADDRGP4 trap_R_RegisterShaderNoMip
CALLI4
ASGNI4
ADDRGP4 levelMenuInfo+3840
ADDRLP4 8
INDIRI4
ASGNI4
line 893
;893:	levelMenuInfo.corner_lr_7_12  = trap_R_RegisterShaderNoMip("menu/common/corner_lr_7_12");
ADDRGP4 $490
ARGP4
ADDRLP4 12
ADDRGP4 trap_R_RegisterShaderNoMip
CALLI4
ASGNI4
ADDRGP4 levelMenuInfo+3848
ADDRLP4 12
INDIRI4
ASGNI4
line 894
;894:	levelMenuInfo.corner_ll_18_34 = trap_R_RegisterShaderNoMip("menu/common/corner_ll_18_34");
ADDRGP4 $492
ARGP4
ADDRLP4 16
ADDRGP4 trap_R_RegisterShaderNoMip
CALLI4
ASGNI4
ADDRGP4 levelMenuInfo+3844
ADDRLP4 16
INDIRI4
ASGNI4
line 896
;895:
;896:	levelMenuInfo.levelSelectedPic = trap_R_RegisterShaderNoMip( ART_LEVELFRAME_SELECTED );
ADDRGP4 $494
ARGP4
ADDRLP4 20
ADDRGP4 trap_R_RegisterShaderNoMip
CALLI4
ASGNI4
ADDRGP4 levelMenuInfo+3808
ADDRLP4 20
INDIRI4
ASGNI4
line 897
;897:	levelMenuInfo.levelFocusPic = trap_R_RegisterShaderNoMip( ART_LEVELFRAME_FOCUS );
ADDRGP4 $496
ARGP4
ADDRLP4 24
ADDRGP4 trap_R_RegisterShaderNoMip
CALLI4
ASGNI4
ADDRGP4 levelMenuInfo+3812
ADDRLP4 24
INDIRI4
ASGNI4
line 898
;898:	levelMenuInfo.levelCompletePic[0] = trap_R_RegisterShaderNoMip( ART_MAP_COMPLETE1 );
ADDRGP4 $498
ARGP4
ADDRLP4 28
ADDRGP4 trap_R_RegisterShaderNoMip
CALLI4
ASGNI4
ADDRGP4 levelMenuInfo+3816
ADDRLP4 28
INDIRI4
ASGNI4
line 899
;899:	levelMenuInfo.levelCompletePic[1] = trap_R_RegisterShaderNoMip( ART_MAP_COMPLETE2 );
ADDRGP4 $501
ARGP4
ADDRLP4 32
ADDRGP4 trap_R_RegisterShaderNoMip
CALLI4
ASGNI4
ADDRGP4 levelMenuInfo+3816+4
ADDRLP4 32
INDIRI4
ASGNI4
line 900
;900:	levelMenuInfo.levelCompletePic[2] = trap_R_RegisterShaderNoMip( ART_MAP_COMPLETE3 );
ADDRGP4 $504
ARGP4
ADDRLP4 36
ADDRGP4 trap_R_RegisterShaderNoMip
CALLI4
ASGNI4
ADDRGP4 levelMenuInfo+3816+8
ADDRLP4 36
INDIRI4
ASGNI4
line 901
;901:	levelMenuInfo.levelCompletePic[3] = trap_R_RegisterShaderNoMip( ART_MAP_COMPLETE4 );
ADDRGP4 $507
ARGP4
ADDRLP4 40
ADDRGP4 trap_R_RegisterShaderNoMip
CALLI4
ASGNI4
ADDRGP4 levelMenuInfo+3816+12
ADDRLP4 40
INDIRI4
ASGNI4
line 902
;902:	levelMenuInfo.levelCompletePic[4] = trap_R_RegisterShaderNoMip( ART_MAP_COMPLETE5 );
ADDRGP4 $510
ARGP4
ADDRLP4 44
ADDRGP4 trap_R_RegisterShaderNoMip
CALLI4
ASGNI4
ADDRGP4 levelMenuInfo+3816+16
ADDRLP4 44
INDIRI4
ASGNI4
line 904
;903:
;904:}
LABELV $479
endproc UI_SPLevelMenu_Cache 48 4
proc UI_SPLevelMenu_Init 120 12
line 913
;905:
;906:
;907:/*
;908:=================
;909:UI_SPLevelMenu_Init
;910:=================
;911:*/
;912:static void UI_SPLevelMenu_Init( void ) 
;913:{
line 923
;914:	int		skill;
;915:	int		n;
;916:	int		x, y;
;917:	int		count;
;918:	char	buf[MAX_QPATH];
;919:	int mapHeight,mapWidth;
;920:
;921:
;922:	// What skill level are we playing at??
;923:	skill = (int)trap_Cvar_VariableValue( "g_spSkill" );
ADDRGP4 $512
ARGP4
ADDRLP4 92
ADDRGP4 trap_Cvar_VariableValue
CALLF4
ASGNF4
ADDRLP4 24
ADDRLP4 92
INDIRF4
CVFI4 4
ASGNI4
line 924
;924:	if( skill < 1 || skill > 5 ) 
ADDRLP4 24
INDIRI4
CNSTI4 1
LTI4 $515
ADDRLP4 24
INDIRI4
CNSTI4 5
LEI4 $513
LABELV $515
line 925
;925:	{
line 926
;926:		trap_Cvar_Set( "g_spSkill", "2" );
ADDRGP4 $512
ARGP4
ADDRGP4 $516
ARGP4
ADDRGP4 trap_Cvar_Set
CALLV
pop
line 927
;927:		skill = 2;
ADDRLP4 24
CNSTI4 2
ASGNI4
line 928
;928:	}
LABELV $513
line 930
;929:
;930:	memset( &levelMenuInfo, 0, sizeof(levelMenuInfo) );
ADDRGP4 levelMenuInfo
ARGP4
CNSTI4 0
ARGI4
CNSTI4 4132
ARGI4
ADDRGP4 memset
CALLP4
pop
line 931
;931:	levelMenuInfo.menu.fullscreen					= qtrue;
ADDRGP4 levelMenuInfo+280
CNSTI4 1
ASGNI4
line 932
;932:	levelMenuInfo.menu.wrapAround					= qtrue;
ADDRGP4 levelMenuInfo+276
CNSTI4 1
ASGNI4
line 933
;933:	levelMenuInfo.menu.draw							= UI_SPLevelMenu_MenuDraw;
ADDRGP4 levelMenuInfo+268
ADDRGP4 UI_SPLevelMenu_MenuDraw
ASGNP4
line 934
;934:	levelMenuInfo.menu.descX						= MENU_DESC_X;
ADDRGP4 levelMenuInfo+292
CNSTI4 100
ASGNI4
line 935
;935:	levelMenuInfo.menu.descY						= MENU_DESC_Y;
ADDRGP4 levelMenuInfo+296
CNSTI4 444
ASGNI4
line 936
;936:	levelMenuInfo.menu.titleX						= MENU_TITLE_X;
ADDRGP4 levelMenuInfo+308
CNSTI4 611
ASGNI4
line 937
;937:	levelMenuInfo.menu.titleY						= MENU_TITLE_Y;
ADDRGP4 levelMenuInfo+312
CNSTI4 24
ASGNI4
line 938
;938:	levelMenuInfo.menu.titleI						= MNT_SINGLEPLAYER_TITLE;
ADDRGP4 levelMenuInfo+316
CNSTI4 5
ASGNI4
line 939
;939:	levelMenuInfo.menu.footNoteEnum					= MNT_SINGLEPLAYER;
ADDRGP4 levelMenuInfo+320
CNSTI4 129
ASGNI4
line 941
;940:
;941:	UI_SPLevelMenu_Cache();
ADDRGP4 UI_SPLevelMenu_Cache
CALLV
pop
line 943
;942:
;943:	levelMenuInfo.mainmenu.generic.type				= MTYPE_BITMAP;      
ADDRGP4 levelMenuInfo+324
CNSTI4 6
ASGNI4
line 944
;944:	levelMenuInfo.mainmenu.generic.flags			= QMF_HIGHLIGHT_IF_FOCUS;
ADDRGP4 levelMenuInfo+324+44
CNSTU4 128
ASGNU4
line 945
;945:	levelMenuInfo.mainmenu.generic.x				= 110;
ADDRGP4 levelMenuInfo+324+12
CNSTI4 110
ASGNI4
line 946
;946:	levelMenuInfo.mainmenu.generic.y				= 391;
ADDRGP4 levelMenuInfo+324+16
CNSTI4 391
ASGNI4
line 947
;947:	levelMenuInfo.mainmenu.generic.name				= BUTTON_GRAPHIC_LONGRIGHT;
ADDRGP4 levelMenuInfo+324+4
ADDRGP4 $535
ASGNP4
line 948
;948:	levelMenuInfo.mainmenu.generic.id				= ID_MAINMENU;
ADDRGP4 levelMenuInfo+324+8
CNSTI4 100
ASGNI4
line 949
;949:	levelMenuInfo.mainmenu.generic.callback			= UI_SPLevelMenu_BackEvent;
ADDRGP4 levelMenuInfo+324+48
ADDRGP4 UI_SPLevelMenu_BackEvent
ASGNP4
line 950
;950:	levelMenuInfo.mainmenu.width					= MENU_BUTTON_MED_WIDTH;
ADDRGP4 levelMenuInfo+324+92
CNSTI4 130
ASGNI4
line 951
;951:	levelMenuInfo.mainmenu.height					= MENU_BUTTON_MED_HEIGHT;
ADDRGP4 levelMenuInfo+324+96
CNSTI4 18
ASGNI4
line 952
;952:	levelMenuInfo.mainmenu.color					= CT_DKPURPLE1;
ADDRGP4 levelMenuInfo+324+104
CNSTI4 35
ASGNI4
line 953
;953:	levelMenuInfo.mainmenu.color2					= CT_LTPURPLE1;
ADDRGP4 levelMenuInfo+324+108
CNSTI4 34
ASGNI4
line 954
;954:	levelMenuInfo.mainmenu.textX					= MENU_BUTTON_TEXT_X;
ADDRGP4 levelMenuInfo+324+124
CNSTI4 5
ASGNI4
line 955
;955:	levelMenuInfo.mainmenu.textY					= MENU_BUTTON_TEXT_Y;
ADDRGP4 levelMenuInfo+324+128
CNSTI4 1
ASGNI4
line 956
;956:	levelMenuInfo.mainmenu.textEnum					= MBT_MAINMENU;
ADDRGP4 levelMenuInfo+324+116
CNSTI4 9
ASGNI4
line 957
;957:	levelMenuInfo.mainmenu.textcolor				= CT_BLACK;
ADDRGP4 levelMenuInfo+324+132
CNSTI4 1
ASGNI4
line 958
;958:	levelMenuInfo.mainmenu.textcolor2				= CT_WHITE;
ADDRGP4 levelMenuInfo+324+136
CNSTI4 8
ASGNI4
line 960
;959:
;960:	levelMenuInfo.back.generic.type				= MTYPE_BITMAP;      
ADDRGP4 levelMenuInfo+468
CNSTI4 6
ASGNI4
line 961
;961:	levelMenuInfo.back.generic.flags			= QMF_HIGHLIGHT_IF_FOCUS;
ADDRGP4 levelMenuInfo+468+44
CNSTU4 128
ASGNU4
line 962
;962:	levelMenuInfo.back.generic.x				= 110;
ADDRGP4 levelMenuInfo+468+12
CNSTI4 110
ASGNI4
line 963
;963:	levelMenuInfo.back.generic.y				= 415;
ADDRGP4 levelMenuInfo+468+16
CNSTI4 415
ASGNI4
line 964
;964:	levelMenuInfo.back.generic.name				= BUTTON_GRAPHIC_LONGRIGHT;
ADDRGP4 levelMenuInfo+468+4
ADDRGP4 $535
ASGNP4
line 965
;965:	levelMenuInfo.back.generic.id				= ID_BACK;
ADDRGP4 levelMenuInfo+468+8
CNSTI4 123
ASGNI4
line 966
;966:	levelMenuInfo.back.generic.callback			= UI_SPLevelMenu_BackEvent;
ADDRGP4 levelMenuInfo+468+48
ADDRGP4 UI_SPLevelMenu_BackEvent
ASGNP4
line 967
;967:	levelMenuInfo.back.width					= MENU_BUTTON_MED_WIDTH;
ADDRGP4 levelMenuInfo+468+92
CNSTI4 130
ASGNI4
line 968
;968:	levelMenuInfo.back.height					= MENU_BUTTON_MED_HEIGHT;
ADDRGP4 levelMenuInfo+468+96
CNSTI4 18
ASGNI4
line 969
;969:	levelMenuInfo.back.color					= CT_DKPURPLE1;
ADDRGP4 levelMenuInfo+468+104
CNSTI4 35
ASGNI4
line 970
;970:	levelMenuInfo.back.color2					= CT_LTPURPLE1;
ADDRGP4 levelMenuInfo+468+108
CNSTI4 34
ASGNI4
line 971
;971:	levelMenuInfo.back.textX					= MENU_BUTTON_TEXT_X;
ADDRGP4 levelMenuInfo+468+124
CNSTI4 5
ASGNI4
line 972
;972:	levelMenuInfo.back.textY					= MENU_BUTTON_TEXT_Y;
ADDRGP4 levelMenuInfo+468+128
CNSTI4 1
ASGNI4
line 973
;973:	levelMenuInfo.back.textEnum					= MBT_BACK;
ADDRGP4 levelMenuInfo+468+116
CNSTI4 118
ASGNI4
line 974
;974:	levelMenuInfo.back.textcolor				= CT_BLACK;
ADDRGP4 levelMenuInfo+468+132
CNSTI4 1
ASGNI4
line 975
;975:	levelMenuInfo.back.textcolor2				= CT_WHITE;
ADDRGP4 levelMenuInfo+468+136
CNSTI4 8
ASGNI4
line 977
;976:
;977:	levelMenuInfo.item_leftarrow.generic.type		= MTYPE_BITMAP;
ADDRGP4 levelMenuInfo+900
CNSTI4 6
ASGNI4
line 978
;978:	levelMenuInfo.item_leftarrow.generic.flags		= QMF_HIGHLIGHT_IF_FOCUS;
ADDRGP4 levelMenuInfo+900+44
CNSTU4 128
ASGNU4
line 979
;979:	levelMenuInfo.item_leftarrow.generic.name		= "menu/common/arrow_left_16.tga";
ADDRGP4 levelMenuInfo+900+4
ADDRGP4 $594
ASGNP4
line 980
;980:	levelMenuInfo.item_leftarrow.generic.x			= 135;
ADDRGP4 levelMenuInfo+900+12
CNSTI4 135
ASGNI4
line 981
;981:	levelMenuInfo.item_leftarrow.generic.y			= 195;
ADDRGP4 levelMenuInfo+900+16
CNSTI4 195
ASGNI4
line 982
;982:	levelMenuInfo.item_leftarrow.generic.callback	= UI_SPLevelMenu_LeftArrowEvent;
ADDRGP4 levelMenuInfo+900+48
ADDRGP4 UI_SPLevelMenu_LeftArrowEvent
ASGNP4
line 983
;983:	levelMenuInfo.item_leftarrow.generic.id			= ID_LEFTARROW;
ADDRGP4 levelMenuInfo+900+8
CNSTI4 10
ASGNI4
line 984
;984:	levelMenuInfo.item_leftarrow.width				= 16;
ADDRGP4 levelMenuInfo+900+92
CNSTI4 16
ASGNI4
line 985
;985:	levelMenuInfo.item_leftarrow.height				= 16;
ADDRGP4 levelMenuInfo+900+96
CNSTI4 16
ASGNI4
line 986
;986:	levelMenuInfo.item_leftarrow.color				= CT_DKGOLD1;
ADDRGP4 levelMenuInfo+900+104
CNSTI4 31
ASGNI4
line 987
;987:	levelMenuInfo.item_leftarrow.color2				= CT_LTGOLD1;
ADDRGP4 levelMenuInfo+900+108
CNSTI4 30
ASGNI4
line 988
;988:	levelMenuInfo.item_leftarrow.textX				= MENU_BUTTON_TEXT_X;
ADDRGP4 levelMenuInfo+900+124
CNSTI4 5
ASGNI4
line 989
;989:	levelMenuInfo.item_leftarrow.textY				= MENU_BUTTON_TEXT_Y;
ADDRGP4 levelMenuInfo+900+128
CNSTI4 1
ASGNI4
line 990
;990:	levelMenuInfo.item_leftarrow.textEnum			= MBT_PREVMAPS;
ADDRGP4 levelMenuInfo+900+116
CNSTI4 140
ASGNI4
line 991
;991:	levelMenuInfo.item_leftarrow.textcolor			= CT_BLACK;
ADDRGP4 levelMenuInfo+900+132
CNSTI4 1
ASGNI4
line 992
;992:	levelMenuInfo.item_leftarrow.textcolor2			= CT_WHITE;
ADDRGP4 levelMenuInfo+900+136
CNSTI4 8
ASGNI4
line 994
;993:
;994:	levelMenuInfo.item_rightarrow.generic.type		= MTYPE_BITMAP;
ADDRGP4 levelMenuInfo+1620
CNSTI4 6
ASGNI4
line 995
;995:	levelMenuInfo.item_rightarrow.generic.name		= "menu/common/arrow_right_16.tga";
ADDRGP4 levelMenuInfo+1620+4
ADDRGP4 $624
ASGNP4
line 996
;996:	levelMenuInfo.item_rightarrow.generic.flags		= QMF_HIGHLIGHT_IF_FOCUS;
ADDRGP4 levelMenuInfo+1620+44
CNSTU4 128
ASGNU4
line 997
;997:	levelMenuInfo.item_rightarrow.generic.x			= 558;
ADDRGP4 levelMenuInfo+1620+12
CNSTI4 558
ASGNI4
line 998
;998:	levelMenuInfo.item_rightarrow.generic.y			= 195;
ADDRGP4 levelMenuInfo+1620+16
CNSTI4 195
ASGNI4
line 999
;999:	levelMenuInfo.item_rightarrow.generic.callback	= UI_SPLevelMenu_RightArrowEvent;
ADDRGP4 levelMenuInfo+1620+48
ADDRGP4 UI_SPLevelMenu_RightArrowEvent
ASGNP4
line 1000
;1000:	levelMenuInfo.item_rightarrow.generic.id		= ID_RIGHTARROW;
ADDRGP4 levelMenuInfo+1620+8
CNSTI4 15
ASGNI4
line 1001
;1001:	levelMenuInfo.item_rightarrow.width				= 16;
ADDRGP4 levelMenuInfo+1620+92
CNSTI4 16
ASGNI4
line 1002
;1002:	levelMenuInfo.item_rightarrow.height			= 16;
ADDRGP4 levelMenuInfo+1620+96
CNSTI4 16
ASGNI4
line 1003
;1003:	levelMenuInfo.item_rightarrow.color				= CT_DKGOLD1;
ADDRGP4 levelMenuInfo+1620+104
CNSTI4 31
ASGNI4
line 1004
;1004:	levelMenuInfo.item_rightarrow.color2			= CT_LTGOLD1;
ADDRGP4 levelMenuInfo+1620+108
CNSTI4 30
ASGNI4
line 1005
;1005:	levelMenuInfo.item_rightarrow.textX				= MENU_BUTTON_TEXT_X;
ADDRGP4 levelMenuInfo+1620+124
CNSTI4 5
ASGNI4
line 1006
;1006:	levelMenuInfo.item_rightarrow.textY				= MENU_BUTTON_TEXT_Y;
ADDRGP4 levelMenuInfo+1620+128
CNSTI4 1
ASGNI4
line 1007
;1007:	levelMenuInfo.item_rightarrow.textEnum			= MBT_PREVMAPS;
ADDRGP4 levelMenuInfo+1620+116
CNSTI4 140
ASGNI4
line 1008
;1008:	levelMenuInfo.item_rightarrow.textcolor			= CT_BLACK;
ADDRGP4 levelMenuInfo+1620+132
CNSTI4 1
ASGNI4
line 1009
;1009:	levelMenuInfo.item_rightarrow.textcolor2		= CT_WHITE;
ADDRGP4 levelMenuInfo+1620+136
CNSTI4 8
ASGNI4
line 1014
;1010:
;1011:
;1012:
;1013:	// Map pics
;1014:	y = 84;
ADDRLP4 12
CNSTI4 84
ASGNI4
line 1015
;1015:	x = 130;
ADDRLP4 8
CNSTI4 130
ASGNI4
line 1016
;1016:	mapHeight = 87;
ADDRLP4 20
CNSTI4 87
ASGNI4
line 1017
;1017:	mapWidth = 116;
ADDRLP4 16
CNSTI4 116
ASGNI4
line 1018
;1018:	levelMenuInfo.item_maps[0].generic.type			= MTYPE_BITMAP;
ADDRGP4 levelMenuInfo+1044
CNSTI4 6
ASGNI4
line 1019
;1019:	levelMenuInfo.item_maps[0].generic.name			= levelMenuInfo.levelPicNames[0];
ADDRGP4 levelMenuInfo+1044+4
ADDRGP4 levelMenuInfo+3360
ASGNP4
line 1020
;1020:	levelMenuInfo.item_maps[0].generic.flags		= QMF_LEFT_JUSTIFY;
ADDRGP4 levelMenuInfo+1044+44
CNSTU4 4
ASGNU4
line 1021
;1021:	levelMenuInfo.item_maps[0].generic.x			= x;
ADDRGP4 levelMenuInfo+1044+12
ADDRLP4 8
INDIRI4
ASGNI4
line 1022
;1022:	levelMenuInfo.item_maps[0].generic.y			= y;
ADDRGP4 levelMenuInfo+1044+16
ADDRLP4 12
INDIRI4
ASGNI4
line 1023
;1023:	levelMenuInfo.item_maps[0].generic.id			= ID_PICTURE0;
ADDRGP4 levelMenuInfo+1044+8
CNSTI4 11
ASGNI4
line 1024
;1024:	levelMenuInfo.item_maps[0].generic.callback		= UI_SPLevelMenu_LevelEvent;
ADDRGP4 levelMenuInfo+1044+48
ADDRGP4 UI_SPLevelMenu_LevelEvent
ASGNP4
line 1025
;1025:	levelMenuInfo.item_maps[0].width				= mapWidth;
ADDRGP4 levelMenuInfo+1044+92
ADDRLP4 16
INDIRI4
ASGNI4
line 1026
;1026:	levelMenuInfo.item_maps[0].height				= mapHeight;
ADDRGP4 levelMenuInfo+1044+96
ADDRLP4 20
INDIRI4
ASGNI4
line 1028
;1027:
;1028:	x += mapWidth + 6;
ADDRLP4 8
ADDRLP4 8
INDIRI4
ADDRLP4 16
INDIRI4
CNSTI4 6
ADDI4
ADDI4
ASGNI4
line 1029
;1029:	levelMenuInfo.item_maps[1].generic.type			= MTYPE_BITMAP;
ADDRGP4 levelMenuInfo+1044+144
CNSTI4 6
ASGNI4
line 1030
;1030:	levelMenuInfo.item_maps[1].generic.name			= levelMenuInfo.levelPicNames[1];
ADDRGP4 levelMenuInfo+1044+144+4
ADDRGP4 levelMenuInfo+3360+64
ASGNP4
line 1031
;1031:	levelMenuInfo.item_maps[1].generic.flags		= QMF_LEFT_JUSTIFY;
ADDRGP4 levelMenuInfo+1044+144+44
CNSTU4 4
ASGNU4
line 1032
;1032:	levelMenuInfo.item_maps[1].generic.x			= x;
ADDRGP4 levelMenuInfo+1044+144+12
ADDRLP4 8
INDIRI4
ASGNI4
line 1033
;1033:	levelMenuInfo.item_maps[1].generic.y			= y;
ADDRGP4 levelMenuInfo+1044+144+16
ADDRLP4 12
INDIRI4
ASGNI4
line 1034
;1034:	levelMenuInfo.item_maps[1].generic.id			= ID_PICTURE1;
ADDRGP4 levelMenuInfo+1044+144+8
CNSTI4 12
ASGNI4
line 1035
;1035:	levelMenuInfo.item_maps[1].generic.callback		= UI_SPLevelMenu_LevelEvent;
ADDRGP4 levelMenuInfo+1044+144+48
ADDRGP4 UI_SPLevelMenu_LevelEvent
ASGNP4
line 1036
;1036:	levelMenuInfo.item_maps[1].width				= mapWidth;
ADDRGP4 levelMenuInfo+1044+144+92
ADDRLP4 16
INDIRI4
ASGNI4
line 1037
;1037:	levelMenuInfo.item_maps[1].height				= mapHeight;
ADDRGP4 levelMenuInfo+1044+144+96
ADDRLP4 20
INDIRI4
ASGNI4
line 1039
;1038:
;1039:	x += mapWidth + 6;
ADDRLP4 8
ADDRLP4 8
INDIRI4
ADDRLP4 16
INDIRI4
CNSTI4 6
ADDI4
ADDI4
ASGNI4
line 1040
;1040:	levelMenuInfo.item_maps[2].generic.type			= MTYPE_BITMAP;
ADDRGP4 levelMenuInfo+1044+288
CNSTI4 6
ASGNI4
line 1041
;1041:	levelMenuInfo.item_maps[2].generic.name			= levelMenuInfo.levelPicNames[2];
ADDRGP4 levelMenuInfo+1044+288+4
ADDRGP4 levelMenuInfo+3360+128
ASGNP4
line 1042
;1042:	levelMenuInfo.item_maps[2].generic.flags		= QMF_LEFT_JUSTIFY;
ADDRGP4 levelMenuInfo+1044+288+44
CNSTU4 4
ASGNU4
line 1043
;1043:	levelMenuInfo.item_maps[2].generic.x			= x;
ADDRGP4 levelMenuInfo+1044+288+12
ADDRLP4 8
INDIRI4
ASGNI4
line 1044
;1044:	levelMenuInfo.item_maps[2].generic.y			= y;
ADDRGP4 levelMenuInfo+1044+288+16
ADDRLP4 12
INDIRI4
ASGNI4
line 1045
;1045:	levelMenuInfo.item_maps[2].generic.id			= ID_PICTURE2;
ADDRGP4 levelMenuInfo+1044+288+8
CNSTI4 13
ASGNI4
line 1046
;1046:	levelMenuInfo.item_maps[2].generic.callback		= UI_SPLevelMenu_LevelEvent;
ADDRGP4 levelMenuInfo+1044+288+48
ADDRGP4 UI_SPLevelMenu_LevelEvent
ASGNP4
line 1047
;1047:	levelMenuInfo.item_maps[2].width				= mapWidth;
ADDRGP4 levelMenuInfo+1044+288+92
ADDRLP4 16
INDIRI4
ASGNI4
line 1048
;1048:	levelMenuInfo.item_maps[2].height				= mapHeight;
ADDRGP4 levelMenuInfo+1044+288+96
ADDRLP4 20
INDIRI4
ASGNI4
line 1050
;1049:
;1050:	x += mapWidth + 6;
ADDRLP4 8
ADDRLP4 8
INDIRI4
ADDRLP4 16
INDIRI4
CNSTI4 6
ADDI4
ADDI4
ASGNI4
line 1051
;1051:	levelMenuInfo.item_maps[3].generic.type			= MTYPE_BITMAP;
ADDRGP4 levelMenuInfo+1044+432
CNSTI4 6
ASGNI4
line 1052
;1052:	levelMenuInfo.item_maps[3].generic.name			= levelMenuInfo.levelPicNames[3];
ADDRGP4 levelMenuInfo+1044+432+4
ADDRGP4 levelMenuInfo+3360+192
ASGNP4
line 1053
;1053:	levelMenuInfo.item_maps[3].generic.flags		= QMF_LEFT_JUSTIFY;
ADDRGP4 levelMenuInfo+1044+432+44
CNSTU4 4
ASGNU4
line 1054
;1054:	levelMenuInfo.item_maps[3].generic.x			= x;
ADDRGP4 levelMenuInfo+1044+432+12
ADDRLP4 8
INDIRI4
ASGNI4
line 1055
;1055:	levelMenuInfo.item_maps[3].generic.y			= y;
ADDRGP4 levelMenuInfo+1044+432+16
ADDRLP4 12
INDIRI4
ASGNI4
line 1056
;1056:	levelMenuInfo.item_maps[3].generic.id			= ID_PICTURE3;
ADDRGP4 levelMenuInfo+1044+432+8
CNSTI4 14
ASGNI4
line 1057
;1057:	levelMenuInfo.item_maps[3].generic.callback		= UI_SPLevelMenu_LevelEvent;
ADDRGP4 levelMenuInfo+1044+432+48
ADDRGP4 UI_SPLevelMenu_LevelEvent
ASGNP4
line 1058
;1058:	levelMenuInfo.item_maps[3].width				= mapWidth;
ADDRGP4 levelMenuInfo+1044+432+92
ADDRLP4 16
INDIRI4
ASGNI4
line 1059
;1059:	levelMenuInfo.item_maps[3].height				= mapHeight;
ADDRGP4 levelMenuInfo+1044+432+96
ADDRLP4 20
INDIRI4
ASGNI4
line 1061
;1060:
;1061:	levelMenuInfo.item_reset.generic.type			= MTYPE_BITMAP;
ADDRGP4 levelMenuInfo+2916
CNSTI4 6
ASGNI4
line 1062
;1062:	levelMenuInfo.item_reset.generic.flags			= QMF_HIGHLIGHT_IF_FOCUS;
ADDRGP4 levelMenuInfo+2916+44
CNSTU4 128
ASGNU4
line 1063
;1063:	levelMenuInfo.item_reset.generic.x				= 432;
ADDRGP4 levelMenuInfo+2916+12
CNSTI4 432
ASGNI4
line 1064
;1064:	levelMenuInfo.item_reset.generic.y				= 350;
ADDRGP4 levelMenuInfo+2916+16
CNSTI4 350
ASGNI4
line 1065
;1065:	levelMenuInfo.item_reset.generic.name			= BUTTON_GRAPHIC_LONGRIGHT;
ADDRGP4 levelMenuInfo+2916+4
ADDRGP4 $535
ASGNP4
line 1066
;1066:	levelMenuInfo.item_reset.generic.id				= ID_RESET;
ADDRGP4 levelMenuInfo+2916+8
CNSTI4 26
ASGNI4
line 1067
;1067:	levelMenuInfo.item_reset.generic.callback		= UI_SPLevelMenu_ResetEvent;
ADDRGP4 levelMenuInfo+2916+48
ADDRGP4 UI_SPLevelMenu_ResetEvent
ASGNP4
line 1068
;1068:	levelMenuInfo.item_reset.width					= MENU_BUTTON_MED_WIDTH;
ADDRGP4 levelMenuInfo+2916+92
CNSTI4 130
ASGNI4
line 1069
;1069:	levelMenuInfo.item_reset.height					= MENU_BUTTON_MED_HEIGHT;
ADDRGP4 levelMenuInfo+2916+96
CNSTI4 18
ASGNI4
line 1070
;1070:	levelMenuInfo.item_reset.color					= CT_DKPURPLE1;
ADDRGP4 levelMenuInfo+2916+104
CNSTI4 35
ASGNI4
line 1071
;1071:	levelMenuInfo.item_reset.color2					= CT_LTPURPLE1;
ADDRGP4 levelMenuInfo+2916+108
CNSTI4 34
ASGNI4
line 1072
;1072:	levelMenuInfo.item_reset.textX					= MENU_BUTTON_TEXT_X;
ADDRGP4 levelMenuInfo+2916+124
CNSTI4 5
ASGNI4
line 1073
;1073:	levelMenuInfo.item_reset.textY					= MENU_BUTTON_TEXT_Y;
ADDRGP4 levelMenuInfo+2916+128
CNSTI4 1
ASGNI4
line 1074
;1074:	levelMenuInfo.item_reset.textEnum				= MBT_RESETPROGRESS;
ADDRGP4 levelMenuInfo+2916+116
CNSTI4 246
ASGNI4
line 1075
;1075:	levelMenuInfo.item_reset.textcolor				= CT_BLACK;
ADDRGP4 levelMenuInfo+2916+132
CNSTI4 1
ASGNI4
line 1076
;1076:	levelMenuInfo.item_reset.textcolor2				= CT_WHITE;
ADDRGP4 levelMenuInfo+2916+136
CNSTI4 8
ASGNI4
line 1079
;1077:
;1078:	// Player pic
;1079:	trap_Cvar_VariableStringBuffer( "model", levelMenuInfo.playerModel, sizeof(levelMenuInfo.playerModel) );
ADDRGP4 $110
ARGP4
ADDRGP4 levelMenuInfo+3852
ARGP4
CNSTI4 64
ARGI4
ADDRGP4 trap_Cvar_VariableStringBuffer
CALLV
pop
line 1080
;1080:	PlayerIcon( levelMenuInfo.playerModel, levelMenuInfo.playerPicName, sizeof(levelMenuInfo.playerPicName) );
ADDRGP4 levelMenuInfo+3852
ARGP4
ADDRGP4 levelMenuInfo+3916
ARGP4
CNSTI4 64
ARGI4
ADDRGP4 PlayerIcon
CALLV
pop
line 1081
;1081:	levelMenuInfo.item_player.generic.type			= MTYPE_BITMAP;
ADDRGP4 levelMenuInfo+1764
CNSTI4 6
ASGNI4
line 1082
;1082:	levelMenuInfo.item_player.generic.flags			= QMF_INACTIVE;
ADDRGP4 levelMenuInfo+1764+44
CNSTU4 16384
ASGNU4
line 1083
;1083:	levelMenuInfo.item_player.generic.name			= levelMenuInfo.playerPicName;
ADDRGP4 levelMenuInfo+1764+4
ADDRGP4 levelMenuInfo+3916
ASGNP4
line 1084
;1084:	levelMenuInfo.item_player.generic.x				= 461;
ADDRGP4 levelMenuInfo+1764+12
CNSTI4 461
ASGNI4
line 1085
;1085:	levelMenuInfo.item_player.generic.y				= 247;
ADDRGP4 levelMenuInfo+1764+16
CNSTI4 247
ASGNI4
line 1086
;1086:	levelMenuInfo.item_player.generic.id			= ID_PLAYERPIC;
ADDRGP4 levelMenuInfo+1764+8
CNSTI4 16
ASGNI4
line 1087
;1087:	levelMenuInfo.item_player.width					= 64;
ADDRGP4 levelMenuInfo+1764+92
CNSTI4 64
ASGNI4
line 1088
;1088:	levelMenuInfo.item_player.height				= 64;
ADDRGP4 levelMenuInfo+1764+96
CNSTI4 64
ASGNI4
line 1090
;1089:
;1090:	levelMenuInfo.playerinfo.generic.type			= MTYPE_BITMAP;
ADDRGP4 levelMenuInfo+3060
CNSTI4 6
ASGNI4
line 1091
;1091:	levelMenuInfo.playerinfo.generic.name			= BUTTON_GRAPHIC_LONGRIGHT;
ADDRGP4 levelMenuInfo+3060+4
ADDRGP4 $535
ASGNP4
line 1092
;1092:	levelMenuInfo.playerinfo.generic.flags			= QMF_HIGHLIGHT_IF_FOCUS;
ADDRGP4 levelMenuInfo+3060+44
CNSTU4 128
ASGNU4
line 1093
;1093:	levelMenuInfo.playerinfo.generic.x				= 432;
ADDRGP4 levelMenuInfo+3060+12
CNSTI4 432
ASGNI4
line 1094
;1094:	levelMenuInfo.playerinfo.generic.y				= 325;
ADDRGP4 levelMenuInfo+3060+16
CNSTI4 325
ASGNI4
line 1095
;1095:	levelMenuInfo.playerinfo.generic.callback		= UI_SPLevelMenu_PlayerEvent;
ADDRGP4 levelMenuInfo+3060+48
ADDRGP4 UI_SPLevelMenu_PlayerEvent
ASGNP4
line 1096
;1096:	levelMenuInfo.playerinfo.generic.id				= ID_PLAYERINFO;
ADDRGP4 levelMenuInfo+3060+8
CNSTI4 112
ASGNI4
line 1097
;1097:	levelMenuInfo.playerinfo.width					= MENU_BUTTON_MED_WIDTH;
ADDRGP4 levelMenuInfo+3060+92
CNSTI4 130
ASGNI4
line 1098
;1098:	levelMenuInfo.playerinfo.height					= MENU_BUTTON_MED_HEIGHT;
ADDRGP4 levelMenuInfo+3060+96
CNSTI4 18
ASGNI4
line 1099
;1099:	levelMenuInfo.playerinfo.color					= CT_DKPURPLE1;
ADDRGP4 levelMenuInfo+3060+104
CNSTI4 35
ASGNI4
line 1100
;1100:	levelMenuInfo.playerinfo.color2					= CT_LTPURPLE1;
ADDRGP4 levelMenuInfo+3060+108
CNSTI4 34
ASGNI4
line 1101
;1101:	levelMenuInfo.playerinfo.textX					= MENU_BUTTON_TEXT_X;
ADDRGP4 levelMenuInfo+3060+124
CNSTI4 5
ASGNI4
line 1102
;1102:	levelMenuInfo.playerinfo.textY					= MENU_BUTTON_TEXT_Y;
ADDRGP4 levelMenuInfo+3060+128
CNSTI4 1
ASGNI4
line 1103
;1103:	levelMenuInfo.playerinfo.textEnum				= MBT_PLAYERINFO;
ADDRGP4 levelMenuInfo+3060+116
CNSTI4 70
ASGNI4
line 1104
;1104:	levelMenuInfo.playerinfo.textcolor				= CT_BLACK;
ADDRGP4 levelMenuInfo+3060+132
CNSTI4 1
ASGNI4
line 1105
;1105:	levelMenuInfo.playerinfo.textcolor2				= CT_WHITE;
ADDRGP4 levelMenuInfo+3060+136
CNSTI4 8
ASGNI4
line 1108
;1106:
;1107:
;1108:	for( n = 0; n < AWARD_MAX; n++ ) 
ADDRLP4 0
CNSTI4 0
ASGNI4
LABELV $838
line 1109
;1109:	{
line 1110
;1110:		levelMenuInfo.awardLevels[n] = UI_GetAwardLevel( n );
ADDRLP4 0
INDIRI4
ARGI4
ADDRLP4 104
ADDRGP4 UI_GetAwardLevel
CALLI4
ASGNI4
ADDRLP4 0
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 levelMenuInfo+3980
ADDP4
ADDRLP4 104
INDIRI4
ASGNI4
line 1111
;1111:	}
LABELV $839
line 1108
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
ADDRLP4 0
INDIRI4
CNSTI4 9
LTI4 $838
line 1114
;1112://	levelMenuInfo.awardLevels[AWARD_FRAGS] = 100 * (levelMenuInfo.awardLevels[AWARD_FRAGS] / 100);
;1113:
;1114:	y = AWARDS_Y;
ADDRLP4 12
CNSTI4 315
ASGNI4
line 1115
;1115:	count = 0;
ADDRLP4 4
CNSTI4 0
ASGNI4
line 1116
;1116:	for( n = 0; n < AWARD_MAX; n++ ) 
ADDRLP4 0
CNSTI4 0
ASGNI4
LABELV $843
line 1117
;1117:	{
line 1118
;1118:		if( levelMenuInfo.awardLevels[n] ) 
ADDRLP4 0
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 levelMenuInfo+3980
ADDP4
INDIRI4
CNSTI4 0
EQI4 $847
line 1119
;1119:		{
line 1120
;1120:			x = 385 + (count * 38);
ADDRLP4 8
CNSTI4 38
ADDRLP4 4
INDIRI4
MULI4
CNSTI4 385
ADDI4
ASGNI4
line 1122
;1121:
;1122:			levelMenuInfo.item_awards[count].generic.type		= MTYPE_BITMAP;
CNSTI4 144
ADDRLP4 4
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+1908
ADDP4
CNSTI4 6
ASGNI4
line 1123
;1123:			levelMenuInfo.item_awards[count].generic.name		= ui_medalPicNames[n];
CNSTI4 144
ADDRLP4 4
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+1908+4
ADDP4
ADDRLP4 0
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 ui_medalPicNames
ADDP4
INDIRP4
ASGNP4
line 1124
;1124:			levelMenuInfo.item_awards[count].generic.flags		= QMF_LEFT_JUSTIFY|QMF_SILENT|QMF_MOUSEONLY;
CNSTI4 144
ADDRLP4 4
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+1908+44
ADDP4
CNSTU4 1050628
ASGNU4
line 1125
;1125:			levelMenuInfo.item_awards[count].generic.x			= x;
CNSTI4 144
ADDRLP4 4
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+1908+12
ADDP4
ADDRLP4 8
INDIRI4
ASGNI4
line 1126
;1126:			levelMenuInfo.item_awards[count].generic.y			= y;
CNSTI4 144
ADDRLP4 4
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+1908+16
ADDP4
ADDRLP4 12
INDIRI4
ASGNI4
line 1127
;1127:			levelMenuInfo.item_awards[count].generic.id			= ID_AWARD1 + n;
CNSTI4 144
ADDRLP4 4
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+1908+8
ADDP4
ADDRLP4 0
INDIRI4
CNSTI4 17
ADDI4
ASGNI4
line 1128
;1128:			levelMenuInfo.item_awards[count].generic.callback	= UI_SPLevelMenu_AwardEvent;
CNSTI4 144
ADDRLP4 4
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+1908+48
ADDP4
ADDRGP4 UI_SPLevelMenu_AwardEvent
ASGNP4
line 1129
;1129:			levelMenuInfo.item_awards[count].width				= 34;
CNSTI4 144
ADDRLP4 4
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+1908+92
ADDP4
CNSTI4 34
ASGNI4
line 1130
;1130:			levelMenuInfo.item_awards[count].height				= 34;
CNSTI4 144
ADDRLP4 4
INDIRI4
MULI4
ADDRGP4 levelMenuInfo+1908+96
ADDP4
CNSTI4 34
ASGNI4
line 1131
;1131:			count++;
ADDRLP4 4
ADDRLP4 4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
line 1132
;1132:		}
LABELV $847
line 1133
;1133:	}
LABELV $844
line 1116
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
ADDRLP4 0
INDIRI4
CNSTI4 9
LTI4 $843
line 1135
;1134:
;1135:	levelMenuInfo.create.generic.type			= MTYPE_BITMAP;
ADDRGP4 levelMenuInfo+612
CNSTI4 6
ASGNI4
line 1136
;1136:	levelMenuInfo.create.generic.flags		= QMF_HIGHLIGHT_IF_FOCUS;
ADDRGP4 levelMenuInfo+612+44
CNSTU4 128
ASGNU4
line 1137
;1137:	levelMenuInfo.create.generic.x			= 293;
ADDRGP4 levelMenuInfo+612+12
CNSTI4 293
ASGNI4
line 1138
;1138:	levelMenuInfo.create.generic.y			= 391;
ADDRGP4 levelMenuInfo+612+16
CNSTI4 391
ASGNI4
line 1139
;1139:	levelMenuInfo.create.generic.name		= BUTTON_GRAPHIC_LONGRIGHT;
ADDRGP4 levelMenuInfo+612+4
ADDRGP4 $535
ASGNP4
line 1140
;1140:	levelMenuInfo.create.generic.id			= ID_CUSTOM;
ADDRGP4 levelMenuInfo+612+8
CNSTI4 27
ASGNI4
line 1141
;1141:	levelMenuInfo.create.generic.callback	= UI_SPLevelMenu_CreateEvent;
ADDRGP4 levelMenuInfo+612+48
ADDRGP4 UI_SPLevelMenu_CreateEvent
ASGNP4
line 1142
;1142:	levelMenuInfo.create.width				= MENU_BUTTON_MED_WIDTH;
ADDRGP4 levelMenuInfo+612+92
CNSTI4 130
ASGNI4
line 1143
;1143:	levelMenuInfo.create.height				= MENU_BUTTON_MED_HEIGHT;
ADDRGP4 levelMenuInfo+612+96
CNSTI4 18
ASGNI4
line 1144
;1144:	levelMenuInfo.create.color				= CT_DKPURPLE1;
ADDRGP4 levelMenuInfo+612+104
CNSTI4 35
ASGNI4
line 1145
;1145:	levelMenuInfo.create.color2				= CT_LTPURPLE1;
ADDRGP4 levelMenuInfo+612+108
CNSTI4 34
ASGNI4
line 1146
;1146:	levelMenuInfo.create.textX				= MENU_BUTTON_TEXT_X;
ADDRGP4 levelMenuInfo+612+124
CNSTI4 5
ASGNI4
line 1147
;1147:	levelMenuInfo.create.textY				= MENU_BUTTON_TEXT_Y;
ADDRGP4 levelMenuInfo+612+128
CNSTI4 1
ASGNI4
line 1148
;1148:	levelMenuInfo.create.textEnum				= MBT_CREATEMATCH;
ADDRGP4 levelMenuInfo+612+116
CNSTI4 66
ASGNI4
line 1149
;1149:	levelMenuInfo.create.textcolor			= CT_BLACK;
ADDRGP4 levelMenuInfo+612+132
CNSTI4 1
ASGNI4
line 1150
;1150:	levelMenuInfo.create.textcolor2			= CT_WHITE;
ADDRGP4 levelMenuInfo+612+136
CNSTI4 8
ASGNI4
line 1152
;1151:
;1152:	levelMenuInfo.advanced.generic.type			= MTYPE_BITMAP;
ADDRGP4 levelMenuInfo+3204
CNSTI4 6
ASGNI4
line 1153
;1153:	levelMenuInfo.advanced.generic.flags		= QMF_HIGHLIGHT_IF_FOCUS;
ADDRGP4 levelMenuInfo+3204+44
CNSTU4 128
ASGNU4
line 1154
;1154:	levelMenuInfo.advanced.generic.x			= 293;
ADDRGP4 levelMenuInfo+3204+12
CNSTI4 293
ASGNI4
line 1155
;1155:	levelMenuInfo.advanced.generic.y			= 415;
ADDRGP4 levelMenuInfo+3204+16
CNSTI4 415
ASGNI4
line 1156
;1156:	levelMenuInfo.advanced.generic.name		= BUTTON_GRAPHIC_LONGRIGHT;
ADDRGP4 levelMenuInfo+3204+4
ADDRGP4 $535
ASGNP4
line 1157
;1157:	levelMenuInfo.advanced.generic.id			= ID_ADVANCED;
ADDRGP4 levelMenuInfo+3204+8
CNSTI4 124
ASGNI4
line 1158
;1158:	levelMenuInfo.advanced.generic.callback	= UI_SPLevelMenu_AdvancedEvent;
ADDRGP4 levelMenuInfo+3204+48
ADDRGP4 UI_SPLevelMenu_AdvancedEvent
ASGNP4
line 1159
;1159:	levelMenuInfo.advanced.width				= MENU_BUTTON_MED_WIDTH;
ADDRGP4 levelMenuInfo+3204+92
CNSTI4 130
ASGNI4
line 1160
;1160:	levelMenuInfo.advanced.height				= MENU_BUTTON_MED_HEIGHT;
ADDRGP4 levelMenuInfo+3204+96
CNSTI4 18
ASGNI4
line 1161
;1161:	levelMenuInfo.advanced.color				= CT_DKPURPLE1;
ADDRGP4 levelMenuInfo+3204+104
CNSTI4 35
ASGNI4
line 1162
;1162:	levelMenuInfo.advanced.color2				= CT_LTPURPLE1;
ADDRGP4 levelMenuInfo+3204+108
CNSTI4 34
ASGNI4
line 1163
;1163:	levelMenuInfo.advanced.textX				= MENU_BUTTON_TEXT_X;
ADDRGP4 levelMenuInfo+3204+124
CNSTI4 5
ASGNI4
line 1164
;1164:	levelMenuInfo.advanced.textY				= MENU_BUTTON_TEXT_Y;
ADDRGP4 levelMenuInfo+3204+128
CNSTI4 1
ASGNI4
line 1165
;1165:	levelMenuInfo.advanced.textEnum				= MBT_ADVANCEDSERVER;
ADDRGP4 levelMenuInfo+3204+116
CNSTI4 214
ASGNI4
line 1166
;1166:	levelMenuInfo.advanced.textcolor			= CT_BLACK;
ADDRGP4 levelMenuInfo+3204+132
CNSTI4 1
ASGNI4
line 1167
;1167:	levelMenuInfo.advanced.textcolor2			= CT_WHITE;
ADDRGP4 levelMenuInfo+3204+136
CNSTI4 8
ASGNI4
line 1169
;1168:
;1169:	levelMenuInfo.fight.generic.type				= MTYPE_BITMAP;
ADDRGP4 levelMenuInfo+756
CNSTI4 6
ASGNI4
line 1170
;1170:	levelMenuInfo.fight.generic.flags				= QMF_HIGHLIGHT_IF_FOCUS;
ADDRGP4 levelMenuInfo+756+44
CNSTU4 128
ASGNU4
line 1171
;1171:	levelMenuInfo.fight.generic.x					= 462;
ADDRGP4 levelMenuInfo+756+12
CNSTI4 462
ASGNI4
line 1172
;1172:	levelMenuInfo.fight.generic.y					= 391;
ADDRGP4 levelMenuInfo+756+16
CNSTI4 391
ASGNI4
line 1173
;1173:	levelMenuInfo.fight.generic.name				= "menu/common/square.tga";
ADDRGP4 levelMenuInfo+756+4
ADDRGP4 $938
ASGNP4
line 1174
;1174:	levelMenuInfo.fight.generic.id					= ID_NEXT;
ADDRGP4 levelMenuInfo+756+8
CNSTI4 28
ASGNI4
line 1175
;1175:	levelMenuInfo.fight.generic.callback			= UI_SPLevelMenu_NextEvent;
ADDRGP4 levelMenuInfo+756+48
ADDRGP4 UI_SPLevelMenu_NextEvent
ASGNP4
line 1176
;1176:	levelMenuInfo.fight.width						= 150;
ADDRGP4 levelMenuInfo+756+92
CNSTI4 150
ASGNI4
line 1177
;1177:	levelMenuInfo.fight.height						= 42;
ADDRGP4 levelMenuInfo+756+96
CNSTI4 42
ASGNI4
line 1178
;1178:	levelMenuInfo.fight.color						= CT_DKPURPLE1;
ADDRGP4 levelMenuInfo+756+104
CNSTI4 35
ASGNI4
line 1179
;1179:	levelMenuInfo.fight.color2						= CT_LTPURPLE1;
ADDRGP4 levelMenuInfo+756+108
CNSTI4 34
ASGNI4
line 1180
;1180:	levelMenuInfo.fight.textX						= 2;
ADDRGP4 levelMenuInfo+756+124
CNSTI4 2
ASGNI4
line 1181
;1181:	levelMenuInfo.fight.textY						= 2;
ADDRGP4 levelMenuInfo+756+128
CNSTI4 2
ASGNI4
line 1182
;1182:	levelMenuInfo.fight.textEnum					= MBT_ENGAGE;
ADDRGP4 levelMenuInfo+756+116
CNSTI4 74
ASGNI4
line 1183
;1183:	levelMenuInfo.fight.textcolor					= CT_BLACK;
ADDRGP4 levelMenuInfo+756+132
CNSTI4 1
ASGNI4
line 1184
;1184:	levelMenuInfo.fight.textcolor2					= CT_WHITE;
ADDRGP4 levelMenuInfo+756+136
CNSTI4 8
ASGNI4
line 1186
;1185:
;1186:	levelMenuInfo.item_null.generic.type			= MTYPE_BITMAP;
ADDRGP4 levelMenuInfo+2772
CNSTI4 6
ASGNI4
line 1187
;1187:	levelMenuInfo.item_null.generic.flags			= QMF_LEFT_JUSTIFY|QMF_MOUSEONLY|QMF_SILENT;
ADDRGP4 levelMenuInfo+2772+44
CNSTU4 1050628
ASGNU4
line 1188
;1188:	levelMenuInfo.item_null.generic.x				= 0;
ADDRGP4 levelMenuInfo+2772+12
CNSTI4 0
ASGNI4
line 1189
;1189:	levelMenuInfo.item_null.generic.y				= 0;
ADDRGP4 levelMenuInfo+2772+16
CNSTI4 0
ASGNI4
line 1190
;1190:	levelMenuInfo.item_null.width					= 640;
ADDRGP4 levelMenuInfo+2772+92
CNSTI4 640
ASGNI4
line 1191
;1191:	levelMenuInfo.item_null.height					= 480;
ADDRGP4 levelMenuInfo+2772+96
CNSTI4 480
ASGNI4
line 1193
;1192:
;1193:	Menu_AddItem( &levelMenuInfo.menu, &levelMenuInfo.mainmenu );
ADDRGP4 levelMenuInfo
ARGP4
ADDRGP4 levelMenuInfo+324
ARGP4
ADDRGP4 Menu_AddItem
CALLV
pop
line 1194
;1194:	Menu_AddItem( &levelMenuInfo.menu, &levelMenuInfo.back );
ADDRGP4 levelMenuInfo
ARGP4
ADDRGP4 levelMenuInfo+468
ARGP4
ADDRGP4 Menu_AddItem
CALLV
pop
line 1195
;1195:	Menu_AddItem( &levelMenuInfo.menu, &levelMenuInfo.item_leftarrow );
ADDRGP4 levelMenuInfo
ARGP4
ADDRGP4 levelMenuInfo+900
ARGP4
ADDRGP4 Menu_AddItem
CALLV
pop
line 1196
;1196:	Menu_AddItem( &levelMenuInfo.menu, &levelMenuInfo.item_rightarrow );
ADDRGP4 levelMenuInfo
ARGP4
ADDRGP4 levelMenuInfo+1620
ARGP4
ADDRGP4 Menu_AddItem
CALLV
pop
line 1197
;1197:	Menu_AddItem( &levelMenuInfo.menu, &levelMenuInfo.item_maps[0] );
ADDRGP4 levelMenuInfo
ARGP4
ADDRGP4 levelMenuInfo+1044
ARGP4
ADDRGP4 Menu_AddItem
CALLV
pop
line 1198
;1198:	Menu_AddItem( &levelMenuInfo.menu, &levelMenuInfo.item_maps[1] );
ADDRGP4 levelMenuInfo
ARGP4
ADDRGP4 levelMenuInfo+1044+144
ARGP4
ADDRGP4 Menu_AddItem
CALLV
pop
line 1199
;1199:	Menu_AddItem( &levelMenuInfo.menu, &levelMenuInfo.item_maps[2] );
ADDRGP4 levelMenuInfo
ARGP4
ADDRGP4 levelMenuInfo+1044+288
ARGP4
ADDRGP4 Menu_AddItem
CALLV
pop
line 1200
;1200:	Menu_AddItem( &levelMenuInfo.menu, &levelMenuInfo.item_maps[3] );
ADDRGP4 levelMenuInfo
ARGP4
ADDRGP4 levelMenuInfo+1044+432
ARGP4
ADDRGP4 Menu_AddItem
CALLV
pop
line 1202
;1201:	// Extend to pick up names at bottom of pictures
;1202:	levelMenuInfo.item_maps[0].generic.bottom += 18;
ADDRLP4 100
ADDRGP4 levelMenuInfo+1044+32
ASGNP4
ADDRLP4 100
INDIRP4
ADDRLP4 100
INDIRP4
INDIRI4
CNSTI4 18
ADDI4
ASGNI4
line 1203
;1203:	levelMenuInfo.item_maps[1].generic.bottom += 18;
ADDRLP4 104
ADDRGP4 levelMenuInfo+1044+144+32
ASGNP4
ADDRLP4 104
INDIRP4
ADDRLP4 104
INDIRP4
INDIRI4
CNSTI4 18
ADDI4
ASGNI4
line 1204
;1204:	levelMenuInfo.item_maps[2].generic.bottom += 18;
ADDRLP4 108
ADDRGP4 levelMenuInfo+1044+288+32
ASGNP4
ADDRLP4 108
INDIRP4
ADDRLP4 108
INDIRP4
INDIRI4
CNSTI4 18
ADDI4
ASGNI4
line 1205
;1205:	levelMenuInfo.item_maps[3].generic.bottom += 18;
ADDRLP4 112
ADDRGP4 levelMenuInfo+1044+432+32
ASGNP4
ADDRLP4 112
INDIRP4
ADDRLP4 112
INDIRP4
INDIRI4
CNSTI4 18
ADDI4
ASGNI4
line 1207
;1206:
;1207:	Menu_AddItem( &levelMenuInfo.menu, &levelMenuInfo.item_player );
ADDRGP4 levelMenuInfo
ARGP4
ADDRGP4 levelMenuInfo+1764
ARGP4
ADDRGP4 Menu_AddItem
CALLV
pop
line 1214
;1208:
;1209://	for( n = 0; n < count; n++ ) 
;1210://	{
;1211://		Menu_AddItem( &levelMenuInfo.menu, &levelMenuInfo.item_awards[n] );
;1212://	}
;1213:
;1214:	Menu_AddItem( &levelMenuInfo.menu, &levelMenuInfo.item_reset );
ADDRGP4 levelMenuInfo
ARGP4
ADDRGP4 levelMenuInfo+2916
ARGP4
ADDRGP4 Menu_AddItem
CALLV
pop
line 1215
;1215:	Menu_AddItem( &levelMenuInfo.menu, &levelMenuInfo.playerinfo );
ADDRGP4 levelMenuInfo
ARGP4
ADDRGP4 levelMenuInfo+3060
ARGP4
ADDRGP4 Menu_AddItem
CALLV
pop
line 1216
;1216:	Menu_AddItem( &levelMenuInfo.menu, &levelMenuInfo.create );
ADDRGP4 levelMenuInfo
ARGP4
ADDRGP4 levelMenuInfo+612
ARGP4
ADDRGP4 Menu_AddItem
CALLV
pop
line 1217
;1217:	Menu_AddItem( &levelMenuInfo.menu, &levelMenuInfo.advanced );
ADDRGP4 levelMenuInfo
ARGP4
ADDRGP4 levelMenuInfo+3204
ARGP4
ADDRGP4 Menu_AddItem
CALLV
pop
line 1218
;1218:	Menu_AddItem( &levelMenuInfo.menu, &levelMenuInfo.fight );
ADDRGP4 levelMenuInfo
ARGP4
ADDRGP4 levelMenuInfo+756
ARGP4
ADDRGP4 Menu_AddItem
CALLV
pop
line 1219
;1219:	Menu_AddItem( &levelMenuInfo.menu, &levelMenuInfo.item_null );
ADDRGP4 levelMenuInfo
ARGP4
ADDRGP4 levelMenuInfo+2772
ARGP4
ADDRGP4 Menu_AddItem
CALLV
pop
line 1221
;1220:
;1221:	trap_Cvar_VariableStringBuffer( "ui_spSelection", buf, sizeof(buf) );
ADDRGP4 $165
ARGP4
ADDRLP4 28
ARGP4
CNSTI4 64
ARGI4
ADDRGP4 trap_Cvar_VariableStringBuffer
CALLV
pop
line 1222
;1222:	if( *buf ) 
ADDRLP4 28
INDIRI1
CVII4 1
CNSTI4 0
EQI4 $1001
line 1223
;1223:	{
line 1224
;1224:		n = atoi( buf );
ADDRLP4 28
ARGP4
ADDRLP4 116
ADDRGP4 atoi
CALLI4
ASGNI4
ADDRLP4 0
ADDRLP4 116
INDIRI4
ASGNI4
line 1225
;1225:		selectedArenaSet = n / ARENAS_PER_TIER;
ADDRGP4 selectedArenaSet
ADDRLP4 0
INDIRI4
CNSTI4 4
DIVI4
ASGNI4
line 1226
;1226:		selectedArena = n % ARENAS_PER_TIER;
ADDRGP4 selectedArena
ADDRLP4 0
INDIRI4
CNSTI4 4
MODI4
ASGNI4
line 1227
;1227:	}
ADDRGP4 $1002
JUMPV
LABELV $1001
line 1229
;1228:	else 
;1229:	{
line 1230
;1230:		selectedArenaSet = currentSet;
ADDRGP4 selectedArenaSet
ADDRGP4 currentSet
INDIRI4
ASGNI4
line 1231
;1231:		selectedArena = currentGame;
ADDRGP4 selectedArena
ADDRGP4 currentGame
INDIRI4
ASGNI4
line 1232
;1232:	}
LABELV $1002
line 1234
;1233:
;1234:	UI_SPLevelMenu_SetMenuItems();
ADDRGP4 UI_SPLevelMenu_SetMenuItems
CALLV
pop
line 1235
;1235:}
LABELV $511
endproc UI_SPLevelMenu_Init 120 12
export UI_SPLevelMenu
proc UI_SPLevelMenu 32 8
line 1244
;1236:
;1237:
;1238:/*
;1239:=================
;1240:UI_SPLevelMenu
;1241:=================
;1242:*/
;1243:void UI_SPLevelMenu( void ) 
;1244:{
line 1249
;1245:	int			level;
;1246:	int			trainingLevel;
;1247:	const char	*arenaInfo;
;1248:
;1249:	trainingTier = -1;
ADDRGP4 trainingTier
CNSTI4 -1
ASGNI4
line 1250
;1250:	arenaInfo = UI_GetSpecialArenaInfo( "training" );
ADDRGP4 $168
ARGP4
ADDRLP4 12
ADDRGP4 UI_GetSpecialArenaInfo
CALLP4
ASGNP4
ADDRLP4 4
ADDRLP4 12
INDIRP4
ASGNP4
line 1251
;1251:	if( arenaInfo ) 
ADDRLP4 4
INDIRP4
CVPU4 4
CNSTU4 0
EQU4 $1004
line 1252
;1252:	{
line 1253
;1253:		minTier = trainingTier;
ADDRGP4 minTier
ADDRGP4 trainingTier
INDIRI4
ASGNI4
line 1254
;1254:		trainingLevel = atoi( Info_ValueForKey( arenaInfo, "num" ) );
ADDRLP4 4
INDIRP4
ARGP4
ADDRGP4 $169
ARGP4
ADDRLP4 16
ADDRGP4 Info_ValueForKey
CALLP4
ASGNP4
ADDRLP4 16
INDIRP4
ARGP4
ADDRLP4 20
ADDRGP4 atoi
CALLI4
ASGNI4
ADDRLP4 8
ADDRLP4 20
INDIRI4
ASGNI4
line 1255
;1255:	}
ADDRGP4 $1005
JUMPV
LABELV $1004
line 1257
;1256:	else 
;1257:	{
line 1258
;1258:		minTier = 0;
ADDRGP4 minTier
CNSTI4 0
ASGNI4
line 1259
;1259:		trainingLevel = -2;
ADDRLP4 8
CNSTI4 -2
ASGNI4
line 1260
;1260:	}
LABELV $1005
line 1262
;1261:
;1262:	finalTier = UI_GetNumSPTiers();
ADDRLP4 16
ADDRGP4 UI_GetNumSPTiers
CALLI4
ASGNI4
ADDRGP4 finalTier
ADDRLP4 16
INDIRI4
ASGNI4
line 1263
;1263:	arenaInfo = UI_GetSpecialArenaInfo( "final" );
ADDRGP4 $201
ARGP4
ADDRLP4 20
ADDRGP4 UI_GetSpecialArenaInfo
CALLP4
ASGNP4
ADDRLP4 4
ADDRLP4 20
INDIRP4
ASGNP4
line 1264
;1264:	if( arenaInfo ) {
ADDRLP4 4
INDIRP4
CVPU4 4
CNSTU4 0
EQU4 $1006
line 1265
;1265:		maxTier = finalTier;
ADDRGP4 maxTier
ADDRGP4 finalTier
INDIRI4
ASGNI4
line 1266
;1266:	}
ADDRGP4 $1007
JUMPV
LABELV $1006
line 1268
;1267:	else 
;1268:	{
line 1269
;1269:		maxTier = finalTier - 1;
ADDRGP4 maxTier
ADDRGP4 finalTier
INDIRI4
CNSTI4 1
SUBI4
ASGNI4
line 1270
;1270:		if( maxTier < minTier ) 
ADDRGP4 maxTier
INDIRI4
ADDRGP4 minTier
INDIRI4
GEI4 $1008
line 1271
;1271:		{
line 1272
;1272:			maxTier = minTier;
ADDRGP4 maxTier
ADDRGP4 minTier
INDIRI4
ASGNI4
line 1273
;1273:		}
LABELV $1008
line 1274
;1274:	}
LABELV $1007
line 1276
;1275:
;1276:	level = UI_GetCurrentGame(-1);
CNSTI4 -1
ARGI4
ADDRLP4 24
ADDRGP4 UI_GetCurrentGame
CALLI4
ASGNI4
ADDRLP4 0
ADDRLP4 24
INDIRI4
ASGNI4
line 1278
;1277:
;1278:	if ( level == -1 ) {
ADDRLP4 0
INDIRI4
CNSTI4 -1
NEI4 $1010
line 1279
;1279:		level = UI_GetNumSPArenas() - 1;
ADDRLP4 28
ADDRGP4 UI_GetNumSPArenas
CALLI4
ASGNI4
ADDRLP4 0
ADDRLP4 28
INDIRI4
CNSTI4 1
SUBI4
ASGNI4
line 1280
;1280:		if( maxTier == finalTier ) 
ADDRGP4 maxTier
INDIRI4
ADDRGP4 finalTier
INDIRI4
NEI4 $1012
line 1281
;1281:		{
line 1282
;1282:			level++;
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
line 1283
;1283:		}
LABELV $1012
line 1284
;1284:	}
LABELV $1010
line 1286
;1285:
;1286:	if( level == trainingLevel ) 
ADDRLP4 0
INDIRI4
ADDRLP4 8
INDIRI4
NEI4 $1014
line 1287
;1287:	{
line 1288
;1288:		currentSet = -1;
ADDRGP4 currentSet
CNSTI4 -1
ASGNI4
line 1289
;1289:		currentGame = 0;
ADDRGP4 currentGame
CNSTI4 0
ASGNI4
line 1290
;1290:	}
ADDRGP4 $1015
JUMPV
LABELV $1014
line 1291
;1291:	else {
line 1292
;1292:		currentSet = level / ARENAS_PER_TIER;
ADDRGP4 currentSet
ADDRLP4 0
INDIRI4
CNSTI4 4
DIVI4
ASGNI4
line 1293
;1293:		currentGame = level % ARENAS_PER_TIER;
ADDRGP4 currentGame
ADDRLP4 0
INDIRI4
CNSTI4 4
MODI4
ASGNI4
line 1294
;1294:	}
LABELV $1015
line 1296
;1295:
;1296:	UI_SPLevelMenu_Init();
ADDRGP4 UI_SPLevelMenu_Init
CALLV
pop
line 1297
;1297:	UI_PushMenu( &levelMenuInfo.menu );
ADDRGP4 levelMenuInfo
ARGP4
ADDRGP4 UI_PushMenu
CALLV
pop
line 1298
;1298:	Menu_SetCursorToItem( &levelMenuInfo.menu, &levelMenuInfo.fight );
ADDRGP4 levelMenuInfo
ARGP4
ADDRGP4 levelMenuInfo+756
ARGP4
ADDRGP4 Menu_SetCursorToItem
CALLV
pop
line 1300
;1299:
;1300:}
LABELV $1003
endproc UI_SPLevelMenu 32 8
export UI_SPLevelMenu_f
proc UI_SPLevelMenu_f 0 4
line 1309
;1301:
;1302:
;1303:/*
;1304:=================
;1305:UI_SPLevelMenu_f
;1306:=================
;1307:*/
;1308:void UI_SPLevelMenu_f( void ) 
;1309:{
line 1310
;1310:	trap_Key_SetCatcher( KEYCATCH_UI );
CNSTI4 2
ARGI4
ADDRGP4 trap_Key_SetCatcher
CALLV
pop
line 1311
;1311:	uis.menusp = 0;
ADDRGP4 uis+16
CNSTI4 0
ASGNI4
line 1312
;1312:	Mouse_Show();
ADDRGP4 Mouse_Show
CALLV
pop
line 1313
;1313:	UI_SPLevelMenu();
ADDRGP4 UI_SPLevelMenu
CALLV
pop
line 1314
;1314:}
LABELV $1017
endproc UI_SPLevelMenu_f 0 4
export UI_SPLevelMenu_ReInit
proc UI_SPLevelMenu_ReInit 0 0
line 1323
;1315:
;1316:
;1317:/*
;1318:=================
;1319:UI_SPLevelMenu_ReInit
;1320:=================
;1321:*/
;1322:void UI_SPLevelMenu_ReInit( void ) 
;1323:{
line 1324
;1324:	levelMenuInfo.reinit = qtrue;
ADDRGP4 levelMenuInfo+3348
CNSTI4 1
ASGNI4
line 1325
;1325:}
LABELV $1019
endproc UI_SPLevelMenu_ReInit 0 0
proc ResetGameMenu_Event 16 4
line 1334
;1326:
;1327:
;1328:/*
;1329:===============
;1330:ResetGameMenu_Event
;1331:===============
;1332:*/
;1333:static void ResetGameMenu_Event (void* ptr, int notification)
;1334:{
line 1335
;1335:	if (notification != QM_ACTIVATED)
ADDRFP4 4
INDIRI4
CNSTI4 3
EQI4 $1022
line 1336
;1336:		return;
ADDRGP4 $1021
JUMPV
LABELV $1022
line 1338
;1337:
;1338:	switch (((menucommon_s*)ptr)->id)
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 8
ADDP4
INDIRI4
ASGNI4
ADDRLP4 8
CNSTI4 100
ASGNI4
ADDRLP4 0
INDIRI4
ADDRLP4 8
INDIRI4
EQI4 $1027
ADDRLP4 0
INDIRI4
ADDRLP4 8
INDIRI4
LTI4 $1024
LABELV $1030
ADDRLP4 0
INDIRI4
CNSTI4 120
EQI4 $1028
ADDRLP4 0
INDIRI4
CNSTI4 121
EQI4 $1029
ADDRLP4 0
INDIRI4
CNSTI4 123
EQI4 $1028
ADDRGP4 $1024
JUMPV
line 1339
;1339:	{
LABELV $1027
line 1341
;1340:		case ID_MAINMENU:
;1341:			UI_PopMenu ();
ADDRGP4 UI_PopMenu
CALLV
pop
line 1342
;1342:			UI_MainMenu();
ADDRGP4 UI_MainMenu
CALLV
pop
line 1343
;1343:			break;
ADDRGP4 $1025
JUMPV
LABELV $1028
line 1347
;1344:
;1345:		case ID_BACK:
;1346:		case ID_NO:
;1347:			UI_PopMenu ();
ADDRGP4 UI_PopMenu
CALLV
pop
line 1348
;1348:			break;
ADDRGP4 $1025
JUMPV
LABELV $1029
line 1351
;1349:
;1350:		case ID_YES:
;1351:			UI_SPLevelMenu_ResetAction(qtrue);
CNSTI4 1
ARGI4
ADDRGP4 UI_SPLevelMenu_ResetAction
CALLV
pop
line 1352
;1352:			break;
LABELV $1024
LABELV $1025
line 1354
;1353:	}
;1354:}
LABELV $1021
endproc ResetGameMenu_Event 16 4
proc UI_resetGameMenu_Draw 20 20
line 1362
;1355:
;1356:/*
;1357:===============
;1358:UI_resetGameMenu_Draw
;1359:===============
;1360:*/
;1361:static void UI_resetGameMenu_Draw( void ) 
;1362:{
line 1366
;1363:	int y;
;1364:
;1365:	// Draw the basic screen layout
;1366:	UI_MenuFrame2(&resetGameMenuInfo.menu);
ADDRGP4 resetGameMenuInfo
ARGP4
ADDRGP4 UI_MenuFrame2
CALLV
pop
line 1368
;1367:
;1368:	trap_R_SetColor( colorTable[CT_LTBROWN1]);
ADDRGP4 colorTable+416
ARGP4
ADDRGP4 trap_R_SetColor
CALLV
pop
line 1369
;1369:	UI_DrawHandlePic(30,203,  47, 186, uis.whiteShader);	// Long left column square on bottom 3rd
CNSTF4 1106247680
ARGF4
CNSTF4 1128988672
ARGF4
CNSTF4 1111228416
ARGF4
CNSTF4 1127874560
ARGF4
ADDRGP4 uis+5252
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 1372
;1370:
;1371:	// Box around text
;1372:	trap_R_SetColor( colorTable[CT_LTPURPLE3]);
ADDRGP4 colorTable+672
ARGP4
ADDRGP4 trap_R_SetColor
CALLV
pop
line 1373
;1373:	UI_DrawHandlePic(122, 103,  32, 64,resetGameMenuInfo.corner_ul);	// Upper left corner
CNSTF4 1123287040
ARGF4
CNSTF4 1120796672
ARGF4
CNSTF4 1107296256
ARGF4
CNSTF4 1115684864
ARGF4
ADDRGP4 resetGameMenuInfo+756
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 1374
;1374:	UI_DrawHandlePic(122, 284,  32, 32,resetGameMenuInfo.corner_ll);	// Lower left corner
CNSTF4 1123287040
ARGF4
CNSTF4 1133379584
ARGF4
ADDRLP4 4
CNSTF4 1107296256
ASGNF4
ADDRLP4 4
INDIRF4
ARGF4
ADDRLP4 4
INDIRF4
ARGF4
ADDRGP4 resetGameMenuInfo+764
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 1375
;1375:	UI_DrawHandlePic(544, 103,  32, 64,resetGameMenuInfo.corner_ur);	// Upper right corner
CNSTF4 1141374976
ARGF4
CNSTF4 1120796672
ARGF4
CNSTF4 1107296256
ARGF4
CNSTF4 1115684864
ARGF4
ADDRGP4 resetGameMenuInfo+760
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 1376
;1376:	UI_DrawHandlePic(545, 285,  32, 32,resetGameMenuInfo.corner_lr);	// Lower right corner
CNSTF4 1141391360
ARGF4
CNSTF4 1133412352
ARGF4
ADDRLP4 8
CNSTF4 1107296256
ASGNF4
ADDRLP4 8
INDIRF4
ARGF4
ADDRLP4 8
INDIRF4
ARGF4
ADDRGP4 resetGameMenuInfo+768
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 1378
;1377:
;1378:	UI_DrawHandlePic(132,103, 426,  31, uis.whiteShader);	// Top of box
CNSTF4 1124335616
ARGF4
CNSTF4 1120796672
ARGF4
CNSTF4 1138032640
ARGF4
CNSTF4 1106771968
ARGF4
ADDRGP4 uis+5252
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 1379
;1379:	UI_DrawHandlePic(122,143,  19, 138, uis.whiteShader);	// Left side of box
CNSTF4 1123287040
ARGF4
CNSTF4 1125056512
ARGF4
CNSTF4 1100480512
ARGF4
CNSTF4 1124728832
ARGF4
ADDRGP4 uis+5252
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 1380
;1380:	UI_DrawHandlePic(549,143,  19, 138, uis.whiteShader);	// Right side of box
CNSTF4 1141456896
ARGF4
CNSTF4 1125056512
ARGF4
CNSTF4 1100480512
ARGF4
CNSTF4 1124728832
ARGF4
ADDRGP4 uis+5252
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 1382
;1381:
;1382:	UI_DrawHandlePic(132,288,  32, 18, uis.whiteShader);	// Bottom Left line
CNSTF4 1124335616
ARGF4
CNSTF4 1133510656
ARGF4
CNSTF4 1107296256
ARGF4
CNSTF4 1099956224
ARGF4
ADDRGP4 uis+5252
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 1383
;1383:	UI_DrawHandlePic(526,288,  32, 18, uis.whiteShader);	// Bottom Right line
CNSTF4 1141080064
ARGF4
CNSTF4 1133510656
ARGF4
CNSTF4 1107296256
ARGF4
CNSTF4 1099956224
ARGF4
ADDRGP4 uis+5252
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 1384
;1384:	UI_DrawHandlePic(167,288, 356, 18, uis.whiteShader);	// Bottom Middle line
CNSTF4 1126629376
ARGF4
CNSTF4 1133510656
ARGF4
CNSTF4 1135738880
ARGF4
CNSTF4 1099956224
ARGF4
ADDRGP4 uis+5252
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 1387
;1385:
;1386:	// Numbers on frame
;1387:	UI_DrawProportionalString(  74,  66, "66917",UI_RIGHT|UI_TINYFONT, colorTable[CT_BLACK]);
CNSTI4 74
ARGI4
CNSTI4 66
ARGI4
ADDRGP4 $1045
ARGP4
CNSTI4 65538
ARGI4
ADDRGP4 colorTable+16
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 1388
;1388:	UI_DrawProportionalString(  74,  188, "098-145",UI_RIGHT|UI_TINYFONT, colorTable[CT_BLACK]);
CNSTI4 74
ARGI4
CNSTI4 188
ARGI4
ADDRGP4 $1047
ARGP4
CNSTI4 65538
ARGI4
ADDRGP4 colorTable+16
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 1389
;1389:	UI_DrawProportionalString(  74,  206, "324-76",UI_RIGHT|UI_TINYFONT, colorTable[CT_BLACK]);
CNSTI4 74
ARGI4
CNSTI4 206
ARGI4
ADDRGP4 $1049
ARGP4
CNSTI4 65538
ARGI4
ADDRGP4 colorTable+16
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 1390
;1390:	UI_DrawProportionalString(  74,  395, "774570",UI_RIGHT|UI_TINYFONT, colorTable[CT_BLACK]);
CNSTI4 74
ARGI4
CNSTI4 395
ARGI4
ADDRGP4 $1051
ARGP4
CNSTI4 65538
ARGI4
ADDRGP4 colorTable+16
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 1392
;1391:
;1392:	UI_DrawProportionalString(  150,  107, "63-0999712",UI_TINYFONT, colorTable[CT_BLACK]);
CNSTI4 150
ARGI4
CNSTI4 107
ARGI4
ADDRGP4 $1053
ARGP4
CNSTI4 65536
ARGI4
ADDRGP4 colorTable+16
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 1394
;1393:
;1394:	y = 172;
ADDRLP4 0
CNSTI4 172
ASGNI4
line 1395
;1395:	UI_DrawProportionalString( 176, y, menu_normal_text[MNT_PLAYER_RESET1], UI_SMALLFONT, colorTable[CT_RED] );
CNSTI4 176
ARGI4
ADDRLP4 0
INDIRI4
ARGI4
ADDRGP4 menu_normal_text+616
INDIRP4
ARGP4
CNSTI4 16
ARGI4
ADDRGP4 colorTable+32
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 1396
;1396:	y+=24;
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 24
ADDI4
ASGNI4
line 1397
;1397:	UI_DrawProportionalString( 176, y, menu_normal_text[MNT_PLAYER_RESET2], UI_SMALLFONT, colorTable[CT_RED] );
CNSTI4 176
ARGI4
ADDRLP4 0
INDIRI4
ARGI4
ADDRGP4 menu_normal_text+620
INDIRP4
ARGP4
CNSTI4 16
ARGI4
ADDRGP4 colorTable+32
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 1398
;1398:	y+=24;
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 24
ADDI4
ASGNI4
line 1399
;1399:	UI_DrawProportionalString( 176, y, menu_normal_text[MNT_PLAYER_RESET3], UI_SMALLFONT, colorTable[CT_RED] );
CNSTI4 176
ARGI4
ADDRLP4 0
INDIRI4
ARGI4
ADDRGP4 menu_normal_text+624
INDIRP4
ARGP4
CNSTI4 16
ARGI4
ADDRGP4 colorTable+32
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 1400
;1400:	y+=24*2;
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 48
ADDI4
ASGNI4
line 1401
;1401:	UI_DrawProportionalString( 262, y, menu_normal_text[MNT_RESET_PLAYER],UI_BLINK | UI_SMALLFONT, colorTable[CT_RED] );
CNSTI4 262
ARGI4
ADDRLP4 0
INDIRI4
ARGI4
ADDRGP4 menu_normal_text+628
INDIRP4
ARGP4
CNSTI4 4112
ARGI4
ADDRGP4 colorTable+32
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 1403
;1402:
;1403:	trap_R_SetColor( colorTable[resetGameMenuInfo.mainmenu.color]);
ADDRGP4 resetGameMenuInfo+324+104
INDIRI4
CNSTI4 4
LSHI4
ADDRGP4 colorTable
ADDP4
ARGP4
ADDRGP4 trap_R_SetColor
CALLV
pop
line 1404
;1404:	UI_DrawHandlePic(110 - 14, resetGameMenuInfo.mainmenu.generic.y, 
CNSTF4 1119879168
ARGF4
ADDRGP4 resetGameMenuInfo+324+16
INDIRI4
CVIF4 4
ARGF4
ADDRLP4 12
CNSTF4 1099956224
ASGNF4
ADDRLP4 12
INDIRF4
ARGF4
ADDRLP4 12
INDIRF4
ARGF4
ADDRGP4 uis+5352
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 1407
;1405:		MENU_BUTTON_MED_HEIGHT, MENU_BUTTON_MED_HEIGHT, uis.graphicButtonLeftEnd);
;1406:
;1407:	trap_R_SetColor( colorTable[resetGameMenuInfo.back.color]);
ADDRGP4 resetGameMenuInfo+468+104
INDIRI4
CNSTI4 4
LSHI4
ADDRGP4 colorTable
ADDP4
ARGP4
ADDRGP4 trap_R_SetColor
CALLV
pop
line 1408
;1408:	UI_DrawHandlePic(110 - 14, resetGameMenuInfo.back.generic.y, 
CNSTF4 1119879168
ARGF4
ADDRGP4 resetGameMenuInfo+468+16
INDIRI4
CVIF4 4
ARGF4
ADDRLP4 16
CNSTF4 1099956224
ASGNF4
ADDRLP4 16
INDIRF4
ARGF4
ADDRLP4 16
INDIRF4
ARGF4
ADDRGP4 uis+5352
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 1412
;1409:		MENU_BUTTON_MED_HEIGHT, MENU_BUTTON_MED_HEIGHT, uis.graphicButtonLeftEnd);
;1410:
;1411:	// standard menu drawing
;1412:	Menu_Draw( &resetGameMenuInfo.menu );
ADDRGP4 resetGameMenuInfo
ARGP4
ADDRGP4 Menu_Draw
CALLV
pop
line 1413
;1413:}
LABELV $1031
endproc UI_resetGameMenu_Draw 20 20
export UI_ResetGameMenu_Cache
proc UI_ResetGameMenu_Cache 16 4
line 1421
;1414:
;1415:/*
;1416:=================
;1417:UI_ResetGameMenu_Cache
;1418:=================
;1419:*/
;1420:void UI_ResetGameMenu_Cache(void)
;1421:{
line 1422
;1422:	resetGameMenuInfo.corner_ul = trap_R_RegisterShaderNoMip("menu/common/corner_ul_19_31.tga");
ADDRGP4 $1075
ARGP4
ADDRLP4 0
ADDRGP4 trap_R_RegisterShaderNoMip
CALLI4
ASGNI4
ADDRGP4 resetGameMenuInfo+756
ADDRLP4 0
INDIRI4
ASGNI4
line 1423
;1423:	resetGameMenuInfo.corner_ur = trap_R_RegisterShaderNoMip("menu/common/corner_ur_19_31.tga");
ADDRGP4 $1077
ARGP4
ADDRLP4 4
ADDRGP4 trap_R_RegisterShaderNoMip
CALLI4
ASGNI4
ADDRGP4 resetGameMenuInfo+760
ADDRLP4 4
INDIRI4
ASGNI4
line 1424
;1424:	resetGameMenuInfo.corner_ll = trap_R_RegisterShaderNoMip("menu/common/corner_ll_18_19.tga");
ADDRGP4 $1079
ARGP4
ADDRLP4 8
ADDRGP4 trap_R_RegisterShaderNoMip
CALLI4
ASGNI4
ADDRGP4 resetGameMenuInfo+764
ADDRLP4 8
INDIRI4
ASGNI4
line 1425
;1425:	resetGameMenuInfo.corner_lr = trap_R_RegisterShaderNoMip("menu/common/corner_lr_18_19.tga");
ADDRGP4 $1081
ARGP4
ADDRLP4 12
ADDRGP4 trap_R_RegisterShaderNoMip
CALLI4
ASGNI4
ADDRGP4 resetGameMenuInfo+768
ADDRLP4 12
INDIRI4
ASGNI4
line 1426
;1426:}
LABELV $1073
endproc UI_ResetGameMenu_Cache 16 4
export ResetGameMenu_Init
proc ResetGameMenu_Init 0 12
line 1434
;1427:
;1428:/*
;1429:=================
;1430:ResetGameMenu_Init
;1431:=================
;1432:*/
;1433:void ResetGameMenu_Init( void )
;1434:{
line 1436
;1435:
;1436:	memset( &resetGameMenuInfo, 0, sizeof(resetGameMenuInfo) );
ADDRGP4 resetGameMenuInfo
ARGP4
CNSTI4 0
ARGI4
CNSTI4 772
ARGI4
ADDRGP4 memset
CALLP4
pop
line 1438
;1437:
;1438:	UI_ResetGameMenu_Cache();
ADDRGP4 UI_ResetGameMenu_Cache
CALLV
pop
line 1440
;1439:
;1440:	resetGameMenuInfo.menu.fullscreen					= qtrue;
ADDRGP4 resetGameMenuInfo+280
CNSTI4 1
ASGNI4
line 1441
;1441:	resetGameMenuInfo.menu.wrapAround					= qtrue;
ADDRGP4 resetGameMenuInfo+276
CNSTI4 1
ASGNI4
line 1442
;1442:	resetGameMenuInfo.menu.draw							= UI_resetGameMenu_Draw;
ADDRGP4 resetGameMenuInfo+268
ADDRGP4 UI_resetGameMenu_Draw
ASGNP4
line 1443
;1443:	resetGameMenuInfo.menu.descX						= MENU_DESC_X;
ADDRGP4 resetGameMenuInfo+292
CNSTI4 100
ASGNI4
line 1444
;1444:	resetGameMenuInfo.menu.descY						= MENU_DESC_Y;
ADDRGP4 resetGameMenuInfo+296
CNSTI4 444
ASGNI4
line 1445
;1445:	resetGameMenuInfo.menu.titleX						= MENU_TITLE_X;
ADDRGP4 resetGameMenuInfo+308
CNSTI4 611
ASGNI4
line 1446
;1446:	resetGameMenuInfo.menu.titleY						= MENU_TITLE_Y;
ADDRGP4 resetGameMenuInfo+312
CNSTI4 24
ASGNI4
line 1447
;1447:	resetGameMenuInfo.menu.titleI						= MNT_CONTROLSMENU_TITLE;
ADDRGP4 resetGameMenuInfo+316
CNSTI4 4
ASGNI4
line 1448
;1448:	resetGameMenuInfo.menu.footNoteEnum					= MNT_RESETPLAYER;
ADDRGP4 resetGameMenuInfo+320
CNSTI4 135
ASGNI4
line 1450
;1449:
;1450:	resetGameMenuInfo.mainmenu.generic.type				= MTYPE_BITMAP;      
ADDRGP4 resetGameMenuInfo+324
CNSTI4 6
ASGNI4
line 1451
;1451:	resetGameMenuInfo.mainmenu.generic.flags			= QMF_HIGHLIGHT_IF_FOCUS;
ADDRGP4 resetGameMenuInfo+324+44
CNSTU4 128
ASGNU4
line 1452
;1452:	resetGameMenuInfo.mainmenu.generic.x				= 110;
ADDRGP4 resetGameMenuInfo+324+12
CNSTI4 110
ASGNI4
line 1453
;1453:	resetGameMenuInfo.mainmenu.generic.y				= 391;
ADDRGP4 resetGameMenuInfo+324+16
CNSTI4 391
ASGNI4
line 1454
;1454:	resetGameMenuInfo.mainmenu.generic.name				= BUTTON_GRAPHIC_LONGRIGHT;
ADDRGP4 resetGameMenuInfo+324+4
ADDRGP4 $535
ASGNP4
line 1455
;1455:	resetGameMenuInfo.mainmenu.generic.id				= ID_MAINMENU;
ADDRGP4 resetGameMenuInfo+324+8
CNSTI4 100
ASGNI4
line 1456
;1456:	resetGameMenuInfo.mainmenu.generic.callback			= ResetGameMenu_Event;
ADDRGP4 resetGameMenuInfo+324+48
ADDRGP4 ResetGameMenu_Event
ASGNP4
line 1457
;1457:	resetGameMenuInfo.mainmenu.width					= MENU_BUTTON_MED_WIDTH;
ADDRGP4 resetGameMenuInfo+324+92
CNSTI4 130
ASGNI4
line 1458
;1458:	resetGameMenuInfo.mainmenu.height					= MENU_BUTTON_MED_HEIGHT;
ADDRGP4 resetGameMenuInfo+324+96
CNSTI4 18
ASGNI4
line 1459
;1459:	resetGameMenuInfo.mainmenu.color					= CT_DKPURPLE1;
ADDRGP4 resetGameMenuInfo+324+104
CNSTI4 35
ASGNI4
line 1460
;1460:	resetGameMenuInfo.mainmenu.color2					= CT_LTPURPLE1;
ADDRGP4 resetGameMenuInfo+324+108
CNSTI4 34
ASGNI4
line 1461
;1461:	resetGameMenuInfo.mainmenu.textX					= MENU_BUTTON_TEXT_X;
ADDRGP4 resetGameMenuInfo+324+124
CNSTI4 5
ASGNI4
line 1462
;1462:	resetGameMenuInfo.mainmenu.textY					= MENU_BUTTON_TEXT_Y;
ADDRGP4 resetGameMenuInfo+324+128
CNSTI4 1
ASGNI4
line 1463
;1463:	resetGameMenuInfo.mainmenu.textEnum					= MBT_MAINMENU;
ADDRGP4 resetGameMenuInfo+324+116
CNSTI4 9
ASGNI4
line 1464
;1464:	resetGameMenuInfo.mainmenu.textcolor				= CT_BLACK;
ADDRGP4 resetGameMenuInfo+324+132
CNSTI4 1
ASGNI4
line 1465
;1465:	resetGameMenuInfo.mainmenu.textcolor2				= CT_WHITE;
ADDRGP4 resetGameMenuInfo+324+136
CNSTI4 8
ASGNI4
line 1467
;1466:
;1467:	resetGameMenuInfo.back.generic.type				= MTYPE_BITMAP;      
ADDRGP4 resetGameMenuInfo+468
CNSTI4 6
ASGNI4
line 1468
;1468:	resetGameMenuInfo.back.generic.flags			= QMF_HIGHLIGHT_IF_FOCUS;
ADDRGP4 resetGameMenuInfo+468+44
CNSTU4 128
ASGNU4
line 1469
;1469:	resetGameMenuInfo.back.generic.x				= 110;
ADDRGP4 resetGameMenuInfo+468+12
CNSTI4 110
ASGNI4
line 1470
;1470:	resetGameMenuInfo.back.generic.y				= 415;
ADDRGP4 resetGameMenuInfo+468+16
CNSTI4 415
ASGNI4
line 1471
;1471:	resetGameMenuInfo.back.generic.name				= BUTTON_GRAPHIC_LONGRIGHT;
ADDRGP4 resetGameMenuInfo+468+4
ADDRGP4 $535
ASGNP4
line 1472
;1472:	resetGameMenuInfo.back.generic.id				= ID_BACK;
ADDRGP4 resetGameMenuInfo+468+8
CNSTI4 123
ASGNI4
line 1473
;1473:	resetGameMenuInfo.back.generic.callback			= ResetGameMenu_Event;
ADDRGP4 resetGameMenuInfo+468+48
ADDRGP4 ResetGameMenu_Event
ASGNP4
line 1474
;1474:	resetGameMenuInfo.back.width					= MENU_BUTTON_MED_WIDTH;
ADDRGP4 resetGameMenuInfo+468+92
CNSTI4 130
ASGNI4
line 1475
;1475:	resetGameMenuInfo.back.height					= MENU_BUTTON_MED_HEIGHT;
ADDRGP4 resetGameMenuInfo+468+96
CNSTI4 18
ASGNI4
line 1476
;1476:	resetGameMenuInfo.back.color					= CT_DKPURPLE1;
ADDRGP4 resetGameMenuInfo+468+104
CNSTI4 35
ASGNI4
line 1477
;1477:	resetGameMenuInfo.back.color2					= CT_LTPURPLE1;
ADDRGP4 resetGameMenuInfo+468+108
CNSTI4 34
ASGNI4
line 1478
;1478:	resetGameMenuInfo.back.textX					= MENU_BUTTON_TEXT_X;
ADDRGP4 resetGameMenuInfo+468+124
CNSTI4 5
ASGNI4
line 1479
;1479:	resetGameMenuInfo.back.textY					= MENU_BUTTON_TEXT_Y;
ADDRGP4 resetGameMenuInfo+468+128
CNSTI4 1
ASGNI4
line 1480
;1480:	resetGameMenuInfo.back.textEnum					= MBT_BACK;
ADDRGP4 resetGameMenuInfo+468+116
CNSTI4 118
ASGNI4
line 1481
;1481:	resetGameMenuInfo.back.textcolor				= CT_BLACK;
ADDRGP4 resetGameMenuInfo+468+132
CNSTI4 1
ASGNI4
line 1482
;1482:	resetGameMenuInfo.back.textcolor2				= CT_WHITE;
ADDRGP4 resetGameMenuInfo+468+136
CNSTI4 8
ASGNI4
line 1484
;1483:
;1484:	resetGameMenuInfo.yes.generic.type					= MTYPE_BITMAP;      
ADDRGP4 resetGameMenuInfo+612
CNSTI4 6
ASGNI4
line 1485
;1485:	resetGameMenuInfo.yes.generic.flags					= QMF_HIGHLIGHT_IF_FOCUS;
ADDRGP4 resetGameMenuInfo+612+44
CNSTU4 128
ASGNU4
line 1486
;1486:	resetGameMenuInfo.yes.generic.x						= 462;
ADDRGP4 resetGameMenuInfo+612+12
CNSTI4 462
ASGNI4
line 1487
;1487:	resetGameMenuInfo.yes.generic.y						= 391;
ADDRGP4 resetGameMenuInfo+612+16
CNSTI4 391
ASGNI4
line 1488
;1488:	resetGameMenuInfo.yes.generic.name					= GRAPHIC_SQUARE;
ADDRGP4 resetGameMenuInfo+612+4
ADDRGP4 $938
ASGNP4
line 1489
;1489:	resetGameMenuInfo.yes.generic.id					= ID_YES;
ADDRGP4 resetGameMenuInfo+612+8
CNSTI4 121
ASGNI4
line 1490
;1490:	resetGameMenuInfo.yes.generic.callback				= ResetGameMenu_Event;
ADDRGP4 resetGameMenuInfo+612+48
ADDRGP4 ResetGameMenu_Event
ASGNP4
line 1491
;1491:	resetGameMenuInfo.yes.width							= 150;
ADDRGP4 resetGameMenuInfo+612+92
CNSTI4 150
ASGNI4
line 1492
;1492:	resetGameMenuInfo.yes.height						= 42;
ADDRGP4 resetGameMenuInfo+612+96
CNSTI4 42
ASGNI4
line 1493
;1493:	resetGameMenuInfo.yes.color							= CT_DKPURPLE1;
ADDRGP4 resetGameMenuInfo+612+104
CNSTI4 35
ASGNI4
line 1494
;1494:	resetGameMenuInfo.yes.color2						= CT_LTPURPLE1;
ADDRGP4 resetGameMenuInfo+612+108
CNSTI4 34
ASGNI4
line 1495
;1495:	resetGameMenuInfo.yes.textX							= MENU_BUTTON_TEXT_X;
ADDRGP4 resetGameMenuInfo+612+124
CNSTI4 5
ASGNI4
line 1496
;1496:	resetGameMenuInfo.yes.textY							= MENU_BUTTON_TEXT_Y;
ADDRGP4 resetGameMenuInfo+612+128
CNSTI4 1
ASGNI4
line 1497
;1497:	resetGameMenuInfo.yes.textEnum						= MBT_YESRESET;
ADDRGP4 resetGameMenuInfo+612+116
CNSTI4 93
ASGNI4
line 1498
;1498:	resetGameMenuInfo.yes.textcolor						= CT_BLACK;
ADDRGP4 resetGameMenuInfo+612+132
CNSTI4 1
ASGNI4
line 1499
;1499:	resetGameMenuInfo.yes.textcolor2					= CT_WHITE;
ADDRGP4 resetGameMenuInfo+612+136
CNSTI4 8
ASGNI4
line 1502
;1500:
;1501:
;1502:	Menu_AddItem( &resetGameMenuInfo.menu, &resetGameMenuInfo.mainmenu );
ADDRGP4 resetGameMenuInfo
ARGP4
ADDRGP4 resetGameMenuInfo+324
ARGP4
ADDRGP4 Menu_AddItem
CALLV
pop
line 1503
;1503:	Menu_AddItem( &resetGameMenuInfo.menu, &resetGameMenuInfo.back );
ADDRGP4 resetGameMenuInfo
ARGP4
ADDRGP4 resetGameMenuInfo+468
ARGP4
ADDRGP4 Menu_AddItem
CALLV
pop
line 1504
;1504:	Menu_AddItem( &resetGameMenuInfo.menu, &resetGameMenuInfo.yes );
ADDRGP4 resetGameMenuInfo
ARGP4
ADDRGP4 resetGameMenuInfo+612
ARGP4
ADDRGP4 Menu_AddItem
CALLV
pop
line 1506
;1505:
;1506:}
LABELV $1082
endproc ResetGameMenu_Init 0 12
export UI_ResetGameMenu
proc UI_ResetGameMenu 0 8
line 1514
;1507:
;1508:/*
;1509:=================
;1510:UI_ResetGameMenu
;1511:=================
;1512:*/
;1513:void UI_ResetGameMenu( void )
;1514:{
line 1515
;1515:	ResetGameMenu_Init();
ADDRGP4 ResetGameMenu_Init
CALLV
pop
line 1517
;1516:
;1517:	UI_PushMenu( &resetGameMenuInfo.menu );
ADDRGP4 resetGameMenuInfo
ARGP4
ADDRGP4 UI_PushMenu
CALLV
pop
line 1518
;1518:	Menu_SetCursorToItem( &resetGameMenuInfo.menu, &resetGameMenuInfo.back );
ADDRGP4 resetGameMenuInfo
ARGP4
ADDRGP4 resetGameMenuInfo+468
ARGP4
ADDRGP4 Menu_SetCursorToItem
CALLV
pop
line 1519
;1519:}
LABELV $1188
endproc UI_ResetGameMenu 0 8
export M_SPChoose_Event
proc M_SPChoose_Event 12 4
line 1528
;1520:
;1521:
;1522:/*
;1523:===============
;1524:M_SPChoose_Event
;1525:===============
;1526:*/
;1527:void M_SPChoose_Event (void* ptr, int notification)
;1528:{
line 1529
;1529:	if (notification != QM_ACTIVATED)
ADDRFP4 4
INDIRI4
CNSTI4 3
EQI4 $1191
line 1530
;1530:		return;
ADDRGP4 $1190
JUMPV
LABELV $1191
line 1532
;1531:
;1532:	switch (((menucommon_s*)ptr)->id)
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 8
ADDP4
INDIRI4
ASGNI4
ADDRLP4 8
CNSTI4 100
ASGNI4
ADDRLP4 0
INDIRI4
ADDRLP4 8
INDIRI4
EQI4 $1196
ADDRLP4 0
INDIRI4
ADDRLP4 8
INDIRI4
GTI4 $1200
LABELV $1199
ADDRLP4 0
INDIRI4
CNSTI4 27
EQI4 $1197
ADDRGP4 $1193
JUMPV
LABELV $1200
ADDRLP4 0
INDIRI4
CNSTI4 122
EQI4 $1198
ADDRGP4 $1193
JUMPV
line 1533
;1533:	{
LABELV $1196
line 1535
;1534:		case ID_MAINMENU:
;1535:			UI_PopMenu ();
ADDRGP4 UI_PopMenu
CALLV
pop
line 1536
;1536:			break;
ADDRGP4 $1194
JUMPV
LABELV $1197
line 1539
;1537:
;1538:		case ID_CUSTOM:
;1539:			UI_StartServerMenu( qfalse );
CNSTI4 0
ARGI4
ADDRGP4 UI_StartServerMenu
CALLV
pop
line 1540
;1540:			break;
ADDRGP4 $1194
JUMPV
LABELV $1198
line 1543
;1541:
;1542:		case ID_PRESET:
;1543:			UI_SPLevelMenu();
ADDRGP4 UI_SPLevelMenu
CALLV
pop
line 1544
;1544:			break;
LABELV $1193
LABELV $1194
line 1546
;1545:	}
;1546:}
LABELV $1190
endproc M_SPChoose_Event 12 4
proc SPChoose_MenuKey 4 8
line 1553
;1547:/*
;1548:===============
;1549:SPChoose_MenuKey
;1550:===============
;1551:*/
;1552:static sfxHandle_t SPChoose_MenuKey( int key )
;1553:{
line 1554
;1554:	return ( Menu_DefaultKey( &s_spchoose.menu, key ) );
ADDRGP4 s_spchoose
ARGP4
ADDRFP4 0
INDIRI4
ARGI4
ADDRLP4 0
ADDRGP4 Menu_DefaultKey
CALLI4
ASGNI4
ADDRLP4 0
INDIRI4
RETI4
LABELV $1201
endproc SPChoose_MenuKey 4 8
proc SPChoose_MenuDraw 8 20
line 1563
;1555:}
;1556:
;1557:/*
;1558:===============
;1559:SPChoose_MenuDraw
;1560:===============
;1561:*/
;1562:static void SPChoose_MenuDraw( void )
;1563:{
line 1565
;1564:	// Draw the basic screen layout
;1565:	UI_MenuFrame(&s_spchoose.menu);
ADDRGP4 s_spchoose
ARGP4
ADDRGP4 UI_MenuFrame
CALLV
pop
line 1567
;1566:
;1567:	trap_R_SetColor( colorTable[CT_LTBROWN1]);
ADDRGP4 colorTable+416
ARGP4
ADDRGP4 trap_R_SetColor
CALLV
pop
line 1568
;1568:	UI_DrawHandlePic(30,203,  47, 186, uis.whiteShader);	// Long left column square on bottom 3rd
CNSTF4 1106247680
ARGF4
CNSTF4 1128988672
ARGF4
CNSTF4 1111228416
ARGF4
CNSTF4 1127874560
ARGF4
ADDRGP4 uis+5252
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 1570
;1569:
;1570:	UI_DrawProportionalString(  74,  66, "45",UI_RIGHT|UI_TINYFONT, colorTable[CT_BLACK]);
CNSTI4 74
ARGI4
CNSTI4 66
ARGI4
ADDRGP4 $1205
ARGP4
CNSTI4 65538
ARGI4
ADDRGP4 colorTable+16
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 1571
;1571:	UI_DrawProportionalString(  74,  84, "8341",UI_RIGHT|UI_TINYFONT, colorTable[CT_BLACK]);
CNSTI4 74
ARGI4
CNSTI4 84
ARGI4
ADDRGP4 $1207
ARGP4
CNSTI4 65538
ARGI4
ADDRGP4 colorTable+16
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 1572
;1572:	UI_DrawProportionalString(  74,  188, "90902",UI_RIGHT|UI_TINYFONT, colorTable[CT_BLACK]);
CNSTI4 74
ARGI4
CNSTI4 188
ARGI4
ADDRGP4 $1209
ARGP4
CNSTI4 65538
ARGI4
ADDRGP4 colorTable+16
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 1573
;1573:	UI_DrawProportionalString(  74,  206, "44",UI_RIGHT|UI_TINYFONT, colorTable[CT_BLACK]);
CNSTI4 74
ARGI4
CNSTI4 206
ARGI4
ADDRGP4 $1211
ARGP4
CNSTI4 65538
ARGI4
ADDRGP4 colorTable+16
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 1574
;1574:	UI_DrawProportionalString(  74,  395, "6801",UI_RIGHT|UI_TINYFONT, colorTable[CT_BLACK]);
CNSTI4 74
ARGI4
CNSTI4 395
ARGI4
ADDRGP4 $1213
ARGP4
CNSTI4 65538
ARGI4
ADDRGP4 colorTable+16
ARGP4
ADDRGP4 UI_DrawProportionalString
CALLV
pop
line 1576
;1575:
;1576:	trap_R_SetColor( colorTable[CT_DKPURPLE1]);
ADDRGP4 colorTable+560
ARGP4
ADDRGP4 trap_R_SetColor
CALLV
pop
line 1579
;1577:
;1578:	// Left rounded ends
;1579:	UI_DrawHandlePic(290 - 14, 240, MENU_BUTTON_MED_HEIGHT, MENU_BUTTON_MED_HEIGHT, uis.graphicButtonLeftEnd);
CNSTF4 1133117440
ARGF4
CNSTF4 1131413504
ARGF4
ADDRLP4 0
CNSTF4 1099956224
ASGNF4
ADDRLP4 0
INDIRF4
ARGF4
ADDRLP4 0
INDIRF4
ARGF4
ADDRGP4 uis+5352
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 1580
;1580:	UI_DrawHandlePic(290 - 14, 310, MENU_BUTTON_MED_HEIGHT, MENU_BUTTON_MED_HEIGHT, uis.graphicButtonLeftEnd);
CNSTF4 1133117440
ARGF4
CNSTF4 1134231552
ARGF4
ADDRLP4 4
CNSTF4 1099956224
ASGNF4
ADDRLP4 4
INDIRF4
ARGF4
ADDRLP4 4
INDIRF4
ARGF4
ADDRGP4 uis+5352
INDIRI4
ARGI4
ADDRGP4 UI_DrawHandlePic
CALLV
pop
line 1582
;1581:
;1582:	Menu_Draw( &s_spchoose.menu );
ADDRGP4 s_spchoose
ARGP4
ADDRGP4 Menu_Draw
CALLV
pop
line 1583
;1583:}
LABELV $1202
endproc SPChoose_MenuDraw 8 20
export SPChooseMenu_Cache
proc SPChooseMenu_Cache 0 0
line 1591
;1584:
;1585:/*
;1586:===============
;1587:SPChooseMenu_Cache
;1588:===============
;1589:*/
;1590:void SPChooseMenu_Cache( void ) 
;1591:{
line 1592
;1592:}
LABELV $1218
endproc SPChooseMenu_Cache 0 0
proc SPChoose_MenuInit 8 8
line 1600
;1593:
;1594:/*
;1595:=================
;1596:SPChoose_MenuInit
;1597:=================
;1598:*/
;1599:static void SPChoose_MenuInit(void)
;1600:{
line 1603
;1601:	int x,y;
;1602:
;1603:	SPChooseMenu_Cache(); 
ADDRGP4 SPChooseMenu_Cache
CALLV
pop
line 1605
;1604:
;1605:	s_spchoose.menu.nitems					= 0;
ADDRGP4 s_spchoose+8
CNSTI4 0
ASGNI4
line 1606
;1606:	s_spchoose.menu.draw					= SPChoose_MenuDraw;
ADDRGP4 s_spchoose+268
ADDRGP4 SPChoose_MenuDraw
ASGNP4
line 1607
;1607:	s_spchoose.menu.key						= SPChoose_MenuKey;
ADDRGP4 s_spchoose+272
ADDRGP4 SPChoose_MenuKey
ASGNP4
line 1608
;1608:	s_spchoose.menu.wrapAround				= qtrue;
ADDRGP4 s_spchoose+276
CNSTI4 1
ASGNI4
line 1609
;1609:	s_spchoose.menu.descX					= MENU_DESC_X;
ADDRGP4 s_spchoose+292
CNSTI4 100
ASGNI4
line 1610
;1610:	s_spchoose.menu.descY					= MENU_DESC_Y;
ADDRGP4 s_spchoose+296
CNSTI4 444
ASGNI4
line 1611
;1611:	s_spchoose.menu.titleX					= MENU_TITLE_X;
ADDRGP4 s_spchoose+308
CNSTI4 611
ASGNI4
line 1612
;1612:	s_spchoose.menu.titleY					= MENU_TITLE_Y;
ADDRGP4 s_spchoose+312
CNSTI4 24
ASGNI4
line 1613
;1613:	s_spchoose.menu.titleI					= MNT_SINGLEPLAYER_TITLE;
ADDRGP4 s_spchoose+316
CNSTI4 5
ASGNI4
line 1614
;1614:	s_spchoose.menu.footNoteEnum			= MNT_SOLOMATCHTYPES;
ADDRGP4 s_spchoose+320
CNSTI4 295
ASGNI4
line 1615
;1615:	s_spchoose.menu.fullscreen				= qtrue;
ADDRGP4 s_spchoose+280
CNSTI4 1
ASGNI4
line 1617
;1616:
;1617:	s_spchoose.mainmenu.generic.type		= MTYPE_BITMAP;      
ADDRGP4 s_spchoose+324
CNSTI4 6
ASGNI4
line 1618
;1618:	s_spchoose.mainmenu.generic.flags		= QMF_HIGHLIGHT_IF_FOCUS;
ADDRGP4 s_spchoose+324+44
CNSTU4 128
ASGNU4
line 1619
;1619:	s_spchoose.mainmenu.generic.x			= 482;
ADDRGP4 s_spchoose+324+12
CNSTI4 482
ASGNI4
line 1620
;1620:	s_spchoose.mainmenu.generic.y			= 136;
ADDRGP4 s_spchoose+324+16
CNSTI4 136
ASGNI4
line 1621
;1621:	s_spchoose.mainmenu.generic.name		= BUTTON_GRAPHIC_LONGRIGHT;
ADDRGP4 s_spchoose+324+4
ADDRGP4 $535
ASGNP4
line 1622
;1622:	s_spchoose.mainmenu.generic.id			= ID_MAINMENU;
ADDRGP4 s_spchoose+324+8
CNSTI4 100
ASGNI4
line 1623
;1623:	s_spchoose.mainmenu.generic.callback	= M_SPChoose_Event;
ADDRGP4 s_spchoose+324+48
ADDRGP4 M_SPChoose_Event
ASGNP4
line 1624
;1624:	s_spchoose.mainmenu.width				= MENU_BUTTON_MED_WIDTH;
ADDRGP4 s_spchoose+324+92
CNSTI4 130
ASGNI4
line 1625
;1625:	s_spchoose.mainmenu.height				= MENU_BUTTON_MED_HEIGHT;
ADDRGP4 s_spchoose+324+96
CNSTI4 18
ASGNI4
line 1626
;1626:	s_spchoose.mainmenu.color				= CT_DKPURPLE1;
ADDRGP4 s_spchoose+324+104
CNSTI4 35
ASGNI4
line 1627
;1627:	s_spchoose.mainmenu.color2				= CT_LTPURPLE1;
ADDRGP4 s_spchoose+324+108
CNSTI4 34
ASGNI4
line 1628
;1628:	s_spchoose.mainmenu.textX				= MENU_BUTTON_TEXT_X;
ADDRGP4 s_spchoose+324+124
CNSTI4 5
ASGNI4
line 1629
;1629:	s_spchoose.mainmenu.textY				= MENU_BUTTON_TEXT_Y;
ADDRGP4 s_spchoose+324+128
CNSTI4 1
ASGNI4
line 1630
;1630:	s_spchoose.mainmenu.textEnum			= MBT_MAINMENU;
ADDRGP4 s_spchoose+324+116
CNSTI4 9
ASGNI4
line 1631
;1631:	s_spchoose.mainmenu.textcolor			= CT_BLACK;
ADDRGP4 s_spchoose+324+132
CNSTI4 1
ASGNI4
line 1632
;1632:	s_spchoose.mainmenu.textcolor2			= CT_WHITE;
ADDRGP4 s_spchoose+324+136
CNSTI4 8
ASGNI4
line 1634
;1633:
;1634:	x = 290;
ADDRLP4 4
CNSTI4 290
ASGNI4
line 1635
;1635:	y = 240;
ADDRLP4 0
CNSTI4 240
ASGNI4
line 1636
;1636:	s_spchoose.preset.generic.type			= MTYPE_BITMAP;
ADDRGP4 s_spchoose+468
CNSTI4 6
ASGNI4
line 1637
;1637:	s_spchoose.preset.generic.flags			= QMF_HIGHLIGHT_IF_FOCUS;
ADDRGP4 s_spchoose+468+44
CNSTU4 128
ASGNU4
line 1638
;1638:	s_spchoose.preset.generic.x				= x;
ADDRGP4 s_spchoose+468+12
ADDRLP4 4
INDIRI4
ASGNI4
line 1639
;1639:	s_spchoose.preset.generic.y				= y;
ADDRGP4 s_spchoose+468+16
ADDRLP4 0
INDIRI4
ASGNI4
line 1640
;1640:	s_spchoose.preset.generic.name			= BUTTON_GRAPHIC_LONGRIGHT;
ADDRGP4 s_spchoose+468+4
ADDRGP4 $535
ASGNP4
line 1641
;1641:	s_spchoose.preset.generic.id				= ID_PRESET;
ADDRGP4 s_spchoose+468+8
CNSTI4 122
ASGNI4
line 1642
;1642:	s_spchoose.preset.generic.callback		= M_SPChoose_Event;
ADDRGP4 s_spchoose+468+48
ADDRGP4 M_SPChoose_Event
ASGNP4
line 1643
;1643:	s_spchoose.preset.width					= MENU_BUTTON_MED_WIDTH;
ADDRGP4 s_spchoose+468+92
CNSTI4 130
ASGNI4
line 1644
;1644:	s_spchoose.preset.height				= MENU_BUTTON_MED_HEIGHT;
ADDRGP4 s_spchoose+468+96
CNSTI4 18
ASGNI4
line 1645
;1645:	s_spchoose.preset.color					= CT_DKPURPLE1;
ADDRGP4 s_spchoose+468+104
CNSTI4 35
ASGNI4
line 1646
;1646:	s_spchoose.preset.color2				= CT_LTPURPLE1;
ADDRGP4 s_spchoose+468+108
CNSTI4 34
ASGNI4
line 1647
;1647:	s_spchoose.preset.textX					= MENU_BUTTON_TEXT_X;
ADDRGP4 s_spchoose+468+124
CNSTI4 5
ASGNI4
line 1648
;1648:	s_spchoose.preset.textY					= MENU_BUTTON_TEXT_Y;
ADDRGP4 s_spchoose+468+128
CNSTI4 1
ASGNI4
line 1649
;1649:	s_spchoose.preset.textEnum				= MBT_PRESETGAME;
ADDRGP4 s_spchoose+468+116
CNSTI4 67
ASGNI4
line 1650
;1650:	s_spchoose.preset.textcolor				= CT_BLACK;
ADDRGP4 s_spchoose+468+132
CNSTI4 1
ASGNI4
line 1651
;1651:	s_spchoose.preset.textcolor2			= CT_WHITE;
ADDRGP4 s_spchoose+468+136
CNSTI4 8
ASGNI4
line 1653
;1652:
;1653:	y += 70;
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 70
ADDI4
ASGNI4
line 1654
;1654:	s_spchoose.create.generic.type			= MTYPE_BITMAP;
ADDRGP4 s_spchoose+612
CNSTI4 6
ASGNI4
line 1655
;1655:	s_spchoose.create.generic.flags		= QMF_HIGHLIGHT_IF_FOCUS;
ADDRGP4 s_spchoose+612+44
CNSTU4 128
ASGNU4
line 1656
;1656:	s_spchoose.create.generic.x			= x;
ADDRGP4 s_spchoose+612+12
ADDRLP4 4
INDIRI4
ASGNI4
line 1657
;1657:	s_spchoose.create.generic.y			= y;
ADDRGP4 s_spchoose+612+16
ADDRLP4 0
INDIRI4
ASGNI4
line 1658
;1658:	s_spchoose.create.generic.name			= BUTTON_GRAPHIC_LONGRIGHT;
ADDRGP4 s_spchoose+612+4
ADDRGP4 $535
ASGNP4
line 1659
;1659:	s_spchoose.create.generic.id			= ID_CUSTOM;
ADDRGP4 s_spchoose+612+8
CNSTI4 27
ASGNI4
line 1660
;1660:	s_spchoose.create.generic.callback		= M_SPChoose_Event;
ADDRGP4 s_spchoose+612+48
ADDRGP4 M_SPChoose_Event
ASGNP4
line 1661
;1661:	s_spchoose.create.width				= MENU_BUTTON_MED_WIDTH;
ADDRGP4 s_spchoose+612+92
CNSTI4 130
ASGNI4
line 1662
;1662:	s_spchoose.create.height				= MENU_BUTTON_MED_HEIGHT;
ADDRGP4 s_spchoose+612+96
CNSTI4 18
ASGNI4
line 1663
;1663:	s_spchoose.create.color				= CT_DKPURPLE1;
ADDRGP4 s_spchoose+612+104
CNSTI4 35
ASGNI4
line 1664
;1664:	s_spchoose.create.color2				= CT_LTPURPLE1;
ADDRGP4 s_spchoose+612+108
CNSTI4 34
ASGNI4
line 1665
;1665:	s_spchoose.create.textX				= MENU_BUTTON_TEXT_X;
ADDRGP4 s_spchoose+612+124
CNSTI4 5
ASGNI4
line 1666
;1666:	s_spchoose.create.textY				= MENU_BUTTON_TEXT_Y;
ADDRGP4 s_spchoose+612+128
CNSTI4 1
ASGNI4
line 1667
;1667:	s_spchoose.create.textEnum				= MBT_CREATEMATCH;
ADDRGP4 s_spchoose+612+116
CNSTI4 66
ASGNI4
line 1668
;1668:	s_spchoose.create.textcolor			= CT_BLACK;
ADDRGP4 s_spchoose+612+132
CNSTI4 1
ASGNI4
line 1669
;1669:	s_spchoose.create.textcolor2			= CT_WHITE;
ADDRGP4 s_spchoose+612+136
CNSTI4 8
ASGNI4
line 1671
;1670:
;1671:	Menu_AddItem( &s_spchoose.menu,	&s_spchoose.mainmenu );
ADDRGP4 s_spchoose
ARGP4
ADDRGP4 s_spchoose+324
ARGP4
ADDRGP4 Menu_AddItem
CALLV
pop
line 1672
;1672:	Menu_AddItem( &s_spchoose.menu,	&s_spchoose.preset );
ADDRGP4 s_spchoose
ARGP4
ADDRGP4 s_spchoose+468
ARGP4
ADDRGP4 Menu_AddItem
CALLV
pop
line 1673
;1673:	Menu_AddItem( &s_spchoose.menu,	&s_spchoose.create );
ADDRGP4 s_spchoose
ARGP4
ADDRGP4 s_spchoose+612
ARGP4
ADDRGP4 Menu_AddItem
CALLV
pop
line 1675
;1674:
;1675:}
LABELV $1219
endproc SPChoose_MenuInit 8 8
export UI_SPChooseMenu
proc UI_SPChooseMenu 0 8
line 1683
;1676:	
;1677:/*
;1678:=================
;1679:UI_SPChooseMenu
;1680:=================
;1681:*/
;1682:void UI_SPChooseMenu( void )
;1683:{
line 1685
;1684:
;1685:	SPChoose_MenuInit();
ADDRGP4 SPChoose_MenuInit
CALLV
pop
line 1687
;1686:
;1687:	UI_PushMenu( &s_spchoose.menu );
ADDRGP4 s_spchoose
ARGP4
ADDRGP4 UI_PushMenu
CALLV
pop
line 1688
;1688:	Menu_SetCursorToItem( &s_spchoose.menu, &s_spchoose.preset );
ADDRGP4 s_spchoose
ARGP4
ADDRGP4 s_spchoose+468
ARGP4
ADDRGP4 Menu_SetCursorToItem
CALLV
pop
line 1689
;1689:}
LABELV $1327
endproc UI_SPChooseMenu 0 8
import ui_language
bss
align 4
LABELV maxTier
skip 4
align 4
LABELV minTier
skip 4
align 4
LABELV finalTier
skip 4
align 4
LABELV trainingTier
skip 4
align 4
LABELV currentGame
skip 4
align 4
LABELV currentSet
skip 4
align 4
LABELV selectedArena
skip 4
align 4
LABELV selectedArenaSet
skip 4
align 4
LABELV resetGameMenuInfo
skip 772
align 4
LABELV levelMenuInfo
skip 4132
align 4
LABELV s_spchoose
skip 756
import JoyYButtonCallback
import JoyXButtonCallback
import AnisotropicFilteringCallback
import SmoothMouseCallback
import MouseSpeedCallback
import InvertMouseCallback
import UI_PrintMenuGraphics
import UI_MenuBottomLineEnd_Graphics
import UI_InitGameinfo
import UI_GetAwardLevel
import UI_LogAwardData
import UI_NewGame
import UI_GetCurrentGame
import UI_CanShowTierVideo
import UI_ShowTierVideo
import UI_TierCompleted
import UI_SetBestScore
import UI_GetBestScore
import UI_GetNumBots
import UI_GetBotInfoByName
import UI_GetBotInfoByNumber
import UI_ServerAdvancedOptions
import UI_GetNumSPTiers
import UI_GetNumSPArenas
import UI_GetNumArenas
import UI_GetSpecialArenaInfo
import UI_GetArenaInfoByMap
import UI_GetArenaInfoByNumber
import UI_NetworkOptionsMenu
import UI_NetworkOptionsMenu_Cache
import ScreensizeCallback
import GammaCallback
import UI_FontsMenu
import UI_SoundMenu_Cache
import UI_SoundMenu
import setup_menubuttons
import UI_DisplayOptionsMenu
import UI_TeamOrdersMenu_Cache
import UI_TeamOrdersMenu_f
import UI_TeamOrdersMenu
import UI_RemoveBotsMenu
import UI_RemoveBots_Cache
import UI_AddBotsMenu
import UI_AddBots_Cache
import trap_R_ModelBounds
import trap_SetCDKey
import trap_MemoryRemaining
import trap_LAN_GetPingInfo
import trap_LAN_GetPing
import trap_LAN_ClearPing
import trap_LAN_GetPingQueueCount
import trap_LAN_GetGlobalServerAddressString
import trap_LAN_GetGlobalServerCount
import trap_LAN_GetLocalServerAddressString
import trap_LAN_GetLocalServerCount
import trap_GetConfigString
import trap_GetGlconfig
import trap_GetClientState
import trap_GetClipboardData
import trap_Key_SetCatcher
import trap_Key_GetCatcher
import trap_Key_ClearStates
import trap_Key_SetOverstrikeMode
import trap_Key_GetOverstrikeMode
import trap_Key_IsDown
import trap_Key_SetBinding
import trap_Key_GetBindingBuf
import trap_Key_KeynumToStringBuf
import trap_S_RegisterSound
import trap_S_StartLocalSound
import trap_CM_LerpTag
import trap_UpdateScreen
import trap_R_DrawStretchPic
import trap_R_SetColor
import trap_R_RenderScene
import trap_R_AddLightToScene
import trap_R_AddPolyToScene
import trap_R_AddRefEntityToScene
import trap_R_ClearScene
import trap_R_RegisterShaderNoMip
import trap_R_RegisterSkin
import trap_R_RegisterModel
import trap_FS_GetFileList
import trap_FS_FCloseFile
import trap_FS_Write
import trap_FS_Read
import trap_FS_FOpenFile
import trap_Cmd_ExecuteText
import trap_Argv
import trap_Argc
import trap_Cvar_InfoStringBuffer
import trap_Cvar_Create
import trap_Cvar_Reset
import trap_Cvar_SetValue
import trap_Cvar_VariableStringBuffer
import trap_Cvar_VariableValue
import trap_Cvar_Set
import trap_Cvar_Update
import trap_Cvar_Register
import trap_Milliseconds
import trap_Error
import trap_Print
import UI_SPSkillMenu_Cache
import UI_SPSkillMenu
import UI_SPPostgameMenu_f
import UI_SPPostgameMenu_Cache
import UI_SPArena_Start
import uis
import m_entersound
import UI_MenuFrame2
import UI_MenuFrame
import UI_PrecacheMenuGraphics
import UI_Cvar_VariableString
import UI_Argv
import UI_ForceMenuOff
import UI_PopMenu
import UI_PushMenu
import UI_SetActiveMenu
import UI_IsFullscreen
import UI_AdjustFrom640
import UI_CursorInRect
import UI_DrawChar
import UI_DrawString
import UI_ProportionalStringWidth
import UI_DrawProportionalString
import UI_ProportionalSizeScale
import UI_DrawBannerString
import UI_DrawRect
import UI_FillRect
import UI_DrawHandlePic
import UI_DrawNamedPic
import UI_ClampCvar
import UI_ConsoleCommand
import UI_Refresh
import UI_MouseEvent
import UI_KeyEvent
import UI_Shutdown
import UI_Init
import UI_InitSpinControl
import UI_LoadButtonText
import UI_LoadMenuText
import UI_RegisterClientModelname
import UI_PlayerInfo_SetInfo
import UI_PlayerInfo_SetModel
import UI_DrawPlayer
import UI_VideoDriverMenu_Cache
import UI_VideoData2Menu_Cache
import UI_VideoDataMenu_Cache
import UI_VideoDataMenu
import DriverInfo_Cache
import ServerInfo_Cache
import UI_ServerInfoMenu
import UI_BotSelectMenu_Cache
import UI_BotSelectMenu
import ServerOptions_Cache
import StartServer_Cache
import UI_StartServerMenu
import UI_ChooseServerTypeMenu_Cache
import ArenaServers_Cache
import UI_ArenaServersMenu
import SpecifyServer_Cache
import UI_SpecifyServerMenu
import s_voicelanguage_Names
import s_textlanguage_Names
import UI_GameOptionsMenu_Cache
import UI_GameOptionsMenu
import PlayerSettings_Cache
import UI_PlayerSettingsMenu
import PlayerModel_Cache
import UI_PlayerModelMenu
import UI_CDKeyMenu2
import UI_CDKeyMenu_f
import UI_CDKeyMenu_Cache
import UI_CDKeyMenu
import UI_ModsMenu_Cache
import UI_ModsMenu
import UI_DemosMenu
import SetupMenu_TopButtons
import UI_ControlsMouseJoyStickMenu_Cache
import Controls_Cache
import UI_DrawConnectScreen
import TeamMain_Cache
import UI_TeamMainMenu
import UI_ConfirmMenu
import ConfirmMenu_Cache
import UI_BotCommandMenu_f
import UI_DynamicMenu
import UI_DynamicMenuCache
import UI_InGameMenu
import InGame_Cache
import ingameFlag
import UI_DemosMenu_Cache
import UI_QuitMenu_Cache
import UI_ChooseServerTypeMenu
import UI_QuitMenu
import UI_Setup_MenuButtons
import UI_UpdateCvars
import UI_RegisterCvars
import UI_MainMenu
import MainMenu_Cache
import MenuField_Key
import MenuField_Draw
import MenuField_Init
import MField_Draw
import MField_CharEvent
import MField_KeyDownEvent
import MField_Clear
import ui_medalSounds
import ui_medalPicNames
import ui_medalNames
import text_color_highlight
import text_color_normal
import text_color_disabled
import listbar_color
import list_color
import name_color
import color_dim
import color_red
import color_orange
import color_blue
import color_yellow
import color_white
import menu_dim_color
import menu_black_color
import menu_red_color
import menu_highlight_color
import menu_dark_color
import menu_grayed_color
import menu_text_color
import menu_null_sound
import menu_buzz_sound
import menu_out_sound
import menu_move_sound
import menu_in_sound
import ScrollList_Key
import ScrollList_Draw
import Bitmap_Draw
import Bitmap_Init
import Menu_DefaultKey
import Menu_SetCursorToItem
import Menu_SetCursor
import Menu_ActivateItem
import Menu_ItemAtCursor
import Menu_Draw
import Menu_AdjustCursor
import Menu_AddItem
import Menu_Focus
import Menu_Cache
import UI_HolomatchInMenu_Cache
import Mouse_Show
import Mouse_Hide
import ui_playerclass
import ui_cdkeychecked2
import ui_cdkeychecked
import ui_server16
import ui_server15
import ui_server14
import ui_server13
import ui_server12
import ui_server11
import ui_server10
import ui_server9
import ui_server8
import ui_server7
import ui_server6
import ui_server5
import ui_server4
import ui_server3
import ui_server2
import ui_server1
import ui_marks
import ui_drawCrosshairNames
import ui_drawCrosshair
import ui_brassTime
import ui_browserShowEmpty
import ui_browserShowFull
import ui_browserSortKey
import ui_browserGameType
import ui_browserMaster
import ui_spSelection
import ui_team_race_red
import ui_team_race_blue
import ui_dowarmup
import ui_warmup
import ui_respawnGhostTime
import ui_forcerespawn
import ui_holoIntro
import ui_adaptRespawn
import ui_dmgmult
import ui_knockback
import ui_gravity
import ui_speed
import ui_weaponrespawn
import ui_spSkill
import ui_spVideos
import ui_spAwards
import ui_spScores5
import ui_spScores4
import ui_spScores3
import ui_spScores2
import ui_spScores1
import ui_botminplayers
import ui_botsFile
import ui_arenasFile
import ui_ctf_friendly
import ui_ctf_timelimit
import ui_ctf_capturelimit
import ui_team_friendly
import ui_team_timelimit
import ui_team_fraglimit
import ui_tourney_timelimit
import ui_tourney_fraglimit
import ui_ffa_timelimit
import ui_ffa_fraglimit
import menu_button_text
import menu_normal_text
import Max_Ammo
import BG_PlayerTouchesItem
import BG_PlayerStateToEntityState
import BG_AddPredictableEventToPlayerstate
import BG_EvaluateTrajectoryDelta
import BG_EvaluateTrajectory
import BG_CanItemBeGrabbed
import BG_FindItemForHoldable
import BG_FindItemForPowerup
import BG_FindItemForAmmo
import BG_FindItemForWeapon
import BG_FindItem
import BG_FindClassnameForHoldable
import BG_FindItemWithClassname
import bg_numItems
import bg_itemlist
import Pmove
import PM_UpdateViewAngles
import Com_Printf
import Com_Error
import Info_NextPair
import Info_Validate
import Info_SetValueForKey_Big
import Info_SetValueForKey
import Info_RemoveKey_big
import Info_RemoveKey
import Info_ValueForKey
import va
import Swap_Init
import BigFloat
import BigLong
import BigShort
import Q_CleanStr
import Q_PrintStrlen
import Q_strcat
import Q_strncpyz
import Q_strrchr
import Q_strupr
import Q_strlwr
import Q_stricmpn
import Q_strncmp
import Q_stricmp
import Q_isalpha
import Q_isupper
import Q_islower
import Q_isprint
import Com_sprintf
import Parse3DMatrix
import Parse2DMatrix
import Parse1DMatrix
import SkipRestOfLine
import SkipBracedSection
import COM_MatchToken
import COM_ParseExt
import COM_Parse
import COM_GetCurrentParseLine
import COM_BeginParseSession
import COM_DefaultExtension
import COM_StripExtension
import COM_SkipPath
import Com_Clamp
import UnVectorShort
import VectorShort
import PerpendicularVector
import AngleVectors
import MatrixMultiply
import PlaneTypeForNormal
import MakeNormalVectors
import RotateAroundDirection
import RotatePointAroundVector
import ProjectPointOnPlane
import PlaneFromPoints
import AngleDelta
import AngleNormalize180
import AngleNormalize360
import AnglesSubtract
import AngleSubtract
import LerpAngle
import AngleMod
import BoxOnPlaneSide
import SetPlaneSignbits
import AxisCopy
import AxisClear
import AnglesToAxis
import vectoangles
import irandom
import flrandom
import Q_crandom
import Q_random
import Q_rand
import Q_log2
import VectorRotate
import Vector4Scale
import VectorInverse
import VectorNormalize2
import VectorNormalizeFast
import VectorNormalize
import CrossProduct
import DistanceSquared
import Distance
import VectorLengthSquared
import VectorLength
import VectorCompare
import AddPointToBounds
import ClearBounds
import RadiusFromBounds
import NormalizeColor
import ColorBytes4
import ColorBytes3
import _VectorMA
import _VectorScale
import _VectorCopy
import _VectorAdd
import _VectorSubtract
import _DotProduct
import ByteToDir
import DirToByte
import ClampShort
import ClampChar
import Q_rsqrt
import Q_fabs
import axisDefault
import vec3_origin
import g_color_table
import colorDkGrey
import colorMdGrey
import colorLtGrey
import colorWhite
import colorCyan
import colorMagenta
import colorYellow
import colorBlue
import colorGreen
import colorRed
import colorBlack
import colorTable
import bytedirs
import fabs
import abs
import tan
import atan2
import cos
import sin
import sqrt
import floor
import ceil
import memcpy
import memset
import memmove
import sscanf
import vsprintf
import _atoi
import atoi
import _atof
import atof
import toupper
import tolower
import strncpy
import strstr
import strchr
import strcmp
import strcpy
import strcat
import strlen
import rand
import srand
import qsort
lit
align 1
LABELV $1213
byte 1 54
byte 1 56
byte 1 48
byte 1 49
byte 1 0
align 1
LABELV $1211
byte 1 52
byte 1 52
byte 1 0
align 1
LABELV $1209
byte 1 57
byte 1 48
byte 1 57
byte 1 48
byte 1 50
byte 1 0
align 1
LABELV $1207
byte 1 56
byte 1 51
byte 1 52
byte 1 49
byte 1 0
align 1
LABELV $1205
byte 1 52
byte 1 53
byte 1 0
align 1
LABELV $1081
byte 1 109
byte 1 101
byte 1 110
byte 1 117
byte 1 47
byte 1 99
byte 1 111
byte 1 109
byte 1 109
byte 1 111
byte 1 110
byte 1 47
byte 1 99
byte 1 111
byte 1 114
byte 1 110
byte 1 101
byte 1 114
byte 1 95
byte 1 108
byte 1 114
byte 1 95
byte 1 49
byte 1 56
byte 1 95
byte 1 49
byte 1 57
byte 1 46
byte 1 116
byte 1 103
byte 1 97
byte 1 0
align 1
LABELV $1079
byte 1 109
byte 1 101
byte 1 110
byte 1 117
byte 1 47
byte 1 99
byte 1 111
byte 1 109
byte 1 109
byte 1 111
byte 1 110
byte 1 47
byte 1 99
byte 1 111
byte 1 114
byte 1 110
byte 1 101
byte 1 114
byte 1 95
byte 1 108
byte 1 108
byte 1 95
byte 1 49
byte 1 56
byte 1 95
byte 1 49
byte 1 57
byte 1 46
byte 1 116
byte 1 103
byte 1 97
byte 1 0
align 1
LABELV $1077
byte 1 109
byte 1 101
byte 1 110
byte 1 117
byte 1 47
byte 1 99
byte 1 111
byte 1 109
byte 1 109
byte 1 111
byte 1 110
byte 1 47
byte 1 99
byte 1 111
byte 1 114
byte 1 110
byte 1 101
byte 1 114
byte 1 95
byte 1 117
byte 1 114
byte 1 95
byte 1 49
byte 1 57
byte 1 95
byte 1 51
byte 1 49
byte 1 46
byte 1 116
byte 1 103
byte 1 97
byte 1 0
align 1
LABELV $1075
byte 1 109
byte 1 101
byte 1 110
byte 1 117
byte 1 47
byte 1 99
byte 1 111
byte 1 109
byte 1 109
byte 1 111
byte 1 110
byte 1 47
byte 1 99
byte 1 111
byte 1 114
byte 1 110
byte 1 101
byte 1 114
byte 1 95
byte 1 117
byte 1 108
byte 1 95
byte 1 49
byte 1 57
byte 1 95
byte 1 51
byte 1 49
byte 1 46
byte 1 116
byte 1 103
byte 1 97
byte 1 0
align 1
LABELV $1053
byte 1 54
byte 1 51
byte 1 45
byte 1 48
byte 1 57
byte 1 57
byte 1 57
byte 1 55
byte 1 49
byte 1 50
byte 1 0
align 1
LABELV $1051
byte 1 55
byte 1 55
byte 1 52
byte 1 53
byte 1 55
byte 1 48
byte 1 0
align 1
LABELV $1049
byte 1 51
byte 1 50
byte 1 52
byte 1 45
byte 1 55
byte 1 54
byte 1 0
align 1
LABELV $1047
byte 1 48
byte 1 57
byte 1 56
byte 1 45
byte 1 49
byte 1 52
byte 1 53
byte 1 0
align 1
LABELV $1045
byte 1 54
byte 1 54
byte 1 57
byte 1 49
byte 1 55
byte 1 0
align 1
LABELV $938
byte 1 109
byte 1 101
byte 1 110
byte 1 117
byte 1 47
byte 1 99
byte 1 111
byte 1 109
byte 1 109
byte 1 111
byte 1 110
byte 1 47
byte 1 115
byte 1 113
byte 1 117
byte 1 97
byte 1 114
byte 1 101
byte 1 46
byte 1 116
byte 1 103
byte 1 97
byte 1 0
align 1
LABELV $624
byte 1 109
byte 1 101
byte 1 110
byte 1 117
byte 1 47
byte 1 99
byte 1 111
byte 1 109
byte 1 109
byte 1 111
byte 1 110
byte 1 47
byte 1 97
byte 1 114
byte 1 114
byte 1 111
byte 1 119
byte 1 95
byte 1 114
byte 1 105
byte 1 103
byte 1 104
byte 1 116
byte 1 95
byte 1 49
byte 1 54
byte 1 46
byte 1 116
byte 1 103
byte 1 97
byte 1 0
align 1
LABELV $594
byte 1 109
byte 1 101
byte 1 110
byte 1 117
byte 1 47
byte 1 99
byte 1 111
byte 1 109
byte 1 109
byte 1 111
byte 1 110
byte 1 47
byte 1 97
byte 1 114
byte 1 114
byte 1 111
byte 1 119
byte 1 95
byte 1 108
byte 1 101
byte 1 102
byte 1 116
byte 1 95
byte 1 49
byte 1 54
byte 1 46
byte 1 116
byte 1 103
byte 1 97
byte 1 0
align 1
LABELV $535
byte 1 109
byte 1 101
byte 1 110
byte 1 117
byte 1 47
byte 1 99
byte 1 111
byte 1 109
byte 1 109
byte 1 111
byte 1 110
byte 1 47
byte 1 98
byte 1 97
byte 1 114
byte 1 49
byte 1 46
byte 1 116
byte 1 103
byte 1 97
byte 1 0
align 1
LABELV $516
byte 1 50
byte 1 0
align 1
LABELV $512
byte 1 103
byte 1 95
byte 1 115
byte 1 112
byte 1 83
byte 1 107
byte 1 105
byte 1 108
byte 1 108
byte 1 0
align 1
LABELV $510
byte 1 109
byte 1 101
byte 1 110
byte 1 117
byte 1 47
byte 1 97
byte 1 114
byte 1 116
byte 1 47
byte 1 108
byte 1 101
byte 1 118
byte 1 101
byte 1 108
byte 1 95
byte 1 99
byte 1 111
byte 1 109
byte 1 112
byte 1 108
byte 1 101
byte 1 116
byte 1 101
byte 1 53
byte 1 0
align 1
LABELV $507
byte 1 109
byte 1 101
byte 1 110
byte 1 117
byte 1 47
byte 1 97
byte 1 114
byte 1 116
byte 1 47
byte 1 108
byte 1 101
byte 1 118
byte 1 101
byte 1 108
byte 1 95
byte 1 99
byte 1 111
byte 1 109
byte 1 112
byte 1 108
byte 1 101
byte 1 116
byte 1 101
byte 1 52
byte 1 0
align 1
LABELV $504
byte 1 109
byte 1 101
byte 1 110
byte 1 117
byte 1 47
byte 1 97
byte 1 114
byte 1 116
byte 1 47
byte 1 108
byte 1 101
byte 1 118
byte 1 101
byte 1 108
byte 1 95
byte 1 99
byte 1 111
byte 1 109
byte 1 112
byte 1 108
byte 1 101
byte 1 116
byte 1 101
byte 1 51
byte 1 0
align 1
LABELV $501
byte 1 109
byte 1 101
byte 1 110
byte 1 117
byte 1 47
byte 1 97
byte 1 114
byte 1 116
byte 1 47
byte 1 108
byte 1 101
byte 1 118
byte 1 101
byte 1 108
byte 1 95
byte 1 99
byte 1 111
byte 1 109
byte 1 112
byte 1 108
byte 1 101
byte 1 116
byte 1 101
byte 1 50
byte 1 0
align 1
LABELV $498
byte 1 109
byte 1 101
byte 1 110
byte 1 117
byte 1 47
byte 1 97
byte 1 114
byte 1 116
byte 1 47
byte 1 108
byte 1 101
byte 1 118
byte 1 101
byte 1 108
byte 1 95
byte 1 99
byte 1 111
byte 1 109
byte 1 112
byte 1 108
byte 1 101
byte 1 116
byte 1 101
byte 1 49
byte 1 0
align 1
LABELV $496
byte 1 109
byte 1 101
byte 1 110
byte 1 117
byte 1 47
byte 1 97
byte 1 114
byte 1 116
byte 1 47
byte 1 109
byte 1 97
byte 1 112
byte 1 115
byte 1 95
byte 1 115
byte 1 101
byte 1 108
byte 1 101
byte 1 99
byte 1 116
byte 1 0
align 1
LABELV $494
byte 1 109
byte 1 101
byte 1 110
byte 1 117
byte 1 47
byte 1 97
byte 1 114
byte 1 116
byte 1 47
byte 1 109
byte 1 97
byte 1 112
byte 1 115
byte 1 95
byte 1 115
byte 1 101
byte 1 108
byte 1 101
byte 1 99
byte 1 116
byte 1 101
byte 1 100
byte 1 0
align 1
LABELV $492
byte 1 109
byte 1 101
byte 1 110
byte 1 117
byte 1 47
byte 1 99
byte 1 111
byte 1 109
byte 1 109
byte 1 111
byte 1 110
byte 1 47
byte 1 99
byte 1 111
byte 1 114
byte 1 110
byte 1 101
byte 1 114
byte 1 95
byte 1 108
byte 1 108
byte 1 95
byte 1 49
byte 1 56
byte 1 95
byte 1 51
byte 1 52
byte 1 0
align 1
LABELV $490
byte 1 109
byte 1 101
byte 1 110
byte 1 117
byte 1 47
byte 1 99
byte 1 111
byte 1 109
byte 1 109
byte 1 111
byte 1 110
byte 1 47
byte 1 99
byte 1 111
byte 1 114
byte 1 110
byte 1 101
byte 1 114
byte 1 95
byte 1 108
byte 1 114
byte 1 95
byte 1 55
byte 1 95
byte 1 49
byte 1 50
byte 1 0
align 1
LABELV $488
byte 1 109
byte 1 101
byte 1 110
byte 1 117
byte 1 47
byte 1 99
byte 1 111
byte 1 109
byte 1 109
byte 1 111
byte 1 110
byte 1 47
byte 1 99
byte 1 111
byte 1 114
byte 1 110
byte 1 101
byte 1 114
byte 1 95
byte 1 117
byte 1 114
byte 1 95
byte 1 49
byte 1 56
byte 1 95
byte 1 49
byte 1 50
byte 1 0
align 1
LABELV $486
byte 1 109
byte 1 101
byte 1 110
byte 1 117
byte 1 47
byte 1 99
byte 1 111
byte 1 109
byte 1 109
byte 1 111
byte 1 110
byte 1 47
byte 1 99
byte 1 111
byte 1 114
byte 1 110
byte 1 101
byte 1 114
byte 1 95
byte 1 117
byte 1 108
byte 1 95
byte 1 49
byte 1 56
byte 1 95
byte 1 49
byte 1 50
byte 1 0
align 1
LABELV $438
byte 1 63
byte 1 0
align 1
LABELV $423
byte 1 37
byte 1 115
byte 1 32
byte 1 37
byte 1 105
byte 1 0
align 1
LABELV $422
byte 1 102
byte 1 114
byte 1 97
byte 1 103
byte 1 108
byte 1 105
byte 1 109
byte 1 105
byte 1 116
byte 1 0
align 1
LABELV $419
byte 1 37
byte 1 115
byte 1 0
align 1
LABELV $346
byte 1 51
byte 1 52
byte 1 53
byte 1 45
byte 1 53
byte 1 0
align 1
LABELV $344
byte 1 55
byte 1 49
byte 1 0
align 1
LABELV $342
byte 1 56
byte 1 49
byte 1 52
byte 1 53
byte 1 52
byte 1 0
align 1
LABELV $340
byte 1 49
byte 1 49
byte 1 49
byte 1 54
byte 1 49
byte 1 49
byte 1 0
align 1
LABELV $250
byte 1 115
byte 1 105
byte 1 110
byte 1 103
byte 1 108
byte 1 101
byte 1 0
align 1
LABELV $247
byte 1 116
byte 1 121
byte 1 112
byte 1 101
byte 1 0
align 1
LABELV $201
byte 1 102
byte 1 105
byte 1 110
byte 1 97
byte 1 108
byte 1 0
align 1
LABELV $169
byte 1 110
byte 1 117
byte 1 109
byte 1 0
align 1
LABELV $168
byte 1 116
byte 1 114
byte 1 97
byte 1 105
byte 1 110
byte 1 105
byte 1 110
byte 1 103
byte 1 0
align 1
LABELV $165
byte 1 117
byte 1 105
byte 1 95
byte 1 115
byte 1 112
byte 1 83
byte 1 101
byte 1 108
byte 1 101
byte 1 99
byte 1 116
byte 1 105
byte 1 111
byte 1 110
byte 1 0
align 1
LABELV $153
byte 1 108
byte 1 101
byte 1 118
byte 1 101
byte 1 108
byte 1 115
byte 1 104
byte 1 111
byte 1 116
byte 1 115
byte 1 47
byte 1 117
byte 1 110
byte 1 107
byte 1 110
byte 1 111
byte 1 119
byte 1 110
byte 1 109
byte 1 97
byte 1 112
byte 1 0
align 1
LABELV $148
byte 1 108
byte 1 101
byte 1 118
byte 1 101
byte 1 108
byte 1 115
byte 1 104
byte 1 111
byte 1 116
byte 1 115
byte 1 47
byte 1 37
byte 1 115
byte 1 46
byte 1 116
byte 1 103
byte 1 97
byte 1 0
align 1
LABELV $134
byte 1 108
byte 1 111
byte 1 110
byte 1 103
byte 1 110
byte 1 97
byte 1 109
byte 1 101
byte 1 95
byte 1 37
byte 1 115
byte 1 0
align 1
LABELV $133
byte 1 108
byte 1 111
byte 1 110
byte 1 103
byte 1 110
byte 1 97
byte 1 109
byte 1 101
byte 1 0
align 1
LABELV $130
byte 1 69
byte 1 78
byte 1 71
byte 1 76
byte 1 73
byte 1 83
byte 1 72
byte 1 0
align 1
LABELV $123
byte 1 109
byte 1 97
byte 1 112
byte 1 0
align 1
LABELV $113
byte 1 110
byte 1 97
byte 1 109
byte 1 101
byte 1 0
align 1
LABELV $110
byte 1 109
byte 1 111
byte 1 100
byte 1 101
byte 1 108
byte 1 0
align 1
LABELV $89
byte 1 98
byte 1 111
byte 1 116
byte 1 115
byte 1 0
align 1
LABELV $84
byte 1 109
byte 1 111
byte 1 100
byte 1 101
byte 1 108
byte 1 115
byte 1 47
byte 1 112
byte 1 108
byte 1 97
byte 1 121
byte 1 101
byte 1 114
byte 1 115
byte 1 50
byte 1 47
byte 1 37
byte 1 115
byte 1 47
byte 1 105
byte 1 99
byte 1 111
byte 1 110
byte 1 95
byte 1 100
byte 1 101
byte 1 102
byte 1 97
byte 1 117
byte 1 108
byte 1 116
byte 1 46
byte 1 106
byte 1 112
byte 1 103
byte 1 0
align 1
LABELV $81
byte 1 109
byte 1 111
byte 1 100
byte 1 101
byte 1 108
byte 1 115
byte 1 47
byte 1 112
byte 1 108
byte 1 97
byte 1 121
byte 1 101
byte 1 114
byte 1 115
byte 1 50
byte 1 47
byte 1 37
byte 1 115
byte 1 47
byte 1 105
byte 1 99
byte 1 111
byte 1 110
byte 1 95
byte 1 37
byte 1 115
byte 1 46
byte 1 106
byte 1 112
byte 1 103
byte 1 0
align 1
LABELV $80
byte 1 100
byte 1 101
byte 1 102
byte 1 97
byte 1 117
byte 1 108
byte 1 116
byte 1 0
